<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class cash_receipt extends CI_Model {

    public function __construct() {
        parent::__construct();
    }

    public function addNewReceipt($data) {
        $serial = -1;
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_RECEIPT_DT', 'value' => $data['RECEIPT_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TYPE', 'value' => $data['TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ACCOUNT', 'value' => $data['ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATUS', 'value' => $data['STATUS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTES', 'value' => $data['NOTES'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SERIAL', 'value' => &$serial, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'ADD_NEW_RECEIPT', $paramts, $results);
        return array('serial' => $serial, 'success' => $success, 'msg' => $msg);
    }

    public function updateReceipt($data) {
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_SERIAL', 'value' => $data['SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECEIPT_DT', 'value' => $data['RECEIPT_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ACCOUNT', 'value' => $data['ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTES', 'value' => $data['NOTES'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'UPDATE_RECEIPT', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }

    public function addTransferInfo($data) {
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_RECEIPT_SR', 'value' => $data['SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_ID', 'value' => $data['TRANS_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_AMOUNT', 'value' => $data['TRANS_AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TARGET_ACNT', 'value' => $data['TARGET_ACNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'ADD_BANK_TRANSFER_INFO', $paramts, $results);
        return array('success' => $success, 'msg' => $msg, 'serial'=>$data['SERIAL']);
    }

    public function addCheckInfo($data) {
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_RECEIPT_SR', 'value' => $data['RECEIPT_SR'], 'length' => 10, 'type' => OCI_ASSOC), //
            array('name' => ':I_CHECK_ID', 'value' => $data['CHECK_ID'], 'length' => 20, 'type' => OCI_ASSOC), //
            array('name' => ':I_CHECK_BANK', 'value' => $data['CHECK_BANK'], 'length' => 10, 'type' => OCI_ASSOC), //$data['CHECK_BANK']
            array('name' => ':I_CHECK_DT', 'value' => $data['CHECK_DT'], 'length' => 20, 'type' => OCI_ASSOC), //$data['CHECK_DT']
            array('name' => ':I_DUE_DAYS', 'value' => $data['DUE_DAYS'], 'length' => 10, 'type' => OCI_ASSOC), //
            array('name' => ':I_CHECK_AMOUNT', 'value' => $data['CHECK_AMOUNT'], 'length' => 10, 'type' => OCI_ASSOC), //$data['CHECK_AMOUNT']
            array('name' => ':I_OWNER_ACNT', 'value' => $data['OWNER_ACNT'], 'length' => 10, 'type' => OCI_ASSOC),//
            array('name' => ':I_TARGET_ACNT', 'value' => $data['TARGET_ACNT'], 'length' => 10, 'type' => OCI_ASSOC),// 
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 1000, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'ADD_PAID_CHECK_INFO', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }


    public function approveReceipt($data) {
        $success = 0;
        $msg = "";
        $paramts = array(
            array('name' => ':I_SERIAL', 'value' => $data['SERIAL'], 'length' => -1, 'type' => OCI_ASSOC), 
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),   
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'RECEIPT_INITIAL_RATIFY', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }

    public function returnReceipt($data) {
        $success = 0;
        $msg = "";
        $paramts = array(
            array('name' => ':I_SERIAL', 'value' => $data['SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),  
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),  
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'RETURN_RECEIPT', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }

    public function cancelReceipt($data) {
        $success = 0;
        $msg = "";
        $paramts = array(
            array('name' => ':I_SERIAL', 'value' => $data['SERIAL'], 'length' => -1, 'type' => OCI_ASSOC), 
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),  
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'CANCEL_RECEIPT', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }


    public function getReceipts($data) {
        $cursor = $this->db->get_cursor();
        $cnt = '';
        $paramts = array(
            array('name' => ':I_RCPT_SR', 'value' => $data['RCPT_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RCPT_STATUS', 'value' => $data['RCPT_STATUS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RCPT_TYPE', 'value' => $data['RCPT_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_DOC_ID', 'value' => $data['DOC_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $data['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COM_ACCOUNT', 'value' => $data['COM_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_REC', 'value' => $data['START_REC'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_LAST_REC', 'value' => $data['LAST_REC'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_RECEIPTS', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR),
            array('name' => ':O_CNT', 'value' => &$cnt, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'GET_RECEIPTS_GENERAL_INFO_LIST', $paramts, $results);
        return $results ;
    }

    public function getReceipt($data) {
        $cursor = $this->db->get_cursor();
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_RCPT_SR', 'value' => $data['RCPT_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_RECEIPT', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'GET_RECEIPT', $paramts, $results);
        return (count($results) > 0)? $results[0] : null;
    }

    public function getCheckReceiptDetails($data) {
        $cursor = $this->db->get_cursor();
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_RCPT_SR', 'value' => $data['RCPT_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_CHECKS', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'GET_CHECK_DETAILS', $paramts, $results);
        return $results;
    }

    public function getTransterReceiptDetails($data) {
        $cursor = $this->db->get_cursor();
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_RCPT_SR', 'value' => $data['RCPT_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DETAILS', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'GET_TRANSFER_DETAILS', $paramts, $results);
        return (count($results) > 0)? $results : null;
    }
    
    public function getPaidChecksList($data){
        //print_r($data) ; exit() ;
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_CHECK_NO', 'value' => $data['CHECK_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_BANK', 'value' => $data['CHECK_BANK'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COMPANY', 'value' => $data['COM_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_DOC_TYPE', 'value' => $data['DOC_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $data['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'GET_PAID_CHECKS_LIST', $paramts, $results);
        return $results;
    }








    public function getGazPetrolAccounts($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_TEARM', 'value' => $data['TEARM'], 'length' => -1, 'type' => OCI_ASSOC), 
            array('name' => ':O_DATA ', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('GLOBAL_PKG', 'GET_GAZ_PETROL_ACCOUNTS', $paramts, $results);
        return (count($results) > 0)? $results : null;
    }


    public function getAccounts($data) {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_TEARM', 'value' => $data['TEARM'], 'length' => -1, 'type' => OCI_ASSOC), 
            array('name' => ':O_DATA ', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('GLOBAL_PKG', 'GET_ACCOUNT_INFO_BY_NAME', $paramts, $results);
        return (count($results) > 0)? $results : null;
    }


    public function getAccount($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ACCOUNT_ID', 'value' => $data['ACCOUNT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_RECEIPT', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('GLOBAL_PKG', 'GET_ACCOUNT', $paramts, $results);
        return (count($results) > 0)? $results[0] : null;
       
    }

    public function getBank($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ID', 'value' => $data['BANK_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_RECEIPT', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('GLOBAL_PKG', 'GET_BANK', $paramts, $results);
        return (count($results) > 0)? $results[0] : null;
       
    }


    public function addBankTransferRecieptInfo($data) {
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_SERIAL', 'value' => $data['SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECEIPT_DT', 'value' => $data['RECEIPT_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COM_ACCOUNT', 'value' => $data['ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_ID', 'value' => $data['TRANS_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_AMOUNT', 'value' => $data['TRANS_AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TARGET_ACNT', 'value' => $data['TARGET_ACNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATUS', 'value' => $data['STATUS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTES', 'value' => $data['NOTES'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'ADD_BANK_TRANSFER_RECIEPT_INFO', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }
    
    public function getSMSNotice($receipt){
        $recv_cur = $this->db->get_cursor();
        $sms_txt = '' ;
        $paramts = array(
            array('name' => ':I_RECEIPT_SR', 'value' => $receipt, 'length' => -1, 'type' => OCI_ASSOC), 
            array('name' => ':O_SMS_TXT', 'value' => &$sms_txt, 'length' => 70, 'type' => OCI_ASSOC),
            array('name' => ':O_RECEIVERS', 'value' => $recv_cur, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'SMS_RECEIPT_APPROVAL', $paramts, $results);
        return array('sms_txt' => $sms_txt, 'receivers' => $results);
    }


    public function getcheckslist($data)
    {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_CHECK_NO', 'value' => $data['CHECK_NO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CHECK_SDT', 'value' => $data['CHECK_SDT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CHECK_EDT', 'value' => $data['CHECK_EDT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECEIPT_SDT', 'value' => $data['RECEIPT_SDT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECEIPT_EDT', 'value' => $data['RECEIPT_EDT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CHECK_BANK', 'value' => $data['CHECK_BANK'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_OWNER_ACNT', 'value' => $data['OWNER_ACNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COLLECT_STAT', 'value' => $data['COLLECT_STAT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ACCOUNT_CAT', 'value' => $data['ACCOUNT_CAT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'GET_CHECKS_LIST', $paramts, $results);
        return $results;
    }

    public function SET_CHECK_COLLECTED($data)
    {
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_CHECK_SR', 'value' => $data['CHECK_SR'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_COLLECT_DT', 'value' => $data['COLLECT_DT'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_BANK', 'value' => $data['BANK'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 5, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'SET_CHECK_COLLECTED', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }

    public function SET_CHECK_RETURNED($data)
    {
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_CHECK_SR', 'value' => $data['CHECK_SR'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_RETURN_DT', 'value' => $data['RETURN_DT'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 5, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'SET_CHECK_RETURNED', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }


    public function MAP_BANKS_ACCOUNTS($bank)
    {
        $account = '';
        $paramts = array(
            array('name' => ':I_BANK', 'value' => $bank, 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_ACCOUNT', 'value' => &$account, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'MAP_BANKS_ACCOUNTS', $paramts, $results);
        return array('account' => $account);
    }

    public function WITHDRAW_CHECK($data)
    {
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_CHECK_SR', 'value' => $data['CHECK_SR'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_WITHDRAW_DT', 'value' => $data['WITHDRAW_DT'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 5, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'WITHDRAW_CHECK', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }

    public function SET_CHECK_RETURNED_IN_BANK($data)
    {
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_CHECK_SR', 'value' => $data['CHECK_SR'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_RETURN_DT', 'value' => $data['RETURN_DT'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_BANK', 'value' => $data['BANK'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 5, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'SET_CHECK_RETURNED_IN_BANK', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }

    public function SET_CHECK_UNCOLLECTED($data)
    {
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_CHECK_SR', 'value' => $data['CHECK_SR'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 5, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'SET_CHECK_UNCOLLECTED', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }
}

