<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class CarConstants extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->load->helper('date');
        $this->load->model('constants');
          $this->user_sso->validate_session();

        if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }
    }

    public function index()
    {
        if (!$this->user_sso->is_allowed_function('55')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('constants/addfreightcarform', $data);
        $this->load->view('includes/footer.php', $data);

    }


    public function addfreightcarform()
    {
         if (!$this->user_sso->is_allowed_function('55')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('constants/addfreightcarform', $data);
        $this->load->view('includes/footer.php', $data);

    }
    public function addFreightCar() {

         if (!$this->user_sso->is_allowed_function('155')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'COMPANY' => $this->input->post('COMPANY'),
            'CAR_ID' => $this->input->post('CAR_ID'),
            'CAR_MODEL' => $this->input->post('CAR_MODEL'),
            'PRODUCT_CATEGORY' => $this->input->post('PRODUCT_CATEGORY'),
            'TRAILER' => $this->input->post('TRAILER'),
            'TANKS' => $this->input->post('TANKS'),
            'TOTAL_CAPACITY' => $this->input->post('TOTAL_CAPACITY'),

        );

        $result = $this->constants->addFreightCar($parm);

        echo json_encode($result);
    }

    public function carConstantsMaster() {

         if (!$this->user_sso->is_allowed_function('56')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['allowActivate'] = $this->user_sso->is_allowed_function('56'); 
        $data['allowDeactivate'] = $this->user_sso->is_allowed_function('56'); 
        $data['allowEdit'] = $this->user_sso->is_allowed_function('56'); 
        $data['companies'] = $this->constants->getCompaniesList();
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('constants/carConstantsMaster', $data);
        $this->load->view('includes/footer.php', $data);

    }
    public function getFreightCars() {
        $parm = array(
            'CAR_SR' => $this->input->post('CAR_SERIAL'),
            'COMPANY' => $this->input->post('COMPANY'),
            'CAR_ID' => $this->input->post('CAR_ID'),
            'CAR_MODEL' => $this->input->post('CAR_MODEL'),
            'PRODUCT_CATEGORY' => $this->input->post('PRODUCT_CATEGORY'),
            'TRAILER' => $this->input->post('TRAILER'),

        );
        $result = $this->constants->getFreightCars($parm);
        echo json_encode($result);
    }

    public function getFreightCarsList() {
        $parm = array(
            'CAR_SR' => $this->input->post('CAR_SERIAL'),
            'COMPANY' => $this->input->post('COMPANY'),
            'CAR_ID' => $this->input->post('CAR_ID'),
            'CAR_MODEL' => $this->input->post('CAR_MODEL'),
            'PRODUCT_CATEGORY' => $this->input->post('PRODUCT_CATEGORY'),
            'TRAILER' => $this->input->post('TRAILER'),

        );
        $result = $this->constants->getFreightCarsList($parm);
        echo json_encode($result);
    }

    public function activateCar(){
        if (!$this->user_sso->is_allowed_function('232')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CAR_SR' => $this->input->post('CAR_SR'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->constants->activateFreightCars($parm);
        echo json_encode($result); exit();
    }

    public function deactivateCar(){
        if (!$this->user_sso->is_allowed_function('233')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CAR_SR' => $this->input->post('CAR_SR'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->constants->deactivateFreightCars($parm);
        echo json_encode($result); exit();
    }

    public function changeCarInfo(){
        if (!$this->user_sso->is_allowed_function('234')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CAR_SERIAL' => $this->input->post('CAR_SERIAL'),
            'COMPANY' => $this->input->post('COMPANY'),
            'CAR_ID' => $this->input->post('CAR_ID'),
            'CAPACITY' => $this->input->post('CAPACITY'),
            'MODEL' => $this->input->post('MODEL'),
            'CATEGORY' => $this->input->post('CATEGORY'),
            'TANKS' => $this->input->post('TANKS'),
            'TRAILER' => $this->input->post('TRAILER'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->constants->updateFreightCars($parm);
        echo json_encode($result); exit();
    }



}
    ?>