<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class cashReceipts extends CI_Controller {

    public function __construct() {
        parent::__construct();
        $this->load->helper('date');
        $this->load->model('cash_receipt');
        $this->load->model('constants');
         $this->load->model('Role_model');
        $this->user_sso->validate_session();

        if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }
    }

    public function index() {
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('home', $data);
        $this->load->view('includes/footer.php', $data);
    }

    

    public function addTransferReceipt() {

         if (!$this->user_sso->is_allowed_function('158')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'RECEIPT_DT' => $this->input->post('RECEIPT_DT'),
            'TYPE' => 'T',
            'ACCOUNT' => $this->input->post('ACCOUNT'),
            'STATUS' => '0',
            'NOTES' => $this->input->post('NOTES'), 
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->cash_receipt->addNewReceipt($parm);
        if($result['success'] > 0){
            $parm = array(
                'SERIAL' => $result['serial'] ,
                'TRANS_ID' => $this->input->post('TRANS_ID'),
                'TRANS_AMOUNT' => $this->input->post('TRANS_AMOUNT'),
                'TARGET_ACNT' => $this->input->post('TARGET_ACNT')
            );
            $result2 = $this->cash_receipt->addTransferInfo($parm);
        }
        echo json_encode($result2);
    }

    public function updateTransferReceipt() {
        $parm = array(
            'SERIAL' => $this->input->post('SERIAL'),
            'RECEIPT_DT' => $this->input->post('RECEIPT_DT'),
            'ACCOUNT' => $this->input->post('ACCOUNT'),
            'NOTES' => $this->input->post('NOTES')
        );

        $result = null;
        $recieptTransfers = json_decode($this->input->post('recieptTransfers'));
        if (count($recieptTransfers) > 0) {
            $result = $this->cash_receipt->updateReceipt($parm);
            if ($result['success'] > 0) {
                for ($i = 0; $i < count($recieptTransfers); $i++) {
                    $item = json_decode($recieptTransfers[$i]);
                    $this->cash_receipt->addTransferInfo(array(
                        'SERIAL' => $this->input->post('SERIAL'),
                        'TRANS_ID' => $item->TRANS_ID,
                        'TRANS_AMOUNT' => $item->TRANS_AMOUNT,
                        'TARGET_ACNT' => $item->TARGET_ACNT
                    ));
                }
            } else {
                $result = array('success' => $result['success'], 'msg' => $result['msg']);
            }
        } else {
            $result = array('success' => 0, 'msg' => 'يجب أن يحتوي السند على شيك واحد على الأقل');
        }
        echo json_encode($result);
    }

    public function addCheckReceipt() {
 if (!$this->user_sso->is_allowed_function('159')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }

        $parm = array(
            'RECEIPT_DT' => $this->input->post('RECEIPT_DT'),
            'TYPE' => 'C',
            'ACCOUNT' => $this->input->post('ACCOUNT'),
            'STATUS' => '0',
            'NOTES' => $this->input->post('NOTES'), 
            'USER' => $this->user_sso->getUserID()
        );
        $result = null;
        $cashRecieptChecks = json_decode($this->input->post('cashRecieptChecks'));
        if (count($cashRecieptChecks) > 0) {
            $result = $this->cash_receipt->addNewReceipt($parm);
            if ($result['serial'] > 0) {
                for ($i = 0; $i < count($cashRecieptChecks); $i++) {
                    $item = json_decode($cashRecieptChecks[$i]);
                    $result2 = $this->cash_receipt->addCheckInfo(array(
                        'RECEIPT_SR' => $result['serial'],
                        'CHECK_ID' => $item->CHECK_ID,
                        'CHECK_BANK' => $item->CHECK_BANK,
                        'CHECK_DT' => $item->CHECK_DT,
                        'DUE_DAYS' => $item->DUE_DAYS,
                        'CHECK_AMOUNT' => $item->CHECK_AMOUNT,
                        'OWNER_ACNT' => $this->input->post('ACCOUNT'),
                        'TARGET_ACNT' => $this->input->post('ACCOUNT')//$item->TARGET_ACNT
                    ));
                    if ($result2['success'] <= 0) {
                        $result = array('serial' => 0, 'success' => $result2['success'], 'msg' => $result2['msg']);
                    }
                }
            } else {
                $result = array('serial' => $result['serial'], 'success' => $result['success'], 'msg' => $result['msg']);
            }
        } else {
            $result = array('serial' => 0, 'success' => 0, 'msg' => 'يجب أن يحتوي السند على شيك واحد على الأقل');
        }

        echo json_encode($result);
    }

    public function updateCheckReceipt() {
        $parm = array(
            'SERIAL' => $this->input->post('SERIAL'),
            'RECEIPT_DT' => $this->input->post('RECEIPT_DT'),
            'ACCOUNT' => $this->input->post('ACCOUNT'),
            'NOTES' => $this->input->post('NOTES')
        );
        $result = null;
        $cashRecieptChecks = json_decode($this->input->post('cashRecieptChecks'));
        if (count($cashRecieptChecks) > 0) {
            $result = $this->cash_receipt->updateReceipt($parm);
            if ($result['success'] > 0) {
                for ($i = 0; $i < count($cashRecieptChecks); $i++) {
                    $item = json_decode($cashRecieptChecks[$i]);
                    $result2 = $this->cash_receipt->addCheckInfo(array(
                        'RECEIPT_SR' => $this->input->post('SERIAL'),
                        'CHECK_ID' => $item->CHECK_ID,
                        'CHECK_BANK' => $item->CHECK_BANK,
                        'CHECK_DT' => $item->CHECK_DT,
                        'DUE_DAYS' => $item->DUE_DAYS,
                        'CHECK_AMOUNT' => $item->CHECK_AMOUNT,
                        'OWNER_ACNT' => $this->input->post('ACCOUNT'),
                        'TARGET_ACNT' => $this->input->post('ACCOUNT')//$item->TARGET_ACNT
                    ));
                    if ($result2['success'] <= 0) {
                        $result = array('serial' => 0, 'success' => $result2['success'], 'msg' => $result2['msg']);
                    }
                }
            } else {
                $result = array('success' => $result['success'], 'msg' => $result['msg']);
            }
        } else {
            $result = array('success' => 0, 'msg' => 'يجب أن يحتوي السند على شيك واحد على الأقل');
        }

        echo json_encode($result);
    }

    public function approveReceipt() {
        if (!$this->user_sso->is_allowed_function('36')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'SERIAL' => $this->input->post('SERIAL'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->cash_receipt->approveReceipt($parm);
        echo json_encode($result);
    }
    
    public function SMSNotification(){
        $RSERIAL = $this->input->post('RECEIPT_SR');
        $sms_info = $this->cash_receipt->getSMSNotice($RSERIAL);
        if(!empty($sms_info)){
            $acc_username = "DistPetrol4rasel";
            $acc_password = md5("13682095") ; 
            $sender = "MofPetrol" ; 
            foreach($sms_info['receivers'] as $receiver){
                $url = "http://rasel.eapp.gov.ps/getway/c_api/send/".$acc_username."/".$acc_password."/".$sender."/sms/".$receiver['AGENT_MOBILE']."/PETROL/".urlencode($sms_info['sms_txt']) ;
                $jsonString = json_decode(file_get_contents($url));
            }
        }
    }

    public function returnReceipt() {
        if (!$this->user_sso->is_allowed_function('38')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'SERIAL' => $this->input->post('SERIAL'),
            'USER' => ''
        );
        $result = $this->cash_receipt->returnReceipt($parm);
        echo json_encode($result);
    }

    public function cancelReceipt() {
        if (!$this->user_sso->is_allowed_function('37')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'SERIAL' => $this->input->post('SERIAL'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->cash_receipt->cancelReceipt($parm);
        echo json_encode($result);
    }

    public function cashTransferReceipts() {

         if (!$this->user_sso->is_allowed_function('32')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'سند قبض حوالة';
        $data['username'] = $this->user_sso->getUserName();
        $data['accounts'] = $this->constants->getAccounts(1);
        $data['bankAccounts'] = $this->constants->getAccounts(2);
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('cashReceipts/cashReceiptsDoc', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function manageTransferReceipts() {
        $data['view_title'] = 'سند قبض شيك';
        $data['username'] = $this->user_sso->getUserName();
        $data['accounts'] = $this->constants->getAccounts(1);
        $data['bankAccounts'] = $this->constants->getAccounts(2);
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('cashReceipts/manageTransferReceipts', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function cashCheckReceipts() {

        if (!$this->user_sso->is_allowed_function('33')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'سند قبض شيك';
        $data['username'] = $this->user_sso->getUserName();
        $data['banks'] = $this->constants->getBanks();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('cashReceipts/cashReceiptsCheck', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function manageCheckReceipts() {

         if (!$this->user_sso->is_allowed_function('35')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'سند قبض شيك';
        $data['username'] = $this->user_sso->getUserName();
        $data['accounts'] = $this->constants->getAccounts(1);
        $data['F_RCPT_SR'] = $this->input->post('F_RCPT_SR');
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('cashReceipts/manageCheckReceipts', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function receiptsMaster() {
        if (!$this->user_sso->is_allowed_function('34')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'إدارة سندات القبض';
        $data['username'] = $this->user_sso->getUserName();
        $data['accounts'] = $this->constants->getAccounts(1);
        $data['allowedToApprove'] = $this->user_sso->is_allowed_function('36'); 
        $data['allowedToCancel'] = $this->user_sso->is_allowed_function('37'); 
        $data['allowedToReturn'] = $this->user_sso->is_allowed_function('38'); 
        $data['allowedToPrint'] = $this->user_sso->is_allowed_function('207'); 
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('cashReceipts/receiptsMaster', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function getReceipts() {
         if (!$this->user_sso->is_allowed_function('34')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'RCPT_SR' => $this->input->post('RCPT_SR'),
            'RCPT_STATUS' => $this->input->post('RCPT_STATUS'),
            'RCPT_TYPE' =>  $this->input->post('RCPT_TYPE'),
            'DOC_ID' =>  $this->input->post('DOC_ID'),
            'START_DT' => $this->input->post('START_DT'),
            'END_DT' => $this->input->post('END_DT'),
            'COM_ACCOUNT' => $this->input->post('COM_ACCOUNT'),
            'START_REC' => $this->input->post('START_REC'),
            'LAST_REC' => $this->input->post('LAST_REC') 
        );
        $receipts = $this->cash_receipt->getReceipts($parm);
        echo json_encode($receipts);
    }
    
    public function paidChecks() {
        if (!$this->user_sso->is_allowed_function('34')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'الشيكات المدفوعة';
        $data['username'] = $this->user_sso->getUserName();
        $data['banks'] = $this->constants->getBanks();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('cashReceipts/paidChecks', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function getPaidChecks() {
         if (!$this->user_sso->is_allowed_function('34')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'RECP_SERIAL' => $this->input->post('RECP_SERIAL'),
            'CHECK_ID' => $this->input->post('CHECK_ID'),
            'COM_ACCOUNT' => $this->input->post('COM_ACCOUNT'),
            'CHECK_BANK' =>  $this->input->post('CHECK_BANK'),
            'DOC_TYPE' => $this->input->post('DOC_TYPE') ,
            'START_DT' => $this->input->post('START_DT'),
            'END_DT' => $this->input->post('END_DT')
        );
        $checks = $this->cash_receipt->getPaidChecksList($parm);
        echo json_encode($checks);
    }
/*
    public function getAccounts() {
        $parm = array(
            'RCPT_SR' => $this->input->post('RCPT_SR'),
            'RCPT_STATUS' => $this->input->post('RCPT_STATUS'),
            'RCPT_TYPE' =>  $this->input->post('RCPT_TYPE'),
            'START_DT' => $this->input->post('START_DT'),
            'END_DT' => $this->input->post('END_DT'),
            'COM_ACCOUNT' => $this->input->post('COM_ACCOUNT'),
            'START_REC' => $this->input->post('START_REC'),
            'LAST_REC' => $this->input->post('LAST_REC') 
        );
        $receipts = $this->cash_receipt->getReceipts($parm);
        echo json_encode($receipts);
    }
*/
    public function getReceipt() {

         if (!$this->user_sso->is_allowed_function('34')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'RCPT_SR' => $this->input->post('RCPT_SR')
        );
        $receiptMaster = $this->cash_receipt->getReceipt($parm);
        $receiptDetails = null;
        
        if(!empty($receiptMaster) && $receiptMaster['CASH_RECEIPT_TYPE'] == 'C'){
            $receiptDetails = $this->cash_receipt->getCheckReceiptDetails($parm);
        }else if(!empty($receiptMaster) && $receiptMaster['CASH_RECEIPT_TYPE'] == 'T'){
            $receiptDetails = $this->cash_receipt->getTransterReceiptDetails($parm);
        }
        echo json_encode(array('receiptMaster' => $receiptMaster, 'receiptDetails' => $receiptDetails));
    }


    public function getAccount() {
        $parm = array(
            'ACCOUNT_ID' => $this->input->post('ACCOUNT_ID')
        );
        $account = $this->cash_receipt->getAccount($parm);
        echo json_encode($account);
    }

    public function getBank() {
        $parm = array(
            'BANK_ID' => $this->input->post('BANK_ID')
        );
        $bank = $this->cash_receipt->getBank($parm);
        echo json_encode($bank);
    }



    public function manageChecks() {

        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'إدارة الشيكات';
        $data['username'] = $this->user_sso->getUserName();
        $data['banks'] = $this->constants->getBanks();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('cashReceipts/manageChecks', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function GetChecksList() {
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CHECK_NO' => $this->input->post('CHECK_NO'),
            'CHECK_SDT' => $this->input->post('CHECK_SDT'),
            'CHECK_EDT' => $this->input->post('CHECK_EDT'),
            'RECEIPT_SDT' => $this->input->post('RECEIPT_SDT'),
            'RECEIPT_EDT' => $this->input->post('RECEIPT_EDT'),
            'CHECK_BANK' => $this->input->post('CHECK_BANK'),
            'OWNER_ACNT' => $this->input->post('OWNER_ACNT'),
            'COLLECT_STAT' => $this->input->post('COLLECT_STAT'),
            'ACCOUNT_CAT' => $this->input->post('ACCOUNT_CAT'),
        );
        $checkslist = $this->cash_receipt->getcheckslist($parm);
        echo json_encode($checkslist);
    }

    public function map_banks_account (){
        $checkslist = $this->cash_receipt->MAP_BANKS_ACCOUNTS($this->input->post('CHECK_BANK'));
        echo json_encode($checkslist);
    }

    public function SET_CHECK_COLLECTED() {
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CHECK_SR' => $this->input->post('CHECK_SR'),
            'COLLECT_DT' => $this->input->post('COLLECT_DT'),
            'BANK' => $this->input->post('BANK'),
            'USER' => $this->user_sso->getUserID()
        );
        $checkCollected = $this->cash_receipt->SET_CHECK_COLLECTED($parm);
        echo json_encode($checkCollected);
    }

    public function SET_CHECK_RETURNED() {
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CHECK_SR' => $this->input->post('CHECK_SR'),
            'RETURN_DT' => $this->input->post('RETURN_DT'),
            'USER' => $this->user_sso->getUserID()
        );
        $checkreturn = $this->cash_receipt->SET_CHECK_RETURNED($parm);
        echo json_encode($checkreturn);
    }

    public function WITHDRAW_CHECK() {
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CHECK_SR' => $this->input->post('CHECK_SR'),
            'WITHDRAW_DT' => $this->input->post('WITHDRAW_DT'),
            'USER' => $this->user_sso->getUserID()
        );
        $withdrawcheck = $this->cash_receipt->WITHDRAW_CHECK($parm);
        echo json_encode($withdrawcheck);
    }

    public function SET_CHECK_RETURNED_IN_BANK() {
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CHECK_SR' => $this->input->post('CHECK_SR'),
            'RETURN_DT' => $this->input->post('RETURN_DT'),
            'BANK' => $this->input->post('BANK'),
            'USER' => $this->user_sso->getUserID()
        );
        $checkreturnbank = $this->cash_receipt->SET_CHECK_RETURNED_IN_BANK($parm);
        echo json_encode($checkreturnbank);
    }

    public function SET_CHECK_UNCOLLECTED() {
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CHECK_SR' => $this->input->post('CHECK_SR'),
            'USER' => $this->user_sso->getUserID()
        );
        $checkuncollected = $this->cash_receipt->SET_CHECK_UNCOLLECTED($parm);
        echo json_encode($checkuncollected);
    }

    public function GetPayableChecks() {

        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'الشيكات الآجلة';
        $data['username'] = $this->user_sso->getUserName();
        $data['banks'] = $this->constants->getBanks();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('cashReceipts/PayableChecks', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function addBankTransferRecieptInfo() {
        $parm = array(
            'SERIAL' => $this->input->post('SERIAL'),
            'RECEIPT_DT' => $this->input->post('RECEIPT_DT'),
            'ACCOUNT' => $this->input->post('ACCOUNT'),
            'TRANS_ID' => $this->input->post('TRANS_ID'),
            'TRANS_AMOUNT' => $this->input->post('TRANS_AMOUNT'),
            'TARGET_ACNT' => $this->input->post('TARGET_ACNT'),
            'STATUS' => '1',
            'NOTES' => 'Some Notes Here.'
        );
        $result = $this->cash_receipt->addBankTransferRecieptInfo($parm);
        echo json_encode($result);
    }

    public function outgoingTransfer(){
        if (!$this->user_sso->is_allowed_function('271')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $transID = $this->input->post('p_TRANS_SR'); 
        $data['view_title'] = 'الحوالات الصادرة';
        $data['username'] = $this->user_sso->getUserName();
        //$data['banks'] = $this->cash_receipt->getInstituteBankAccounts(array('CURRENCY' => NULL, 'PARENT' => 4)); 
        if(empty($transID)){
            $data['transData'] = array('TRANS_SERIAL' => '',
                                'FROM_ACCOUNT' => '', 
                                'FROM_ACC_NAME' => '',
                                'FROM_ACC_VAL' => '',
                                'FROM_BALANCE' => '', 
                                'FROM_CURN_NAME' => '', 
                                'FROM_CURRENCY' => '', 
                                'TO_ACC_NAME' => '', 
                                'TO_ACC_VAL' => '', 
                                'TO_ACCOUNT' => '', 
                                'TO_CURN_NAME' => '', 
                                'TO_CURRENCY' => '', 
                                'TRANS_DT' => '', 
                                'TRANS_AMOUNT' => '', 
                                'EXCHANGE_RATE' => '',
                                'TRANS_SUBJECT' => ''
                            ); 
        } else {
            $transResult = $this->cash_receipt->getOutgoingTransfersList(array('TRANS_SR' => $transID, 'FROM_ACCOUNT' => '', 'TO_ACCOUNT' => '', 
                'FROM_DATE' => '', 'TO_DATE' => '', 'TRANS_STAT' => ''));
            $data['transData'] = $transResult[0]; 
        }
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('cashReceipts/outgoingTransfer', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function getInstituteBankAccounts(){
        $term = $this->input->post('TERM'); 
        $currency = $this->input->post('CURRENCY'); 
        $parent = $this->input->post('PARENT'); 
        echo(json_encode($this->cash_receipt->getInstituteBankAccounts(array('TERM' => $term, 'CURRENCY' => $currency , 'PARENT' => $parent)))) ; exit(); 
    }

    public function getOutgoingTransferDebtorAccounts(){
        $term = $this->input->post('TERM'); 
        echo(json_encode($this->cash_receipt->getOutgoingTransferDebtorAccounts($term))) ; exit(); 
    }

    public function addOutgoingTransfer(){
        if (!$this->user_sso->is_allowed_function('271')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $transSerial = $this->input->post('TRANS_SERIAL'); 
        $param = array(
            'TRANS_SERIAL'=> $transSerial, 
            'FROM_ACC'  => $this->input->post('FROM_ACC'),
            'FROM_CURR'  => $this->input->post('FROM_CURR'),
            'TO_ACC'    => $this->input->post('TO_ACC'),
            'TO_CURR'    => $this->input->post('TO_CURR'),
            'TRANS_AMOUNT'=> $this->input->post('TRANS_AMOUNT'),
            'TRANS_DT'  => $this->input->post('TRANS_DT'),
            'EXC_RATE'  => $this->input->post('EXC_RATE'),
            'TRANS_SUBJECT'=> $this->input->post('TRANS_SUBJECT'), 
            'USER'      => $this->user_sso->getUserID(),
        );
        if(empty($transSerial)){
            echo(json_encode($this->cash_receipt->addNewOutgoingTransfer($param))); exit();
        } else {
            echo(json_encode($this->cash_receipt->changeOutgoingTransfer($param))); exit();
        }
    }

    public function outgoingTransMaster(){
        if (!$this->user_sso->is_allowed_function('265')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'إدارة سندات الصرف';
        $data['username'] = $this->user_sso->getUserName();
        $data['banks'] = $this->cash_receipt->getInstituteBankAccounts(array('TERM'=>'', 'CURRENCY' => NULL, 'PARENT' => 4));  
        $data['allowedToCApprove'] = $this->user_sso->is_allowed_function('266'); 
        $data['allowedToFApprove'] = $this->user_sso->is_allowed_function('267'); 
        $data['allowedToReturnExch'] = $this->user_sso->is_allowed_function('274'); 
        //$data['allowedToMApprove'] = $this->user_sso->is_allowed_function('1'); 
        $data['allowedToApprove'] = $this->user_sso->is_allowed_function('273'); 
        $data['allowedToExchange'] = $this->user_sso->is_allowed_function('270'); 
        $data['allowedToCancel'] = $this->user_sso->is_allowed_function('268'); 
        $data['allowedToReturn'] = $this->user_sso->is_allowed_function('269'); 
        $data['allowedToEdit'] = $this->user_sso->is_allowed_function('271'); 
        $data['allowedToPrint'] = $this->user_sso->is_allowed_function('272'); 
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('cashReceipts/outgoingTransfersMaster', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function getOutgoingTransfersList(){
        if (!$this->user_sso->is_allowed_function('265')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $param = array(
                'TRANS_SR' => $this->input->post('TRANS_SR'),
                'FROM_ACCOUNT' => $this->input->post('FROM_ACCOUNT'),
                'TO_ACCOUNT' => $this->input->post('TO_ACCOUNT'),
                'FROM_DATE' => $this->input->post('FROM_DATE'),
                'TO_DATE' => $this->input->post('TO_DATE'),
                'TRANS_STAT' => $this->input->post('TRANS_STAT')
        ); 
        echo(json_encode($this->cash_receipt->getOutgoingTransfersList($param))); exit(); 
    }

    public function setExchangeRate(){
        if (!$this->user_sso->is_allowed_function('270')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $param = array(
                'TRANS_SERIAL' => $this->input->post('TRANS_SERIAL'),
                'EXC_RATE' => $this->input->post('EXC_RATE'), 
                'EXCHANGE_DATE' => $this->input->post('EXCHANGE_DATE'), 
                'USER'      => $this->user_sso->getUserID()
        ); 
        echo(json_encode($this->cash_receipt->setExchangeRate($param))); exit(); 
    }

    public function returnExchangedOutTransfer(){
        if (!$this->user_sso->is_allowed_function('273')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $param = array(
            'TRANS_SERIAL' => $this->input->post('TRANS_SERIAL'),
            'CHANGE_TYPE' => $this->input->post('TRANS_STATUS'),
            'USER'      => $this->user_sso->getUserID()
        ); 
        echo(json_encode($this->cash_receipt->changeOutgoingTransferStatus($param))); exit(); 
    }

    public function approveOutgoingTransfer(){
        if (!$this->user_sso->is_allowed_function('273')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $param = array(
                'TRANS_SERIAL' => $this->input->post('TRANS_SERIAL'),
                'USER'      => $this->user_sso->getUserID()
        ); 
        echo(json_encode($this->cash_receipt->approveOutgoingTransfer($param))); exit(); 
    }

    public function cancelOutgoingTransfer(){
        if (!$this->user_sso->is_allowed_function('268')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $param = array(
                'TRANS_SERIAL' => $this->input->post('TRANS_SERIAL'),
                'USER'      => $this->user_sso->getUserID()
        ); 
        echo(json_encode($this->cash_receipt->cancelOutgoingTransfer($param))); exit(); 
    }

    public function returnOutgoingTransfer(){
        if (!$this->user_sso->is_allowed_function('269')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $param = array(
                'TRANS_SERIAL' => $this->input->post('TRANS_SERIAL'),
                'USER'      => $this->user_sso->getUserID()
        ); 
        echo(json_encode($this->cash_receipt->returnOutgoingTransfer($param))); exit(); 
    }

    //public function changeOutgoingTransferStatus(){
    public function approveOutgoingTransferFinManager(){
        if (!$this->user_sso->is_allowed_function('267')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $param = array(
                'TRANS_SERIAL' => $this->input->post('TRANS_SERIAL'),
                'CHANGE_TYPE' => $this->input->post('TRANS_STATUS'),
                'USER'      => $this->user_sso->getUserID()
        ); 
        echo(json_encode($this->cash_receipt->changeOutgoingTransferStatus($param))); exit(); 
    }

    public function approveOutgoingTransferControler(){
        if (!$this->user_sso->is_allowed_function('266')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $param = array(
                'TRANS_SERIAL' => $this->input->post('TRANS_SERIAL'),
                'CHANGE_TYPE' => $this->input->post('TRANS_STATUS'),
                'USER'      => $this->user_sso->getUserID()
        ); 
        echo(json_encode($this->cash_receipt->changeOutgoingTransferStatus($param))); exit(); 
    }

}

?>
