<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class common extends CI_Controller {

    public function __construct() {
        parent::__construct();
        $this->load->model('constants');
        //$this->load->model('common');    
    }

    public function index() {
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = 'مستخدم النظام';
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('home', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function calendar() {
        $data['view_title'] = 'التقويم';
        $data['username'] = 'مستخدم النظام';
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('app_calendar', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function getBanks() {
        $results = $this->constants->getBanks();
        echo json_encode($results);
    }

    public function getCompanyByTerm() {
        $term = $this->input->post('TERM');
        $results = $this->constants->getCompanyByTerm($term);
        echo(json_encode($results));
    }

    public function getPetrolProductInfoByID() {
        $ID = $this->input->post('ID');
        $Info = $this->constants->getProductInfo($ID, NULL);
        echo(json_encode($Info));
        exit();
    }

    public function getCompaniesAccounts() {
        $term = $this->input->post('term');
        $Info = $this->constants->getOilandGazAccounts($term, NULL);
        echo(json_encode($Info));
        exit();
    }

    public function getCompanyInfo() {
        echo json_encode($this->constants->getCompanyInfo($this->input->post('term')));
    }

    public function getTransCompanys() {
        echo json_encode($this->constants->getCompanyInfo($this->input->post('term')));
    }

    public function getTesters() {
        echo json_encode($this->constants->getTesters($this->input->post('term')));
    }

    public function getFreightCars() {
        $parm = array(
            'TERM' => $this->input->post('TERM'),
            'OWNER' => $this->input->post('OWNER'),
            'CATEGORY' => $this->input->post('CATEGORY'),
            'IS_TRAILER' => $this->input->post('IS_TRAILER')
        );
        echo json_encode($this->constants->getFreightCars($parm));
    }

    public function getCarsByTerm() {
        $productCat = (($this->input->post('CATEGORY') == 3) || ($this->input->post('CATEGORY') == 5)) ? 3 : 2 ; 
        $parm = array(
            'TERM' => $this->input->post('TERM'),
            'CATEGORY' => $productCat
        );
        echo json_encode($this->constants->getCarsByTerm($parm));
    }

    public function getAccountsByTerm() {
        $parm = array(
            'TERM' => $this->input->post('TERM'),
            'PARENT_ACCOUNT' => $this->input->post('PARENT_ACCOUNT')
        );
        $accounts = $this->constants->getAccountsByTerm($parm);
        echo json_encode($accounts);
    }

    public function getAnyAccountsByTerm() {
        $parm = array(
            'TERM' => $this->input->post('TERM'),
            'PARENT_ACCOUNT' => $this->input->post('PARENT_ACCOUNT')
        );
        $accounts = $this->constants->getAnyAccountByTerm($parm);
        echo json_encode($accounts);
    }


    public function getAccountByValue() {
        $parm = array(
            'ACCOUNT_VALUE' => $this->input->post('ACCOUNT_VALUE')
        );
        $account = $this->constants->getAccountByValue($parm);
        echo json_encode($account);
    }

}

?>
