<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class consignments extends CI_Controller {

    public function __construct() {
        parent::__construct();

        $this->user_sso->validate_session();

        if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }

        $this->load->helper('date');
        $this->load->model('consignment');
        $this->load->model('constants');
    }

    public function index() {
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('home', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function outConsignmentMaster() {
        if (!$this->user_sso->is_allowed_function('20')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['allow_to_search'] = $this->user_sso->is_allowed_function('156');
        $data['allow_to_view'] = $this->user_sso->is_allowed_function('22'); // function 10
        $data['allow_to_approve'] = $this->user_sso->is_allowed_function('23') ; // function 20
        $data['allow_to_cancel'] = $this->user_sso->is_allowed_function('25') ; // function 30
        $data['allow_to_port_return'] = $this->user_sso->is_allowed_function('254') ;; 
        $data['view_title'] = '';
        $data['username'] = $this->user_sso->getUserName();
        //$data['accounts'] = $this->constants->getAccounts(1);
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('consignments/outConsignmentsMaster', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function outConsignment() {
        if (!$this->user_sso->is_allowed_function('21')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('warehouse');
        $data['view_title'] = '';
        $data['username'] = $this->user_sso->getUserName();
        //$data['accounts'] = $this->constants->getAccounts(1);
        //$data['bankAccounts'] = $this->constants->getAccounts(2);
        $data['products'] = $this->constants->getProductInfo();
        $data['out_cons_id'] = $this->consignment->getOotConsignemetSerial();
        $data['warehouses'] = $this->warehouse->getWarehousesList(); 
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('consignments/outConsignment', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function manageOutConsignment() {
        if (!$this->user_sso->is_allowed_function('22')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('warehouse');
        $data['F_CON_SR'] = $this->input->post('F_CON_SR');
        $data['warehouses'] = $this->warehouse->getWarehousesList();
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('consignments/manageOutConsignment', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function addOutConsignment() {
        if (!$this->user_sso->is_allowed_function('21')) {
            $result = array('success' => 0, 'msg' => 'لا يوجد لديك صلاحيات لهذه العملية.');
            echo json_encode($result);
            return;
        }
        $parm = array(
            'CON_ID' => $this->input->post('CON_ID'),
            'CON_DT' => $this->input->post('CON_DT'),
            'FUEL_TYPE' => $this->input->post('FUEL_TYPE'),
            'FUEL_AMOUNT' => $this->input->post('FUEL_AMOUNT'),
            'COMP_ACCOUNT' => $this->input->post('COMP_ACCOUNT'),
            'TRANS_COM' => $this->input->post('TRANS_COM'),
            'TRANS_TYPE' => $this->input->post('TRANS_TYPE'),
            'DRIVER' => $this->input->post('DRIVER'),
            'TESTER' => $this->input->post('TESTER'),
            'NOTES' => $this->input->post('NOTES'),
            'STATUS' => 0,
            'WAREHOUSE'=>$this->input->post('WAREHOUSE'),
            'INSERT_USER' => $this->user_sso->getUserID()
        );


        $result = null;
        $outConsignmentDetails = json_decode($this->input->post('outConsignmentDetails'));
        if (count($outConsignmentDetails) > 0) {
            $result = $this->consignment->addOutConsignment($parm);
            if ($result['success'] > 0) {
                for ($i = 0; $i < count($outConsignmentDetails); $i++) {
                    $item = json_decode($outConsignmentDetails[$i]);
                    $this->consignment->addOutConsignmentDetails(array(
                        'CON_SR' => $result['consignmentSID'],
                        'CAR_ID' => $item->CAR_ID,
                        'FUll_CELLS' => $item->FUll_CELLS,
                        'AMOUNT' => $item->AMOUNT
                    ));
                }
            } else {
                $result = array('success' => $result['success'], 'msg' => $result['msg']);
            }
        } else {
            $result = array('success' => 0, 'msg' => 'يجب أن تحتوي الارسالية على شاحنة واحدة على الأقل');
        }

        echo json_encode($result);
    }

    public function updateOutConsignment() {
        if (!$this->user_sso->is_allowed_function('157')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CON_SR' => $this->input->post('CON_SR'),
            'CON_ID' => $this->input->post('CON_ID'),
            'CON_DT' => $this->input->post('CON_DT'),
            'FUEL_TYPE' => $this->input->post('FUEL_TYPE'),
            'FUEL_AMOUNT' => $this->input->post('FUEL_AMOUNT'),
            'COMP_ACCOUNT' => $this->input->post('COMP_ACCOUNT'),
            'TRANS_COM' => $this->input->post('TRANS_COM'),
            'TRANS_TYPE' => $this->input->post('TRANS_TYPE'),
            'DRIVER' => $this->input->post('DRIVER'),
            'TESTER' => $this->input->post('TESTER'),
            'NOTES' => $this->input->post('NOTES'), 
            'USER' => $this->user_sso->getUserID(),
            'WAREHOUSE' => $this->input->post('WAREHOUSE')
        );
        $result = null;
        $outConsignmentDetails = json_decode($this->input->post('outConsignmentDetails'));
        if (count($outConsignmentDetails) > 0) {
            $result = $this->consignment->updateOutConsignment($parm);
            //var_dump($result); exit;
            if ($result['success'] > 0) {
                for ($i = 0; $i < count($outConsignmentDetails); $i++) {
                    $item = json_decode($outConsignmentDetails[$i]);
                    $this->consignment->addOutConsignmentDetails(array(
                        'CON_SR' => $this->input->post('CON_SR'),
                        'CAR_ID' => $item->CAR_ID,
                        'FUll_CELLS' => $item->FUll_CELLS,
                        'AMOUNT' => $item->AMOUNT
                    ));
                }
            } else {
                $result = array('success' => $result['success'], 'msg' => $result['msg']);
            }
        } else {
            $result = array('success' => 0, 'msg' => 'يجب أن تحتوي الارسالية على شاحنة واحدة على الأقل');
        }

        echo json_encode($result);
    }

    public function getOutConsignments() {
        if (!$this->user_sso->is_allowed_function('156')) {
           redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CON_ID' => $this->input->post('CON_ID'),
            'START_DT' => $this->input->post('START_DT'),
            'END_DT' => $this->input->post('END_DT'),
            'COMP_ACCOUNT' => $this->input->post('COMP_ACCOUNT'),
            'FUEL_TYPE' => $this->input->post('FUEL_TYPE'),
            'CAR_ID' => $this->input->post('CAR_ID'),
            'TRANS_TYPE' => $this->input->post('TRANS_TYPE'),
            'TESTER' => $this->input->post('TESTER'),
            'TRANS_COM' => $this->input->post('TRANS_COM'), 
            'STATUS' => $this->input->post('STATUS')
        );
        $outConsignments = $this->consignment->getOutConsignments($parm);
        echo json_encode($outConsignments);
    }

    public function getOutConsignment() {
        if (!$this->user_sso->is_allowed_function('22')) {
            echo json_encode(array('consignmentMaster' => null, 'consignmentDetails' => null));
            return;
        }
        $parm = array(
            'CON_SR' => $this->input->post('CON_SR')
        );
        $consignmentMaster = $this->consignment->getOutConsignment($parm);
        $consignmentDetails = $this->consignment->getOutConsignmentDetails($parm);

        echo json_encode(array('consignmentMaster' => $consignmentMaster, 'consignmentDetails' => $consignmentDetails));
    }

    public function approveOutConsignment() {
        if (!$this->user_sso->is_allowed_function('23')) {
            echo json_encode(array('success' => 0, 'msg' => 'لا يوجد لديك صلاحيات لهذه العملية.'));
            return;
        }
        $parm = array(
            'CON_SR' => $this->input->post('CON_SR'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->consignment->approveOutConsignment($parm);
        echo json_encode($result);
    }

    public function cancelOutConsignment() {
        if (!$this->user_sso->is_allowed_function('1')) {
            echo json_encode(array('success' => 0, 'msg' => 'لا يوجد لديك صلاحيات لهذه العملية.'));
            return;
        }
        $parm = array(
            'CON_SR' => $this->input->post('CON_SR'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->consignment->cancelOutConsignment($parm);
        echo json_encode($result);
    }

    public function returnOutConsignment() {
        if (!$this->user_sso->is_allowed_function('24')) {
            echo json_encode(array('success' => 0, 'msg' => 'لا يوجد لديك صلاحيات لهذه العملية.'));
            return;
        }
        $parm = array(
            'CON_SR' => $this->input->post('CON_SR'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->consignment->returnOutConsignment($parm);
        echo json_encode($result);
    }

    public function portReturnConsignment(){
        if (!$this->user_sso->is_allowed_function('254')) {
            echo json_encode(array('success' => 0, 'msg' => 'لا يوجد لديك صلاحيات لهذه العملية.'));
            return;
        }
        $parm = array(
            'CON_SR' => $this->input->post('CON_SR'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->consignment->portReturnConsignment($parm);
        echo json_encode($result);
    }

    public function inConsignmentForm() {
        if (!$this->user_sso->is_allowed_function('31')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('consignments/inConsignment.php', $data);
        $this->load->view('includes/footer.php', $data);
    }
    
    public function inConsignmentEgyptForm() {
        if (!$this->user_sso->is_allowed_function('30')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('warehouse');
        $data['username'] = $this->user_sso->getUserName();
        $data['warehouses'] = $this->warehouse->getWarehousesList(); 
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('consignments/inConsignmentEgypt.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function completeEgyptInConsignmentForm($id = 0) {
        if (!$this->user_sso->is_allowed_function('222')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $cid = ($id)? : $this->input->post('F_C_CON_SR');
        $consignment = $this->consignment->getInConsignmentInfo($cid, 2);
        //print_r($consignment );exit;
        $data['consignment'] = $consignment;
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('consignments/completeInConsignmentEgypt.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function completeEgyptInConsignment() {
        if (!$this->user_sso->is_allowed_function('222')) {
            echo(json_encode(array('success' => 0, 'msg' => 'لست مخول بالقيام بهذه العملية'))); 
            return;
        }
        $parm = array(
            "CON_SR" => $this->input->post('CON_SR'),
            "SUPLIER_ACC" => $this->input->post("SUPLIER_ACC") , 
            "FUEL_AMOUNT_TN" => $this->input->post("FUEL_AMOUNT_TN") , 
            "NOTES" => $this->input->post("NOTES"), 
            "USER" => $this->user_sso->getUserID(), 
        );
        $result = $this->consignment->complteEgyptInConsignement($parm);
        echo json_encode($result); exit() ;
    }

    public function addInConsignmentInfo() {
        if (!$this->user_sso->is_allowed_function('31')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $info = array(
            "BENEFICIARY" => $this->input->post("BENEFICIARY"),
            "IN_DATE" => $this->input->post("IN_DATE"),
            "FUEL_TYPE" => $this->input->post("FUEL_TYPE"),
            "FUEL_AMOUNT" => $this->input->post("FUEL_AMOUNT"),
            "SUPPLIER_COM" => $this->input->post("SUPPLIER_COM") 
        );
        $results = $this->consignment->addNewInConsignment($info);
        echo json_encode($results);
        exit();
    }
    
    public function addInEgyptConsignmentInfo() {
        if (!$this->user_sso->is_allowed_function('30')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $info = array(
            "SUPLIER_ACC" => $this->input->post("SUPLIER_ACC"),
            "OUT_DATE" => $this->input->post("OUT_DATE"),
            "FUEL_TYPE" => $this->input->post("FUEL_TYPE"),
            "IN_DATE" => $this->input->post("IN_DATE"),
            "FUEL_AMOUNT_TN" => $this->input->post("FUEL_AMOUNT_TN") , 
            "PAL_AMOUNT_TN" => $this->input->post("PAL_AMOUNT_TN") , 
            "FUEL_AMOUNT" => $this->input->post("FUEL_AMOUNT") , 
            "OUT_DATE" => $this->input->post("OUT_DATE") ,  
            "INVOICE_ID" => $this->input->post("INVOICE_ID") , 
            "BENEFICIARY_NO" => $this->input->post("BENEFICIARY_NO") , 
            "FRONT_CAR_ID" => $this->input->post("FRONT_CAR_ID") , 
            "BACK_CAR_ID" => $this->input->post("BACK_CAR_ID") , 
            "EGY_DRIVER" => $this->input->post("EGY_DRIVER") , 
            "WAREHOUSE_NO" => $this->input->post("WAREHOUSE_NO"),
            "SHIFT_SR" => $this->input->post("SHIFT_SR"),
            "NOTE" => $this->input->post("NOTES"), 
            "METER_READING_20" => $this->input->post("METER_READING_20") , 
            "METER_READING_NORMAL" => $this->input->post("METER_READING_NORMAL") , 
            "WITHDRAW_AMOUNT" => $this->input->post("WITHDRAW_AMOUNT") , 
            "FILTER_AMOUNT" => $this->input->post("FILTER_AMOUNT") , 
            "SAMPLES_AMOUNT" => $this->input->post("SAMPLES_AMOUNT") , 
            "AGREED_LACK_AMOUNT" => $this->input->post("AGREED_LACK_AMOUNT") , 
            "OLD_LACK_ALTER" => $this->input->post("OLD_LACK_ALTER") , 
            "OLD_LACK_INVOICE" => $this->input->post("OLD_LACK_INVOICE") , 
            "NEW_LACK_ALTER" => $this->input->post("NEW_LACK_ALTER") ,
            "NET_LACK_20" => $this->input->post("NET_LACK_20") ,  
            "NET_LACK_NORMAL" => $this->input->post("NET_LACK_NORMAL") ,  
            "METER_NO" => $this->input->post("METER_NO") , 
            "INSEPT_NOTES" => $this->input->post("INSEPT_NOTES") , 
            "USER" => $this->user_sso->getUserID()
        );
        $results = $this->consignment->addNewEgyptInConsignment($info);
        echo json_encode($results);
        exit();
    }
    
    public function inConsignmentsMaster() {
         if (!$this->user_sso->is_allowed_function('200')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['allow_to_complete'] = $this->user_sso->is_allowed_function('222');
        $data['allow_to_view'] = $this->user_sso->is_allowed_function('202'); // function 10
        $data['allow_to_review'] = $this->user_sso->is_allowed_function('286'); 
        $data['allow_to_approve'] = $this->user_sso->is_allowed_function('203') ; // function 20
        $data['allow_to_cancel'] = $this->user_sso->is_allowed_function('204') ; // function 30
        $data['allow_to_return'] = $this->user_sso->is_allowed_function('221') ; // function 30
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('consignments/inConsignmentsMaster.php', $data);
        $this->load->view('includes/footer.php', $data);
    }
    
    public function getInConsignmentsLst(){
        if (!$this->user_sso->is_allowed_function('201')) {
           redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CON_SR' => $this->input->post('CON_ID'),
            'START_DT' => $this->input->post('START_DT'),
            'END_DT' => $this->input->post('END_DT'),
            'IN_PORT' => $this->input->post('IN_PORT'),
            'FUEL_TYPE' => $this->input->post('FUEL_TYPE'),
            'STATUS' => $this->input->post('STATUS'), 
            'BILL_NO' => $this->input->post('BILL_NO')
        );
        $consignments = $this->consignment->getInConsignments($parm);
        echo json_encode($consignments); exit() ; 
    }
    
    public function manageInConsignment() {
        if (!$this->user_sso->is_allowed_function('202')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('warehouse');
        $data['allow_to_update'] = $this->user_sso->is_allowed_function('205'); 
        $data['F_CON_SR'] = $this->input->post('F_CON_SR');
        $data['warehouses'] = $this->warehouse->getWarehousesList(); 
        $port = $this->input->post('F_IN_PORT') ;
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        if($port == 1) $this->load->view('consignments/manageInConsignment', $data);
        if($port == 2) $this->load->view('consignments/manageEgyInConsignment', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function reviewEgyptInConsignmentData() {
        if (!$this->user_sso->is_allowed_function('286')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('warehouse');
        $data['allow_to_review'] = $this->user_sso->is_allowed_function('286'); 
        $data['F_CON_SR'] = $this->input->post('R_CON_SR');
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('consignments/reviewEgyInConsignment', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function reviewInConsignment(){
        if (!$this->user_sso->is_allowed_function('286')) {
            echo json_encode(array('success' => 0, 'msg' => 'لست مخول للقيام بهذا الإجراء')); 
            return;
        }
        $info = array(
            'CONSG_SERIAL' => $this->input->post('CON_SR'), 
            'USER' =>  $this->user_sso->getUserID()
        ); 
        $result = $this->consignment->reviewEgyptInConsignment($info);
        echo json_encode($result); exit() ;
    }
    
    public function getInConsignementInfo(){
        if (!$this->user_sso->is_allowed_function('201')) {
           redirect('/messages/disply_msg/1020/');
            return;
        }
        $result = $this->consignment->getInConsignmentInfo($this->input->post('CON_SR'), $this->input->post('PORT'));
        echo json_encode($result); exit() ; 
    }
    
    public function updateInConsignmentInfo(){
        if (!$this->user_sso->is_allowed_function('205')) {
           redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CON_SR' => $this->input->post('CON_SR'),
            'CON_DT' => $this->input->post('CON_DT'),
            'FUEL_TYPE' => $this->input->post('FUEL_TYPE'),
            'FUEL_AMOUNT' => $this->input->post('FUEL_AMOUNT'),
            'BENEFICIARY' => $this->input->post('BENEFICIARY'),
            'SUPPLIER' => $this->input->post('SUPPLIER')
        );
        $result = $this->consignment->updateInConsignementInfo($parm);
        echo json_encode($result); exit() ;
    }
    
    public function updateEgyInConsignmentInfo(){
        if (!$this->user_sso->is_allowed_function('205')) {
           redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            "CON_SR" => $this->input->post('CON_SR'),
            "SUPLIER_ACC" => $this->input->post("SUPLIER_ACC"),
            "OUT_DATE" => $this->input->post("OUT_DATE"),
            "FUEL_TYPE" => $this->input->post("FUEL_TYPE"),
            "IN_DATE" => $this->input->post("IN_DATE"),
            "FUEL_AMOUNT_TN" => $this->input->post("FUEL_AMOUNT_TN") , 
            "PAL_AMOUNT_TN" => $this->input->post("PAL_AMOUNT_TN") , 
            "FUEL_AMOUNT" => $this->input->post("FUEL_AMOUNT") , 
            "INVOICE_ID" => $this->input->post("INVOICE_ID") , 
            "BENEFICIARY_NO" => $this->input->post("BENEFICIARY_NO") , 
            "FRONT_CAR_ID" => $this->input->post("FRONT_CAR_ID") , 
            "BACK_CAR_ID" => $this->input->post("FRONT_CAR_ID") , 
            "DRIVER_NAME" => $this->input->post("DRIVER_NAME") , 
            "WAREHOUSE_NO" => $this->input->post("WAREHOUSE_NO") , 
            "SHIFT_SR" => $this->input->post("SHIFT_SR"),
            "NOTE" => $this->input->post("NOTES"), 
            "METER_READING_20" => $this->input->post("METER_READING_20") , 
            "METER_READING_NORMAL" => $this->input->post("METER_READING_NORMAL") , 
            "WITHDRAW_AMOUNT" => $this->input->post("WITHDRAW_AMOUNT") , 
            "FILTER_AMOUNT" => $this->input->post("FILTER_AMOUNT") , 
            "SAMPLES_AMOUNT" => $this->input->post("SAMPLES_AMOUNT") , 
            "AGREED_LACK_AMOUNT" => $this->input->post("AGREED_LACK_AMOUNT") , 
            "OLD_LACK_ALTER" => $this->input->post("OLD_LACK_ALTER") , 
            "OLD_LACK_INVOICE" => $this->input->post("OLD_LACK_INVOICE") , 
            "NEW_LACK_ALTER" => $this->input->post("NEW_LACK_ALTER") ,
            "NET_LACK_20" => $this->input->post("NET_LACK_20") ,  
            "NET_LACK_NORMAL" => $this->input->post("NET_LACK_NORMAL") ,  
            "METER_NO" => $this->input->post("METER_NO") , 
            "INSEPT_NOTES" => $this->input->post("INSEPT_NOTES") , 
            "USER" => $this->user_sso->getUserID()
        ); 
        $result = $this->consignment->updateEgyptInConsignementInfo($parm);
        echo json_encode($result); exit() ;
    }
    
    public function approveInConsignment(){
        if (!$this->user_sso->is_allowed_function('203')) {
           redirect('/messages/disply_msg/1020/');
            return;
        }
        $result = $this->consignment->approveInConignement($this->input->post('CON_SR'), $this->input->post("IN_PORT"), $this->user_sso->getUserID());
        echo json_encode($result); exit() ;
    }
    
    public function cancelInConsignment(){
        if (!$this->user_sso->is_allowed_function('204')) {
           redirect('/messages/disply_msg/1020/');
            return;
        }
        $result = $this->consignment->cancelInConignement($this->input->post('CON_SR'), $this->input->post("IN_PORT"), $this->user_sso->getUserID());
        echo json_encode($result); exit() ;
    }
    
    public function returneInConsignment(){
        if (!$this->user_sso->is_allowed_function('221')) {
           redirect('/messages/disply_msg/1020/');
            return;
        }
        $result = $this->consignment->returnInConignement($this->input->post('CON_SR'), $this->input->post("IN_PORT"), $this->user_sso->getUserID());
        echo json_encode($result); exit() ;
    }

    public function getAccount() {
        if (!$this->user_sso->is_allowed_function('1')) {
            echo json_encode(null);
            return;
        }
        $parm = array(
            'ACCOUNT_ID' => $this->input->post('ACCOUNT_ID')
        );
        $account = $this->cash_receipt->getAccount($parm);
        echo json_encode($account);
    }
    
    
     public function EgyptionPurchases() {
        if (!$this->user_sso->is_allowed_function('200')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['allow_to_search'] = $this->user_sso->is_allowed_function('201');
        $data['allow_to_view'] = $this->user_sso->is_allowed_function('202'); // function 10
        $data['allow_to_approve'] = $this->user_sso->is_allowed_function('203') ; // function 20
        $data['allow_to_cancel'] = $this->user_sso->is_allowed_function('204') ; // function 30
        $data['allow_to_return'] = $this->user_sso->is_allowed_function('203') ; // function 30
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('consignments/EgyptionPurchases.php', $data);
        $this->load->view('includes/footer.php', $data);
    }
    
    public function GetEgyptionPurchasesLst_Total(){
        if (!$this->user_sso->is_allowed_function('201')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'START_DT' => $this->input->post('START_DT'),
            'END_DT' => $this->input->post('END_DT'),
            'FUEL_TYPE' => $this->input->post('FUEL_TYPE'),
            'STATUS' => $this->input->post('STATUS'),
        );
        $consignments = $this->consignment->GetEgyptionPurchases_TOTALS($parm);
        echo json_encode($consignments);
        exit() ;
    }
    
    public function GetEgyptionPurchasesLst_Details(){
        if (!$this->user_sso->is_allowed_function('201')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'START_DT' => $this->input->post('START_DT'),
            'END_DT' => $this->input->post('END_DT'),
            'FUEL_TYPE' => $this->input->post('FUEL_TYPE'),
            'STATUS' => $this->input->post('STATUS'),
        );
        $consignments = $this->consignment->GetEgyptionPurchases_DETAILS($parm);
        echo json_encode($consignments);
        exit() ;
    }

    public function GetInLackAmounts(){
        if (!$this->user_sso->is_allowed_function('253')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('consignments/lackAmounts.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function getEgyLackAmounts(){
        if (!$this->user_sso->is_allowed_function('253')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'START_DT' => $this->input->post('START_DT'),
            'END_DT' => $this->input->post('END_DT'),
            'FUEL_TYPE' => $this->input->post('FUEL_TYPE')
        );
        $results = $this->consignment->GetEgyptionInConsgLackAmounts($parm);
        echo json_encode($results);
        exit() ;
    }

    public function rafahPortReports(){
        if (!$this->user_sso->is_allowed_function('253')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('consignments/rafahPortReports.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function getTotalOutProduct(){
        $parm = array(
            'p_PRODUCT_ID' => $this->input->post('p_PRODUCT_ID'),
            'p_START_DATE' => $this->input->post('p_START_DATE'),
            'p_END_DATE' => $this->input->post('p_END_DATE')
        );
        $results = $this->consignment->getTotalOutProductinPeriod($parm);
        echo json_encode($results);
        exit() ;
    }
    
}

?>
