<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class constant extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->load->helper('date');
        $this->load->model('constants');
          $this->user_sso->validate_session();

        if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }
    }

    public function index()
    {
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('home', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function Companies()
    {
         if (!$this->user_sso->is_allowed_function('57')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = '';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('constants/companies', $data);
        $this->load->view('includes/footer.php', $data);
    }


    public function Fuel()
    {

        if (!$this->user_sso->is_allowed_function('58')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = '';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('constants/fuel', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function  view_company(){

         if (!$this->user_sso->is_allowed_function('59')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = '';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('constants/view_company', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function  view_fuel(){
        if (!$this->user_sso->is_allowed_function('60')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'إدارة بيانات الوقود';
        $data['username'] = $this->user_sso->getUserName();
        $data['initApproval'] = $this->user_sso->is_allowed_function('219') ;
        $data['finalApproval'] = $this->user_sso->is_allowed_function('220') ;
        $data['allowToAdd'] = $this->user_sso->is_allowed_function('58') ;
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('constants/view_fuel', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function productPriceInitialApproval(){
        if (!$this->user_sso->is_allowed_function('219')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $info = array(
            'PRICE_SR' => $this->input->post('PRICE_SR'),
            'USER_ID' => $this->user_sso->getUserID()
        );
       echo(json_encode($this->constants->initProductPriceApproval($info))); exit();
    }

    public function addcompany() {

        if (!$this->user_sso->is_allowed_function('57')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm_company = array(
            'company_name' => $this->input->post('company_name'),
            'company_id' => $this->input->post('company_id'),
            'company_type' => $this->input->post('company_type')
        );
       $result = $this->constants->addcompany($parm_company);
       if($result['success'] == 1){
            $accounts = json_decode($this->input->post('accounts'));
            if (count($accounts) > 0) {
                   for ($i = 0; $i < count($accounts); $i++) {
                        $item = json_decode($accounts[$i]);
                       $accountval='0'.$item->parent_account_id.$item->account_value;
                       $this->constants->addaccount(array(
                            'company_id' => $this->input->post('company_id'),
                            'account_value' => $accountval,
                            'parent_account_id' => $item->parent_account_id,
                            'company_name' => $this->input->post('company_name')
                        ));
                    }
            }
        }
        echo json_encode($result);
    }


    public function  addfuel(){
        $parm = array(
            'FUEL_TYPE' => $this->input->post('FUEL_TYPE'),
            'buy_price' => $this->input->post('buy_price'),
            'sale_price' => $this->input->post('sale_price'),
            'market_price' => $this->input->post('market_price'),
            'differ_price' => $this->input->post('differ_price'),
            'start_date' => $this->input->post('start_date'),
            'end_date' => $this->input->post('end_date'), 
            'USER_ID' => $this->user_sso->getUserID()
        );
        $result = $this->constants->addfuel($parm);
        echo json_encode($result);
    }


    public function  view_company_action(){

         if (!$this->user_sso->is_allowed_function('59')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data=array(
            'company_id' => $this->input->post('company_id'),
            'company_type' => $this->input->post('company_type'),
            'parent_account' => $this->input->post('parent_account'),
        );
        $results = $this->constants->get_company($data);
        echo json_encode( $results);
    }

    public function  view_fuel_action(){
        if (!$this->user_sso->is_allowed_function('60')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data=array(
            'FUEL_TYPE' => $this->input->post('FUEL_TYPE'),
            'start_date' => $this->input->post('start_date'),
            'end_date' => $this->input->post('end_date'),
        );
        $results = $this->constants->get_fuel($data);
        echo json_encode( $results);
    }

    public function  validcompany(){
        $data=array(
            'company_id' => $this->input->post('ID')
        );
        $results = $this->constants->validcompany($data);
        echo json_encode( $results);
    }

    public function  delete_fuel_price(){
        $results = $this->constants->delete_fuel_price($this->input->post('fuel_id'));
        echo json_encode( $results);
    }

    public function get_product_buy_price(){
        $info = array(
            'PRODUCT' => $this->input->post('PRODUCT'),
            'OUT_DATE' => $this->input->post('OUT_DATE')
        );
        $results = $this->constants->get_product_buy_price($info);
        echo json_encode($results);
    }

    public function companyLimits(){
        if (!$this->user_sso->is_allowed_function('275')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'تسجيل بيانات سقف شركة';
        $data['username'] = $this->user_sso->getUserName();
        $limitSr = $this->input->post('p_LIMIT_SERIAL');
        $limitInfo[0] = array(
            'COM_FIN_NO' => '', 
            'COM_ACCOUNT' => '', 
            'COM_NAME' => '',
            'COM_LIMIT' => '',  
            'COM_RATIO' => '',  
            'PERIOD_STD' => '',  
            'PERIOD_EDD' => '',  
            'NOTES' => '',  
            'SERIAL_NO' => '',  

        );
        if(!empty($limitSr)){
            $limitInfo = $this->constants->getCompaniesLimitsInfo(array('LIMIT_SR'=>$limitSr, 'COM_ACCOUNT'=>null, 'PERIOD_START'=>null, 'PERIOD_END'=>null, 'STATUS'=>null)); 
        }
        $data['limitInfo'] = $limitInfo[0]; 
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('constants/comLimitsForm', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function saveCompanyLimitInfo(){
        if (!$this->user_sso->is_allowed_function('275')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $info = array(
            'COM_ACCOUNT' => $this->input->post('COM_ACCOUNT'), 
            'COMPANY_LIMIT' => $this->input->post('COMPANY_LIMIT'), 
            'COMPANY_RATIO' => $this->input->post('COMPANY_RATIO'), 
            'PERIOD_START' => $this->input->post('PERIOD_START'), 
            'PERIOD_END' => $this->input->post('PERIOD_END'), 
            'LIMIT_SERIAL' => $this->input->post('LIMIT_SERIAL'), 
            'NOTES' => $this->input->post('NOTES'), 
            'USER' => $this->user_sso->getUserID()
        );
        if(!empty($info['LIMIT_SERIAL'])){
            echo(json_encode($this->constants->editCompanyLimitInfo($info))); exit(); 
        }
        else {
            echo(json_encode($this->constants->addCompanyLimitInfo($info))); exit(); 
        }
    }

    public function comLimitsMaster(){
        if (!$this->user_sso->is_allowed_function('276')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'إدارة بيانات سقف الشركات';
        $data['username'] = $this->user_sso->getUserName();
        $data['allowedToEdit'] = $this->user_sso->is_allowed_function('275');
        $data['allowedToApprove'] = $this->user_sso->is_allowed_function('278');
        $data['allowedToCancel'] = $this->user_sso->is_allowed_function('279');
        $data['allowedToReturn'] = $this->user_sso->is_allowed_function('280');
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('constants/manageComLimits', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function getCompaniesLimitsData(){
        if (!$this->user_sso->is_allowed_function('276')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data = array(
            'LIMIT_SR'=>'', 
            'COM_ACCOUNT'=> $this->input->post('COM_ACCOUNT'), 
            'PERIOD_START'=> $this->input->post('LIMIT_START'), 
            'PERIOD_END'=> $this->input->post('LIMIT_END'), 
            'STATUS'=> $this->input->post('STATUS')
        );
        echo(json_encode($this->constants->getCompaniesLimitsInfo($data))); exit(); 
    }

    public function approveCompanyLimit(){
        if (!$this->user_sso->is_allowed_function('278')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data = array (
            'LIMIT_SERIAL' => $this->input->post('LIMIT_SR'), 
            'USER' => $this->user_sso->getUserID()
        );
        echo(json_encode($this->constants->approveCompanyLimit($data))); exit(); 
    }

    public function cancelCompanyLimit(){
        if (!$this->user_sso->is_allowed_function('279')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data = array (
            'LIMIT_SERIAL' => $this->input->post('LIMIT_SR'), 
            'USER' => $this->user_sso->getUserID()
        );
        echo(json_encode($this->constants->cancelCompanyLimit($data))); exit(); 
    }

    public function returnCompanyLimit(){
        if (!$this->user_sso->is_allowed_function('280')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data = array (
            'LIMIT_SERIAL' => $this->input->post('LIMIT_SR'), 
            'USER' => $this->user_sso->getUserID()
        );
        echo(json_encode($this->constants->returnCompanyLimit($data))); exit(); 
    }

    public function getEgyptianDriver(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $term = $this->input->post('TERM');
        echo(json_encode($this->constants->getEgyptianDriverByTerm($term))); exit(); 
    }

}


