<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');


class FControl extends CI_Controller {

    public function __construct() {
        parent::__construct();
        $this->user_sso->validate_session();

        if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }
    }

    public function index() {

        if (!$this->user_sso->is_allowed_function('167')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $data['view_title'] = '';
        $data['username'] = $this->user_sso->getUserName(); 
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('notices/noticesMaster.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function noticesMaster() {

        if (!$this->user_sso->is_allowed_function('218')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $data['view_title'] = 'الرقابة على الإشعارات الصادرة';
        $data['username'] = $this->user_sso->getUserName(); 
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('notices/noticesMaster.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function getNoticesList(){
        if (!$this->user_sso->is_allowed_function('218')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $this->load->model('notice');
        $ntype = $this->input->post('NOTICE_TYPE') ;
        $product = $category = NULL;
        if(!empty($ntype) && (($ntype == 2) || ($ntype == 3))){ $product = $this->input->post('PRODUCT') ;}
        else {$category = $this->input->post('PRODUCT') ;}
        $info = array(
                    'NOTICE_ID' => $this->input->post('NOTICE_ID'),
                    'START_DT' => $this->input->post('START_DT'),
                    'END_DT' => $this->input->post('END_DT'),
                    'COM_ACCOUNT' => $this->input->post('COMP_ACCOUNT'),
                    'N_TYPE' => $ntype,
                    'PRODUCT' => $product,
                    'CATEGORY' => $category,
                    'STATUS' => $this->input->post('STATUS')
                );
        $result = $this->notice->getIssuedNoticesList($info) ;
        echo(json_encode($result)) ; exit() ; 
    }

    function approveIssuedNotice(){
        if (!$this->user_sso->is_allowed_function('223')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $this->load->model('notice');
        $data = array(
            'NOTICE_ID' => $this->input->post('NOTICE_SR'),                 
            'USER_ID'   =>  $this->user_sso->getUserID()                 
        );
        $result = $this->notice->approveNotification($data) ;
        echo(json_encode($result)) ; exit() ; 
    }

    function returnIssuedNotice(){
        if (!$this->user_sso->is_allowed_function('223')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $this->load->model('notice');
        $data = array(
            'NOTICE_ID' => $this->input->post('NOTICE_SR'),                 
            'USER_ID'   =>  $this->user_sso->getUserID()                 
        );
        $result = $this->notice->returnNotification($data) ;
        echo(json_encode($result)) ; exit() ; 
    }

    public function productPriceFinalApproval(){
        if (!$this->user_sso->is_allowed_function('220')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('constants');
        $info = array(
            'PRICE_SR' => $this->input->post('PRICE_SR'),
            'USER_ID' => $this->user_sso->getUserID()
        );
       echo(json_encode($this->constants->finalProductPriceApproval($info))); exit();
    }

}