<?php 
if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Fees extends CI_Controller {

    public function __construct() {
        parent::__construct();
        $this->load->model('fees_model');
        $this->user_sso->validate_session();

        if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }
    }

    public function index()
    {   
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $data['view_title'] = 'إدارة تراخيص الشركات';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('license/licencesMaster.php', $data);
        $this->load->view('includes/footer.php', $data);     
    }

    public function payableFees(){
        if (!$this->user_sso->is_allowed_function('242')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $FEE_SR = $this->input->post('p_FEE_SR'); 
        if (!empty($FEE_SR)) {
            $info = array('FEE_SR'=>$FEE_SR, 'CLIENT_TYPE'=>'', 'CLIENT_ID'=>'', 'FEE_TYPE'=>'', 'MERIT_ST'=>'', 'MERIT_END'=>'', 'STATUS'=>'');
            $fee = $this->fees_model->getPayableFeesList($info);
            $data['fee_info'] = $fee[0]; 
            $data['form_action'] = 'UPDATE_FEE'; 
        } else {
            $data['fee_info'] = array('SERIAL_NO'=>'', 'CLIENT_TYPE'=>0, 'CLIENT_ID'=>'', 'FEE_TYPE'=>1, 'FEE_AMOUNT'=>'', 'MERIT_DT'=>'', 'CLIENT_NAME'=>'', 'FEE_NOTES'=>''); 
            $data['form_action'] = 'ADD_FEE'; 
        }        
        $data['view_title'] = 'نموذج إضافة بيانات رسوم تشغيلية ';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('fees/newFeesForm.php', $data);
        $this->load->view('includes/footer.php', $data);     
    }

    public function getDistributorByTerm(){
        echo(json_encode($this->fees_model->getDistributorInfo($this->input->post('term')))); exit();
    }

    public function addNewPayableFees(){
        $data = array(
            'CLIENT_TYPE'   =>  $this->input->post('CLIENT_TYPE'),
            'CLIENT_ID'     =>  $this->input->post('CLIENT_ID'),
            'FEE_TYPE'      =>  $this->input->post('FEE_TYPE'),
            'FEE_AMOUNT'    =>  $this->input->post('FEE_AMOUNT'),
            'MERIT_DT'      =>  $this->input->post('MERIT_DT'),
            'FEE_NOTES'     =>  $this->input->post('FEE_NOTES'),
            'USER_ID'       =>  $this->user_sso->getUserID(),
        );
        echo(json_encode($this->fees_model->addNewPayableFees($data))); exit();
    }

    public function payableFeesMaster(){
        if (!$this->user_sso->is_allowed_function('244')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 

        $data['allowedToEdit'] = $this->user_sso->is_allowed_function('242'); 
        $data['allowedToApprove'] = $this->user_sso->is_allowed_function('247'); 
        $data['allowedToCancel'] = $this->user_sso->is_allowed_function('248'); 
        $data['allowedToReturn'] = $this->user_sso->is_allowed_function('249'); 

        $data['view_title'] = 'إدارة  رسوم التشغيل';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('fees/feesMaster.php', $data);
        $this->load->view('includes/footer.php', $data);     
    }

    public function getPayableFees(){
        $info = array(
            'FEE_SR'        => '', 
            'CLIENT_TYPE'   => $this->input->post('CLIENT_TYPE'), 
            'CLIENT_ID'     => $this->input->post('CLIENT_ID'), 
            'FEE_TYPE'      => $this->input->post('FEE_TYPE'), 
            'MERIT_ST'      => $this->input->post('MERIT_ST'),
            'MERIT_END'     => $this->input->post('MERIT_END'),
            'STATUS'        => $this->input->post('STATUS')
        );
        echo(json_encode($this->fees_model->getPayableFeesList($info))); exit(); 
    }

    public function changePayableFees(){
        $data = array(
            'FEE_SERIAL'    =>  $this->input->post('FEE_SERIAL'), 
            'CLIENT_TYPE'   =>  $this->input->post('CLIENT_TYPE'),
            'CLIENT_ID'     =>  $this->input->post('CLIENT_ID'),
            'FEE_TYPE'      =>  $this->input->post('FEE_TYPE'),
            'FEE_AMOUNT'    =>  $this->input->post('FEE_AMOUNT'),
            'MERIT_DT'      =>  $this->input->post('MERIT_DT'),
            'FEE_NOTES'     =>  $this->input->post('FEE_NOTES'),
            'USER_ID'       =>  $this->user_sso->getUserID(),
        );
        echo(json_encode($this->fees_model->updatePayableFees($data))); exit();
    }

    public function approvePayableFees(){
        if (!$this->user_sso->is_allowed_function('247')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $fserial = $this->input->post('FEE_SERIAL'); 
        echo(json_encode($this->fees_model->approvePayableFees($fserial, $this->user_sso->getUserID()))); exit(); 
    }

    public function cancelPayableFees(){
        if (!$this->user_sso->is_allowed_function('248')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $fserial = $this->input->post('FEE_SERIAL'); 
        echo(json_encode($this->fees_model->cancelPayableFees($fserial, $this->user_sso->getUserID()))); exit(); 
    }

    public function returnPayableFees(){
        if (!$this->user_sso->is_allowed_function('249')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $fserial = $this->input->post('FEE_SERIAL'); 
        echo(json_encode($this->fees_model->returnPayableFees($fserial, $this->user_sso->getUserID()))); exit(); 
    }

    public function payments(){
        if (!$this->user_sso->is_allowed_function('243')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $PAYMENT_SR = $this->input->post('p_PAY_SR'); 
        if (!empty($PAYMENT_SR)) {
            $info = array('PAY_SR'=>$PAYMENT_SR, 'CLIENT_TYPE'=>'', 'CLIENT_ID'=>'', 'RECEIPT_TYPE'=>'', 'PAY_ST'=>'', 'PAY_END'=>'', 'STATUS'=>'', 'CHECK_STATE'=>null);
            $payment = $this->fees_model->getPaymentsList($info);
            $data['pay_info'] = $payment[0]; 
            $data['form_action'] = 'UPDATE_PAYMENT'; 
        } else {
            $data['pay_info'] = array('SERIAL_NO'=>'', 'CLIENT_TYPE'=>0, 'CLIENT_ID'=>'', 'RECEIPT_TYPE'=>'T', 'RECEIPT_ID'=>'', 
                                        'PAY_AMOUNT'=>'', 'PAY_DT'=>'', 'CLIENT_NAME'=>'', 'NOTES'=>'', 'PAY_BANK' => 128, 'CHECK_BANK'=> 1, 
                                        'CHECK_DATE_TXT'=>'', 'CURRENCY' => 2); 
            $data['form_action'] = 'ADD_PAYMENT'; 
        } 
        $data['banks'] = $this->fees_model->getInstituteBankAccounts($data['pay_info']['CURRENCY']);   
        $data['view_title'] = 'نموذج إضافة بيانات رسوم تشغيلية ';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('fees/paymentsForm.php', $data);
        $this->load->view('includes/footer.php', $data);     
    }

    public function getInstituteBankAccounts(){
        $currency = $this->input->post('CURRENCY'); 
        echo(json_encode($this->fees_model->getInstituteBankAccounts($currency))); exit(); 
    } 

    public function savePaymentInfo(){
        $data = array(
            'PAY_SERIAL'    =>  $this->input->post('PAY_SERIAL'), 
            'CLIENT_TYPE'   =>  $this->input->post('CLIENT_TYPE'),
            'CLIENT_ID'     =>  $this->input->post('CLIENT_ID'),
            'RECEIPT_TYPE'  =>  $this->input->post('RECEIPT_TYPE'),
            'RECEIPT_ID'    =>  $this->input->post('RECEIPT_ID'),
            'AMOUNT'        =>  $this->input->post('AMOUNT'),
            'CURRENCY'      =>  $this->input->post('CURRENCY'),
            'BANK'          =>  $this->input->post('BANK'),
            'PAYMENT_DT'    =>  $this->input->post('PAYMENT_DT'),
            'CHECK_BANK'    =>  $this->input->post('CHECK_BANK'),
            'CHECK_DATE'    =>  $this->input->post('CHECK_DATE'),
            'PAY_NOTES'     =>  $this->input->post('PAY_NOTES'),
            'USER_ID'       =>  $this->user_sso->getUserID(),
        );
        if($this->input->post('PAY_ACTION') == 'ADD_PAYMENT'){
            echo(json_encode($this->fees_model->addPayment($data))); exit();
        }
        elseif($this->input->post('PAY_ACTION') == 'UPDATE_PAYMENT') {
            echo(json_encode($this->fees_model->updatePayment($data))); exit();
        }
    }

    public function paymentsMaster(){
        if (!$this->user_sso->is_allowed_function('244')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 

        $data['allowedToEdit'] = $this->user_sso->is_allowed_function('243'); 
        $data['allowedToApprove'] = $this->user_sso->is_allowed_function('250'); 
        $data['allowedToCancel'] = $this->user_sso->is_allowed_function('252'); 
        $data['allowedToReturn'] = $this->user_sso->is_allowed_function('251'); 
        $data['allowedToDepositCheck'] = $this->user_sso->is_allowed_function('1'); 
        $data['allowedToCollectCheck'] = $this->user_sso->is_allowed_function('1'); 
        $data['allowedToReturnCheck'] = $this->user_sso->is_allowed_function('1'); 
        $data['allowedToTransIraadCheck'] = $this->user_sso->is_allowed_function('1'); 
        
        $data['view_title'] = 'إدارة  دفعات الرسوم المفروضة';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('fees/paymentsMaster.php', $data);
        $this->load->view('includes/footer.php', $data);     
    }

    public function getPaymentsList(){
        $check_status = ($this->input->post('RECEIPT_TYPE') == 'C') ? $this->input->post('STATUS') : null; 
        $info = array(
            'PAY_SR'        => '', 
            'CLIENT_TYPE'   => $this->input->post('CLIENT_TYPE'), 
            'CLIENT_ID'     => $this->input->post('CLIENT_ID'), 
            'RECEIPT_TYPE'  => $this->input->post('RECEIPT_TYPE'), 
            'PAY_ST'        => $this->input->post('PAY_ST'),
            'PAY_END'       => $this->input->post('PAY_END'),
            'STATUS'        => $this->input->post('STATUS'), 
            'CHECK_STATE'   => $this->input->post('CHECK_STATE')
        );
        echo(json_encode($this->fees_model->getPaymentsList($info))); exit(); 
    }

    public function approvePayment(){
        if (!$this->user_sso->is_allowed_function('250')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $pserial = $this->input->post('PAY_SERIAL'); 
        echo(json_encode($this->fees_model->approvePayment($pserial, $this->user_sso->getUserID()))); exit();
    }

    public function returnPayment(){
        if (!$this->user_sso->is_allowed_function('251')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $pserial = $this->input->post('PAY_SERIAL'); 
        echo(json_encode($this->fees_model->returnPayment($pserial, $this->user_sso->getUserID()))); exit();
    }

    public function cancelPayment(){
        if (!$this->user_sso->is_allowed_function('252')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $pserial = $this->input->post('PAY_SERIAL'); 
        echo(json_encode($this->fees_model->cancelPayment($pserial, $this->user_sso->getUserID()))); exit();
    }

    public function depositPaymentCheck(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $pserial = $this->input->post('PAY_SERIAL'); 
        $depositDate = $this->input->post('DEPOSIT_DT'); 
        $info = array('PAY_SERIAL' => $pserial, 'DEPOSIT_DATE' => $depositDate, 'USER' => $this->user_sso->getUserID()); 
        echo(json_encode($this->fees_model->depositPaymentInBank($info))); exit();
    }

    public function returnPaymentInBank(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $pserial = $this->input->post('PAY_SERIAL'); 
        $returnDate = $this->input->post('RETURN_DT'); 
        $info = array('PAY_SERIAL' => $pserial, 'RETURN_DATE' => $returnDate, 'USER' => $this->user_sso->getUserID()); 
        echo(json_encode($this->fees_model->returnPaymentInBank($info))); exit();
    }

    public function colleckPaymentCheck(){
        if (!$this->user_sso->is_allowed_function('282')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $pserial = $this->input->post('PAY_SERIAL'); 
        $collectDate = $this->input->post('COLLECT_DT'); 
        $info = array('PAY_SERIAL' => $pserial, 'COLLECT_DATE' => $collectDate, 'USER' => $this->user_sso->getUserID()); 
        echo(json_encode($this->fees_model->colleckPaymentCheck($info))); exit();
    }

    public function transformPayToIraad(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $info = array(
            'PAY_SERIAL' => $this->input->post('PAY_SERIAL'), 
            'TRANS_AMOUNT' => $this->input->post('TRANS_AMOUNT'), 
            'TRANS_DT' => $this->input->post('TRANS_DT'), 
            'USER' => $this->user_sso->getUserID()
        ); 
        echo(json_encode($this->fees_model->transformPayToIraad($info))); exit();
    }

    public function statements(){
        if (!$this->user_sso->is_allowed_function('246')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 

        $data['view_title'] = 'إستعلام حسابات رسوم التشغيل';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('statements/oparating_accounts_statements.php', $data);
        $this->load->view('includes/footer.php', $data); 
    }

    public function bankCommission(){
        if (!$this->user_sso->is_allowed_function('288')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $data['banks'] = $this->fees_model->getInstituteBankAccounts(); 
        $data['view_title'] = 'تسجيل العمولات البنكية';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('fees/bankCommissionForm.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function saveBankCommissionInfo(){
        if (!$this->user_sso->is_allowed_function('288')) {
            echo(json_encode(array('SUCCESS' => 0, 'MSG' => 'لست مخول للقيام بهذه العملية' )));
        } 
        $data = array(
            'COMS_BANK' => $this->input->post('COMS_BANK'), 
            'COMS_AMOUNT' => $this->input->post('COMS_AMOUNT'), 
            'COMS_CURRENCY' => $this->input->post('COMS_CURRENCY'), 
            'COMS_DATE' => $this->input->post('COMS_DATE'), 
            'COMS_NOTES' => $this->input->post('COMS_NOTES'), 
            'USER' => $this->user_sso->getUserID()
        );
        echo(json_encode($this->fees_model->addBankCommissionInfo($data))); exit();
    }

    public function bankCommissionsMaster(){
        if (!$this->user_sso->is_allowed_function('287')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $data['allowedToApprove'] = $this->user_sso->is_allowed_function('289'); 
        $data['allowedToCancel'] = $this->user_sso->is_allowed_function('291'); 
        $data['allowedToReturn'] = $this->user_sso->is_allowed_function('290'); 
        $data['banks'] = $this->fees_model->getInstituteBankAccounts(); 
        $data['view_title'] = 'إدارة العمولات البنكية';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('fees/bankCommissionMaster.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function getBankCommissionsList(){
        $parm = array(
            'COMMIS_SR' => $this->input->post('SERIAL'), 
            'COMMIS_BANK' => $this->input->post('BANK'), 
            'COMMIS_START' => $this->input->post('COMMIS_STD'), 
            'COMMIS_END' => $this->input->post('COMMIS_END'), 
            'COMMIS_STATUS' => $this->input->post('STATUS'), 
        ); 
        echo(json_encode($this->fees_model->getBankCommissionsList($parm))); exit();
    }

    public function approveCommission(){
        if (!$this->user_sso->is_allowed_function('289')) {
            echo(json_encode(array('SUCCESS' => 0, 'MSG' => 'لست مخول للقيام بهذه العملية' )));
        } 
        $parm = array(
            'COMMIS_SR' => $this->input->post('COM_SERIAL'), 
            'USER' => $this->user_sso->getUserID()
        ); 
        echo(json_encode($this->fees_model->approveCommission($parm))); exit();
    }

    public function cancelCommission(){
        if (!$this->user_sso->is_allowed_function('291')) {
            echo(json_encode(array('SUCCESS' => 0, 'MSG' => 'لست مخول للقيام بهذه العملية' )));
        } 
        $parm = array(
            'COMMIS_SR' => $this->input->post('COM_SERIAL'), 
            'USER' => $this->user_sso->getUserID()
        ); 
        echo(json_encode($this->fees_model->cancelCommission($parm))); exit();
    }

    public function returnCommission(){
        if (!$this->user_sso->is_allowed_function('290')) {
            echo(json_encode(array('SUCCESS' => 0, 'MSG' => 'لست مخول للقيام بهذه العملية' )));
        }
        $parm = array(
            'COMMIS_SR' => $this->input->post('COM_SERIAL'), 
            'USER' => $this->user_sso->getUserID()
        ); 
        echo(json_encode($this->fees_model->returnCommission($parm))); exit();
    }
}
