<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class guarantees extends CI_Controller {

    public function __construct() {
        parent::__construct();
         $this->user_sso->validate_session();

        if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }
        $this->load->model('guarantee');
        $this->load->model('constants');
        $this->load->helper('date');
        
    }

    public function index() {
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('home', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function guaranteesMaster() {  
         if (!$this->user_sso->is_allowed_function('46')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }

        $data['banks'] = $this->constants->getBanks();
        $data['username'] = $this->user_sso->getUserName();
        $data['allowedToEdit'] = $this->user_sso->is_allowed_function('47'); 
        $data['allowedToApprove'] = $this->user_sso->is_allowed_function('48'); 
        $data['allowedToCancel'] = $this->user_sso->is_allowed_function('44'); 
        $data['allowedToReturn'] = $this->user_sso->is_allowed_function('50');
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('guarantees/guaranteesMaster', $data);
        $this->load->view('includes/footer.php', $data);
    }

     public function guarantee() {
         if (!$this->user_sso->is_allowed_function('45')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['banks'] = $this->constants->getBanks();
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('guarantees/guarantee', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function manageGuarantee() {
         if (!$this->user_sso->is_allowed_function('47')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['banks'] = $this->constants->getBanks();
        $data['F_GUARANTEE_SID'] = $this->input->post('F_GUARANTEE_SID');
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('guarantees/manageGuarantee', $data);
        $this->load->view('includes/footer.php', $data);
    }
 

    public function addGuarantee() {
        if (!$this->user_sso->is_allowed_function('45')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'COMPANY' => $this->input->post('COMPANY'),
            'ACCOUNT' => $this->input->post('ACCOUNT'),
            'BANK' => $this->input->post('BANK'),
            'BANK_ACCOUNT' => $this->input->post('BANK_ACCOUNT'),
            'GUARANTEE_VALUE' => $this->input->post('GUARANTEE_VALUE'),
            'START_DATE' => $this->input->post('START_DATE'),
            'END_DATE' => $this->input->post('END_DATE'),
            'USER' => $this->user_sso->getUserID()
        );
        
        $result = $this->guarantee->addGuarantee($parm);
        echo json_encode($result);
    }


    public function updateGuarantee() {
        if (!$this->user_sso->is_allowed_function('47')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'GUARANTEE_SID' => $this->input->post('GUARANTEE_SID'),
            'COMPANY' => $this->input->post('COMPANY'),
            'ACCOUNT' => $this->input->post('ACCOUNT'),
            'BANK' => $this->input->post('BANK'),
            'BANK_ACCOUNT' => $this->input->post('BANK_ACCOUNT'),
            'GUARANTEE_VALUE' => $this->input->post('GUARANTEE_VALUE'),
            'START_DATE' => $this->input->post('START_DATE'),
            'END_DATE' => $this->input->post('END_DATE'),
            'USER' => $this->user_sso->getUserID()
        );
        
        $result = $this->guarantee->updateGuarantee($parm);
        echo json_encode($result);
    }


    public function getGuarantees() {
        $parm = array(
            'GUARANTEE_SID' => $this->input->post('GUARANTEE_SID'),
            'COMPANY' => $this->input->post('COMPANY'),
            'ACCOUNT' => $this->input->post('ACCOUNT'),
            'BANK' => $this->input->post('BANK'),
            'BANK_ACCOUNT' => $this->input->post('BANK_ACCOUNT'),
            'GUARANTEE_VALUE' => $this->input->post('GUARANTEE_VALUE'),
            'START_DATE' => $this->input->post('START_DATE'),
            'END_DATE' => $this->input->post('END_DATE'),
            'USER' => $this->user_sso->getUserID(),
            'STATUS' => $this->input->post('STATUS')
        );
        $result = $this->guarantee->getGuarantees($parm);
        echo json_encode($result); 
    }


    public function getGuarantee() {
        $parm = array(
            'GUARANTEE_SID' => $this->input->post('GUARANTEE_SID')
        );
        $result = $this->guarantee->getGuarantee($parm);
        echo json_encode($result); 
    }


    public function approveGuarantee() {
        if (!$this->user_sso->is_allowed_function('48')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'GUARANTEE_SID' => $this->input->post('GUARANTEE_SID'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->guarantee->approveGuarantee($parm);
        echo json_encode($result);
    }


    public function returnGuarantee() {
        if (!$this->user_sso->is_allowed_function('50')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
       $parm = array(
            'GUARANTEE_SID' => $this->input->post('GUARANTEE_SID'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->guarantee->returnGuarantee($parm);
        echo json_encode($result);
    }


    public function cancelGuarantee() {
        if (!$this->user_sso->is_allowed_function('49')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'GUARANTEE_SID' => $this->input->post('GUARANTEE_SID'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->guarantee->cancelGuarantee($parm);
        echo json_encode($result);
    }

    public function addBankTransferRecieptInfo() {
        $parm = array(
            'SERIAL' => $this->input->post('SERIAL'),
            'RECEIPT_DT' => $this->input->post('RECEIPT_DT'),
            'ACCOUNT' => $this->input->post('ACCOUNT'),
            'TRANS_ID' => $this->input->post('TRANS_ID'),
            'TRANS_AMOUNT' => $this->input->post('TRANS_AMOUNT'),
            'TARGET_ACNT' => $this->input->post('TARGET_ACNT'),
            'STATUS' => '1',
            'NOTES' => 'Some Notes Here.'
        );
        $result = $this->cash_receipt->addBankTransferRecieptInfo($parm);
        echo json_encode($result);
    }

}

?>
