<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');


class Notifications extends CI_Controller {

    public function __construct() {
        parent::__construct();
        $this->load->model('notice');
        $this->user_sso->validate_session();

        if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }
    }

    public function index() {
        if (!$this->user_sso->is_allowed_function('26')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $data['view_title'] = '';
        $data['username'] = $this->user_sso->getUserName();
        $data['allow_to_issue'] = $this->user_sso->is_allowed_function('167') ;
        $data['allow_to_delete'] = $this->user_sso->is_allowed_function('236') ;        
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('notices/notifications.php', $data);
        $this->load->view('includes/footer.php', $data);
    }
    
    public function getCompanyPurchasesTotals(){
        $notice_type = $this->input->post('NOTICE_TYPE') ; 
        $com_acc = $this->input->post('COMP_ACCOUNT') ; 
        $pro_cat = (($notice_type == 1) || ($notice_type == 4) || ($notice_type == 5) || ($notice_type == 6) || ($notice_type == 8)) ? $this->input->post('PRODUCT') : NULL ;
        $pro_no =  (($notice_type == 2) || ($notice_type == 3) || ($notice_type == 7)) ? $this->input->post('PRODUCT') : NULL ;
        $start_date = $this->input->post('START_DT') ; 
        $end_date = $this->input->post('END_DT') ; 
        $info = array('COMPANY_ACCOUNT' =>  $com_acc , 
                      'PRODUCT_CAT'     =>  $pro_cat , 
                      'PRODUCT_TYPE'    =>  $pro_no , 
                      'START_DATE'      =>  $start_date ,
                      'END_DATE'        =>  $end_date, 
                      'NOTICE_TYPE'     =>  $notice_type
                ); 
        $result = $this->notice->getTotalPurchases($info) ;
        echo(json_encode($result)) ; exit() ;        
    }
    
    public function issueNotification(){
        if (!$this->user_sso->is_allowed_function('167')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $copy = $this->input->post('P_COPY') ;  
        $info = array('START_DT'    => $this->input->post('P_START_DATE') , 
                      'END_DT'      => $this->input->post('P_END_DATE') ,
                      'COM_ACCOUNT' => $this->input->post('P_COM_ACC') ,
                      'CATEGORY'    => $this->input->post('P_PRODUCT_CAT') ,
                      'PRODUCT'     => $this->input->post('P_PRODUCT_TYPE') ,
                      'N_TYPE'      => $this->input->post('P_NOTICE_TYPE') ,
                      'OP_AMOUNT'   => 0 ,
                      'USER'        => $this->user_sso->getUserID()
            );
        if($info['N_TYPE'] == 1){
            $res = $this->issueTaxInvoice($info) ;
            echo(json_encode($res)) ; exit() ; 
        }
        elseif($info['N_TYPE'] == 2){
            $res = $this->issueSurplusNotice($info) ;
            echo(json_encode($res)) ; exit() ; 
        }
        elseif($info['N_TYPE'] == 3){
            $res = $this->issueLackNotice($info) ;
            echo(json_encode($res)) ; exit() ; 
        }
        elseif($info['N_TYPE'] == 4){
            $res = $this->issueTransNotice($info) ;
            echo(json_encode($res)) ; exit() ; 
        }elseif($info['N_TYPE'] == 5){
            $res = $this->issueOpFeeNotice($info) ;
            echo(json_encode($res)) ; exit() ; 
        }
        elseif($info['N_TYPE'] == 6){
            $res = $this->issueCashDiscountNotice($info) ;
            echo(json_encode($res)) ; exit() ; 
        }
        elseif($info['N_TYPE'] == 7){
            $res = $this->issueProductDifferencesNotice($info) ;
            echo(json_encode($res)) ; exit() ; 
        }
        elseif($info['N_TYPE'] == 8){
            $res = $this->issueScaleFeesNotice($info) ;
            echo(json_encode($res)) ; exit() ; 
        }
    }
    
    
    public function printNotification(){
        if (!$this->user_sso->is_allowed_function('26')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $pType = $this->input->post('P_PRODUCT_TYPE') ; 
        $pCat = $this->input->post('P_PRODUCT_CAT') ;  
        $this->load->helper('url') ;
        $info = array('START_DT'    => $this->input->post('P_START_DATE') , 
                      'END_DT'      => $this->input->post('P_END_DATE') ,
                      'COM_ACCOUNT' => $this->input->post('P_COM_ACC') ,
                      'CATEGORY'    => $pCat ,
                      'PRODUCT'     => $pType ,
                      'N_TYPE'      => $this->input->post('P_NOTICE_TYPE') ,
                      'USER'        => $this->user_sso->getUserID()
            );
        $res = $this->getNoticeSerialNo($info) ;
        //print($res); exit(); 
        if($info['N_TYPE'] == 1){
            if($pCat != 8){
                redirect('reports/printTaxInvoice/'.$res) ; exit() ;
            } else{
                redirect('reports/printInvoice/'.$res) ; exit() ;
            } 
        }
        elseif($info['N_TYPE'] == 2){
            redirect('reports/printSurplusNotice/'.$res) ; exit() ;
        }
        elseif($info['N_TYPE'] == 3){
            redirect('reports/printLackNotice/'.$res) ; exit() ;
        }
        elseif($info['N_TYPE'] == 4){
            redirect('reports/printTransNotice/'.$res) ; exit() ;
        }
        elseif($info['N_TYPE'] == 5){
            redirect('reports/printOperatingNotice/'.$res) ; exit() ;
        }
        elseif($info['N_TYPE'] == 6){
            redirect('reports/printCashNotice/'.$res) ; exit() ;
        }
        elseif($info['N_TYPE'] == 7){
            redirect('reports/printDiffNotice/'.$res) ; exit() ;
        }
        elseif($info['N_TYPE'] == 8){
            redirect('reports/printScaleFeeNotice/'.$res) ; exit() ;
        }
    }

    function printIssuedNotification(){
        $notice_type = $this->input->post('P_NOTICE_TYPE');
        $res = $this->input->post('P_NOTICE_ID');
        if($notice_type == 2){
            redirect('reports/printSurplusNotice/'.$res) ; exit() ;
        }
        elseif($notice_type == 3){
            redirect('reports/printLackNotice/'.$res) ; exit() ;
        }
        elseif($notice_type == 4){
            redirect('reports/printTransNotice/'.$res) ; exit() ;
        }
        elseif($notice_type == 5){
            redirect('reports/printOperatingNotice/'.$res) ; exit() ;
        }
        elseif($notice_type == 6){
            redirect('reports/printCashNotice/'.$res) ; exit() ;
        }
        elseif($notice_type == 7){
            redirect('reports/printDiffNotice/'.$res) ; exit() ;
        }
        elseif($notice_type == 8){
            redirect('reports/printScaleFeeNotice/'.$res) ; exit() ;
        }
    }
    
    private function issueTaxInvoice($info){
        return $this->notice->issueTaxInvoice($info) ; 
    }
    
    private function getNoticeSerialNo($info){
        $notice_list = $this->notice->getNotificationsList($info) ;
        $last_notice = end($notice_list['notice_list']) ;
        return $last_notice['SERIAL_NO'] ;
    } 
    
    private  function issueTransNotice($info){
        return $this->notice->issueTransNotice($info) ;
    }
    
    private function issueSurplusNotice($info){
        return $this->notice->issueSurplusNotice($info) ;
    }
    
    private function issueLackNotice($info){
        return $this->notice->issueLackNotice($info) ;
    }
    
    private function issueOpFeeNotice($info){
        return $this->notice->issueOpFeeNotice($info) ;
    }

    private function issueCashDiscountNotice($info){
        return $this->notice->issueCashNotice($info) ;
    }

    function issueProductDifferencesNotice($info){
        return $this->notice->issueDifferencesNotice($info) ;
    }

    function issueScaleFeesNotice($info){
        return $this->notice->issueScaleFeesNotice($info) ;
    }

    public function getNoticeInfo(){
        $pType = $this->input->post('P_PRODUCT_TYPE') ; 
        $pCat = $this->input->post('P_PRODUCT_CAT') ;  
        $info = array('START_DT'    => $this->input->post('P_START_DATE') , 
                      'END_DT'      => $this->input->post('P_END_DATE') ,
                      'COM_ACCOUNT' => $this->input->post('P_COM_ACC') ,
                      'CATEGORY'    => $pCat ,
                      'PRODUCT'     => $pType ,
                      'N_TYPE'       => $this->input->post('P_NOTICE_TYPE') 
        );
        $notice = $this->notice->getNotificationsList($info) ;
        echo(json_encode($notice['notice_list'][0])) ; exit() ; 
    }

    public function deleteNotification(){
        if (!$this->user_sso->is_allowed_function('236')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $info = array('SERIAL_NO'   => $this->input->post('SERIAL_NO') , 
                      'DEL_NOTE'    => $this->input->post('DEL_NOTE') ,
                      'USER'        => $this->user_sso->getUserID()
        );
        echo(json_encode($this->notice->deleteNotification($info))) ; exit() ; 
    }

    public function calculateCashDiscNotice(){ 
        $com_acc = $this->input->post('COM_ACC') ; 
        $pro_cat = $this->input->post('PRODUCT_CAT') ;
        $start_date = $this->input->post('START_DATE') ; 
        $end_date = $this->input->post('END_DATE') ; 
        $info = array('COMPANY_ACCOUNT' =>  $com_acc , 
                      'PRODUCT_CAT'     =>  $pro_cat , 
                      'START_DATE'      =>  $start_date ,
                      'END_DATE'        =>  $end_date
        ); 
        $result = $this->notice->getCashDiscAccountStatment($info) ;
        echo(json_encode($result)) ; exit() ;   
    }
}