<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Order extends CI_Controller {

    public function __construct() {
        parent::__construct();
        $this->user_sso->validate_session();
        if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }
        $this->load->model('orders');
		
		
		if (! function_exists('array_column')) {
    function array_column(array $input, $columnKey, $indexKey = null) {
        $array = array();
        foreach ($input as $value) {
            if ( !array_key_exists($columnKey, $value)) {
                trigger_error("Key \"$columnKey\" does not exist in array");
                return false;
            }
            if (is_null($indexKey)) {
                $array[] = $value[$columnKey];
            }
            else {
                if ( !array_key_exists($indexKey, $value)) {
                    trigger_error("Key \"$indexKey\" does not exist in array");
                    return false;
                }
                if ( ! is_scalar($value[$indexKey])) {
                    trigger_error("Key \"$indexKey\" does not contain scalar value");
                    return false;
                }
                $array[$value[$indexKey]] = $value[$columnKey];
            }
        }
        return $array;
    }
}
    }
    
    
    public function getOrdersMaster() {
        if (!$this->user_sso->is_allowed_function('209')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'FROM_DATE' => $this->input->post('FROM_DATE'),
            'TO_DATE' => $this->input->post('TO_DATE'),
            'ORDER_TYPE' => $this->input->post('ORDER_TYPE'),
            'MASTER_STATUS' => $this->input->post('MASTER_STATUS'),
            'MASTER_FLAG' => $this->input->post('MASTER_FLAG')
        );
        $info = $this->orders->getOrdersMaster($parm);
        echo json_encode($info);
    }

    

	  public function get_defered_checks_list() {
         if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'I_ACCOUNT' => $this->input->post('I_ACCOUNT'),
            'I_TO_DATE' => $this->input->post('I_TO_DATE'),
        );
        $info = $this->orders->getDeferedChecksList($parm);
        $table="";
        $check_val = 0;
        foreach($info as $info){
            $check_val=$check_val+$info['CHECK_VALUE'];
			$table= $table .
			"<tr><td>{$info['CHECK_ID']}</td><td>{$info['PAID_DATE']}</td><td>{$info['CHECK_DATE']}</td><td>{$info['DUE_PERIODE']}</td><td>{$info['ACTIVE_DATE']}</td><td>{$info['CHECK_VALUE']}</td></tr>";  

        }
        $table=$table."<tr> <td colspan='4'>&nbsp; &nbsp; </td><td style='background-color: darkseagreen;'>المجموع:</td><td style='background-color: darkseagreen;'>".$check_val."</td></tr>";
        echo $table;
    }

	public function partiallyExecute() {
        if (!$this->user_sso->is_allowed_function('212')) {
            $result = array('success' => 0, 'msg' => 'لا يوجد لديك صلاحيات لهذه العملية.');
            echo json_encode($result);
            return;
        }
        $parm = array(
            'ORDER_DATE' => $this->input->post('ORDER_DATE'),
            'ORDER_TYPE' => $this->input->post('ORDER_TYPE'),
            'MASTER_STATUS' => 2,
            'MASTER_FLAG' => 0,
			'USER_ID' => ''
        );
        $info = $this->orders->saveOrdersMaster($parm);
        echo json_encode($info);
    }
	
	//  
	public function sendOrderToport() {
		 if (!$this->user_sso->is_allowed_function('213')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
       
		
        $parm = array(
            'MASTER_ID' => $this->input->post('MASTER_ID'),
			'USER_ID' => ''
			// 'USER_ID' => $this->user_sso->getUserID()
        );
        $info = $this->orders->sendOrderToport($parm);
        echo json_encode($info);
    }
	
	
	public function totallyExecute() {
        if (!$this->user_sso->is_allowed_function('211')) {
            $result = array('success' => 0, 'msg' => 'لا يوجد لديك صلاحيات لهذه العملية.');
            echo json_encode($result);
            return;
        }
        $parm = array(
            'ORDER_DATE' => $this->input->post('ORDER_DATE'),
            'ORDER_TYPE' => $this->input->post('ORDER_TYPE'),
            'MASTER_STATUS' => 1,
            'MASTER_FLAG' => 1,
			'USER_ID' => ''
        );
        $info = $this->orders->saveOrdersMaster($parm);
        echo json_encode($info);
    }

    public function approveOrder(){
        if (!$this->user_sso->is_allowed_function('216')) {
            $result = array('success' => 0, 'msg' => 'لا يوجد لديك صلاحيات لهذه العملية.');
            echo json_encode($result);
            return;
        }
        $parm = array(
            'ORDER_ID' => $this->input->post('MASTER_ID'),
            'USER_ID' => $this->user_sso->getUserID()
        );
        $info = $this->orders->approveOrder($parm);
        echo json_encode($info);
    }
    
    public function saveOrder() {
        if (!$this->user_sso->is_allowed_function('217')) {
            $result = array('success' => 0, 'msg' => 'لا يوجد لديك صلاحيات لهذه العملية.');
            echo json_encode($result);
            return;
        }
        $orderInfo = json_decode($this->input->post('orderInfo'), true);
        $fuelDetails = json_decode($this->input->post('fuelDetails'), true);

		
		
        $parm = array(
            'ORDER_ID' => $orderInfo['ORDER_ID'],
            'ORDER_DATE' => $orderInfo['ORDER_DATE'],
            'ORDER_TYPE' => $orderInfo['ORDER_TYPE'],
            'ACCOUNT_ID' => $orderInfo['ACCOUNT_ID'],
			'I_Todayck' => $orderInfo['I_Todayck'],
			'I_ACC_BALANCE' =>	$orderInfo['I_ACC_BALANCE'],
			'I_CHECKS'      =>	$orderInfo['I_CHECKS'],
			'I_GURANTEES'   =>	$orderInfo['I_GURANTEES'],
			'I_ORDER_PRICE' =>	$orderInfo['I_ORDER_PRICE'],
			'I_OLD_ORDERS'  =>	$orderInfo['I_OLD_ORDERS'],
			'I_TOTAL_BALANCE' => $orderInfo['I_TOTAL_BALANCE'],
			'GROUP_NO' => '',
            'RANK_NO' => 0 , //$orderInfo['RANK_NO'],
            'USER_ID' => $this->user_sso->getUserID(),

        );
        $result = $this->orders->saveOrderInfo($parm);
        if($result['orderId'] > 0) {
           for ($i = 0; $i < count($fuelDetails); $i++) {
               $item = json_decode($fuelDetails[$i]);
               $saveFuleResults = $this->orders->saveOrderFuelInfo(array(
                    'ORDER_ID' => $result['orderId'],
                    'PRODUCT_TYPE' => $item->FUEL_SERIAL,
                    'ORDERED_AMOUNT' => $item->FUEL_AMOUNT,
                    'APPROVED_AMOUNT' => $item->APPROVED_AMOUNT,
                    'PRODUCT_PRICE' => $item->PRODUCT_PRICE,
                    'RECEIVED_AMOUNT' => $item->RECEIVED_AMOUNT,
                    'RECEIVE_STATUS' => $item->RECEIVE_STATUS,
                    'USER_ID' => $this->user_sso->getUserID(),
                ));
           } 
        }
        echo json_encode($result);
        return;
    }

    public function index() {
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar.php', $data);
        $this->load->view('orders/new_rafah_order.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function new_order() { //old code
        $data['view_title'] = '';
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar.php', $data);
        $this->load->view('new_order.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function initPetrolOrder1() {
        if (!$this->user_sso->is_allowed_function('210')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('orders/initOrders', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function initPetrolOrder() {
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['username'] = $this->user_sso->getUserName();
        $data['ORDER_DATE'] = $this->input->post('F_ORDER_DATE');
        $data['ORDER_TYPE'] = $this->input->post('F_ORDER_TYPE');
        $TODAY_ORDER = $this->input->post('F_TODAY_ORDER') ;
        $data['TODAY_ORDER'] = $TODAY_ORDER ;
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('orders/initOrders', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function getCompaniesFinancialInfo() {
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'ORDER_DATE' => $this->input->post('ORDER_DT'),
            'FULE_CAT' => $this->input->post('ORDER_TYPE'),
            'USER_ID' => $this->user_sso->getUserID()
        );
        $info = $this->orders->getCompaniesInfoForPetrolOrder($parm);
        if ($info['ORDER_SR'] != -1) {
            echo json_encode($info['DATA']);
        } else {
            echo json_encode($info);
        }
    }

    public function ordersMaster() {
        if (!$this->user_sso->is_allowed_function('208')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['allow_to_search'] = $this->user_sso->is_allowed_function('201');
        $data['allow_to_view'] = $this->user_sso->is_allowed_function('202'); // function 10
        $data['allow_to_approve'] = $this->user_sso->is_allowed_function('203'); // function 20
        $data['allow_to_cancel'] = $this->user_sso->is_allowed_function('204'); // function 30
        $data['allow_to_return'] = $this->user_sso->is_allowed_function('203'); // function 30
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('orders/ordersMaster.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function newOrder() {
        $data['view_title'] = '';
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar.php', $data);
        $this->load->view('orders/newOrder.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function getInitialOrdersList() {

        if (!$this->user_sso->is_allowed_function('201')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'I_ORDER_ID' => $this->input->post('I_ORDER_ID'),
            'I_FROM' => $this->input->post('I_FROM'),
            'I_TO' => $this->input->post('I_TO'),
            'I_TYPE' => $this->input->post('I_TYPE'),
            'I_STATUS' => $this->input->post('I_STATUS'),
        );
        $orders = $this->orders->getInitialOrdersList($parm);
        // var_dump($orders);
        //exit;
        echo json_encode($orders['com_info']);
        exit();
    }

    // public function ApproveOrder() {
    //     if (!$this->user_sso->is_allowed_function('203')) {
    //         redirect('/messages/disply_msg/1020/');
    //         return;
    //     }
    //     $data = array(
    //         'ID' => $this->input->post('Order_Id'),
    //         'USER_ID' => $this->user_sso->getUserID()
    //     );
    //     $result = $this->orders->approveOrder($data);
    //     echo json_encode($result);
    //     exit();
    // }

    public function manageOrders($id = null) {
        if (!$this->user_sso->is_allowed_function('202')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
		$Order_Id = $this->input->post('Order_Id');
        $id = (empty($Order_Id))? $id : $Order_Id;
        $data['allow_to_update'] = $this->user_sso->is_allowed_function('205');
        $data['orderMaster'] = $this->orders->getOrderMaster($id);

        //print_r($data['orderMaster']);exit;
        $data['orderDetails'] = $this->orders->getOrderDetails($id);
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('orders/manageOrder', $data);
        $this->load->view('includes/footer.php', $data);
    }

    /*public function OrderMaster() {
        if (!$this->user_sso->is_allowed_function('200')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['allow_to_search'] = $this->user_sso->is_allowed_function('201');
        $data['allow_to_view'] = $this->user_sso->is_allowed_function('202'); // function 10
        $data['allow_to_approve'] = $this->user_sso->is_allowed_function('203'); // function 20
        $data['allow_to_cancel'] = $this->user_sso->is_allowed_function('204'); // function 30
        $data['allow_to_return'] = $this->user_sso->is_allowed_function('203'); // function 30
        //$data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('orders/order_master.php', $data);
        $this->load->view('includes/footer.php', $data);
    }*/

    public function createMasterOrder() {
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'Order_date' => $this->input->post('Order_date'),
            'Order_type' => $this->input->post('Order_type'),
            'USER_ID' => $this->user_sso->getUserID()
        );

        $info = $this->orders->createOrder($parm);

        var_dump($data);
        if ($info['ORDER_SR'] != -1) {
            echo json_encode($info['DATA']);
        } else {
            echo json_encode($info);
        }
    }
    
    public function getOrderInfo() {
        $parm = array(
            'I_ORDER_DATE' => $this->input->post('Order_date'),
            'I_FUEL_CATEGORY' => $this->input->post('Order_type'),
            'I_USER' => $this->user_sso->getUserID(),
            'I_Todayck'=> $this->input->post('todayck'),
			// 
        );
        $result = $this->orders->getOrdersInfo($parm);
        //$ordersInfo = $result['ordersInfo'];
        $data['ORDER_TYPE'] = $this->input->post('Order_type') ;
        $data['ordersInfo'] = $result['ordersInfo'];
        $html = $this->load->view('orders/orderInfo.php', $data);
        echo $html;
    }

/*    public function getOrderDetails() {
        $parm = array(
            'I_ORDER_DATE' => $this->input->post('Order_date'),
            'I_FUEL_CATEGORY' => $this->input->post('Order_type'),
            // 'I_ORDER_DATE' => "02-02-2018",
            // 'I_FUEL_CATEGORY' => 2,
            'I_USER' => "931701023",
        );
        $orders = $this->orders->GET_ORDER_INFO($parm);

        $all_info = array();

        foreach ($orders["DATA"] as $info) {
            if (!array_key_exists($info["ACCOUNT_ID"], $all_info))
                $all_info[$info["ACCOUNT_ID"]] = array();
            if (!array_key_exists("basic_info", $all_info[$info["ACCOUNT_ID"]])) {
                $basic_info = array(
                    "ORDER_ID" => $info["ORDER_ID"],
                    "OLD_ORDERS_PRICE" => $info["OLD_ORDERS_PRICE"],
                    "ACCOUNT_NAME" => $info["ACCOUNT_NAME"],
                    "ACCOUNT_VALUE" => $info["ACCOUNT_VALUE"],
                    "ACCOUNT_BALANCE" => $info["ACCOUNT_BALANCE"],
                    "S_ACCOUNT_BALANCE" => $info["S_ACCOUNT_BALANCE"],
                    "DEFERRED_CHECKS" => $info["DEFERRED_CHECKS"],
                    "GARANTEES_BALANCE" => $info["GARANTEES_BALANCE"],
                    "S_GUARANTEES_BALANCE" => $info["S_GUARANTEES_BALANCE"],);
                $all_info[$info["ACCOUNT_ID"]]["basic_info"] = $basic_info;
            }


            if (!array_key_exists("item_info", $all_info[$info["ACCOUNT_ID"]])) {
                $all_info[$info["ACCOUNT_ID"]]["item_info"] = array();
                $item_info = array(
                    "FUEL_SERIAL" => $info["FUEL_SERIAL"],
                    "FUEL_NAME" => $info["FUEL_NAME"],
                    "FUEL_AMOUNT" => $info["FUEL_AMOUNT"],
                    "S_FUEL_AMOUNT" => $info["S_FUEL_AMOUNT"],
                    "APPROVED_AMOUNT" => $info["APPROVED_AMOUNT"],
                    "PRODUCT_PRICE" => $info["PRODUCT_PRICE"],
                    "S_PRODUCT_PRICE" => $info["S_PRODUCT_PRICE"],
                    "RECEIVED_AMOUNT" => $info["RECEIVED_AMOUNT"],
                    "RECEIVE_STATUS" => $info["RECEIVE_STATUS"]);
                array_push($all_info[$info["ACCOUNT_ID"]]["item_info"], $item_info);
            } else {

                $item_info = array(
                    "FUEL_SERIAL" => $info["FUEL_SERIAL"],
                    "FUEL_NAME" => $info["FUEL_NAME"],
                    "FUEL_AMOUNT" => $info["FUEL_AMOUNT"],
                    "S_FUEL_AMOUNT" => $info["S_FUEL_AMOUNT"],
                    "APPROVED_AMOUNT" => $info["APPROVED_AMOUNT"],
                    "PRODUCT_PRICE" => $info["PRODUCT_PRICE"],
                    "S_PRODUCT_PRICE" => $info["S_PRODUCT_PRICE"],
                    "RECEIVED_AMOUNT" => $info["RECEIVED_AMOUNT"],
                    "RECEIVE_STATUS" => $info["RECEIVE_STATUS"]);
                array_push($all_info[$info["ACCOUNT_ID"]]["item_info"], $item_info);
            }
        }

        $data["all_info"] = $all_info;

        $data['username'] = $this->user_sso->getUserName();
        /* $this->load->view('includes/header.php', $data);
          $this->load->view('includes/sidebar', $data);
          $this->load->view('orders/manual_order', $data);
          $this->load->view('includes/footer.php', $data); */
     /*   $data = $this->load->view('orders/manual_order', $data, TRUE);
        //return $data;
        echo $data;
    }*/
	
	
    public function new_available_date() { //old code
        $data['view_title'] = 'التواريخ المتاحة للطلبيات';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar.php', $data);
        $this->load->view('orders/new_available_date.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

	// addAvailabeOrderDate
	public function addAvailabeOrderDate() {
		if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'I_ORDER_DT' => $this->input->post('I_ORDER_DT'),
            'I_RAFAH' => $this->input->post('I_RAFAH'),
            'I_KARM' => $this->input->post('I_KARM'),
            'I_RAFAH_GAS' => $this->input->post('I_RAFAH_GAS'),
        );
        $info = $this->orders->addAvailabeDate($parm);
        echo json_encode($info);
		
		
	}
	
	
	
	public function deleteAvailableDays() {
		$parm = array(
            'I_ORDER_DT' => $this->input->post('I_ORDER_DT'),
        );
       // $data = $this->orders->removeAvailableDays($parm);
	//	echo json_encode($data);
		$info = $this->orders->removeAvailableDays($parm);
        echo json_encode($info);
		
		
		
		
		
	}
	
	public function getAvailableDays() {
		
			/* if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }*/
		   $parm = array(
            'I_ORDER_DT' => $this->input->post('I_ORDER_DT'),
            'ORDER_TYPE' => $this->input->post('ORDER_TYPE'),
        );
        $info = $this->orders->getAvailableDays($parm);
		
        echo json_encode($info);
		
		
		
	}
        
    public function smsAgentsNotification(){
        if (!$this->user_sso->is_allowed_function('214')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $order_date = $this->input->post('ORDER_DATE') ; 
        $order_type = $this->input->post('ORDER_TYPE') ;
        $sms_list = $this->orders->getAgentsToNotify($order_date, $order_type) ;
        $count = 0 ; 
        foreach ($sms_list as $sms_info){
            $SMSText = 'اعتماد طلبية ' . $sms_info['OCATEGORY'] . ' ' . $sms_info['ODATE'] . ',' . $sms_info['OTYPES'] ;   
            $smsResp = $this->send_SMS($sms_info['SMSTEXT'], $sms_info['AGENT_MOBILE'], 'PETROL ORDER') ;
            $count++ ; 
        }    
        echo(json_encode(array('smsCount'=>$count))) ; 
    }
    
    private function send_SMS($SMS_TEXT, $RECEIVER, $SMS_TITLE){
        $acc_username = "DistPetrol4rasel";
        $acc_password = md5("13682095") ; 
        $sender = "MofPetrol" ; 
        
        $url = "http://rasel.eapp.gov.ps/getway/c_api/send/".$acc_username."/".$acc_password."/".$sender."/sms/".$RECEIVER."/".urlencode($SMS_TITLE)."/".urlencode($SMS_TEXT) ;
        $jsonString = json_decode(file_get_contents($url));
        $response = $jsonString;
        // var_dump($response) ;        
    }
    
    public function test_SMS(){
        $SMS_TEXT = 'SMSTestText';
        $RECEIVER = '0592907768' ;
        $SMS_TITLE = 'MOF Petrol' ;
        $acc_username = "DistPetrol4rasel";
        $acc_password = md5("13682095") ; 
        $sender = "MofPetrol" ; 
        
        $url = "http://rasel.eapp.gov.ps/getway/c_api/send/".$acc_username."/".$acc_password."/".$sender."/sms/".$RECEIVER."/".urlencode($SMS_TITLE)."/".urlencode($SMS_TEXT) ;
        $jsonString = json_decode(file_get_contents($url));
        $response = $jsonString;
        var_dump($response) ;        
    }
	
	
	

}

?>
