<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class reports extends CI_Controller {

    private $jasper;
    private $petrolReportPath = '/Petrol/Reports/';

    public function __construct() {
        parent::__construct();
        
        $this->user_sso->validate_session();

        if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }

        $isOnline = 1;
        if ($isOnline === 1) {
            $petrolReportPath = '/Petrol/Reports/';
        } else {
            $petrolReportPath = '/Petrol/Reports/';
        }
        $this->load->helper('jasper_helper');
        jasper_init($isOnline);
        $this->jasper = Connect_Jasper($isOnline);
       //  $this->load->model('consignment');
    }

    public function index() {
        
    }
    
    
    public function printTaxInvoice($notice_serial){
        if (!$this->user_sso->is_allowed_function('26')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $Report_Name = $this->petrolReportPath . 'taxInvoice';
        $Parameters = array(
            'I_INVOICE_SR' => $notice_serial
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }
    
    public function printTransNotice($notice_serial){
        if (!$this->user_sso->is_allowed_function('26')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $Report_Name = $this->petrolReportPath . 'transNotice';
        $Parameters = array(
            'I_NOTICE_SR' => $notice_serial
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }

    public function printLackNotice($notice_serial){
        if (!$this->user_sso->is_allowed_function('26')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $Report_Name = $this->petrolReportPath . 'lackNotice';
        $Parameters = array(
            'I_NOTICE_SR' => $notice_serial
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }

    public function printSurplusNotice($notice_serial){
        if (!$this->user_sso->is_allowed_function('26')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $Report_Name = $this->petrolReportPath . 'surplusNotice';
        $Parameters = array(
            'I_NOTICE_SR' => $notice_serial
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }

    public function printOperatingNotice($notice_serial){
        if (!$this->user_sso->is_allowed_function('26')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $Report_Name = $this->petrolReportPath . 'oparatingNotice';
        $Parameters = array(
            'I_NOTICE_SR' => $notice_serial
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }

    public function printCashNotice($notice_serial){
        if (!$this->user_sso->is_allowed_function('26')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $Report_Name = $this->petrolReportPath . 'cashDiscNotice';
        $Parameters = array(
            'I_NOTICE_SR' => $notice_serial
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }
    
    public function printDetailedAccountStatement(){
        if (!$this->user_sso->is_allowed_function('184')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $account_id = $this->input->post('F_ACCOUNT_ID') ;
        $start_dt   = $this->input->post('F_START_DT') ;
        $end_dt     = $this->input->post('F_END_DT') ;
        $com_name   = $this->input->post('F_ACCOUNT_NAME') ; 
        $Report_Name = $this->petrolReportPath . $this->input->post('F_REPORT_NAME');
        $Parameters = array(
            'p_ACCOUNT'     => $account_id , 
            'p_START_DATE'  => $start_dt ,
            'p_END_DATE'    => $end_dt, 
            'p_COM_NAME'    => $com_name
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }
    
    public function printInvoice($notice_serial){
        if (!$this->user_sso->is_allowed_function('26')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $Report_Name = $this->petrolReportPath . 'takahInvoice';
        $Parameters = array(
            'I_INVOICE_SR' => $notice_serial
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }


public function print_gas_contract($serial){
       /* if (!$this->user_sso->is_allowed_function('26')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        */
       $application_serial = $this->uri->segment(3);
       
        $Report_Name = $this->petrolReportPath . 'finalgas';
        $Parameters = array(
            'I_APP_SR' => $application_serial
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }

    public function print_gas_repoert($serial){
       /* if (!$this->user_sso->is_allowed_function('26')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        */
       $application_serial = $this->uri->segment(3);
       
        $Report_Name = $this->petrolReportPath . 'petrolgaz';
        $Parameters = array(
            'I_APP_SR' => $application_serial
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }
    
    public function printUserChain(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $chain = $this->input->post('P_CHAIN_SERIAL') ;
        $Report_Name = $this->petrolReportPath . 'userChain';
        $Parameters = array(
            'I_CHAIN_SR' => $chain
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }
    
    public function printInstallmentApp(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $order_id = $this->input->post('R_ORDER_DT') ;
        $account_id = $this->input->post('R_ACCOUNT_ID') ;
        $Report_Name = $this->petrolReportPath . 'installmentApp';
        $Parameters = array(
            'p_ORDER_DT' => $order_id, 
            'p_ACCOUNT_ID' => $account_id
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }
    
    public function printWarehouseTransactions(){
        if (!$this->user_sso->is_allowed_function('184')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $PRODUCT_ID = $this->input->post('F_PRODUCT') ;
        $PRODUCT_NAME = $this->input->post('F_PRODUCT_NAME') ;
        $WAREHOUSE_ID = $this->input->post('F_WAREHOUSE') ;
        $WAREHOUSE_NAME = $this->input->post('F_WAREHOUSE_NAME') ;
        $START_DT = $this->input->post('F_START_DT') ;
        $END_DT = $this->input->post('F_END_DT') ;
        $report = ($this->input->post('F_REPORT_NAME') == 'detailed') ? 'warehouseTransDetails' : 'warehouseTransTotals' ; 
        $Report_Name = $this->petrolReportPath . $report;
        $Parameters = array(
            'p_PRODUCT_ID'      => $PRODUCT_ID , 
            'p_PRODUCT_NAME'    => $PRODUCT_NAME ,
            'p_WAREHOUSE_ID'    => $WAREHOUSE_ID, 
            'p_WAREHOUSE_NAME'  => $WAREHOUSE_NAME, 
            'p_START_DATE'      => $START_DT, 
            'p_END_DATE'        => $END_DT            
        );
     // $R=$this->consignment->TEST($Parameters);
      //echo "<meta charset='utf-8' />";
      //var_dump($R);
      $this->Print_PDF(null, null, $Report_Name, $Parameters); 

    }
    
    public function printPayablechecks(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $CHECK_SDT = $this->input->post('F_CHECK_SDT') ;
        $CHECK_EDT = $this->input->post('F_CHECK_EDT') ;
        $COLLECT_STAT = $this->input->post('F_COLLECT_STAT') ;
        $Report_Name = $this->petrolReportPath . "payableCheckes";
        $Parameters = array(
            'p_START_DATE'      => $CHECK_SDT ,
            'p_END_DATE'    => $CHECK_EDT ,
            'p_CHECK_STATUS'    => $COLLECT_STAT,
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters);
    }

    public function printCashRecieptsList(){
        if (!$this->user_sso->is_allowed_function('34')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $Report_Name = $this->petrolReportPath . "receiptsList";
        $Parameters = array(
            'p_RECEIPT_ID' => $this->input->post('RCPT_SR'),
            'p_RECP_STATUS' => $this->input->post('RCPT_STATUS'),
            'p_RECP_TYPE' =>  $this->input->post('RCPT_TYPE'),
            'p_DOC_ID' =>  $this->input->post('DOC_ID'),
            'p_START_DATE' => $this->input->post('START_DT'),
            'p_END_DATE' => $this->input->post('END_DT'),
            'p_ACCOUNT' => $this->input->post('ACCOUNT')
        );
        $this->Print_PDF('سندات القبض', null, $Report_Name, $Parameters);
    }

    public function printOperatingFeesStatement(){
        if (!$this->user_sso->is_allowed_function('246')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $Report_Name = $this->petrolReportPath . 'operatingFeesStatement';
        $Parameters = array(
            'p_CLIENT_TYPE'     => $this->input->post('F_CLIENT_TYPE'), 
            'p_CLIENT_ID'       => $this->input->post('F_CLIENT_ID') ,
            'p_COM_NAME'        => $this->input->post('F_CLIENT_NAME'), 
            'p_START_DATE'      => $this->input->post('F_START_DT'), 
            'p_END_DATE'        => $this->input->post('F_END_DT')        
        );
      $this->Print_PDF(null, null, $Report_Name, $Parameters);
    }

    public function printOutgoingTransfer(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $Report_Name = $this->petrolReportPath . 'outgoingTransfer';
        $Parameters = array(
            'p_TARNS_SERIAL'     => $this->input->post('i_TRANS_SR'),      
        );
      $this->Print_PDF(null, null, $Report_Name, $Parameters);
    }
    

    public function printOutConsignment() {
        $R_CON_SR = $this->input->post('R_CON_SR');
        
        $Doc_Name = $R_CON_SR;
        $Report_Name = $this->petrolReportPath . 'outConsignment';

        $Parameters = array(
            'I_CONS_SR' => $R_CON_SR
        );
        //print_r($Parameters) ; exit() ;

        $this->Print_PDF($Doc_Name, null, $Report_Name, $Parameters);
    }
    
    public function printCashReciept() {
        if (!$this->user_sso->is_allowed_function('207')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $I_RCPT_SR = $this->input->post('R_RCPT_SR');
        //print_r($this->input->post()) ; exit() ; 
        $Doc_Name = $I_RCPT_SR;
        $Report_Name = $this->petrolReportPath . 'cashReciept';

        $Parameters = array(
            'I_RCPT_SR' => $I_RCPT_SR
        ); 

        $this->Print_PDF($Doc_Name, null, $Report_Name, $Parameters);
    }
    
   
    public function Print_PDF($Doc_Name, $DOC_ID, $Report_Name, $Parameters) {

        $report = $this->jasper->reportService()->runReport($Report_Name, 'pdf', null, null, $Parameters);


        header('Cache-Control: must-revalidate');
        header('Pragma: public');
        header('Content-Description: File Transfer');
        header('Content-Disposition: inline; filename=' . $Doc_Name . '.pdf');
        header('Content-Transfer-Encoding: binary');
        header('Content-Length: ' . strlen($report));
        header('Content-Type: application/pdf; charset=utf-8');
        echo $report;
    }

    public function Print_XLSX($Report_Name, $Parameters) {

        $report = $this->jasper->reportService()->runReport($Report_Name, 'xlsx', null, null, $Parameters);

        header('Cache-Control: must-revalidate');
        header('Pragma: public');
        header('Content-Description: File Transfer');
        header('Content-Disposition: inline; filename=' . $Report_Name . '.xlsx');
        header('Content-Transfer-Encoding: binary');
        header('Content-Length: ' . strlen($report));
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.sheet; charset=utf-8');
        echo $report;
    }
	
	   // DISTRIPUTED_AMOUNTS
	 public function printDistributedAmounts($I_ORDER_SR){
        if (!$this->user_sso->is_allowed_function('215')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $Report_Name = $this->petrolReportPath . 'center_station'; ////Report ID = center_station, Report Name = DISTRIPUTED_AMOUNTS
        $Parameters = array(
            'I_ORDER_SR' => $I_ORDER_SR );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }
    
    public function printCompaniesFinStanding(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $CATEGORY = $this->input->post('C_CATEGORY') ;
        $DATE = $this->input->post('C_DATE') ;
        $CAT_NAME = $this->input->post('C_CAT_NAME') ;
        $TODAY = $this->input->post('C_TODAY_ORDER') ; 
        $Report_Name = $this->petrolReportPath . "companiesFinStanding";
        $Parameters = array(
            'p_CAT_NAME'    => $CAT_NAME, 
            'p_CATEGORY'    => $CATEGORY ,
            'p_DATE'        => $DATE ,
            'p_TODAY_ORDER' => $TODAY,
            'p_COM_DEPTS' => 0,
            'p_INSTIT_DEPTS' => 0
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters);
    }

    
    public function printPurchasesList(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $START_DATE = $this->input->post('I_START_DATE') ;
        $END_DATE = $this->input->post('I_END_DATE') ;
        $NOTICE_TYPE = $this->input->post('I_NOTICE_TYPE') ;
        $PRODUCT_CAT = $this->input->post('I_PRODUCT_CAT') ; 
        $CATEGORY_NAME = $this->input->post('I_CATEGORY_NAME') ; 
        $PRODUCT_ID = $this->input->post('I_PRODUCT_ID') ; 
        $PRODUCT_NAME = $this->input->post('I_PRODUCT_NAME') ;
        $USER = $this->user_sso->getUserName();
        $Report_Name = $this->petrolReportPath . 'noticesList';
        $Parameters = array(
            'p_NOTICE_TYPE'    => $NOTICE_TYPE, 
            'p_START_DATE'    => $START_DATE ,
            'p_END_DATE'        => $END_DATE ,
            'p_PRODUCT_CAT' => $PRODUCT_CAT,
            'p_PRODUCT_CAT_NAME' => $CATEGORY_NAME, 
            'p_PRODUCT_ID' => $PRODUCT_ID,
            'p_PRODUCT_NAME' => $PRODUCT_NAME,
            'p_USER' => $USER,
            
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters);
    }

    public function printDiffNotice($notice_serial){
        if (!$this->user_sso->is_allowed_function('26')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $Report_Name = $this->petrolReportPath . 'productDiffNotice';
        $Parameters = array(
            'I_NOTICE_SR' => $notice_serial
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }

    public function printScaleFeeNotice($notice_serial){
        if (!$this->user_sso->is_allowed_function('26')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $Report_Name = $this->petrolReportPath . 'scaleFeesNotice';
        $Parameters = array(
            'I_NOTICE_SR' => $notice_serial
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }

    public function printJarIDs(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $Report_Name = $this->petrolReportPath . 'gasJarIdentity';
        $Parameters = array(
            'p_SERIAL' => $this->input->post('i_JAR_SR'),
            'p_STATION' => $this->input->post('i_STATION_CODE') 
        );
        //var_dump($Parameters); exit();
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }

    public function print30JarIDs(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $Report_Name = $this->petrolReportPath . 'gasJarIdentity';
        $Parameters = array(
            'p_USER' => $this->user_sso->getUserID(),
            'p_STATION' => $this->input->post('i_STATION_CODE') 
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }

    public function printEgyptianProductsLacks(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $Report_Name = $this->petrolReportPath . $this->input->post('F_L_REPORT_NAME');
        $Parameters = array(
            'p_IN_DATE' => $this->input->post('F_L_IN_DATE') 
        );
        $this->Print_PDF(null, null, $Report_Name, $Parameters); 
    }
	

}

?>
