<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class Samples extends CI_Controller {

    public function __construct() {
        parent::__construct();
         $this->load->helper('date');
        $this->load->model('samples_model');
        $this->load->model('constants');
         $this->user_sso->validate_session();

        if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }
       
  }

    public function index() {
         if (!$this->user_sso->is_allowed_function('180')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = 'مستخدم النظام';
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('samples/samplefuelcheckform', $data);
        $this->load->view('includes/footer.php', $data);

    }


    public function samplecheckform() {
       
        if (!$this->user_sso->is_allowed_function('51')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = 'مستخدم النظام';
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('samples/samplefuelcheckform', $data);
        $this->load->view('includes/footer.php', $data);

    }

    public function samplesMaster() {

         if (!$this->user_sso->is_allowed_function('52')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data[''] = 0;
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('samples/samplesMaster', $data);
        $this->load->view('includes/footer.php', $data);

    }


    public function addFuelSample() {
         if (!$this->user_sso->is_allowed_function('51')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'FINANCIAL_NO' => $this->input->post('FINANCIAL_NO'),
            'COMPANY' => $this->input->post('COMPANY'),
            'RECEIVE_DATE' => $this->input->post('RECEIVE_DATE'),
            'RECEIVE_TIME' => $this->input->post('RECEIVE_TIME'),
            'RECEIVE_PLACE' => $this->input->post('RECEIVE_PLACE'),
            'NO_OF_SAMPLES' => $this->input->post('NO_OF_SAMPLES'),
            'FUEL_TYPE' => $this->input->post('FUEL_TYPE'),
            'NOTES' => $this->input->post('NOTES'),
            'RECEIVE_COMMITEE' => $this->input->post('RECEIVE_COMMITEE')

        );
        $result = $this->samples_model->addNewFuelsample($parm);
        echo json_encode($result);
    }


    public function getSamples() {

        $parm = array(
            'FINANCIAL_NO' => $this->input->post('FINANCIAL_NO'),
            'COMPANY' => $this->input->post('COMPANY'),
            'RECEIVE_PLACE' => $this->input->post('RECEIVE_PLACE'),
            'START_DT' =>  $this->input->post('START_DT'),
            'END_DT' => $this->input->post('END_DT'),

        );

        $result = $this->samples_model->getSamples($parm);

        echo json_encode($result);

      //  return  $data['cnt'];

    }

    public function getSamplesCount()
    {
        $cnt = 0;
        $parm = array(
            'FINANCIAL_NO' => $this->input->post('FINANCIAL_NO'),
            'COMPANY' => $this->input->post('COMPANY'),
            'RECEIVE_PLACE' => $this->input->post('RECEIVE_PLACE'),
            'START_DT' => $this->input->post('START_DT'),
            'END_DT' => $this->input->post('END_DT'),

        );

        $cnt = $this->samples_model->getSamplesCount($parm);

       echo $cnt;

    }


        public function getSample() {
        $parm = array(
            'FINANCIAL_NO' => $this->input->post('FINANCIAL_NO')
        );
        $result = $this->samples_model->getSample($parm);
        echo json_encode($result);
    }

    public function updateFuelSample() {
        $parm = array(
            'FINANCIAL_NO' => $this->input->post('FINANCIAL_NO'),
            'COMPANY' => $this->input->post('COMPANY'),
            'RECEIVE_DATE' => $this->input->post('RECEIVE_DATE'),
            'RECEIVE_TIME' => $this->input->post('RECEIVE_TIME'),
            'RECEIVE_PLACE' => $this->input->post('RECEIVE_PLACE'),
            'NO_OF_SAMPLES' => $this->input->post('NO_OF_SAMPLES'),
            'FUEL_TYPE' => $this->input->post('FUEL_TYPE'),
            'NOTES' => $this->input->post('NOTES'),
            'RECEIVE_COMMITEE' => $this->input->post('RECEIVE_COMMITEE')

        );

        $result = $this->samples_model->updateFuelSample($parm);
        echo json_encode($result);
    }

public function manageSamples() {
     if (!$this->user_sso->is_allowed_function('165')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
   // echo "controller manage sample";
    $data['F_FINANCIAL_NO'] = $this->input->post('F_SMP');
    $this->load->view('includes/header.php', $data);
    $this->load->view('includes/sidebar', $data);
    $this->load->view('samples/manageSamples', $data);
    $this->load->view('includes/footer.php', $data);
}


} ?>