<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Statements extends CI_Controller {

    public function __construct() {
        parent::__construct();
        $this->user_sso->validate_session();

        if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }
        $this->load->model('eservices');
    }
    
    public function index(){
        if (!$this->user_sso->is_allowed_function('181')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar.php', $data);
        $this->load->view('statements/account_statement.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function detailedAccountStatement() { //old code
        if (!$this->user_sso->is_allowed_function('181')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['username'] = $this->user_sso->getUserName();
		
		$data['ACCOUNT_TERM'] = $this->input->post('F_ACCOUNT_TERM');
		$data['ACCOUNT'] = $this->input->post('F_ACCOUNT');
                $chain_dt = $this->input->post('F_CHAIN_DT_FROM') ;
                $data['CHAIN_DT_FROM'] = (!empty($chain_dt)) ? $chain_dt : date('d/m/Y', time() - 60*60*24*30);
		//$data['CHAIN_DT_TO'] = $this->input->post('F_CHAIN_DT_TO');
		
		
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar.php', $data);
        $this->load->view('statements/account_statement.php', $data);
        $this->load->view('includes/footer.php', $data);
    }
    
    public function queryDetailedAccountStatament(){
        if (!$this->user_sso->is_allowed_function('183')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('user_chain');
        $parms = array(
                    'ACCOUNT_ID'=> $this->input->post('ACCOUNT_ID') , 
                    'START_DATE'=> $this->input->post('START_DATE') , 
                    'END_DATE'=> $this->input->post('END_DATE')                  
                ) ;
        echo(json_encode($this->user_chain->getDetaildAccountStatement($parms))) ; exit() ;
        
    }
    
    public function queryOrderAccountStatament(){
        if (!$this->user_sso->is_allowed_function('183')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('user_chain');
        $parms = array(
                    'ACCOUNT_ID'=> $this->input->post('ACCOUNT_ID') , 
                    'START_DATE'=> $this->input->post('START_DATE') , 
                    'END_DATE'=> $this->input->post('END_DATE')                  
                ) ;
        echo(json_encode($this->user_chain->getOrderAccountStatement($parms))) ; exit() ;
    }

    public function queryParentAccountStatment(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('user_chain');
        $parms = array(
            'ACCOUNT_ID'=> $this->input->post('ACCOUNT_ID') , 
            'START_DATE'=> $this->input->post('START_DATE') , 
            'END_DATE'=> $this->input->post('END_DATE')                  
        ) ;
        echo(json_encode($this->user_chain->getParentAccountStatement($parms))) ; exit() ;
        
    }
    
    public function manageAgentsAccounts(){
        if (!$this->user_sso->is_allowed_function('191')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar.php');
        $this->load->view('statements/manage_agents_accounts.php');
        $this->load->view('includes/footer.php');
    }
    
    public function getCompanyAgent(){
        if (!$this->user_sso->is_allowed_function('191')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $comID = $this->input->post('COMPANY_ID') ;
        $result = $this->eservices->get_company_agent_info($comID);
        echo(json_encode($result)) ; exit();
    }
    
    public function getAgentAccounts(){
        if (!$this->user_sso->is_allowed_function('191')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $agentID = $this->input->post('AGENT_ID') ;
        $result = $this->eservices->get_agent_potential_accounts($agentID);
        echo(json_encode($result)) ; exit();
    }
    
    public function saveAgentsAccounts(){
        if (!$this->user_sso->is_allowed_function('192')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $agent_id = $this->input->post('AGENT_ID');
        $success = $this->eservices->delete_agent_accounts($agent_id);
        if($success){
            $accounts = json_decode($this->input->post('active_accounts'));
            $det_success = 1 ; 
            for ($i = 0; $i < count($accounts); $i++) {
                $item = json_decode($accounts[$i]);
                $det_success = $this->eservices->add_account_to_agent(array(
                    'AGENT_ID' => $agent_id,
                    'ACCOUNT_ID' => $item->ACCOUNT_ID
                ));
            }
            echo json_encode(array('success' => $det_success));
        } else {
            echo json_encode(array('success' => $success));
        }
    }
    
    public function warehouse_transactions() { //old code
        if (!$this->user_sso->is_allowed_function('181')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('warehouse');
        $data['warehouses'] = $this->warehouse->getWarehousesList(); 
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar.php', $data);
        $this->load->view('statements/warehouse_transactions.php', $data);
        $this->load->view('includes/footer.php', $data);
    }
    
    public function queryWarehouseTransDetails(){
        if (!$this->user_sso->is_allowed_function('181')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('warehouse');
        $parms = array(
            'WAREHOUSE_NO' => $this->input->post('WAREHOUSE_NO'),
            'FUEL_CAT' => $this->input->post('PRODUCT'),
            'START_DT' => $this->input->post('START_DT'),
            'END_DT' => $this->input->post('END_DT')                
        ) ;
        echo(json_encode($this->warehouse->getDetaildwarehouseTrans($parms))) ; exit() ;
    }
    
    public function queryWarehouseTransTotals(){
        if (!$this->user_sso->is_allowed_function('181')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('warehouse');
        $parms = array(
            'WAREHOUSE_NO' => null ,//$this->input->post('WAREHOUSE_NO'),
            'FUEL_CAT' => null ,//$this->input->post('PRODUCT'),
            'START_DT' => $this->input->post('START_DT'),
            'END_DT' => $this->input->post('END_DT')                
        ) ;
        echo(json_encode($this->warehouse->getWarehouseTransTotals($parms))) ; exit() ;
    }

    public function queryOparatingChainsStatament(){
        if (!$this->user_sso->is_allowed_function('183')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('fees_model');
        $parms = array(
            'CLIENT_TYPE'   => $this->input->post('CLIENT_TYPE'), 
            'CLIENT_ID'     => $this->input->post('CLIENT_ID'), 
            'START_DATE'=> $this->input->post('START_DATE') , 
            'END_DATE'=> $this->input->post('END_DATE')                  
        ) ;
        echo(json_encode($this->fees_model->getOparatingFeesAccountStatement($parms))) ; exit() ;
    }

    public function purchasesList(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('constants');
        $data['products'] = $this->constants->getProductInfo(); 
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar.php', $data);
        $this->load->view('statements/companies_purchases.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function getCompaniesPurchases(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('consignment');
        $parms = array(
            'COMPANY' => $this->input->post('COMPANY_ID'),
            'START_DT' => $this->input->post('START_DATE'),
            'END_DT' => $this->input->post('END_DATE')           
        ) ;
        echo(json_encode($this->consignment->getPivotPurchases($parms))) ; exit() ;
    }

    public function catPurchasesList(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('constants');
        $data['categories'] = $this->constants->getCategoriesList(); 
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar.php', $data);
        $this->load->view('statements/companies_purchases_cat.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function getCompaniesPurchasesByCat(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('consignment');
        $parms = array(
            'CATEGORY' => $this->input->post('CATEGORY'),
            'COMPANY' => $this->input->post('COMPANY'),
            'START_DT' => $this->input->post('START_DATE'),
            'END_DT' => $this->input->post('END_DATE')           
        ) ;
        echo(json_encode($this->consignment->getPivotPurchasesByCategory($parms))) ; exit() ;
    }

    public function companiesRatios(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('constants');
        $data['categories'] = $this->constants->getCategoriesList(); 
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar.php', $data);
        $this->load->view('statements/companies_ratios', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function calculateCompaniesRatios(){
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $this->load->model('consignment');
        $parms = array(
            'COMPANY' => $this->input->post('COMPANY'),
            'START_DT' => $this->input->post('START_DATE'),
            'END_DT' => $this->input->post('END_DATE')           
        ) ;
        $totals = $this->consignment->getTotalSalesToCompanies($parms); 
        $data = $sales = $this->consignment->calculateCompaniesRatios($parms); 
        foreach($sales as $key => $value){
            $sales[$key]['BANZEN_TOTAL'] = $totals[0]['BANZEN_TOTAL']; 
            $sales[$key]['SOLAR_TOTAL'] = $totals[0]['SOLAR_TOTAL']; 
            $sales[$key]['GAS_TOTAL'] = $totals[0]['GAS_TOTAL']; 
        }
        echo(json_encode($sales)) ; exit() ;
        
    }

}