<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class stations extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->load->helper('date');
        $this->load->model('station');
        $this->user_sso->validate_session();
        if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }
    }

    public function add_stations()
    {
        if (!$this->user_sso->is_allowed_function('237')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = 'مستخدم النظام';
        $data['gov'] = $this->station->GET_GOVERNORATES_LIST();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('stations/add_station', $data);
        $this->load->view('includes/footer.php', $data);

    }

    public function search_stations()
    {
        if (!$this->user_sso->is_allowed_function('238')) {
             redirect('/messages/disply_msg/1020/');
             return;
        }
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = 'مستخدم النظام';
        $data['gov'] = $this->station->GET_GOVERNORATES_LIST();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('stations/search_stations', $data);
        $this->load->view('includes/footer.php', $data);

    }

    public function GET_CITIES_LIST()
    {
        $result = $this->station->GET_CITIES_LIST($this->input->post('gov_id'));
        echo json_encode($result);
    }

    public function GET_SUPPLIYERS_LIST()
    {
        $result = $this->station->GET_SUPPLIYERS_LIST($this->input->post('TYPE'));
        echo json_encode($result);
    }

    public function add_new_station()
    {   
        if (!$this->user_sso->is_allowed_function('237')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parms = array(
            'SNAME' => $this->input->post('STATION_NAME'),
            'COM_ID' => $this->input->post('COM_ID'),
            'OWNER' => $this->input->post('OWNER_NAME'),
            'GOVER' => $this->input->post('GOVERNORATE_ID'),
            'CITY' => $this->input->post('CITIE_ID'),
            'CORD_X' => $this->input->post('COORDINATE_X'),
            'CORD_Y' => $this->input->post('COORDINATE_Y'),
            'ADDRESS' => $this->input->post('FULL_ADDRESS'),
            'START_DT' => $this->input->post('START_DT'),
            'STYPE' => $this->input->post('STATION_TYPE'),
            'CONFIRM' => $this->input->post('CONFIRMED'),
            'AGENT_ID' => $this->input->post('AGENT_ID'),
            'AGENT_NAME' => $this->input->post('AGENT_NAME'),
            'NOTES' => $this->input->post('NOTES'),
            'USER'=> $this->user_sso->getUserID());
        $result = $this->station->ADD_NEW_STATION_INFO($parms);
        if($result['STATION_SR']>0) {
            $SUP_ID = $this->input->post('SUPPLIER_ID');
            if(!empty($SUP_ID)){
                for ($i = 0; $i < count($SUP_ID); $i++) {
                    $this->station->ADD_STATION_SUPPLIERS(array(
                        'ST_ID' => $result['STATION_SR'],
                        'SUP_ID' => $SUP_ID[$i],
                    ));
                }
            }
            if (!empty($_FILES['files'])) {
                for ($i = 0; $i < count($_FILES['files']['name']); $i++) {
                    if (!empty($_FILES['files']['name'][$i])) {
                        $file_parms = array(
                            'STATION_SR' => $result['STATION_SR'],
                            'FILE_CONTENT' => $_FILES['files']['tmp_name'][$i],
                            'FILE_NAME' => $_FILES['files']['name'][$i],
                            'FILE_TYPE' => $_FILES['files']['type'][$i],
                            'USER' => $this->user_sso->getUserID()
                        );
                        $fileresult = $this->station->ADD_STATION_FILE($file_parms);
                    }
                }
            }
            $msg="done";
            redirect('stations/add_stations?op='.$msg);
        }else{
            $msg="fail";
            redirect('stations/add_stations?op='.$msg);
        }
    }

    public function get_stations_list()
    {
        if (!$this->user_sso->is_allowed_function('238')) {
             redirect('/messages/disply_msg/1020/');
             return;
        }
        $parms = array(
            'STATION_NO' => $this->input->post('STATION_NO'),
            'STYPE' => $this->input->post('STATION_TYPE'),
            'SUP_ID' => $this->input->post('SUPPLIER_ID'),
            'GOVER' => $this->input->post('GOVERNORATE_ID'),
            'CITY' => $this->input->post('CITIE_ID'),
            'CONF' => $this->input->post('CONFIRMED')
        );
        $result = $this->station->GET_STAITIONS_INFO($parms);
        echo json_encode($result);
    }

    public function get_ALL_stations()
    {
        $result = $this->station->GET_ALL_STAITION();
        echo json_encode($result);
    }

    public function view_station()
    {

        $parms = array(
            'STATION_NO' => $this->input->post('STATION_NO'),
            'STYPE' => null,
            'SUP_ID' => null,
            'GOVER' =>null,
            'CITY' =>null,
            'CONF' => null
        );
        $result['station'] = $this->station->GET_STAITIONS_INFO($parms);
        $result['station_file'] = $this->station->GET_STATION_FILES_LIST($this->input->post('STATION_NO'));
        $data = $this->load->view('stations/view_station', $result, TRUE);
        echo json_encode($data);
    }

    public function open_station_file($FILE_NO)
    {
        $result = $this->station->GET_STAITION_FILE($FILE_NO);
           $data = $result[0]['FILE_CONTENT'];
            $name = $result[0]['FILE_NAME'];
            $type = $result[0]['FILE_TYPE'];
            header('Cache-Control: must-revalidate');
            header('Pragma: public');
            header('Content-Description: File Transfer');
            header('Content-Disposition: inline; filename=' . $name);
            header('Content-Transfer-Encoding: binary');
            header('Content-Length: ' . strlen($data));
            header('Content-type:' . $type);
            echo $data;
    }

    public function updata_station($STATION_NO)

    {
        if (!$this->user_sso->is_allowed_function('239')) {
             redirect('/messages/disply_msg/1020/');
             return;
        }
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = 'مستخدم النظام';
        $data['gov'] = $this->station->GET_GOVERNORATES_LIST();
        $parms = array(
            'STATION_NO' => $STATION_NO,
            'STYPE' => null,
            'SUP_ID' => null,
            'GOVER' =>null,
            'CITY' =>null,
            'CONF' => null
        );
        $station_info = $this->station->GET_STAITIONS_INFO($parms);

        $data['station_info']=$station_info;
        $data['cites']=$this->station->GET_CITIES_LIST($station_info[0]['GOVERNORATE_ID']);
        $data['suppliers'] = $this->station->GET_SUPPLIYERS_LIST($station_info[0]['STATION_TYPE']);
        $station_suppliers=$this->station->GET_STATION_SUPPLIERS($station_info[0]['SERIAL_NO']);
        $stat_sup=array();
        for ($i = 0; $i < sizeof($station_suppliers); $i++){
            array_push($stat_sup, $station_suppliers[$i]['SUPPLIER_ID']);}
        $data['station_suppliers']=$stat_sup;
        $data['station_file'] = $this->station->GET_STATION_FILES_LIST($station_info[0]['SERIAL_NO']);
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('stations/update_station', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function delete_station_file()
    {
        $result = $this->station->DELETE_STAITION_FILE($this->input->post('serial_no'));
        echo json_encode($result);
    }

    public function update_station_info()
    {
        if (!$this->user_sso->is_allowed_function('239')) {
             redirect('/messages/disply_msg/1020/');
             return;
        }
        $parms = array(
            'STATION_SR' => $this->input->post('STATION_ID'),
            'SNAME' => $this->input->post('STATION_NAME'),
            'COM_ID' => $this->input->post('COM_ID'),
            'OWNER' => $this->input->post('OWNER_NAME'),
            'GOVER' => $this->input->post('GOVERNORATE_ID'),
            'CITY' => $this->input->post('CITIE_ID'),
            'CORD_X' => $this->input->post('COORDINATE_X'),
            'CORD_Y' => $this->input->post('COORDINATE_Y'),
            'ADDRESS' => $this->input->post('FULL_ADDRESS'),
            'START_DT' => $this->input->post('START_DT'),
            'CONFIRM' => $this->input->post('CONFIRMED'),
            'AGENT_ID' => $this->input->post('AGENT_ID'),
            'AGENT_NAME' => $this->input->post('AGENT_NAME'),
            'NOTES' => $this->input->post('NOTES'),
            'USER'=> $this->user_sso->getUserID());
        $result = $this->station->UPDATE_STATION_INFO($parms);
        if($result['success']>0) {
            if (!empty($_FILES['files'])) {
                for ($i = 0; $i < count($_FILES['files']['name']); $i++) {
                    if (!empty($_FILES['files']['name'][$i])) {
                        $file_parms = array(
                            'STATION_SR' => $this->input->post('STATION_ID'),
                            'FILE_CONTENT' => $_FILES['files']['tmp_name'][$i],
                            'FILE_NAME' => $_FILES['files']['name'][$i],
                            'FILE_TYPE' => $_FILES['files']['type'][$i],
                            'USER' => $this->user_sso->getUserID()
                        );
                        $fileresult = $this->station->ADD_STATION_FILE($file_parms);
                        var_dump($fileresult);
                    }
                }
            }
            $msg="done";
            redirect('stations/updata_station/'.$this->input->post("STATION_ID").'?op='.$msg);
        }else{
            $msg="fail";
            redirect('stations/updata_station/'.$this->input->post("STATION_ID").'?op='.$msg);
        }
    }

    public function station_licenses()
    {
        if (!$this->user_sso->is_allowed_function('240')) {
             redirect('/messages/disply_msg/1020/');
             return;
         }
        $result['station_sr']=$this->input->post('STATION_SR');
        $result['license_type']=$this->station->GET_LICENSE_TYPES_LIST();
        $parms = array(
            'LICENSE_SR' => null,
            'STATION_SR' => $this->input->post('STATION_SR'),
            'YEAR' => null,
            'LTYPE' => null,
        );
        $result['license']=$this->station->GET_STATIONS_LICENSES_LIST($parms);
        $data = $this->load->view('stations/station_Licenses', $result, TRUE);
        echo json_encode($data);
    }

    public function add_new_station_license()
    {
        if (!$this->user_sso->is_allowed_function('241')) {
             redirect('/messages/disply_msg/1020/');
             return;
         }
        $parms = array(
            'STATION_SR' => $this->input->post('STATION_SR'),
            'LTYPE' => $this->input->post('LTYPE'),
            'YEAR' => $this->input->post('YEAR'),
            'START_DT' => $this->input->post('START_DT'),
            'END_DT' => $this->input->post('END_DT'),
            'NOTES' => $this->input->post('NOTES'),
            'USER'=> $this->user_sso->getUserID());
        $result = $this->station->ADD_NEW_STATION_LICENSE($parms);
        if($result['licenses_sr']>0) {
            if (!empty($_FILES)) {
                for ($i = 0; $i <sizeof($_FILES); $i++) {
                    if (!empty($_FILES[$i]['name'])) {
                        $file_parms = array(
                            'LICENS_SR' => $result['licenses_sr'],
                            'FILE_CONTENT' => $_FILES[$i]['tmp_name'],
                            'FILE_NAME' => $_FILES[$i]['name'],
                            'FILE_TYPE' => $_FILES[$i]['type'],
                            'USER' => $this->user_sso->getUserID()
                        );
                        $fileresult = $this->station->ADD_LICENSE_FILE($file_parms);
                    }
                }
            }
        }
        echo json_encode($result);
    }

    public function search_licenses()
    {
        if (!$this->user_sso->is_allowed_function('240')) {
             redirect('/messages/disply_msg/1020/');
             return;
         }
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = 'مستخدم النظام';
        $data['license_type']=$this->station->GET_LICENSE_TYPES_LIST();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('stations/search_licenses', $data);
        $this->load->view('includes/footer.php', $data);

    }

    public function get_all_stations_licenses()
    {
        if (!$this->user_sso->is_allowed_function('240')) {
             redirect('/messages/disply_msg/1020/');
             return;
         }
        $result['license_type']=$this->station->GET_LICENSE_TYPES_LIST();
        $parms = array(
            'LICENSE_SR' => null,
            'STATION_SR' => $this->input->post('STATION_SR'),
            'YEAR' => $this->input->post('YEAR'),
            'LTYPE' => $this->input->post('LTYPE'),
        );
        $result=$this->station->GET_STATIONS_LICENSES_LIST($parms);
        echo json_encode($result);
    }

    public function open_license_file($FILE_NO)
    {
        $result = $this->station->GET_LICENSE_FILE_CONTENT($FILE_NO);
        $data = $result[0]['FILE_CONTENT'];
        $name = $result[0]['FILE_NAME'];
        $type = $result[0]['FILE_TYPE'];
        header('Cache-Control: must-revalidate');
        header('Pragma: public');
        header('Content-Description: File Transfer');
        header('Content-Disposition: inline; filename=' . $name);
        header('Content-Transfer-Encoding: binary');
        header('Content-Length: ' . strlen($data));
        header('Content-type:' . $type);
        echo $data;
    }




  /*  public function station_visits()
    {
         if (!$this->user_sso->is_allowed_function('')) {
             redirect('/messages/disply_msg/1020/');
             return;
         }
        $result['station_sr']=$this->input->post('STATION_SR');
        $data = $this->load->view('stations/station_visits', $result, TRUE);
        echo json_encode($data);
    }

    public function add_new_station_visit()
    {
        $parms = array(
            'STATION_SR' => $this->input->post('STATION_SR'),
            'LTYPE' => $this->input->post(''),
            'YEAR' => $this->input->post(''),
            'START_DT' => $this->input->post(''),
            'END_DT' => $this->input->post(''),
            'NOTES' => $this->input->post(''),
            'USER'=> $this->user_sso->getUserID());
        $result = $this->station->ADD_NEW_STATION_VISIT($parms);
        echo json_encode($result);
    }


    public function search_visits()
    {
        if (!$this->user_sso->is_allowed_function('')) {
             redirect('/messages/disply_msg/1020/');
             return;
         }
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = 'مستخدم النظام';
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('stations/search_visits', $data);
        $this->load->view('includes/footer.php', $data);

    }*/

}
