<?php if (!defined('BASEPATH')) exit('No direct script access allowed');

class stores extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->load->helper('date');
        $this->load->model('store');
        $this->user_sso->validate_session();
        if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }
    }

    public function add_stores()
    {
        if (!$this->user_sso->is_allowed_function('262')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = 'مستخدم النظام';
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('stores/add_store', $data);
        $this->load->view('includes/footer.php', $data);

    }

    public function search_stores()
    {
        if (!$this->user_sso->is_allowed_function('263')) {
             redirect('/messages/disply_msg/1020/');
             return;
        }
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = 'مستخدم النظام';
        $data['WAREHOUSES'] = $this->store->GET_ALL_WAREHOUSE();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('stores/search_stores', $data);
        $this->load->view('includes/footer.php', $data);

    }

    public function add_new_store()
    {
        if (!$this->user_sso->is_allowed_function('262')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parms = array(
            'STORE_NAME' => $this->input->post('STORE_NAME'),
            'STORE_TYPE' => $this->input->post('STORE_TYPE')           
        );
        $result = $this->store->ADD_NEW_STORE($parms);
        echo json_encode($result);
    }

    public function get_stores_list()
    {
        if (!$this->user_sso->is_allowed_function('263')) {
            redirect('/messages/disply_msg/1020/');
            return;
       }
        $parms = array(
            'STORE_ID' => $this->input->post('STORE_ID'),
        );
        $result = $this->store->GET_STORE_INFO($parms);
        echo json_encode($result);
    }
       
    public function get_stores_warehouse_list()
    {
        $parms = array(
   
            'STORE_TYPE' => $this->input->post('STORE_TYPE')
                
        );
        $result = $this->store->GET_STORE_TYPE_LIST($parms);
        echo json_encode($result);
    }

    public function get_ALL_stores()
    {
        $result = $this->store->GET_ALL_STORES();
        echo json_encode($result);
    }

    public function updateWarehouseInfo(){
    if (!$this->user_sso->is_allowed_function('264')) {
        redirect('/messages/disply_msg/1020/');
        return;
    }

    $parm = array(
        'STR_ID'    =>     $this->input->post("STR_ID"),
     //   'RES_STORE_NAME'    => $this->input->post("RES_STORE_NAME"),
        'RES_STORE_TYPE'    => $this->input->post("RES_STORE_TYPE"),        
       // 'USER'          => $this->user_sso->getUserID()
    );
    $WAREHOUSES = $this->store->updateWarehouseData($parm);
    //var_dump($WAREHOUSES);
    echo json_encode($WAREHOUSES);
}

  public function delete_store()
    {
        $result = $this->store->DELETE_STORE($this->input->post('STR_ID'));
        echo json_encode($result);
    }
}