<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class testers extends CI_Controller
{

    public function __construct()
    {
        parent::__construct();
        $this->load->helper('date');
        $this->load->model('testers_model');
        $this->user_sso->validate_session();

        if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }
    }

    public function index()
    {
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('testers/addTesterForm', $data);
        $this->load->view('includes/footer.php', $data);

    }


    public function addTesterForm()
    {

         if (!$this->user_sso->is_allowed_function('61')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('testers/addTesterForm', $data);
        $this->load->view('includes/footer.php', $data);

    }
    public function addTester() {
         if (!$this->user_sso->is_allowed_function('61')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'TESTER_ID' => $this->input->post('TESTER_ID'),
            'TESTER_NAME' => $this->input->post('TESTER_NAME'),

        );

        $result = $this->testers_model->addTester($parm);

        echo json_encode($result);
    }

    public function testersMaster() {
         if (!$this->user_sso->is_allowed_function('62')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }

        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('testers/testersMaster', $data);
        $this->load->view('includes/footer.php', $data);

    }
    public function getTesters() {

         if (!$this->user_sso->is_allowed_function('62')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }

        $parm = array(
            'TESTER_TERM' => $this->input->post('TESTER_TERM')
        );

        $result = $this->testers_model->getTesters($parm);

        echo json_encode($result);




    }



}
    ?>