<?php
 
if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class user extends CI_Controller {

    public function __construct() {
        parent::__construct();

        $this->user_sso->validate_session();
		if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }
        $this->load->model('user_m');
       
        
    }

    public function index() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
   
        $data['view_title'] = 'المستخدمين - استعلام';
        $data['view_grid_title'] = 'المستخدمين';
        $data['username'] = $this->user_sso->getUserName();

        $usersMaster = $this->user_m->getUsers(array(
            'USER_ID_NO' => null,
            'USER_FNAME' => null,
            'USER_SNAME' => null,
            'USER_LNAME' => null,
            'USER_EMP_NO' => null,
            'USER_STATUS' => null,
            'USER_LEVEL_CD' => null
		));

		$data['usersMaster'] = $usersMaster;
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('user/usersMaster.php', $data);
        $this->load->view('includes/footer.php', $data);
    }
	
	public function manageUser() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'المستخدمين - ادارة الحسابات';
        $data['view_grid_title'] = 'المستخدمين';
        $data['username'] = $this->user_sso->getUserName();

        $roles = $this->user_m->GET_RESP_ROLE(array(
            'I_ROLE_SID' =>null,
            'I_ROLE_NAME' => null,
            'I_ROLE_LOCATION' => $this->session->userdata('sess_location_id')
        ));
 
        $data['roles'] = $roles['ret_data'];
		$data['F_USER_ID_NO'] = $this->input->post('F_USER_ID_NO');;
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('user/manageUser.php', $data);
        $this->load->view('includes/footer.php', $data);
    }


    	public function Add_new_User() {
            if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'المستخدمين - ادارة الحسابات';
        $data['view_grid_title'] = 'المستخدمين';
        $data['username'] = $this->user_sso->getUserName();
        $roles = $this->user_m->GET_RESP_ROLE(array(
            'I_ROLE_SID' =>null,
            'I_ROLE_NAME' => null,
            'I_ROLE_LOCATION' => $this->session->userdata('sess_location_id')
        ));
 
        $data['roles'] = $roles['ret_data'];
	$data['F_USER_ID_NO'] = $this->input->post('F_USER_ID_NO');;
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('user/add_new_user.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

public function Add_new_User_data() {

    if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }

		$data['save']  = $this->user_m->ADD_RESP_USER(
                array(
                    'I_USER_ID_NO' => $this->input->post('USER_ID_NO'),
                    'I_USER_FNAME'=>$this->input->post('USER_FNAME'),
                    'I_USER_SNAME'=>$this->input->post('USER_SNAME'),
                    'I_USER_LNAME'=>$this->input->post('USER_LNAME'),
                    'I_USER_EMP_NO'=>$this->input->post('USER_EMP_NO'),
                    'I_USER_STATUS'=>$this->input->post('USER_STATUS'),
                     'I_USER_LEVEL_CD'=>'',
                     'I_USER_JOP_TITLE'=>$this->input->post('USER_JOP_TITLE'),
                     'I_IS_SYS_ADMIN' =>'0',
                )
            );

     

$role = json_decode($this->input->post('role_rows'));
$data['isert'] ='';

  if ($role > 0) {
            for ($i = 0; $i < count($role); $i++) {

                 $item = json_decode($role[$i]);


                    $parameter = array(
                        'I_USER_ID' => $this->input->post('USER_ID_NO'),
                        'I_ROLE_ID' => $item->ROLE_ID
                        
                    );

                    $data['isert'] = $this->user_m->ADD_RESP_USER_ROLE($parameter);
                   
            }
        }


     //     print json_encode($data['isert']);
         print json_encode($data['save']);

}


    public function getUser() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $userMaster = $this->user_m->getUser(array(
            'USER_ID_NO' => $this->input->post('USER_ID_NO'),
        ));

        $userRoles = null;
        if($userMaster){
            $userRoles = $this->user_m->GET_RESP_USER_ROLE(
                array(
                    'I_USER_ID' => $userMaster['USER_ID_NO'],
                    'I_ROLE_ID' => null
                )
            );
            echo json_encode(array('userMaster' => $userMaster, 'userRoles' => $userRoles['ret_data']));
        }else{
            echo json_encode(array('userMaster' => null, 'userRoles' => null));
        }
    }

    public function getUsers() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $usersMaster = $this->user_m->getUsers(array(
            'USER_ID_NO' => $this->input->post('USER_ID_NO'),
            'USER_FNAME' => $this->input->post('USER_FNAME'),
            'USER_SNAME' => $this->input->post('USER_SNAME'),
            'USER_LNAME' => $this->input->post('USER_LNAME'),
            'USER_EMP_NO' => $this->input->post('USER_EMP_NO'),
            'USER_STATUS' => $this->input->post('USER_STATUS'),
            'USER_LEVEL_CD' => null
        ));
        echo json_encode($usersMaster); 
    }

    public function updateUser() {

        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $recordID = $this->input->post('USER_ID_NO_OLD');
        $this->user_m->DELETE_RESP_USER_ROLE(array(
            'I_USER_ID' => $recordID
        ));
        

        $retArr = $this->user_m->updateUser(array(
            'USER_ID_NO_OLD' => $recordID,
            'USER_ID_NO' => $this->input->post('USER_ID_NO'),
            'USER_FNAME' => $this->input->post('USER_FNAME'),
            'USER_SNAME' => $this->input->post('USER_SNAME'),
            'USER_LNAME' => $this->input->post('USER_LNAME'),
            'USER_EMP_NO' => $this->input->post('USER_EMP_NO'),
            'USER_STATUS' => $this->input->post('USER_STATUS'),
            'USER_JOB_TITLE' => $this->input->post('USER_JOB_TITLE')
        ));

        if ($recordID > 0) {
            $det_rows = json_decode($this->input->post('role_rows'));
            for ($i = 0; $i < count($det_rows); $i++) {
                $item = json_decode($det_rows[$i]);

                $this->user_m->ADD_RESP_USER_ROLE(array(
                    'I_USER_ID' => $recordID,
                    'I_ROLE_ID' => $item->ROLE_ID
                ));
            }
        }
        echo json_encode(array('success' => 1, 'msg' => 'تمت العملية بنجاح.'));
    }

    public function getRole() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $roleMaster = $this->user_m->getRole(array(
            'ROLE_SID' => $this->input->post('ROLE_ID'),
        ));

        $roleFunctions = null;
        if($roleMaster){
            $roleFunctions = $this->user_m->getRoleFunctions(
                array(
                    'ROLE_ID' => $this->input->post('ROLE_ID'),
                )
            );
            echo json_encode(array('roleMaster' => $roleMaster, 'roleFunctions' => $roleFunctions));
        }else{
            echo json_encode(array('roleMaster' => null, 'roleFunctions' => null));
        }
    }

    public function newRole() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['functions'] = $this->user_m->getFunctions();
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('user/newRole.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function manageRole() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['F_ROLE_ID'] = $this->input->post('F_ROLE_ID');
        $data['functions'] = $this->user_m->getFunctions();
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('user/manageRole.php', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function addRole() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $ROLE_SID = $this->user_m->addRole(array(
            'ROLE_NAME' => $this->input->post('ROLE_NAME')
        ));

        if ($ROLE_SID > 0) {
            $det_rows = json_decode($this->input->post('function_rows'));
            for ($i = 0; $i < count($det_rows); $i++) {
                $item = json_decode($det_rows[$i]);

                $this->user_m->addRoleFunction(array(
                    'ROLE_ID' => $ROLE_SID,
                    'FUNCTION_ID' => $item->FUNCTION_ID
                ));
            }
        }
        echo json_encode(array('success' => 1, 'msg' => 'تمت العملية بنجاح.' . $ROLE_SID));
    }

    public function updateRole() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $ROLE_SID = $this->user_m->updateRole(array(
            'ROLE_SID' => $this->input->post('ROLE_ID'),
            'ROLE_NAME' => $this->input->post('ROLE_NAME')
        ));

        if ($ROLE_SID > 0) {
            $det_rows = json_decode($this->input->post('function_rows'));
            for ($i = 0; $i < count($det_rows); $i++) {
                $item = json_decode($det_rows[$i]);

                $this->user_m->addRoleFunction(array(
                    'ROLE_ID' => $ROLE_SID,
                    'FUNCTION_ID' => $item->FUNCTION_ID
                ));
            }
        }
        echo json_encode(array('success' => 1, 'msg' => 'تمت العملية بنجاح.'));
    }

    public function getRoles() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $roles = $this->user_m->getRoles(array(
            'ROLE_SID' => $this->input->post('ROLE_ID'),
            'ROLE_NAME' => $this->input->post('ROLE_NAME')
        ));
        echo json_encode($roles); 
    }

    public function roles() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['roles'] = $this->user_m->getRoles(array(
            'ROLE_SID' =>null,
            'ROLE_NAME' => null
        ));
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('user/rolesMaster.php', $data);
        $this->load->view('includes/footer.php', $data);
    }



















    public function role() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'الصلاحيات - استعلام';
        $data['view_grid_title'] = 'الصلاحيات';
        $data['username'] = 'مستخدم النظام';

        $data['role_master'] = $this->user_m->GET_RESP_ROLE(array(
            'I_ROLE_SID' => null,
            'I_ROLE_NAME' => null,
            'I_ROLE_LOCATION' => $this->session->userdata('sess_location_id')
                ));

        $this->load->view('include/header2.php', $data);
        $this->load->view('user/user_role_master_query.php', $data);
        $this->load->view('include/footer.php', $data);
    }

    

    public function get_role() {

        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $retArr = $this->user_m->GET_RESP_ROLE(array(
            'I_ROLE_SID' => $_POST['ROLE_SID'],
            'I_ROLE_NAME' => $_POST['ROLE_NAME'],
            'I_ROLE_LOCATION' => $this->session->userdata('sess_location_id')
                ));

        $ret = '<table class="mws-datatable-fn mws-table ">
                <thead>
                    <tr>
                        <th width="100px">رقم الصلاحية</th>
                        <th>اسم الصلاحية</th>
                        <th width="45px"></th>
                    </tr>
                </thead>
            <tbody>';



        $role_master = $retArr['ret_data'];


        for ($i = 0; $i < count($role_master); $i++) {


            $ret .= '<tr>' .
                    '<td>' . $role_master[$i]["ROLE_SID"] . '</td>
                        <td>' . $role_master[$i]["ROLE_NAME"] . '</td>
                       <td>
 
                            <a href="index.php/user/edit_r/' . $role_master[$i]["ROLE_SID"] . '" class="mws-button black small cmd" target="_blank">
                               تعديل
                            </a>  
                        </td>

                    </tr>';
        }

        $ret .= '            </tbody>
            <tfoot>
                <tr>
                    <th></th>
                    <th></th>
                    <th></th>
                </tr>
            </tfoot>            
        </table>';





        echo ($ret);
    }
	
	


    public function manage_role() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'الصلاحيات - ادارة صلاحيات المستخدمين';
        $data['view_grid_title'] = 'الصلاحيات';
        $data['username'] = 'مستخدم النظام';

        $data['functions'] = $this->user_m->GET_RESP_FUNCTION();


        $this->load->view('include/header2.php', $data);
        $this->load->view('user/user_role_manage.php', $data);
        $this->load->view('include/footer.php', $data);
    }

    public function add_user() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }

        $retArr = $this->user_m->ADD_RESP_USER(array(
            'I_USER_ID_NO' => $_POST['USER_ID_NO'],
            'I_USER_FNAME' => $_POST['USER_FNAME'],
            'I_USER_SNAME' => $_POST['USER_SNAME'],
            'I_USER_LNAME' => $_POST['USER_LNAME'],
            'I_USER_EMP_NO' => $_POST['USER_EMP_NO'],
            'I_USER_STATUS' => $_POST['USER_STATUS'],
            'I_USER_LEVEL_CD' =>  $_POST['USER_LEVEL_CD'],
            'I_USER_JOP_TITLE' => $_POST['USER_JOP_TITLE'],
            'I_IS_SYS_ADMIN' => $_POST['SYS_ADMIN']
                ));

        $recordID = $_POST['USER_ID_NO'];

        if ($recordID > 0) {

            $det_rows = json_decode($_POST['year_rows']);

            for ($i = 0; $i < count($det_rows); $i++) {
                $item = json_decode($det_rows[$i]);

                $this->user_m->ADD_RESP_USER_YEAR(array(
                    'I_USER_ID' => $recordID,
                    'I_USER_YEAR' => $item->index
                ));
            }

            $det_rows = json_decode($_POST['role_rows']);

            for ($i = 0; $i < count($det_rows); $i++) {
                $item = json_decode($det_rows[$i]);

                $this->user_m->ADD_RESP_USER_ROLE(array(
                    'I_USER_ID' => $recordID,
                    'I_ROLE_ID' => $item->index
                ));
            }
            
            if ($this->session->userdata('sess_is_super_admin') == '1') {

                $det_rows = json_decode($_POST['loc_rows']);

                for ($i = 0; $i < count($det_rows); $i++) {
                    $item = json_decode($det_rows[$i]);

                    $this->user_m->ADD_RESP_USER_LOCATION(array(
                        'I_USER_ID' => $recordID,
                        'I_LOCATION_CODE' => $item->index
                    ));
                }
            }
        }
    }

    public function add_role() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }

        $retArr = $this->user_m->ADD_RESP_ROLE(array(
            'I_ROLE_NAME' => $_POST['ROLE_NAME'],
            'I_ROLE_LOCATION' => $this->session->userdata('sess_location_id')
                ));

        $recordID = $retArr['responseId'];


        if ($recordID > 0) {

            $det_rows = json_decode($_POST['role_fns']);

            for ($i = 0; $i < count($det_rows); $i++) {
                $item = json_decode($det_rows[$i]);

                $this->user_m->ADD_RESP_ROLE_FUNCTION(array(
                    'I_ROLE_ID' => $recordID,
                    'I_FUNCTION_ID' => $item->index
                ));
            }
        }
    }

    

    public function edit_role() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }

        $recordID = $_POST['ROLE_SID'];

        $this->user_m->DELETE_RESP_ROLE_FUNCTION(array(
            'I_ROLE_ID' => $recordID
        ));

        $retArr = $this->user_m->UPDATE_RESP_ROLE(array(
            'I_ROLE_SID' => $_POST['ROLE_SID'],
            'I_ROLE_NAME' => $_POST['ROLE_NAME'],
            'I_ROLE_LOCATION' => $this->session->userdata('sess_location_id')
                ));

        $recordID = $retArr['responseId'];

        if ($recordID > 0) {

            $det_rows = json_decode($_POST['role_fns']);

            for ($i = 0; $i < count($det_rows); $i++) {
                $item = json_decode($det_rows[$i]);

                $this->user_m->ADD_RESP_ROLE_FUNCTION(array(
                    'I_ROLE_ID' => $recordID,
                    'I_FUNCTION_ID' => $item->index
                ));
            }
        }
    }

    

    public function edit_r() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'الصلاحيات - ادارة صلاحيات المستخدمين';
        $data['view_grid_title'] = 'الصلاحيات';
        $data['username'] = 'مستخدم النظام';

        $data['functions'] = $this->user_m->GET_RESP_FUNCTION();


        $this->load->view('include/header2.php', $data);
        $this->load->view('user/user_role_manage.php', $data);
        $this->load->view('user/user_role_srp.php', $data);
        $this->load->view('include/footer.php', $data);
    }

    public function get_by_id_user() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $USER_ID_NO = $_POST['USER_ID_NO'];
        $I_USER_LEVEL_CD = null;
        
        if ($this->session->userdata('sess_is_super_admin')) {
            $I_USER_LEVEL_CD=null;
        } else {
            $I_USER_LEVEL_CD = $this->session->userdata('sess_location_id');
        }
        
        $data['user_master'] = $this->user_m->GET_RESP_USER(array(
            'I_USER_ID_NO' => $USER_ID_NO,
            'I_USER_FNAME' => null,
            'I_USER_SNAME' => null,
            'I_USER_LNAME' => null,
            'I_USER_EMP_NO' => null,
            'I_USER_STATUS' => null,
            'I_USER_LEVEL_CD' => $I_USER_LEVEL_CD
                ));


        $data['user_role'] = $this->user_m->GET_RESP_USER_ROLE(array(
            'I_USER_ID' => $data['user_master']['ret_data'][0]['USER_ID_NO'],
            'I_ROLE_ID' => null
                ));

        $data['user_year'] = $this->user_m->GET_RESP_USER_YEAR(array(
            'I_USER_ID' => $data['user_master']['ret_data'][0]['USER_ID_NO'],
            'I_USER_YEAR' => null
                ));
        
        $data['user_loc'] = $this->user_m->GET_RESP_USER_LOCATION(array(
            'I_USER_ID' => $data['user_master']['ret_data'][0]['USER_ID_NO'] 
                ));        

        echo json_encode($data);
    }

    public function get_by_id_role() {
        if ($this->session->userdata('sess_is_sys_admin') != '1') {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $ROLE_ID = $_POST['ROLE_ID'];

        $data['role_info'] = $this->user_m->GET_RESP_ROLE(array(
            'I_ROLE_SID' => $ROLE_ID,
            'I_ROLE_NAME' => null,
            'I_ROLE_LOCATION' => $this->session->userdata('sess_location_id')
                ));
                
        $data['role_fns'] = $this->user_m->GET_RESP_ROLE_FUNCTION(array(
            'I_ROLE_ID' => $data['role_info']['ret_data'][0]['ROLE_SID'],
            'I_FUNCTION_ID' => null
                ));

        echo json_encode($data);
    }
	
	
	public function logout() {
        $this->session->sess_destroy();
        $this->user_sso->logout();		
    }


}

?>