<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class userChains extends CI_Controller {

    public function __construct() {
        parent::__construct();
        $this->load->model('user_chain');
        $this->load->helper('date');
        $this->load->model('consignment');
        $this->load->model('constants');
        $this->user_sso->validate_session();
        if (!$this->user_sso->is_valid_session()) {
            $userSSO_ID = $this->user_sso->getUserID();
            $this->user_sso->set_user_session($userSSO_ID);
        }
    }

    public function index() {
        if (!$this->user_sso->is_allowed_function('1')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $data['view_title'] = 'الصفحة الرئيسية';
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('home', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function userChainMaster() { 

     if (!$this->user_sso->is_allowed_function('40')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $data['allowedToApprove'] = $this->user_sso->is_allowed_function('42'); 
        $data['allowedToReturn'] = $this->user_sso->is_allowed_function('43'); 
        $data['allowedToCancel'] = $this->user_sso->is_allowed_function('44'); 
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('userChains/userChainsMaster', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function chainMaster() {  
         if (!$this->user_sso->is_allowed_function('163')) {
            redirect('/messages/disply_msg/1020/');
            return;
        } 
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('userChains/chainsMaster', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function userChain() {
        if (!$this->user_sso->is_allowed_function('39')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('userChains/userChain', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function manageUserChain() {
        if (!$this->user_sso->is_allowed_function('41')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['F_CHAIN_SERIAL'] = $this->input->post('F_CHAIN_SERIAL');
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('userChains/manageUserChain', $data);
        $this->load->view('includes/footer.php', $data);
    }
 

    public function addUserChain() {
        if (!$this->user_sso->is_allowed_function('161')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CAHIN_DATE' => $this->input->post('CAHIN_DATE'),
            'CHAIN_DESC' => $this->input->post('CHAIN_DESC'),
            'INSERT_USER' => $this->user_sso->getUserID()
        );
        
        $result = null;
        $userChainDetails = json_decode($this->input->post('userChainDetails'));
        if (count($userChainDetails) > 0) {
            $result = $this->user_chain->addUserChain($parm);
            $chainSerial = $result['chainSerial'];
            if ($chainSerial > 0) {
                for ($i = 0; $i < count($userChainDetails); $i++) {   
                    $item = json_decode($userChainDetails[$i]);
                    $userChainDetail = $this->user_chain->addUserChainDetails(array(
                        'CHAIN_SERIAL' => $chainSerial,
                        'FROM_ACCOUNT' => $item->FROM_ACCOUNT,
                        'TO_ACCOUNT' => $item->TO_ACCOUNT,
                        'AMOUNT' => $item->AMOUNT
                    ));
                    if($userChainDetail['chainDetailSerial'] <= 0){
                        $result = array('success' => $userChainDetail['success'], 'msg' => $userChainDetail['msg']);
                    }
                }
            } else {
                $result = array('success' => $result['success'], 'msg' => $result['msg']);
            }
        } else {
            $result = array('success' => 0, 'msg' => 'يجب أن يحتوي القيد على سجل واحد على الأقل');
        }
        echo json_encode($result);
    }

    public function updateUserChain() {
        if (!$this->user_sso->is_allowed_function('41')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CHAIN_SERIAL' => $this->input->post('CHAIN_SERIAL'),
            'CAHIN_DATE' => $this->input->post('CAHIN_DATE'),
            'CHAIN_DESC' => $this->input->post('CHAIN_DESC'),
            'INSERT_USER' => $this->user_sso->getUserID()
        );
        
        $result = null;
        $userChainDetails = json_decode($this->input->post('userChainDetails'));
        if (count($userChainDetails) > 0) {
            $result = $this->user_chain->updateUserChain($parm);
            if ($result['chainSerial'] > 0) {
                for ($i = 0; $i < count($userChainDetails); $i++) {
                    $item = json_decode($userChainDetails[$i]);
                    $userChainDetail = $this->user_chain->addUserChainDetails(array(
                        'CHAIN_SERIAL' => $this->input->post('CHAIN_SERIAL'),
                        'FROM_ACCOUNT' => $item->FROM_ACCOUNT,
                        'TO_ACCOUNT' => $item->TO_ACCOUNT,
                        'AMOUNT' => $item->AMOUNT
                    ));
                }
            } else {
                $result = array('success' => $result['success'], 'msg' => $result['msg']);
            }
        } else {
            $result = array('success' => 0, 'msg' => 'يجب أن تحتوي الارسالية على شاحنة واحدة على الأقل');
        }

        echo json_encode($result);
    }


    public function getUserChains() {
         if (!$this->user_sso->is_allowed_function('162')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CHAIN_SERIAL' => $this->input->post('CHAIN_SERIAL'),
            'START_DT' => $this->input->post('START_DT'),
            'END_DT' => $this->input->post('END_DT'),
            'STATUS' => $this->input->post('STATUS')
        );
        $userChains = $this->user_chain->getUserChains($parm);
        echo json_encode($userChains);
    }

    public function getChains() {
        if (!$this->user_sso->is_allowed_function('164')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CHAIN_SERIAL' => $this->input->post('CHAIN_SERIAL'),
            'CHAIN_DT_FROM' => $this->input->post('CHAIN_DT_FROM'),
            'CHAIN_DT_TO' => $this->input->post('CHAIN_DT_TO'),
            'TRANS_TYPE' => $this->input->post('TRANS_TYPE'),
            'TRANS_SERIAL' => $this->input->post('TRANS_SERIAL'),
            'ACCOUNT_NO' => $this->input->post('ACCOUNT_NO')
        );
        $userChains = $this->user_chain->getChains($parm);
        echo json_encode($userChains);
    }



    public function getUserChain() {
        $parm = array(
            'CHAIN_SERIAL' => $this->input->post('CHAIN_SERIAL')
        );
        $userChainMaster = $this->user_chain->getUserChain($parm);
        $userChainDetails = $this->user_chain->getUserChainDetails($parm);
        echo json_encode(array('userChainMaster' => $userChainMaster, 'userChainDetails' => $userChainDetails));
    }

    
   

    public function approveUserChain() {
        if (!$this->user_sso->is_allowed_function('42')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CHAIN_SERIAL' => $this->input->post('CHAIN_SERIAL'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->user_chain->approveUserChain($parm);
        echo json_encode($result);
    }

    public function returnUserChain() {
        if (!$this->user_sso->is_allowed_function('43')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CHAIN_SERIAL' => $this->input->post('CHAIN_SERIAL'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->user_chain->returnUserChain($parm);
        echo json_encode($result);
    }

    public function cancelUserChain() {
        if (!$this->user_sso->is_allowed_function('44')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $parm = array(
            'CHAIN_SERIAL' => $this->input->post('CHAIN_SERIAL'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->user_chain->cancelUserChain($parm);
        echo json_encode($result);
    }

    public function getAccount() {
        $parm = array(
            'ACCOUNT_ID' => $this->input->post('ACCOUNT_ID')
        );
        $account = $this->cash_receipt->getAccount($parm);
        echo json_encode($account);
    }
    
    public function getChainTypesList(){
        $types = $this->user_chain->getChainType(NULL , NULL);
        echo json_encode($types); exit() ;
    }




    public function companies_ratios() {
        if (!$this->user_sso->is_allowed_function('224')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('userChains/companies_ratios', $data);
        $this->load->view('includes/footer.php', $data);
    }


    public function GET_COMPANIES_RATIOS() {
        $parm = array(
            'ACCOUNT_ID' => $this->input->post('ACCOUNT_ID'),
            'PRODUCT_ID' => $this->input->post('PRODUCT_ID'),
            'START_DATE' => $this->input->post('START_DATE'),
            'END_DATE' => $this->input->post('END_DATE'),
        );
        $result = $this->user_chain->GET_COMPANIES_RATIOS($parm);
        echo json_encode($result);
    }

    public function GetCompaniesFin() {
        if (!$this->user_sso->is_allowed_function('225')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = '';
        $data['username'] = $this->user_sso->getUserName();
        $data['banks'] = $this->constants->getBanks();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('userChains/companiesfinstanding', $data);
        $this->load->view('includes/footer.php', $data);
    }
    
    public function GetCompaniesFinData(){
        $parm = array(
            'CATEGORY' => $this->input->post('CATEGORY'),
            'QDATE' => $this->input->post('QDATE'),
            'TODAY_ORDER' => ($this->input->post('TODAY_ORDER'))? 1 : 0 ,
        );
        $result = $this->user_chain->GET_COMPANIES_FIN_STANDING($parm);
        echo json_encode($result);
    }


    public function addBankTransferRecieptInfo() {
        $parm = array(
            'SERIAL' => $this->input->post('SERIAL'),
            'RECEIPT_DT' => $this->input->post('RECEIPT_DT'),
            'ACCOUNT' => $this->input->post('ACCOUNT'),
            'TRANS_ID' => $this->input->post('TRANS_ID'),
            'TRANS_AMOUNT' => $this->input->post('TRANS_AMOUNT'),
            'TARGET_ACNT' => $this->input->post('TARGET_ACNT'),
            'STATUS' => '1',
            'NOTES' => 'Some Notes Here.'
        );
        $result = $this->cash_receipt->addBankTransferRecieptInfo($parm);
        echo json_encode($result);
    }

    public function GetAccountsSummary() {
        if (!$this->user_sso->is_allowed_function('226')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['view_title'] = 'فهرس الحسابات';
        $data['username'] = $this->user_sso->getUserName();
        $data['categories'] = $this->constants->getAccountsCategories();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('userChains/accountsIndex', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function getAccountsSummaryList(){
        if (!$this->user_sso->is_allowed_function('226')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $category = $this->input->post('ACCOUNT_ID');
        $result = $this->user_chain->getAccountsSummaryIndex($category);
        echo json_encode($result);
    }

    public function exchangeTransaction() {
        if (!$this->user_sso->is_allowed_function('227')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $TRANSID = $this->input->post('F_TRANS_SERIAL');
        if(!empty($TRANSID)){
            $transData = $this->user_chain->getExchangeCurrencyTrans(array('TRANS_ID'=>$TRANSID));
            $transData = $transData[0];
        }
        else {
            $transData = array(
                'TO_ACCOUNT' => '', 'TO_ACC_NAME' => '', 'TO_CURRENCY' => '', 'TO_CURN_NAME' => '', 
                'FROM_ACCOUNT' => '', 'FROM_ACC_NAME' => '', 'FROM_CURRENCY' => '', 'FROM_CURN_NAME' => '', 
                'SERIAL_NO' => '', 'EXCHANGE_RATE' => '', 'TRANS_AMOUNT' => '', 'TRANS_DT' => '', 'TRANS_NOTE' => ''
            );
        }
        $data['transData'] = $transData ; 
        $data['username'] = $this->user_sso->getUserName();
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('userChains/currencyExchange', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function addNewExchangeTransaction(){
        if (!$this->user_sso->is_allowed_function('227')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $info = array(
            'FROM_ACCOUNT' => $this->input->post('FROM_ACCOUNT'),
            'FROM_CURRENCY' => $this->input->post('FROM_CURRENCY'),
            'TO_ACCOUNT' => $this->input->post('TO_ACCOUNT'),
            'TO_CURRENCY' => $this->input->post('TO_CURRENCY'),
            'TRANS_AMOUNT' => $this->input->post('TRANS_AMOUNT'),
            'RATE' => $this->input->post('RATE'),
            'TRANS_DATE' => $this->input->post('TRANS_DATE'),
            'USER' => $this->user_sso->getUserID(),
            'NOTES' => $this->input->post('NOTES')
        );
        $result = $this->user_chain->addExchangeCurrencyTrans($info);
        echo json_encode($result);
    }

    public function exchangeTransMaster() {
        if (!$this->user_sso->is_allowed_function('228')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $data['username'] = $this->user_sso->getUserName();
        $data['allowedToApprove'] = $this->user_sso->is_allowed_function('229'); 
        $data['allowedToReturn'] = $this->user_sso->is_allowed_function('231'); 
        $data['allowedToCancle'] = $this->user_sso->is_allowed_function('230'); 
        $data['allowedToEdit'] = $this->user_sso->is_allowed_function('235'); 
        $this->load->view('includes/header.php', $data);
        $this->load->view('includes/sidebar', $data);
        $this->load->view('userChains/manageCurrencyExchange', $data);
        $this->load->view('includes/footer.php', $data);
    }

    public function getExchangeTransactionsList(){
        if (!$this->user_sso->is_allowed_function('228')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $info = array(
            'FROM_ACCOUNT' => $this->input->post('FROM_ACCOUNT'),
            'FROM_CURRENCY' => $this->input->post('FROM_CURRENCY'),
            'TO_ACCOUNT' => $this->input->post('TO_ACCOUNT'),
            'TO_CURRENCY' => $this->input->post('TO_CURRENCY'),
            'FROM_DATE' => $this->input->post('FROM_DATE'),
            'TO_DATE' => $this->input->post('TO_DATE'),
            'TRANS_ID' => $this->input->post('TRANS_SR'),
            'STATUS' => $this->input->post('TRANS_STAT')
        );
        $result = $this->user_chain->getExchangeCurrencyTrans($info);
        echo json_encode($result);
    }

    public function approveExchangeTransaction(){
        if (!$this->user_sso->is_allowed_function('229')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $info = array(
            'TRANS_ID' => $this->input->post('TARNS_SR'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->user_chain->approveExchangeCurrencyTrans($info);
        echo json_encode($result);
    }

    public function cancleExchangeTransaction(){
        if (!$this->user_sso->is_allowed_function('230')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $info = array(
            'TRANS_ID' => $this->input->post('TARNS_SR'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->user_chain->cancleExchangeCurrencyTrans($info);
        echo json_encode($result);
    }

    public function returnExchangeTransaction(){
        if (!$this->user_sso->is_allowed_function('231')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $info = array(
            'TRANS_ID' => $this->input->post('TARNS_SR'),
            'USER' => $this->user_sso->getUserID()
        );
        $result = $this->user_chain->returnExchangeCurrencyTrans($info);
        echo json_encode($result);
    }

    public function changeExchangeTransaction(){
        if (!$this->user_sso->is_allowed_function('235')) {
            redirect('/messages/disply_msg/1020/');
            return;
        }
        $info = array(
            'SERIAL_NO' => $this->input->post('TRANS_ID'),
            'FROM_ACCOUNT' => $this->input->post('FROM_ACCOUNT'),
            'FROM_CURRENCY' => $this->input->post('FROM_CURRENCY'),
            'TO_ACCOUNT' => $this->input->post('TO_ACCOUNT'),
            'TO_CURRENCY' => $this->input->post('TO_CURRENCY'),
            'TRANS_AMOUNT' => $this->input->post('TRANS_AMOUNT'),
            'RATE' => $this->input->post('RATE'),
            'TRANS_DATE' => $this->input->post('TRANS_DATE'),
            'USER' => $this->user_sso->getUserID(),
            'NOTES' => $this->input->post('NOTES')
        );
        $result = $this->user_chain->editExchangeCurrencyTrans($info);
        echo json_encode($result);
    }
}

?>
