<?php 
if (!defined('BASEPATH'))
	exit('No direct script access allowed');

class warehouses extends CI_Controller {

	public function __construct() {
		parent::__construct();

		$this->user_sso->validate_session();

		if (!$this->user_sso->is_valid_session()) {
			$userSSO_ID = $this->user_sso->getUserID();
			$this->user_sso->set_user_session($userSSO_ID);
		}

		$this->load->helper('date');
		$this->load->model('warehouse');
	}

	public function index() {
		$this->manageWarhouseTrans();
	}

	public function warhouseTrans(){
		if (!$this->user_sso->is_allowed_function('256')) {
			redirect('/messages/disply_msg/1020/');
			return;
		}
		$data['warehouses'] = $this->warehouse->getWarehousesList(); 
		$data['transactions'] = $this->warehouse->getTransactionsTypesList() ;
		$data['allow_to_add'] = $this->user_sso->is_allowed_function('1');
		$data['username'] = $this->user_sso->getUserName();
		$this->load->view('includes/header.php', $data);
		$this->load->view('includes/sidebar', $data);
		$this->load->view('warehouse/warehouse_trans_form.php', $data);
		$this->load->view('includes/footer.php', $data);
	}

	public function addWarhouseTransaction(){
		if (!$this->user_sso->is_allowed_function('256')) {
			redirect('/messages/disply_msg/1020/');
			return;
		}
		$parm = array(
				'TRANS_DATE'    => $this->input->post('TRANS_DATE'),
				'TRANS_TYPE'    => $this->input->post('TRANS_TYPE'),
				'FUEL_CAT'      => $this->input->post('FUEL_CAT'),
				'FROM_WAREHOUSE'=> $this->input->post('FROM_WAREHOUSE'),
				'TO_WAREHOUSE'  => $this->input->post('TO_WAREHOUSE'),
				'TRANS_AMOUNT'  => $this->input->post('TRANS_AMOUNT'),
				'TRANS_NOTES'  => $this->input->post('TRANS_NOTES'),
				'USER'          => $this->user_sso->getUserID()
		);
		$consignments = $this->warehouse->addNewWarehouseTransaction($parm);
		echo json_encode($consignments);
		exit() ;
	}

	public function manageWarhouseTrans(){
		if (!$this->user_sso->is_allowed_function('257')) {
			redirect('/messages/disply_msg/1020/');
			return;
		}
		$data['warehouses'] = $this->warehouse->getWarehousesList();
		$data['product'] = $this->warehouse->getProductWarehouseList();
		$data['username'] = $this->user_sso->getUserName();
		$data['allowedToEdit'] = $this->user_sso->is_allowed_function('258');
		$data['allowedToApprove'] = $this->user_sso->is_allowed_function('259');
		$data['allowedToCancel'] = $this->user_sso->is_allowed_function('260');
		$data['allowedToReturn'] = $this->user_sso->is_allowed_function('261');
		$this->load->view('includes/header.php', $data);
		$this->load->view('includes/sidebar', $data);
		$this->load->view('warehouse/warehouseTransMaster.php', $data);
		$this->load->view('includes/footer.php', $data);
	}

	public function getWarhouseTransaction(){
		if (!$this->user_sso->is_allowed_function('257')) {
			redirect('/messages/disply_msg/1020/');
			return;
		}
		$parm = array(
				'WAREHOUSE_NO'    => $this->input->post('WAREHOUSE'),
				'FUEL_CAT'      => $this->input->post('FUEL_CAT'),
				'TRANS_TYPE'    => $this->input->post('TRANS_TYPE'),
				'START_DT'=> $this->input->post('START_DT'),
				'END_DT'=> $this->input->post('END_DT'),
				'STATUS'=> $this->input->post('STATUS'),
		);
		$warehouse_trans = $this->warehouse->getRegisdwarehouseTrans($parm);
		echo json_encode($warehouse_trans);
		exit() ;
	}

	public function AproveWarehouseTrans() {
		if (!$this->user_sso->is_allowed_function('259')) {
			echo json_encode(array('success' => 0, 'msg' => 'لا يوجد لديك صلاحيات لهذه العملية.'));
			return;
		}
		$parm = array(
				'TRANS_SR' => $this->input->post('TRANS_SR'),
				'USER' => $this->user_sso->getUserID()
		);
		$result = $this->warehouse->AproveWarehouseTrans($parm);
		echo json_encode($result);
	}
	//safaa

	public function updateWarehouseTrans(){
		if (!$this->user_sso->is_allowed_function('258')) {
			redirect('/messages/disply_msg/1020/');
			return;
		}
		$data['warehouses'] = $this->warehouse->getWarehousesList();
		$data['product'] = $this->warehouse->getProductWarehouseList();
		$data['warehouses_info'] = $this->warehouse->getWarehousestransForm($this->input->post('U_TRANS_SR'));
		$data['username'] = $this->user_sso->getUserName();
		// var_dump($data['warehouses_info']);exit();
		$this->load->view('includes/header.php', $data);   
		$this->load->view('includes/sidebar', $data);
		$this->load->view('warehouse/updateWarehousTrans.php', $data);
		$this->load->view('includes/footer.php', $data);
	}

	public function updateWarehouseTransAction(){
		if (!$this->user_sso->is_allowed_function('258')) {
			redirect('/messages/disply_msg/1020/');
			return;
		}
		$parm = array(
				'TRANS_SR'    => $this->input->post('TRANS_SR'),
				'TRANS_TYPE'    => $this->input->post('TRANS_TYPE'),
				'TRANS_DATE'    => $this->input->post('TRANS_DATE'),
				'FUEL_CAT'      => $this->input->post('FUEL_CAT'),
				'FROM_WAREHOUSE'=> $this->input->post('FROM_WAREHOUSE'),
				'TO_WAREHOUSE'  => $this->input->post('TO_WAREHOUSE'),
				'TRANS_AMOUNT'  => $this->input->post('TRANS_AMOUNT'),
				'RELATED_SR'  => $this->input->post('RELATED_SR'),
				'TRANS_NOTE'  => $this->input->post('TRANS_NOTE'),
				'USER'          => $this->user_sso->getUserID()
		);
		$consignments = $this->warehouse->updateWarehouseTransInfo($parm);
		echo json_encode($consignments);
	}

	public function rejectWarehouseTrans() {
		if (!$this->user_sso->is_allowed_function('260')) {
			echo json_encode(array('success' => 0, 'msg' => 'لا يوجد لديك صلاحيات لهذه العملية.'));
			return;
		}
		$parm = array(
				'TRANS_SR' => $this->input->post('TRANS_SR'),
				'USER' => $this->user_sso->getUserID()
		);
		$result = $this->warehouse->rejectWarehouseTrans($parm);
		echo json_encode($result);
	}

	public function returnWarehouseTrans() {
		if (!$this->user_sso->is_allowed_function('261')) {
			echo json_encode(array('success' => 0, 'msg' => 'لا يوجد لديك صلاحيات لهذه العملية.'));
			return;
		}
		$parm = array(
				'TRANS_SR' => $this->input->post('TRANS_SR'),
				'USER' => $this->user_sso->getUserID()
		);
		$result = $this->warehouse->returnWarehouseTrans($parm);
		echo json_encode($result);
	}

}

?>