<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Check extends CI_Model {

    public function __construct() {
        parent::__construct();
    }

     
    public function addUserChain($data) {
        $chainSerial = -1;
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_CAHIN_DATE', 'value' => $data['CAHIN_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CHAIN_DESC', 'value' => $data['CHAIN_DESC'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_INSERT_USER', 'value' => $data['INSERT_USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SERIAL_NO', 'value' => &$chainSerial, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'ADD_USER_CHAIN', $paramts, $results);
        return array('chainSerial' => $chainSerial, 'success' => $success, 'msg' => $msg);
    }

    public function addUserChainDetails($data) {
        $chainDetailSerial = -1;
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_CHAIN_SERIAL', 'value' => $data['CHAIN_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FROM_ACCOUNT', 'value' => $data['FROM_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TO_ACCOUNT', 'value' => $data['TO_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_AMOUNT', 'value' => $data['AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DET_SERIAL_NO', 'value' => &$chainDetailSerial, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'ADD_USER_CHAIN_DETAILS', $paramts, $results);
        return array('chainDetailSerial' => $chainDetailSerial, 'success' => $success, 'msg' => $msg);
    }

     public function updateUserChain($data) {
        $chainSerial = -1;
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_SERIAL_NO', 'value' => $data['CHAIN_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CAHIN_DATE', 'value' => $data['CAHIN_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CHAIN_DESC', 'value' => $data['CHAIN_DESC'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_INSERT_USER', 'value' => $data['INSERT_USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SERIAL_NO', 'value' => &$chainSerial, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'UPDATE_USER_CHAIN', $paramts, $results);
        return array('chainSerial' => $chainSerial, 'success' => $success, 'msg' => $msg);
    }



    public function approveUserChain($data) {
        $success = 0;
        $msg = "";
        $paramts = array(
            array('name' => ':I_SERIAL_NO', 'value' => $data['CHAIN_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),  
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'APPROVE_USER_CHAIN', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }

    public function returnUserChain($data) {
        $success = 0;
        $msg = "";
        $paramts = array(
            array('name' => ':I_SERIAL_NO', 'value' => $data['CHAIN_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),  
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'RETURN_USER_CHAIN', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }

    public function cancelUserChain($data) {
        $success = 0;
        $msg = "";
        $paramts = array(
            array('name' => ':I_SERIAL_NO', 'value' => $data['CHAIN_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),  
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'CANCEL_USER_CHAIN', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }


    public function getUserChains($data) {
        $cursor = $this->db->get_cursor();
        $cnt = '';
        $paramts = array(
            array('name' => ':I_SERIAL_NO', 'value' => $data['CHAIN_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $data['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATUS', 'value' => $data['STATUS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_CHAINS', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'GET_USER_CHAINS', $paramts, $results);
        return $results;
    }

    public function getUserChain($data) {
        $cursor = $this->db->get_cursor();
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_CHAIN_SERIAL', 'value' => $data['CHAIN_SERIAL'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_CHAIN', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'GET_USER_CHAIN', $paramts, $results);
        return (count($results) > 0)? $results[0] : null;
    }

    public function getUserChainDetails($data) {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_CHAIN_SERIAL', 'value' => $data['CHAIN_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DETAILS', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'GET_USER_CHAIN_DETAILS', $paramts, $results);
        return (count($results) > 0)? $results : null;
    }




    public function getChains($data) {
        $cursor = $this->db->get_cursor();
        $cnt = '';
        $paramts = array(
            array('name' => ':I_CHSAN_SERIAL', 'value' => $data['CHAIN_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CHAIN_DT_FROM', 'value' => $data['CHAIN_DT_FROM'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CHAIN_DT_TO', 'value' => $data['CHAIN_DT_TO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_TYPE', 'value' => $data['TRANS_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_SERIAL', 'value' => $data['TRANS_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ACCOUNT_NO', 'value' => $data['ACCOUNT_NO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_CHAINS', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'GET_CHAINS', $paramts, $results);
        return (count($results) > 0)? $results : null;
    }
    
    public function getDetaildAccountStatement($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ACCOUNT', 'value' => $data['ACCOUNT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $data['END_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('REPORTS_PKG', 'PRINT_DETAILED_ACCOUNT_STAT', $paramts, $results);
        return  $results ;
        
    }






















    public function getGazPetrolAccounts($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_TEARM', 'value' => $data['TEARM'], 'length' => -1, 'type' => OCI_ASSOC), 
            array('name' => ':O_DATA ', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('GLOBAL_PKG', 'GET_GAZ_PETROL_ACCOUNTS', $paramts, $results);
        return (count($results) > 0)? $results : null;
    }


    public function getAccounts($data) {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_TEARM', 'value' => $data['TEARM'], 'length' => -1, 'type' => OCI_ASSOC), 
            array('name' => ':O_DATA ', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('GLOBAL_PKG', 'GET_ACCOUNT_INFO_BY_NAME', $paramts, $results);
        return (count($results) > 0)? $results : null;
    }


    public function getAccount($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ACCOUNT_ID', 'value' => $data['ACCOUNT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_RECEIPT', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('GLOBAL_PKG', 'GET_ACCOUNT', $paramts, $results);
        return (count($results) > 0)? $results[0] : null;
       
    }

    public function getBank($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ID', 'value' => $data['BANK_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_RECEIPT', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('GLOBAL_PKG', 'GET_BANK', $paramts, $results);
        return (count($results) > 0)? $results[0] : null;
       
    }
    
    public function getOotConsignemetSerial(){
        $serial = -1 ; 
        $paramts = array(
            array('name' => ':O_CONS_SR', 'value' => &$serial, 'length' => -1, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CONSIGNMENTS_PKG', 'GET_OUT_CONSIGNMENT_SERIAL_NO', $paramts, $results);
        return $serial;
       
    }
    
    public function getChainType($term, $chain_id){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_TERM', 'value' => $term, 'length' => 20, 'type' => OCI_ASSOC),
            array('name' => ':I_ID', 'value' => $chain_id, 'length' => 3, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'GET_CHAIN_TYPE', $paramts, $results);
        return $results ;
    }

}

