<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Fees_Model extends CI_Model {

    public function __construct() {
        parent::__construct();
    }

    public function getDistributorInfo($term){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_TERM', 'value' => $term, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('FEES_PKG', 'GET_DISTRIBUTOR_BY_TERM', $paramts, $results);
        return $results;
    }
    
    public function addNewPayableFees($info){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_CLIENT_TYPE', 'value' => $info['CLIENT_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CLIENT_ID', 'value' => $info['CLIENT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FEE_TYPE', 'value' => $info['FEE_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FEE_AMOUNT', 'value' => $info['FEE_AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_MERIT_DT', 'value' => $info['MERIT_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTE', 'value' => $info['FEE_NOTES'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'ADD_MERITED_FEES', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function getPayableFeesList($info){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_FEE_SR', 'value' =>$info['FEE_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CLIENT_TYPE', 'value' =>$info['CLIENT_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CLIENT_ID', 'value' =>$info['CLIENT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FEE_TYPE', 'value' =>$info['FEE_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_MERIT_ST', 'value' =>$info['MERIT_ST'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_MERIT_END', 'value' =>$info['MERIT_END'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATUS', 'value' =>$info['STATUS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR) 
        );
        $this->db->stored_procedure('FEES_PKG', 'GET_PAYABLE_FEES_DATA', $paramts, $results);
        return ($results);
    }

    public function updatePayableFees($info){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_FEE_SR', 'value' => $info['FEE_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CLIENT_TYPE', 'value' => $info['CLIENT_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CLIENT_ID', 'value' => $info['CLIENT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FEE_TYPE', 'value' => $info['FEE_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FEE_AMOUNT', 'value' => $info['FEE_AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_MERIT_DT', 'value' => $info['MERIT_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTE', 'value' => $info['FEE_NOTES'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'UPDATE_MERITED_FEES', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function approvePayableFees($FEE_SERIAL, $USER){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_FEE_SR', 'value' => $FEE_SERIAL, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $USER, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'APPROVE_MERITED_FEE', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function cancelPayableFees($FEE_SERIAL, $USER){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_FEE_SR', 'value' => $FEE_SERIAL, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $USER, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'CANCEL_MERITED_FEE', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function returnPayableFees($FEE_SERIAL, $USER){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_FEE_SR', 'value' => $FEE_SERIAL, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $USER, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'RETURN_MERITED_FEE', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function addPayment($info){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_CLIENT_TYPE', 'value' => $info['CLIENT_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CLIENT_ID', 'value' => $info['CLIENT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECP_TYPE', 'value' => $info['RECEIPT_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECP_ID', 'value' => $info['RECEIPT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_AMOUNT', 'value' => $info['AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CURRENCY', 'value' => $info['CURRENCY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_BANK', 'value' => $info['BANK'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PAY_DT', 'value' => $info['PAYMENT_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CHECK_BANK', 'value' => $info['CHECK_BANK'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CHECK_DT', 'value' => $info['CHECK_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTE', 'value' => $info['PAY_NOTES'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'ADD_PAYMENT', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function updatePayment($info){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_PAY_SR', 'value' => $info['PAY_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CLIENT_TYPE', 'value' => $info['CLIENT_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CLIENT_ID', 'value' => $info['CLIENT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECP_TYPE', 'value' => $info['RECEIPT_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECP_ID', 'value' => $info['RECEIPT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_AMOUNT', 'value' => $info['AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CURRENCY', 'value' => $info['CURRENCY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_BANK', 'value' => $info['BANK'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PAY_DT', 'value' => $info['PAYMENT_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CHECK_BANK', 'value' => $info['CHECK_BANK'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CHECK_DT', 'value' => $info['CHECK_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTE', 'value' => $info['PAY_NOTES'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'UPDATE_PAYMENT', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function getPaymentsList($info){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_PAY_SR', 'value' =>$info['PAY_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CLIENT_TYPE', 'value' =>$info['CLIENT_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CLIENT_ID', 'value' =>$info['CLIENT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECP_TYPE', 'value' =>$info['RECEIPT_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CHECK_STATE', 'value' =>$info['CHECK_STATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PAY_ST', 'value' =>$info['PAY_ST'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PAY_END', 'value' =>$info['PAY_END'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATUS', 'value' =>$info['STATUS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR) 
        );
        $this->db->stored_procedure('FEES_PKG', 'GET_PAYMENTS_DATA', $paramts, $results);
        return ($results);
    }

    public function approvePayment($PAY_SR, $USER){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_PAY_SR', 'value' => $PAY_SR, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $USER, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'APPROVE_PAYMENT', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function cancelPayment($PAY_SR, $USER){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_PAY_SR', 'value' => $PAY_SR, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $USER, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'CANCEL_PAYMENT', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function returnPayment($PAY_SR, $USER){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_PAY_SR', 'value' => $PAY_SR, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $USER, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'RETURN_PAYMENT', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function depositPaymentInBank($data){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_PAY_SR', 'value' => $data['PAY_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_DEPOSIT_DT', 'value' => $data['DEPOSIT_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'DEPOSIT_PAYMENT_CHECK_IN_BANK', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function returnPaymentInBank($data){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_PAY_SR', 'value' => $data['PAY_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RETURN_DT', 'value' => $data['RETURN_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'RETURN_PAYMENT_CHECK', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function colleckPaymentCheck($data){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_PAY_SR', 'value' => $data['PAY_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COLLECT_DT', 'value' => $data['COLLECT_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'COLLECT_PAYMENT_CHECK', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function transformPayToIraad($data){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_PAY_SR', 'value' => $data['PAY_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_AMOUNT', 'value' => $data['TRANS_AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_DT', 'value' => $data['TRANS_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'TRANSFORM_PAY_TO_IRAAD', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function getOparatingFeesAccountStatement($info){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_CLIENT_TYPE', 'value' =>$info['CLIENT_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CLIENT_ID', 'value' =>$info['CLIENT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' =>$info['START_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' =>$info['END_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR) 
        );
        $this->db->stored_procedure('REPORTS_PKG', 'PRINT_OPERATIONG_FEES_STATMENT', $paramts, $results);
        return ($results);
    }

    public function getInstituteBankAccounts($currency = 2){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_CURRENCY', 'value' => $currency, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR) 
        );
        $this->db->stored_procedure('FEES_PKG', 'GET_FEES_BANKS', $paramts, $results);
        return ($results);
    }

    public function addBankCommissionInfo($data){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_COM_DATE', 'value' => $data['COMS_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COM_AMOUNT', 'value' => $data['COMS_AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COM_CURRENCY', 'value' => $data['COMS_CURRENCY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COM_BANK', 'value' => $data['COMS_BANK'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COM_NOTES', 'value' => $data['COMS_NOTES'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'ADD_BANK_COMMISSION_INFO', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function getBankCommissionsList($info){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_SERIAL', 'value' => $info['COMMIS_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_BANK', 'value' => $info['COMMIS_BANK'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $info['COMMIS_START'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $info['COMMIS_END'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATUS', 'value' => $info['COMMIS_STATUS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR) 
        );
        $this->db->stored_procedure('FEES_PKG', 'GET_BANK_COMMISSIONS_LIST', $paramts, $results);
        return ($results);
    }

    public function approveCommission($info){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_SERIAL', 'value' => $info['COMMIS_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'APPROVE_BANK_COMMISSION', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function cancelCommission($info){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_SERIAL', 'value' => $info['COMMIS_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'CANCEL_BANK_COMMISSION', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

    public function returnCommission($info){
        $success = -1 ; $msg = '' ; 
        $paramts = array(
            array('name' => ':I_SERIAL', 'value' => $info['COMMIS_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FEES_PKG', 'RETURN_BANK_COMMISSION', $paramts, $results);
        return array('SUCCESS' => $success , 'MSG'=>$msg) ; 
    }

}