<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class guarantee extends CI_Model {

    public function __construct() {
        parent::__construct();
    }

     
    public function addGuarantee($data) {
        $guaranteeSerial = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_COMPANY', 'value' => $data['COMPANY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ACCOUNT', 'value' => $data['ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_BANK', 'value' => $data['BANK'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_BANK_ACCOUNT', 'value' => $data['BANK_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_GUARANTEE_VALUE', 'value' => $data['GUARANTEE_VALUE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DATE', 'value' => $data['START_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DATE', 'value' => $data['END_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_GUARANTEE_SID', 'value' => &$guaranteeSerial, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('GUARANTEE_PKG', 'ADD_GUARANTEE', $paramts, $results);
        return array('guaranteeSerial' => $guaranteeSerial, 'msg' => $msg);
    }


     public function updateGuarantee($data) {
        $guaranteeSerial = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_GUARANTEE_SID', 'value' => $data['GUARANTEE_SID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COMPANY', 'value' => $data['COMPANY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ACCOUNT', 'value' => $data['ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_BANK', 'value' => $data['BANK'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_BANK_ACCOUNT', 'value' => $data['BANK_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_GUARANTEE_VALUE', 'value' => $data['GUARANTEE_VALUE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DATE', 'value' => $data['START_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DATE', 'value' => $data['END_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_GUARANTEE_SID', 'value' => &$guaranteeSerial, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('GUARANTEE_PKG', 'UPDATE_GUARANTEE', $paramts, $results);
        return array('guaranteeSerial' => $guaranteeSerial, 'msg' => $msg);
    }



    public function approveGuarantee($data) {
        $guaranteeSerial = 0;
        $msg = '';
        $paramts = array(
            array('name' => ':I_GUARANTEE_SID', 'value' => $data['GUARANTEE_SID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_GUARANTEE_SID', 'value' => &$guaranteeSerial, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('GUARANTEE_PKG', 'APPROVE_GUARANTEE', $paramts, $results);
        return array('guaranteeSerial' => $guaranteeSerial, 'msg' => $msg);
    }

    public function returnGuarantee($data) {
        $guaranteeSerial = 0;
        $msg = '';
        $paramts = array(
            array('name' => ':I_GUARANTEE_SID', 'value' => $data['GUARANTEE_SID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_GUARANTEE_SID', 'value' => &$guaranteeSerial, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('GUARANTEE_PKG', 'RETURN_GUARANTEE', $paramts, $results);
        return array('guaranteeSerial' => $guaranteeSerial, 'msg' => $msg);
    }

    public function cancelGuarantee($data) {
        $guaranteeSerial = 0;
        $msg = '';
        $paramts = array(
            array('name' => ':I_GUARANTEE_SID', 'value' => $data['GUARANTEE_SID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_GUARANTEE_SID', 'value' => &$guaranteeSerial, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('GUARANTEE_PKG', 'CANCEL_GUARANTEE', $paramts, $results);
        return array('guaranteeSerial' => $guaranteeSerial, 'msg' => $msg);
    }


    public function getGuarantees($data) {
        $cursor = $this->db->get_cursor();
        $cnt = '';
        $paramts = array(
            array('name' => ':I_GUARANTEE_SID', 'value' => $data['GUARANTEE_SID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COMPANY', 'value' => $data['COMPANY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ACCOUNT', 'value' => $data['ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_BANK', 'value' => $data['BANK'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_BANK_ACCOUNT', 'value' => $data['BANK_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_GUARANTEE_VALUE', 'value' => $data['GUARANTEE_VALUE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DATE', 'value' => $data['START_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DATE', 'value' => $data['END_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATUS', 'value' => $data['STATUS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_GUARANTEES', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('GUARANTEE_PKG', 'GET_GUARANTEES', $paramts, $results);
        return (count($results) > 0)? $results : null;
    }

    public function getGuarantee($data) {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_GUARANTEE_SID', 'value' => $data['GUARANTEE_SID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_GUARANTEE', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('GUARANTEE_PKG', 'GET_GUARANTEE', $paramts, $results);
        return (count($results) > 0)? $results[0] : null;
    }
}

