<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Notice extends CI_Model {

    public function __construct() {
        parent::__construct();
    }
    
    public function getTotalPurchases($info){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_COM_ACC', 'value' => $info['COMPANY_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PROD_CAT', 'value' => $info['PRODUCT_CAT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PROD_TYPE', 'value' => $info['PRODUCT_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $info['START_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $info['END_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTICE_TYPE', 'value' => $info['NOTICE_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'GET_TOTAL_COMPANIES_PURCHASES', $paramts, $results);
        return array('com_info' => $results) ; 
    }
    
    public function issueTaxInvoice($info){
        $success = -1 ; $msg = '' ; $notice_sr = -1 ;
        $paramts = array(
            array('name' => ':I_COM_ACC', 'value' => $info['COM_ACCOUNT'], 'length' => 3, 'type' => OCI_ASSOC),
            array('name' => ':I_PROD_CAT', 'value' => $info['CATEGORY'], 'length' => 1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATR_DT', 'value' => $info['START_DT'], 'length' => 20, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $info['END_DT'], 'length' => 20, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTE', 'value' => '', 'length' => 50, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_NOTICE_SR', 'value' => &$notice_sr, 'length' => 5, 'type' => OCI_ASSOC),
           // array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 200, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'ISSUE_TAX_INVOICE_TO_COMPANY', $paramts, $results);
        return array('SUCCESS' => $success , 'NOTICE_SR'=>$notice_sr , 'MSG'=>$msg) ; 
    }
    
    public function getNotificationsList($info){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_COM_ACC', 'value' => $info['COM_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTICE_TYPE', 'value' => $info['N_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PROD_CAT', 'value' => $info['CATEGORY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PROD_TYPE', 'value' => $info['PRODUCT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $info['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $info['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'GET_COMPANY_NOTICES_LIST', $paramts, $results);
        return array('notice_list' => $results) ;  
    }
    
    public function issueTransNotice($info){
        $msg = '' ; 
        $notice_sr = -1 ;
        $paramts = array(
            array('name' => ':I_COM_ACC', 'value' => $info['COM_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PROD_CAT', 'value' => $info['CATEGORY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATR_DT', 'value' => $info['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $info['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTE', 'value' => '', 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_NOTICE_SR', 'value' => &$notice_sr, 'length' => 28, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 200, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'ISSUE_TRANS_NOTICE_TO_COMPANY', $paramts, $results);
        return array('NOTICE_SR'=>$notice_sr , 'MSG'=>$msg) ; 
    }
    
    public function issueSurplusNotice($info){
        $msg = '' ; 
        $notice_sr = -1 ;
        $paramts = array(
            array('name' => ':I_COM_ACC', 'value' => $info['COM_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PROD_TYPE', 'value' => $info['PRODUCT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATR_DT', 'value' => $info['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $info['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTE', 'value' => '', 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_NOTICE_SR', 'value' => &$notice_sr, 'length' => 28, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 200, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'ISSUE_SURPLUS_NOTICE_TO_COM', $paramts, $results);
        return array('NOTICE_SR'=>$notice_sr , 'MSG'=>$msg) ; 
        
    }
    
    public function issueLackNotice($info){
        $msg = '' ; 
        $notice_sr = -1 ;
        $paramts = array(
            array('name' => ':I_COM_ACC', 'value' => $info['COM_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PROD_TYPE', 'value' => $info['PRODUCT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATR_DT', 'value' => $info['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $info['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTE', 'value' => '', 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_NOTICE_SR', 'value' => &$notice_sr, 'length' => 28, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 200, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'ISSUE_LACK_NOTICE_TO_COMPANY', $paramts, $results);
        return array('NOTICE_SR'=>$notice_sr , 'MSG'=>$msg) ; 
        
    }
    
    public function issueOpFeeNotice($info){
        $msg = '' ; 
        $notice_sr = -1 ;
        $paramts = array(
            array('name' => ':I_COM_ACC', 'value' => $info['COM_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PROD_CAT', 'value' => $info['CATEGORY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATR_DT', 'value' => $info['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $info['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_AMOUNT', 'value' => $info['OP_AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTE', 'value' => '', 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_NOTICE_SR', 'value' => &$notice_sr, 'length' => 28, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 200, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'ISSUE_OPERATION_NOTICE', $paramts, $results);
        return array('NOTICE_SR'=>$notice_sr , 'MSG'=>$msg) ; 
    }

    public function issueCashNotice($info){
        $msg = '' ; 
        $notice_sr = -1 ;
        $paramts = array(
            array('name' => ':I_COM_ACC', 'value' => $info['COM_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PROD_CAT', 'value' => $info['CATEGORY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATR_DT', 'value' => $info['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $info['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_AMOUNT', 'value' => $info['OP_AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTE', 'value' => '', 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_NOTICE_SR', 'value' => &$notice_sr, 'length' => 28, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 200, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'ISSUE_CASH_DISCOUNT_NOTICE', $paramts, $results);
        return array('NOTICE_SR'=>$notice_sr , 'MSG'=>$msg) ; 
    }

    public function issueDifferencesNotice($info){
        $msg = '' ; 
        $notice_sr = -1 ;
        $paramts = array(
            array('name' => ':I_COM_ACC', 'value' => $info['COM_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PROD_TYPE', 'value' => $info['PRODUCT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATR_DT', 'value' => $info['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $info['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_NOTICE_SR', 'value' => &$notice_sr, 'length' => 28, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 200, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'ISSUE_PRODUCT_DIFFERENCES_NOTICE', $paramts, $results);
        return array('NOTICE_SR'=>$notice_sr , 'MSG'=>$msg) ; 
    }

    public function issueScaleFeesNotice($info){
        $msg = '' ; 
        $notice_sr = -1 ;
        $paramts = array(
            array('name' => ':I_COM_ACC', 'value' => $info['COM_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PROD_CAT', 'value' => $info['CATEGORY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATR_DT', 'value' => $info['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $info['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_NOTICE_SR', 'value' => &$notice_sr, 'length' => 28, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 200, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'ISSUE_SCALE_FEES_NOTICE', $paramts, $results);
        return array('NOTICE_SR'=>$notice_sr , 'MSG'=>$msg) ; 
    }

    public function getIssuedNoticesList($info){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_NOTE_SR', 'value' => $info['NOTICE_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COM_ACC', 'value' => $info['COM_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTICE_TYPE', 'value' => $info['N_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PROD_CAT', 'value' => $info['CATEGORY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PROD_TYPE', 'value' => $info['PRODUCT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $info['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $info['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATUS', 'value' => $info['STATUS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'GET_ISSUED_NOTICES_LIST', $paramts, $results);
        return array('notice_list' => $results) ;  
    }

    public function approveNotification($info){
        $msg = '' ; 
        $success = -1 ;
        $paramts = array(
            array('name' => ':I_NOTICE_ID', 'value' => $info['NOTICE_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 28, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 200, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'APPROVE_ISSUED_NOTIFICATION', $paramts, $results);
        return array('success'=>$success , 'msg'=>$msg) ;
    }

    public function returnNotification($info){
        $msg = '' ; 
        $success = -1 ;
        $paramts = array(
            array('name' => ':I_NOTICE_ID', 'value' => $info['NOTICE_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 28, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 200, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'RETURN_ISSUED_NOTIFICATION', $paramts, $results);
        return array('success'=>$success , 'msg'=>$msg) ;
    }


    public function deleteNotification($info){
        $msg = '' ; 
        $success = -1 ;
        $paramts = array(
            array('name' => ':I_NOTICE_SR', 'value' => $info['SERIAL_NO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_DELETE_NOTE', 'value' => $info['DEL_NOTE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER_ID', 'value' => $info['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 28, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 200, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'DELETE_ISSUED_NOTIFICATION', $paramts, $results);
        return array('success'=>$success , 'msg'=>$msg) ;
    }

    public function getCashDiscAccountStatment($info){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ACCOUNT', 'value' => $info['COMPANY_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $info['START_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $info['END_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('REPORTS_PKG', 'PRINT_DETAILED_CHASH_DISC_STAT', $paramts, $results);
        return $results ;  
    }
     
}