<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Orders extends CI_Model {

    public function __construct() {
        parent::__construct();
    }
    
	
	 public function sendOrderToport($data) {
        $masterId = -1;
		$success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_MASTER_SR', 'value' => $data['MASTER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
		    array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 5, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('ORDERS_PKG', 'SEND_ORDER_TO_PORT', $paramts, $results);
		return array('success' => $success, 'msg' => $msg);
    }
	
	
    public function saveOrdersMaster($data) {
        $masterId = -1;
        $msg = '';
		
		
		
        $paramts = array(
            array('name' => ':I_ORDER_DATE', 'value' => $data['ORDER_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ORDER_TYPE', 'value' => $data['ORDER_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_MASTER_STATUS', 'value' => $data['MASTER_STATUS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_MASTER_FLAG', 'value' => $data['MASTER_FLAG'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MASTER_ID', 'value' => &$masterId, 'length' => 11, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('ORDERS_PKG', 'SAVE_ORDER_MASTER', $paramts, $results);
        return array('masterId' => $masterId, 'msg' => $msg);;
    }
    

    // GET_DEFERRED_CHECKS_LIST get_defered_checks_list
    public function getDeferedChecksList($data) {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ACCOUNT', 'value' => $data['I_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TO_DATE', 'value' => $data['I_TO_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_CHECKS_LIST', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );

        $this->db->stored_procedure('FINANCIAL_PKG', 'GET_DEFERRED_CHECKS_LIST', $paramts, $results);
        return $results;
    }
    


    public function getOrdersMaster($data) {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ORDER_FROM_DATE', 'value' => $data['FROM_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ORDER_TO_DATE', 'value' => $data['TO_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ORDER_TYPE', 'value' => $data['ORDER_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_MASTER_STATUS', 'value' => $data['MASTER_STATUS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_MASTER_FLAG', 'value' => $data['MASTER_FLAG'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_ORDER_MASTER', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
		// GET_MASTER_INFO_NEW ORDERS_PKG
		$this->db->stored_procedure('ORDERS_PKG', 'GET_MASTER_INFO', $paramts, $results);
       // $this->db->stored_procedure('ORDERS_PKG', 'GET_MASTER_INFO', $paramts, $results);
        return $results;
		
	  
    }
    
    
    public function saveOrderInfo($data) {
        $orderId = -1;
        $msg = '';
        $results = NULL;
		
		
		
		
        $paramts = array(
            array('name' => ':I_ORDER_ID', 'value' => $data['ORDER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ORDER_DATE', 'value' => $data['ORDER_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FUEL_CATEGORY', 'value' => $data['ORDER_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COM_ACCOUNT', 'value' => $data['ACCOUNT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
			array('name' => ':I_ACC_BALANCE', 'value' => $data['I_ACC_BALANCE'], 'length' => -1, 'type' => OCI_ASSOC),
			array('name' => ':I_CHECKS', 'value' => $data['I_CHECKS'], 'length' => -1, 'type' => OCI_ASSOC),
			array('name' => ':I_GURANTEES', 'value' => $data['I_GURANTEES'], 'length' => -1, 'type' => OCI_ASSOC),
			array('name' => ':I_ORDER_PRICE', 'value' => $data['I_ORDER_PRICE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_OLD_ORDERS', 'value' => $data['I_OLD_ORDERS'], 'length' => -1, 'type' => OCI_ASSOC),
			array('name' => ':I_TOTAL_BALANCE', 'value' => $data['I_TOTAL_BALANCE'], 'length' => -1, 'type' => OCI_ASSOC),
			array('name' => ':I_TODAY_ORDER', 'value' => $data['I_Todayck'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_GROUP_NO', 'value' => $data['GROUP_NO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RANK_NO', 'value' => $data['RANK_NO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_ORDER_ID', 'value' => &$orderId, 'length' => 11, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('ORDERS_PKG', 'SAVE_ORDER_INFO', $paramts, $results);
		//$this->db->stored_procedure('ORDERS_PKG', 'SAVE_ORDER_INFO', $paramts, $results);

        return array('orderId' => $orderId, 'msg' => $msg);
    }
    
    public function saveOrderFuelInfo($data) {
        $orderId = -1;
        $msg = '';
        $results = NULL;
        $paramts = array(
            array('name' => ':I_ORDER_ID', 'value' => $data['ORDER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PRODUCT_TYPE', 'value' => $data['PRODUCT_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ORDERED_AMOUNT', 'value' => $data['ORDERED_AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_APPROVED_AMOUNT', 'value' => $data['APPROVED_AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PRODUCT_PRICE', 'value' => $data['PRODUCT_PRICE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECEIVED_AMOUNT', 'value' => $data['RECEIVED_AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECEIVE_STATUS', 'value' => $data['RECEIVE_STATUS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('ORDERS_PKG', 'SAVE_ORDER_FUEL_INFO', $paramts, $results);
        return array('orderId' => $orderId, 'msg' => $msg);
    }

    /*

      PROCEDURE GET_ORDER_INFO (
      I_ORDER_DATE            IN      VARCHAR2,
      I_FUEL_CATEGORY         IN      ORDER_MASTER_TB.FUEL_CATEGORY%TYPE,
      I_USER                  IN      VARCHAR2,
      O_ORDER_INFO            OUT     SYS_REFCURSOR,
      O_MSG                   OUT VARCHAR2
      );


     */
    
    
    public function getOrdersInfo($data) {
        $cursor = $this->db->get_cursor();
        $msg = '';
        $paramts = array(
            array('name' => ':I_ORDER_DATE', 'value' => $data['I_ORDER_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FUEL_CATEGORY', 'value' => $data['I_FUEL_CATEGORY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TODAY_ORDER', 'value' => $data['I_Todayck'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['I_USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_ORDER_INFO', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC),
        );

        $this->db->stored_procedure('ORDERS_PKG', 'GET_ORDER_INFO', $paramts, $results);
        return array('ordersInfo' => $results, 'msg' => $msg);
    }

    public function GET_ORDER_INFO($data) {
        $cursor = $this->db->get_cursor();
        $msg = '';
        $paramts = array(
            array('name' => ':I_ORDER_DATE', 'value' => $data['I_ORDER_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FUEL_CATEGORY', 'value' => $data['I_FUEL_CATEGORY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['I_USER'], 'length' => -1, 'type' => OCI_ASSOC),
            //array('name' => ':O_ORDER_INFO', 'value' => &$order_sr, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_ORDER_INFO', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC),
        );

        $this->db->stored_procedure('ORDERS_PKG', 'GET_ORDER_INFO', $paramts, $results);
        return array('DATA' => $results, 'O_ORDER_INFO' => $cursor, 'MSG' => $msg);
    }

    public function getCompaniesInfoForPetrolOrder($data) {
        $cursor = $this->db->get_cursor();
        $order_sr = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_ORDER_DT', 'value' => $data['ORDER_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FUEL_CAT', 'value' => $data['FULE_CAT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_ORDER_SR', 'value' => &$order_sr, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('ORDERS_PKG', 'START_ORDER_PREPERATION', $paramts, $results);
        return array('DATA' => $results, 'ORDER_SR' => $order_sr, 'MSG' => $msg);
    }

    public function createOrder($data) {
        $orderId = -1;
        $cursor = $this->db->get_cursor();

        $msg = '';
        $results = NULL;
        $paramts = array(
            array('name' => ':I_ORDER_DATE', 'value' => '21/02/2018', 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ORDER_TYPE', 'value' => $data['Order_type'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_ORDER_ID', 'value' => &$orderId, 'length' => 11, 'type' => OCI_ASSOC),
            array('name' => ':O_ORDER_MASTER', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('ORDERS_PKG', 'CREATE_ORDER', $paramts, $results);
        return $results;
        echo '<pre>';
        print_r($results);
        exit;
        //return array('OrderId' => $results[0][ORDER_ID], 'success' => $results[0]['success'], 'msg' => $results[0]['msg']);
        return isset($results[0]) ? $results[0] : null;
    }

    public function approveOrder($data) {
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_ORDER_ID', 'value' => $data['ORDER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 5, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('ORDERS_PKG', 'APPROVE_ORDER', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }
	
	//  		// ORDERS_PKG.ADD_AVAILABLE_ORDER_DATE 
	/*
	  'I_ORDER_DT' => $this->input->post('I_ORDER_DT'),
            'I_RAFAH' => $this->input->post('I_RAFAH'),
            'I_KARM' => $this->input->post('I_KARM'),
    
	ORDERS_PKG.GET_AVAILABLE_ORDERS_DATES (
        I_ORDER_DT  IN  VARCHAR2,		-- ÊÇÑíÎ ãÍÏÏ ãÑÇÏ ÇáÈÍË Úäå (ÛíÑ ÇáÒÇãí)
        O_DATA      OUT GLOBAL_PKG.MYCURSOR	-- ÇáÈíÇäÇÊ ÇáãÑÌÚÉ:
    )						-- ORDER_DT	ÊÇÑíÎ ÇáØáÈíÉ
						-- RAFAH_PORT  	ÇáØáÈíÉ ãÊÇÍÉ ÚÈÑ ãÚÈÑ ÑÝÍ (0æ 1)
						-- KARM_PORT	ÇáØáÈíÉ ãÊÇÍÉ ÚÈÑ ãÚÈÑ ßÑã ÃÈæ ÓÇáã(0æ 1)

	
	
	
	*/
	
	 public function getAvailableDays($data) {
		 
		  //  var_dump($data);
			
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ORDER_DT', 'value' => $data['I_ORDER_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('ORDERS_PKG', 'GET_AVAILABLE_ORDERS_DATES', $paramts, $results);
		
        return (isset($results) ? $results : array());
		
    }
	
	
	 public function removeAvailableDays($data) {
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_ORDER_DT', 'value' => $data['I_ORDER_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 5, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
       // $this->db->stored_procedure('ORDERS_PKG', 'REMOVE_AVAILABLE_ORDER_DATE', $paramts, $results);
        $this->db->stored_procedure('ORDERS_PKG', 'REMOVE_AVAILABLE_ORDER_DATE', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
 	
    }
	

	
	
	
    public function addAvailabeDate($data) {
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_ORDER_DT', 'value' => $data['I_ORDER_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RAFAH', 'value' => $data['I_RAFAH'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_KARM', 'value' => $data['I_KARM'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RAFAH_GAS', 'value' => $data['I_RAFAH_GAS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 5, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('ORDERS_PKG', 'ADD_AVAILABLE_ORDER_DATE', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }
	


    /*
      PROCEDURE GET_ORDERS_MASTER(
      I_ORDER_ID        IN      ORDERS_MASTER_TB.ORDER_ID%TYPE,
      I_FROM        IN      VARCHAR2,
      I_TO        IN      VARCHAR2,
      I_TYPE        IN      ORDERS_MASTER_TB.ORDER_TYPE%TYPE,
      I_STATUS        IN      ORDERS_MASTER_TB.ORDER_STATUS%TYPE,
      O_DATA      OUT     SYS_REFCURSOR
      )  AS



     */

    /*

      public function getInConsignmentsLst(){
      if (!$this->user_sso->is_allowed_function('201')) {
      redirect('/messages/disply_msg/1020/');
      return;
      }
      $parm = array(
      'CON_SR' => $this->input->post('CON_ID'),
      'START_DT' => $this->input->post('START_DT'),
      'END_DT' => $this->input->post('END_DT'),
      'IN_PORT' => $this->input->post('IN_PORT'),
      'FUEL_TYPE' => $this->input->post('FUEL_TYPE'),
      'STATUS' => $this->input->post('STATUS'),
      'BILL_NO' => $this->input->post('BILL_NO')
      );
      $consignments = $this->consignment->getInConsignments($parm);
      echo json_encode($consignments); exit() ;
      }


     */

    public function getInitialOrdersList($info) {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ORDER_ID', 'value' => $info['I_ORDER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FROM', 'value' => $info['I_FROM'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TO', 'value' => $info['I_TO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TYPE', 'value' => $info['I_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATUS', 'value' => $info['I_STATUS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        //print_r($paramts) ; exit() ; 
        $this->db->stored_procedure('ORDERS_PKG', 'GET_ORDER_MASTER', $paramts, $results);
        return array('com_info' => $results);
    }

    public function getOrderMaster($id) {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ORDER_ID', 'value' => $id, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('ORDERS_PKG', 'GET_ORDER_MASTER', $paramts, $results);
        return (isset($results[0]) ? $results[0] : array());
    }

    public function getOrderDetails($id) {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ORDER_ID', 'value' => $id, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('ORDERS_PKG', 'GET_ORDER_DETAILS', $paramts, $results);
        return $results;
    }
    
    public function getAgentsToNotify($order_date, $order_type) {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ORDER_DT', 'value' => $order_date, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ORDER_TYP', 'value' => $order_type, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('ORDERS_PKG', 'GET_ORDER_SMS_NOTICES_INFO', $paramts, $results);
        return $results;
    }

}
