<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Rafah_port_model extends CI_Model
{

    public function __construct()
    {
        parent::__construct();
    }

    public function getJobTitlesList(){
        $cursor =  $this->db->get_cursor();
        $parameters = array(
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR) 
        );
        $this->db->stored_procedure('PORTS_PKG', 'GET_JOB_TITLES_LIST', $parameters, $results);
        return $results;
    }

    public function getRafahPortWorkersByTerm($TERM){
        $cursor =  $this->db->get_cursor();
        $parameters = array(
            array('name' => ':I_TERM', 'value' => $TERM, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR) 
        );
        $this->db->stored_procedure('PORTS_PKG', 'GET_RAFAH_PORT_WORKER_BY_TERM', $parameters, $results);
        return $results;
    }

    public function addRafahShiftInfo($data){
        $shiftSr = -1 ; 
        $msg = '' ; 
        $paramts = array(
            array('name' => ':I_SHIFT_DT', 'value' => $data['SHIFT_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_SHIFT_START', 'value' => $data['START_TIME'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_SHIFT_END', 'value' => $data['END_TIME'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_DIRECTION', 'value' => $data['WORK_DIRECTION'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['INSERT_USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SHIFT_SR', 'value' => &$shiftSr, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 1000, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('PORTS_PKG', 'ADD_RAFAH_PROT_SHIFT_INFO', $paramts, $results);
        return array('SERIAL' => $shiftSr, 'MSG' => $msg);  
    }

    public function addRafahSiftWorker($data){
        $success = -1 ; 
        $msg = '' ; 
        $paramts = array(
            array('name' => ':I_SHIFT_SR', 'value' => $data['SHIFT_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_WORKER_ID', 'value' => $data['WORKER_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_JOB_TITLE', 'value' => $data['JOB_TITLE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 1000, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('PORTS_PKG', 'ADD_RAFAH_PORT_SHIFT_WORKERS', $paramts, $results);
        return array('SUCCESS' => $success, 'MSG' => $msg);  
    }

    public function getWorkShiftsInfo($data){
        $cursor =  $this->db->get_cursor();
        $parameters = array(
            array('name' => ':I_SERIAL', 'value' => $data['SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_SHIFT_ST_DT', 'value' => $data['START_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_SHIFT_ED_DT', 'value' => $data['END_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_DIRECTION', 'value' => $data['WORK_DIRECTION'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR) 
        );
        $this->db->stored_procedure('PORTS_PKG', 'GET_RAFAH_PORT_SHIFT_INFO', $parameters, $results);
        return $results;
    }

    public function deleteShiftInfo($data){
        $success = -1 ; 
        $msg = '' ; 
        $paramts = array(
            array('name' => ':I_SHIFT_SR', 'value' => $data['SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 1000, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('PORTS_PKG', 'DELETE_RAFAH_PORT_SHIFT_INFO', $paramts, $results);
        return array('SUCCESS' => $success, 'MSG' => $msg);  
    }

    public function getRafahTanksList(){
        $cursor =  $this->db->get_cursor();
        $parameters = array(
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR) 
        );
        $this->db->stored_procedure('PORTS_PKG', 'GET_RAFAH_PORT_TANKS_INFO', $parameters, $results);
        return $results;
    }

    public function addTankGaugesData($data){
        $success = -1 ; 
        $paramts = array(
            array('name' => ':I_AT_WORK', 'value' => $data['AT_WORK'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_GAUGE_DATE', 'value' => $data['GAUGE_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_GAUGE_TIME', 'value' => $data['GAUGE_TIME'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_SHIFT_SR', 'value' => $data['SHIFT_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TANK', 'value' => $data['TANK_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PRODUCT', 'value' => $data['TANK_PRODUCT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_VALUE', 'value' => $data['TANK_VALUE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTES', 'value' => $data['TANK_NOTES'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['INSERT_USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => -1, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('PORTS_PKG', 'ADD_RAFAH_PORT_TANKS_GAUGES', $paramts, $results);
        return $success;  
    }

    public function getTanksGaugesData($info){
        $cursor =  $this->db->get_cursor();
        $parameters = array(
            array('name' => ':I_GAUGE_START', 'value' => $info['GAUGE_START'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_GAUGE_END', 'value' => $info['GAUGE_END'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_AT_DAY_TIME', 'value' => $info['AT_DAY_TIME'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_SHIFT_SR', 'value' => $info['SHIFT_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TANK_SR', 'value' => $info['TANK_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PRODUCT', 'value' => $info['PRODUCT_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR) 
        );
        $this->db->stored_procedure('PORTS_PKG', 'GET_RAFAH_PORT_TANKS_GAUGES_DATA', $parameters, $results);
        return $results;
    }

    public function getPreviousDayTanksGauges($info){
        $cursor =  $this->db->get_cursor();
        $parameters = array(
            array('name' => ':I_TODAY', 'value' => $info['GDAY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR) 
        );
        $this->db->stored_procedure('PORTS_PKG', 'GET_PREVIOUS_DAY_LAST_GAUGES', $parameters, $results);
        return $results;
    }

}

