<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class samples_model extends CI_Model
{

    public function __construct()
    {
        parent::__construct();
    }

    public function addNewFuelSample($data)
    {
        $SampleSerial = -1;

        $msg = '';
        $paramts = array(
            array('name' => ':I_FINANCIAL_NO', 'value' => $data['FINANCIAL_NO'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_COMPANY', 'value' => $data['COMPANY'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_RECEIVE_DATE', 'value' => $data['RECEIVE_DATE'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_RECEIVE_TIME', 'value' => $data['RECEIVE_TIME'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_RECEIVE_PLACE', 'value' => $data['RECEIVE_PLACE'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_NO_OF_SAMPLES', 'value' => $data['NO_OF_SAMPLES'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_FUEL_TYPE', 'value' => $data['FUEL_TYPE'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTES', 'value' => $data['NOTES'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_RECEIVE_COMMITEE', 'value' => $data['RECEIVE_COMMITEE'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_FINANCIAL_NO', 'value' => &$SampleSerial, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('SAMPLES_PKG', 'ADD_NEW_FUEL_SAMPLE', $paramts,$results);
        return array('sampleSerial' => $SampleSerial, 'msg' => $msg);

    }

    public function getSamples($data) {
        $cursor = $this->db->get_cursor();

        $paramts = array(
            array('name' => ':I_FINANCIAL_NO', 'value' => $data['FINANCIAL_NO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COMPANY', 'value' => $data['COMPANY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $data['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECEIVE_PLACE', 'value' => $data['RECEIVE_PLACE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_Data', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)


        );
        $this->db->stored_procedure('SAMPLES_PKG', 'GET_FUEL_SAMPLE_LIST', $paramts, $results);
             return (count($results) > 0)? $results : null;
    }

    public function getSamplesCount($data) {
        $cnt = 0;

        $paramts = array(
            array('name' => ':I_FINANCIAL_NO', 'value' => $data['FINANCIAL_NO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COMPANY', 'value' => $data['COMPANY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $data['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECEIVE_PLACE', 'value' => $data['RECEIVE_PLACE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_COUNT', 'value' => &$cnt, 'length' => 300, 'type' => OCI_ASSOC)


        );
        $this->db->stored_procedure('SAMPLES_PKG', 'GET_FUEL_SAMPLE_COUNT', $paramts, $results);
      //  echo $cnt;
        return $cnt;
    }




    public function getSample($data) {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_FINANCIAL_NO', 'value' => $data['FINANCIAL_NO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_Sample', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('SAMPLES_PKG', 'GET_SAMPLE', $paramts, $results);
        return (count($results) > 0)? $results[0] : null;
    }


    public function updateFuelSample($data) {
        $sampleSerial = -1;
        $msg = '';

              $paramts = array(
            array('name' => ':I_FINANCIAL_NO', 'value' => $data['FINANCIAL_NO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COMPANY', 'value' => $data['COMPANY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECEIVE_DATE', 'value' => $data['RECEIVE_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECEIVE_TIME', 'value' => $data['RECEIVE_TIME'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECEIVE_PLACE', 'value' => $data['RECEIVE_PLACE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NO_OF_SAMPLES', 'value' => $data['NO_OF_SAMPLES'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FUEL_TYPE', 'value' => $data['FUEL_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTES', 'value' => $data['NOTES'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RECEIVE_COMMITEE', 'value' => $data['RECEIVE_COMMITEE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_FINANCIAL_NO', 'value' => &$sampleSerial, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('SAMPLES_PKG', 'UPDATE_FUEL_SAMPLE', $paramts,$results);
      return array('sampleSerial' => $sampleSerial, 'msg' => $msg);
    }


}
?>


