<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class station extends CI_Model
{

    public function __construct()
    {
        parent::__construct();
    }

    public function GET_GOVERNORATES_LIST()
    {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('STATIONS_PKG', 'GET_GOVERNORATES_LIST', $paramts, $results);
        return $results;
    }

    public function GET_CITIES_LIST($gov_id)
    {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_GOVR_ID', 'value' => $gov_id, 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('STATIONS_PKG', 'GET_CITIES_LIST', $paramts, $results);
        return $results;
    }

    public function GET_SUPPLIYERS_LIST($type)
    {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_TYPE', 'value' => $type, 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('STATIONS_PKG', 'GET_SUPPLIYERS_LIST', $paramts, $results);
        return $results;
    }

    public function ADD_NEW_STATION_INFO($data)
    {
        $STATION_SR = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_SNAME', 'value' => $data['SNAME'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COM_ID', 'value' => $data['COM_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_OWNER', 'value' => $data['OWNER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_GOVER', 'value' => $data['GOVER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CITY', 'value' => $data['CITY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CORD_X', 'value' => $data['CORD_X'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CORD_Y', 'value' => $data['CORD_Y'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ADDRESS', 'value' => $data['ADDRESS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STYPE', 'value' => $data['STYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CONFIRM', 'value' => $data['CONFIRM'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_AGENT_ID', 'value' => $data['AGENT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_AGENT_NAME', 'value' => $data['AGENT_NAME'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTES', 'value' => $data['NOTES'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_STATION_SR', 'value' => &$STATION_SR, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('STATIONS_PKG', 'ADD_NEW_STATION_INFO', $paramts, $results);
        return array('STATION_SR' => $STATION_SR, 'msg' => $msg);
    }

    public function ADD_STATION_SUPPLIERS($data)
    {
        $success = -1;
        $paramts = array(
            array('name' => ':I_STATION_SR', 'value' => $data['ST_ID'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_SUPPLIER_ID', 'value' => $data['SUP_ID'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
        );
        $this->db->stored_procedure('STATIONS_PKG', 'ADD_STATION_SUPPLIERS', $paramts, $results);
        return array('success' => $success);
    }

    public function ADD_STATION_FILE($data)
    {
        $lob = $this->db->get_blob_descriptor();
        $file = $data['FILE_CONTENT'];
        $success = -1;
        $SQL = "BEGIN STATIONS_PKG.ADD_STATION_FILE(:I_STATION_SR, :I_FILE_NAME, :I_FILE_TYPE, :I_USER, :O_FILE_CONTENT, :O_SUCCESS) ; END;";
        $db = $this->load->database('oracle', TRUE);
        $stmt = oci_parse($db->conn_id, $SQL);
        oci_bind_by_name($stmt, ':I_STATION_SR', $data['STATION_SR'], -1, OCI_ASSOC);
        oci_bind_by_name($stmt, ':I_FILE_NAME', $data['FILE_NAME'], -1, OCI_ASSOC);
        oci_bind_by_name($stmt, ':I_FILE_TYPE', $data['FILE_TYPE'], -1, OCI_ASSOC);
        oci_bind_by_name($stmt, ':I_USER', $data['USER'], -1, OCI_ASSOC);
        oci_bind_by_name($stmt, ':O_FILE_CONTENT', $lob, -1, OCI_B_BLOB);
        oci_bind_by_name($stmt, ':O_SUCCESS', $success, 300, OCI_ASSOC);
        oci_execute($stmt, OCI_DEFAULT);
        if (file_exists($file)) {
            $lob->savefile($file);
            $lob->free();
            $this->db->trans_commit();
        }
        return array('success' => $success);
    }

    public function GET_STAITIONS_INFO($data)
    {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_STATION_SR', 'value' => $data['STATION_NO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TYPE', 'value' => $data['STYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_SUPPLIER', 'value' => $data['SUP_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_GOVER_SR', 'value' => $data['GOVER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CITY_SR', 'value' => $data['CITY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CONFIRMED', 'value' => $data['CONF'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('STATIONS_PKG', 'GET_STAITIONS_INFO', $paramts, $results);
        return $results;
    }

    public function GET_STATION_SUPPLIERS($STATION_SR)
    {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_STATION_SR', 'value' => $STATION_SR, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('STATIONS_PKG', 'GET_STATION_SUPPLIERS', $paramts, $results);
        return $results;
    }

    public function GET_STATION_FILES_LIST($SRRIAL_NO)
    {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_STATION_SR', 'value' => $SRRIAL_NO, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('STATIONS_PKG', 'GET_STATION_FILES_LIST', $paramts, $results);
        return $results;
    }

    public function GET_STAITION_FILE($FILE_NO)
    {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_FILE_SR', 'value' => $FILE_NO, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('STATIONS_PKG', 'GET_STAITION_FILE', $paramts, $results);
        return $results;
    }

    public function GET_ALL_STAITION()
    {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('STATIONS_PKG', 'GET_ALL_STAITION', $paramts, $results);
        return $results;
    }

    public function DELETE_STAITION_FILE($SRRIAL_NO)
    {
        $success = -1;
        $paramts = array(
            array('name' => ':I_FILE_SR', 'value' => $SRRIAL_NO, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
        );
        $this->db->stored_procedure('STATIONS_PKG', 'DELETE_STAITION_FILE', $paramts, $results);
        return array('success' => $success);
    }

    public function UPDATE_STATION_INFO($data)
    {
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_STATION_SR', 'value' => $data['STATION_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_SNAME', 'value' => $data['SNAME'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_COM_ID', 'value' => $data['COM_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_OWNER', 'value' => $data['OWNER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_GOVER', 'value' => $data['GOVER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CITY', 'value' => $data['CITY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CORD_X', 'value' => $data['CORD_X'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CORD_Y', 'value' => $data['CORD_Y'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ADDRESS', 'value' => $data['ADDRESS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CONFIRM', 'value' => $data['CONFIRM'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_AGENT_ID', 'value' => $data['AGENT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_AGENT_NAME', 'value' => $data['AGENT_NAME'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTES', 'value' => $data['NOTES'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('STATIONS_PKG', 'CHANGE_STATION_INFO', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }

    public function ADD_NEW_STATION_LICENSE($data)
    {
        $licenses_sr = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_STATION_SR', 'value' => $data['STATION_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_LTYPE', 'value' => $data['LTYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_YEAR', 'value' => $data['YEAR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $data['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTES', 'value' => $data['NOTES'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_LICENSE_SR', 'value' => &$licenses_sr, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('STATIONS_PKG', 'ADD_NEW_STATION_LICENSE', $paramts, $results);
        return array('licenses_sr' => $licenses_sr, 'msg' => $msg);
    }

    public function ADD_LICENSE_FILE($data)
    {
        $lob = $this->db->get_blob_descriptor();
        $file = $data['FILE_CONTENT'];
        $success = -1;
        $SQL = "BEGIN STATIONS_PKG.ADD_LICENSE_FILE(:I_LICENS_SR, :I_FILE_NAME, :I_FILE_TYPE, :I_USER, :O_FILE_CONTENT, :O_SUCCESS) ; END;";
        $db = $this->load->database('oracle', TRUE);
        $stmt = oci_parse($db->conn_id, $SQL);
        oci_bind_by_name($stmt, ':I_LICENS_SR', $data['LICENS_SR'], -1, OCI_ASSOC);
        oci_bind_by_name($stmt, ':I_FILE_NAME', $data['FILE_NAME'], -1, OCI_ASSOC);
        oci_bind_by_name($stmt, ':I_FILE_TYPE', $data['FILE_TYPE'], -1, OCI_ASSOC);
        oci_bind_by_name($stmt, ':I_USER', $data['USER'], -1, OCI_ASSOC);
        oci_bind_by_name($stmt, ':O_FILE_CONTENT', $lob, -1, OCI_B_BLOB);
        oci_bind_by_name($stmt, ':O_SUCCESS', $success, 300, OCI_ASSOC);
        oci_execute($stmt, OCI_DEFAULT);
        if (file_exists($file)) {
            $lob->savefile($file);
            $lob->free();
            $this->db->trans_commit();
        }
        return array('success' => $success);
    }

    public function DELETE_LICENSE_FILE($SRRIAL_NO)
    {
        $success = -1;
        $paramts = array(
            array('name' => ':I_FILE_SR', 'value' => $SRRIAL_NO, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
        );
        $this->db->stored_procedure('STATIONS_PKG', 'DELETE_LICENSE_FILE', $paramts, $results);
        return array('success' => $success);
    }

    public function GET_LICENSE_FILES_LIST($SRRIAL_NO)
    {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_LICENSE_SR', 'value' => $SRRIAL_NO, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_Data', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('STATIONS_PKG', 'GET_LICENSE_FILES_LIST', $paramts, $results);
        return $results;
    }

    public function GET_LICENSE_TYPES_LIST()
    {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('STATIONS_PKG', 'GET_LICENSE_TYPES_LIST', $paramts, $results);
        return $results;
    }

    public function ADD_NEW_STATION_VISIT($data)
    {
        $licenses_sr = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_STATION_SR', 'value' => $data['STATION_SR'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_LTYPE', 'value' => $data['LTYPE'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_YEAR', 'value' => $data['YEAR'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DT'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $data['END_DT'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTES', 'value' => $data['NOTES'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_LICENSE_SR', 'value' => &$licenses_sr, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('STATIONS_PKG', 'ADD_NEW_STATION_VISIT', $paramts, $results);
        return array('licenses_sr' => $licenses_sr, 'msg' => $msg);
    }

    public function GET_STATIONS_LICENSES_LIST($data)
    {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_LICENSE_SR', 'value' => $data['LICENSE_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATION_SR', 'value' => $data['STATION_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_YEAR', 'value' => $data['YEAR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_LTYPE', 'value' => $data['LTYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('STATIONS_PKG', 'GET_STATIONS_LICENSES_LIST', $paramts, $results);
        return $results;
    }

    public function GET_LICENSE_FILE_CONTENT($FILE_NO)
    {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_FILE_SR', 'value' => $FILE_NO, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('STATIONS_PKG', 'GET_LICENSE_FILE_CONTENT', $paramts, $results);
        return $results;
    }
}