<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class user_chain extends CI_Model {

    public function __construct() {
        parent::__construct();
    }

     
    public function addUserChain($data) {
        $chainSerial = -1;
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_CAHIN_DATE', 'value' => $data['CAHIN_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CHAIN_DESC', 'value' => $data['CHAIN_DESC'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_INSERT_USER', 'value' => $data['INSERT_USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SERIAL_NO', 'value' => &$chainSerial, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'ADD_USER_CHAIN', $paramts, $results);
        return array('chainSerial' => $chainSerial, 'success' => $success, 'msg' => $msg);
    }

    public function addUserChainDetails($data) {
        $chainDetailSerial = -1;
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_CHAIN_SERIAL', 'value' => $data['CHAIN_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FROM_ACCOUNT', 'value' => $data['FROM_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TO_ACCOUNT', 'value' => $data['TO_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_AMOUNT', 'value' => $data['AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DET_SERIAL_NO', 'value' => &$chainDetailSerial, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'ADD_USER_CHAIN_DETAILS', $paramts, $results);
        return array('chainDetailSerial' => $chainDetailSerial, 'success' => $success, 'msg' => $msg);
    }

     public function updateUserChain($data) {
        $chainSerial = -1;
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_SERIAL_NO', 'value' => $data['CHAIN_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CAHIN_DATE', 'value' => $data['CAHIN_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CHAIN_DESC', 'value' => $data['CHAIN_DESC'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_INSERT_USER', 'value' => $data['INSERT_USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SERIAL_NO', 'value' => &$chainSerial, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'UPDATE_USER_CHAIN', $paramts, $results);
        return array('chainSerial' => $chainSerial, 'success' => $success, 'msg' => $msg);
    }



    public function approveUserChain($data) {
        $success = 0;
        $msg = "";
        $paramts = array(
            array('name' => ':I_SERIAL_NO', 'value' => $data['CHAIN_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),  
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),  
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'APPROVE_USER_CHAIN', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }

    public function returnUserChain($data) {
        $success = 0;
        $msg = "";
        $paramts = array(
            array('name' => ':I_SERIAL_NO', 'value' => $data['CHAIN_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),  
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'RETURN_USER_CHAIN', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }

    public function cancelUserChain($data) {
        $success = 0;
        $msg = "";
        $paramts = array(
            array('name' => ':I_SERIAL_NO', 'value' => $data['CHAIN_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),  
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 300, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'CANCEL_USER_CHAIN', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }


    public function getUserChains($data) {
        $cursor = $this->db->get_cursor();
        $cnt = '';
        $paramts = array(
            array('name' => ':I_SERIAL_NO', 'value' => $data['CHAIN_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $data['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATUS', 'value' => $data['STATUS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_CHAINS', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'GET_USER_CHAINS', $paramts, $results);
        return $results;
    }

    public function getUserChain($data) {
        $cursor = $this->db->get_cursor();
        $success = -1;
        $msg = '';
        $paramts = array(
            array('name' => ':I_CHAIN_SERIAL', 'value' => $data['CHAIN_SERIAL'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_CHAIN', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'GET_USER_CHAIN', $paramts, $results);
        return (count($results) > 0)? $results[0] : null;
    }

    public function getUserChainDetails($data) {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_CHAIN_SERIAL', 'value' => $data['CHAIN_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DETAILS', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'GET_USER_CHAIN_DETAILS', $paramts, $results);
        return (count($results) > 0)? $results : null;
    }




    public function getChains($data) {
        $cursor = $this->db->get_cursor();
        $cnt = '';
        $paramts = array(
            array('name' => ':I_CHSAN_SERIAL', 'value' => $data['CHAIN_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CHAIN_DT_FROM', 'value' => $data['CHAIN_DT_FROM'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_CHAIN_DT_TO', 'value' => $data['CHAIN_DT_TO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_TYPE', 'value' => $data['TRANS_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_SERIAL', 'value' => $data['TRANS_SERIAL'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_ACCOUNT_NO', 'value' => $data['ACCOUNT_NO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_CHAINS', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'GET_CHAINS', $paramts, $results);
        return (count($results) > 0)? $results : null;
    }
    
    public function getDetaildAccountStatement($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ACCOUNT', 'value' => $data['ACCOUNT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $data['END_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('REPORTS_PKG', 'PRINT_DETAILED_ACCOUNT_STAT', $paramts, $results);
        return  $results ;
        
    }
    
    public function getOrderAccountStatement($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ACCOUNT', 'value' => $data['ACCOUNT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $data['END_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('REPORTS_PKG', 'PRINT_DETAILED_ACCOUNT_CHINS', $paramts, $results);
        return  $results ;
    }

    public function getParentAccountStatement($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ACCOUNT', 'value' => $data['ACCOUNT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $data['END_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('REPORTS_PKG', 'PRINT_DETAILED_PARENT_ACCOUNT_STAT', $paramts, $results);
        return  $results ;
    }
    
    public function GET_COMPANIES_FIN_STANDING($data){
        $cursor = $this->db->get_cursor();
        $COM_DEBTS = -1 ; 
        $INSTIT_DEBTS = -1 ; 
        $paramts = array(
            array('name' => ':I_ACCOUNTS_CAT', 'value' => $data['CATEGORY'], 'length' => 1, 'type' => OCI_ASSOC),
            array('name' => ':I_DATE', 'value' => $data['QDATE'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_TODAY_ORDER', 'value' => $data['TODAY_ORDER'], 'length' => 1, 'type' => OCI_ASSOC),
            array('name' => ':O_COM_DEBTS', 'value' => &$COM_DEPTS, 'length' => 20, 'type' => OCI_ASSOC),
            array('name' => ':O_INSTIT_DEBTS', 'value' => &$INSTIT_DEPTS, 'length' => 20, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('REPORTS_PKG', 'GET_COMPANIES_FIN_STANDING', $paramts, $results);
        return  $results ;
        
    }


    public function getGazPetrolAccounts($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_TEARM', 'value' => $data['TEARM'], 'length' => -1, 'type' => OCI_ASSOC), 
            array('name' => ':O_DATA ', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('GLOBAL_PKG', 'GET_GAZ_PETROL_ACCOUNTS', $paramts, $results);
        return (count($results) > 0)? $results : null;
    }


    public function getAccounts($data) {
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_TEARM', 'value' => $data['TEARM'], 'length' => -1, 'type' => OCI_ASSOC), 
            array('name' => ':O_DATA ', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('GLOBAL_PKG', 'GET_ACCOUNT_INFO_BY_NAME', $paramts, $results);
        return (count($results) > 0)? $results : null;
    }


    public function getAccount($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ACCOUNT_ID', 'value' => $data['ACCOUNT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_RECEIPT', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('GLOBAL_PKG', 'GET_ACCOUNT', $paramts, $results);
        return (count($results) > 0)? $results[0] : null;
       
    }

    public function getBank($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ID', 'value' => $data['BANK_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_RECEIPT', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('GLOBAL_PKG', 'GET_BANK', $paramts, $results);
        return (count($results) > 0)? $results[0] : null;
       
    }
    
    public function getOotConsignemetSerial(){
        $serial = -1 ; 
        $paramts = array(
            array('name' => ':O_CONS_SR', 'value' => &$serial, 'length' => -1, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CONSIGNMENTS_PKG', 'GET_OUT_CONSIGNMENT_SERIAL_NO', $paramts, $results);
        return $serial;
       
    }
    
    public function getChainType($term, $chain_id){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_TERM', 'value' => $term, 'length' => 20, 'type' => OCI_ASSOC),
            array('name' => ':I_ID', 'value' => $chain_id, 'length' => 3, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('CHAINS_PKG', 'GET_CHAIN_TYPE', $paramts, $results);
        return $results ;
    }



    public function GET_COMPANIES_RATIOS($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ACCOUNT', 'value' => $data['ACCOUNT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PRODUCT', 'value' => $data['PRODUCT_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $data['END_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'GET_COMPANIES_RATIOS', $paramts, $results);
        return  $results ;

    }

    public function getAccountsSummaryIndex($category){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_ACC_PARENT', 'value' => $category, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'GET_COMPANIES_ACCOUNTS_INDEX', $paramts, $results);
        return  $results ;
    }

    public function addExchangeCurrencyTrans($info){
        $success = 0;
        $msg = "";
        $TRANS_SR = 0 ;
        $paramts = array(
            array('name' => ':I_FROM_ACC', 'value' => $info['FROM_ACCOUNT'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_FROM_CURR', 'value' => $info['FROM_CURRENCY'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_TO_ACC', 'value' => $info['TO_ACCOUNT'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_TO_CURR', 'value' => $info['TO_CURRENCY'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_AMOUNT', 'value' => $info['TRANS_AMOUNT'], 'length' => 15, 'type' => OCI_ASSOC),
            array('name' => ':I_RATE', 'value' => $info['RATE'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_DATE', 'value' => $info['TRANS_DATE'], 'length' => 20, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTE', 'value' => $info['NOTES'], 'length' => 10000, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_TRANS_SR', 'value' => &$TRANS_SR, 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'ADD_CURRENCY_EXCHANGE_TRANS', $paramts, $results);
        return  array('success' => $success, 'MSG' => $msg, 'trans_sr' => $TRANS_SR); 
    }

    public function getExchangeCurrencyTrans($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_TRANS_SR', 'value' => @$data['TRANS_ID'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FROM_ACC', 'value' => @$data['FROM_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TO_ACC', 'value' => @$data['TO_ACCOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FROM_CURR', 'value' => @$data['FROM_CURRENCY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TO_CURR', 'value' => @$data['TO_CURRENCY'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => @$data['FROM_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => @$data['TO_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATUS', 'value' => @$data['STATUS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'GET_CURN_EXCHANGE_TRANS_LIST', $paramts, $results);
        return  $results ;
    }

    public function approveExchangeCurrencyTrans($data){
        $success = 0;
        $msg = "";
        $paramts = array(
            array('name' => ':I_TRANS_SR', 'value' => $data['TRANS_ID'], 'length' => 10000, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'APPROVE_EXCHANGE_CURRENCY_TRAN', $paramts, $results);
        return  array('success' => $success, 'MSG' => $msg); 
    }

    public function cancleExchangeCurrencyTrans($data){
        $success = 0;
        $msg = "";
        $paramts = array(
            array('name' => ':I_TRANS_SR', 'value' => $data['TRANS_ID'], 'length' => 10000, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'CANCLE_EXCHANGE_CURRENCY_TRANS', $paramts, $results);
        return  array('success' => $success, 'MSG' => $msg); 
    }

    public function returnExchangeCurrencyTrans($data){
        $success = 0;
        $msg = "";
        $paramts = array(
            array('name' => ':I_TRANS_SR', 'value' => $data['TRANS_ID'], 'length' => 10000, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'RETURN_EXCHANGE_CURRENCY_TRANS', $paramts, $results);
        return  array('success' => $success, 'MSG' => $msg); 
    }

    public function editExchangeCurrencyTrans($info){
        $success = 0;
        $msg = "";
        $paramts = array(
            array('name' => ':I_TRANS_SERIAL', 'value' => $info['SERIAL_NO'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_FROM_ACC', 'value' => $info['FROM_ACCOUNT'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_FROM_CURR', 'value' => $info['FROM_CURRENCY'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_TO_ACC', 'value' => $info['TO_ACCOUNT'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_TO_CURR', 'value' => $info['TO_CURRENCY'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_AMOUNT', 'value' => $info['TRANS_AMOUNT'], 'length' => 15, 'type' => OCI_ASSOC),
            array('name' => ':I_RATE', 'value' => $info['RATE'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_DATE', 'value' => $info['TRANS_DATE'], 'length' => 20, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTE', 'value' => $info['NOTES'], 'length' => 10000, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $info['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 1, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 500, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('FINANCIAL_PKG', 'CHANGE_CURRENCY_EXCHANGE_TRANS', $paramts, $results);
        return  array('success' => $success, 'MSG' => $msg); 
    }

}