<?php



if (!defined('BASEPATH'))

    exit('No direct script access allowed');



class user_sso extends CI_Model {

    /*     * ******** Class Vars ********* */



    private $_userInfo;  // Users Instant.

    private $isSsoUser;  // is User loged to the sytem using SSO.



    public function __construct() {

        // Call the Model constructor

        parent::__construct();

        $this->load->helper('form');

        $this->load->helper('url');

    }



    public function initialize() {

        $this->isSsoUser = $SSOUser = 1;

        if ($this->isSsoUser == 1) {

            /*             * *************************** */

            /*             * ******** SSO Code ********* */

            /*             * *************************** */

            $this->load->helper('sso_helper');

            $userInfo = sso();

            $this->load->library('SSOUsers', $userInfo);

            $this->_userInfo = new SSOUsers($userInfo);

            /*             * *************************** */

            /*             * *************************** */

        } else {

            $userInfo = array('UserIdentity' => array('931701023'), 'employee_number' => array('209040'), 'Name' => array('همسة محمد كريم'));

            $this->load->library('SSOUsers', $userInfo);

            $this->_userInfo = new SSOUsers($userInfo);

        }

    }



    /*     * ********************************************* */

    /* This function returns an instant of Users    */

    /* @Level		Public							 */

    /* @Parm		-								 */

    /* @Return		Users  		Users instance		 */

    /*     * ********************************************* */



    public function getLogedUser() {

        return $this->_userInfo;

    }



    /*     * ********************************************* */

    /* This function returns the user id			 */

    /* @Level		Public							 */

    /* @Parm		-								 */

    /* @Return		String  	User ID				 */

    /*     * ********************************************* */



    public function getUserID() {

        $user = $this->getLogedUser();

        return $user->getIdentificationNo();

    }



    /*     * ********************************************* */

    /* This function returns the user name			 */

    /* @Level		Public							 */

    /* @Parm		-								 */

    /* @Return		String  	User Name			 */

    /*     * ********************************************* */



    public function getUserName() {

        $user = $this->getLogedUser();

        return $user->getFullName();

    }



    /*     * ********************************************* */

    /* This function returns the emp  NO/

      /* @Level		Public */

    /* @Parm		-								 */

    /* @Return		String  	User Name			 */

    /*     * ********************************************* */



    public function getEmployeeNo() {

        $user = $this->getLogedUser();

        return $user->getEmployeeNo();

    }



    /*     * ********************************************* */

    /* This function to logout from the system		 */

    /* @Level		Public							 */

    /* @Parm		-								 */

    /* @Return		-								 */

    /*     * ********************************************* */



    public function logout() {



        if ($this->isSsoUser == 1) {

            $this->load->helper('sso_helper');

            logout();

        } else {

            // In testing case >> do nothing. 

        }

    }



    /*     * ****

     * 

     * 

     * 

     * 

     * 

     */



    public function set_user_session($userID) {

        $this->load->model('user_m');



        $result = $this->user_m->getUser(array(

            'USER_ID_NO' => $userID,

        ));

        

        if (sizeof($result) <= 0) {

            $this->session->sess_destroy();

            redirect('/messages/unauthorized/');

            return;

        }



        $this->session->set_userdata(array(

            'sess_user_name' => $result['USER_ID_NO'],

            'sess_real_name' => $result['USER_FNAME'] . ' ' . $result['USER_SNAME'] . ' ' . $result['USER_LNAME'],

            'sess_is_sys_admin' => $result['IS_SYS_ADMIN'],

            'sess_is_super_admin' => $result['IS_SUPER_ADMIN']

        ));

    }



    public function validate_session() {

        if (!( $this->session->userdata('sess_location_id') && $this->session->userdata('sess_user_name'))) {

            $this->initialize();

        }

    }



    public function is_valid_session() {

        if ($this->session->userdata('sess_location_id')) {

            return true;

        } else {

            return false;

        }

    }



    public function is_allowed_function($functionID) {

        $this->load->model('user_m');



        $is_allowed = false;

        if ($this->session->userdata('sess_is_sys_admin') == '1') {

            $is_allowed = true;

            return $is_allowed;

        }

        $rs = $this->user_m->GET_RESP_USER_ROLE_FUNCTION(array(

            'I_USER_ID' => $this->session->userdata('sess_user_name')

        ));



        $rs = $rs['ret_data'];

        if (sizeof($rs) <= 0) {

            return $is_allowed;

        } else {

            for ($i = 0; $i < count($rs); ++$i) {

                if ($rs[$i]['FUNCTION_ID'] == $functionID) {

                    $is_allowed = true;

                    return $is_allowed;

                }

            }

        }

        return $is_allowed;

    }



}



?>