<?php

if (!defined('BASEPATH'))
    exit('No direct script access allowed');

class Warehouse extends CI_Model {

    public function __construct() {
        parent::__construct();
    }

    public function getDetaildwarehouseTrans($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_WAREHOUSE', 'value' => $data['WAREHOUSE_NO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PRODUCT', 'value' => $data['FUEL_CAT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $data['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('CONSIGNMENTS_PKG','GET_WAREHOUSE_DETAILED_TRANS', $paramts, $results);
        return $results;
    }
    
    public function getWarehouseTransTotals($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_WAREHOUSE', 'value' => $data['WAREHOUSE_NO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PRODUCT', 'value' => $data['FUEL_CAT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_DT', 'value' => $data['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $data['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('REPORTS_PKG','PRINT_WAREHOUSE_TRANS_TOTALS', $paramts, $results);
        return $results;
    }
    
    public function addNewWarehouseTransaction($data){
        $success = -1 ; 
        $msg = '' ; 
        $paramts = array(
            array('name' => ':I_TRANS_TYPE', 'value' => $data['TRANS_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_DATE', 'value' => $data['TRANS_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PRODUCT', 'value' => $data['FUEL_CAT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FROM_WH', 'value' => $data['FROM_WAREHOUSE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TO_WH', 'value' => $data['TO_WAREHOUSE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_AMOUNT', 'value' => $data['TRANS_AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_NOTES', 'value' => $data['TRANS_NOTES'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 5, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        //print_r($paramts) ; exit() ; 
        $this->db->stored_procedure('CONSIGNMENTS_PKG', 'ADD_WAREHOUSE_TRANSACTION', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }
    
    public function getTransactionsTypesList(){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('CONSIGNMENTS_PKG','GET_TRANSACTIONS_TYPES_LIST', $paramts, $results);
        return $results;
    }
    
    public function getWarehousesList(){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('CONSIGNMENTS_PKG','GET_WAREHOUSE_LIST', $paramts, $results);
        return $results;
    }

    public function getProductWarehouseList(){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('CONSIGNMENTS_PKG','GET_PRODUCT_WAREHOUSE_CATS', $paramts, $results);
        return $results;
    }

    public function getRegisdwarehouseTrans($data){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_WAREHOUSE', 'value' => $data['WAREHOUSE_NO'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PRODUCT', 'value' => $data['FUEL_CAT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TTYPE', 'value' => $data['TRANS_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_START_ST', 'value' => $data['START_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_END_DT', 'value' => $data['END_DT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_STATUS', 'value' => $data['STATUS'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('CONSIGNMENTS_PKG','GET_REGISTERED_WAREHOUSE_TRANS', $paramts, $results);
        return $results;
    }

    public function AproveWarehouseTrans($data){
        $success = -1 ;
        $msg = '' ;
        $paramts = array(
            array('name' => ':I_TRANS_SR', 'value' => $data['TRANS_SR'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 5, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CONSIGNMENTS_PKG', 'APPROVE_WAREHOUSE_TRANSACTION', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }

    public function rejectWarehouseTrans($data){
        $success = -1 ;
        $msg = '' ;
        $paramts = array(
            array('name' => ':I_TRANS_SR', 'value' => $data['TRANS_SR'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 5, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CONSIGNMENTS_PKG', 'REJECT_WAREHOUSE_TRANSACTION', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }

    public function returnWarehouseTrans($data){
        $success = -1 ;
        $msg = '' ;
        $paramts = array(
            array('name' => ':I_TRANS_SR', 'value' => $data['TRANS_SR'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => 10, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 5, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CONSIGNMENTS_PKG', 'RETURN_WAREHOUSE_TRANSACTION', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }

    public function updateWarehouseTransInfo($data){
        $success = -1 ;
        $msg = '' ;
        $paramts = array(
            array('name' => ':I_TRANS_SR', 'value' => $data['TRANS_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_TYPE', 'value' => $data['TRANS_TYPE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_DATE', 'value' => $data['TRANS_DATE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_PRODUCT', 'value' => $data['FUEL_CAT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_FROM_WH', 'value' => $data['FROM_WAREHOUSE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TO_WH', 'value' => $data['TO_WAREHOUSE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_AMOUNT', 'value' => $data['TRANS_AMOUNT'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_RELATED_SR', 'value' => $data['RELATED_SR'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_TRANS_NOTE', 'value' => $data['TRANS_NOTE'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':I_USER', 'value' => $data['USER'], 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_SUCCESS', 'value' => &$success, 'length' => 5, 'type' => OCI_ASSOC),
            array('name' => ':O_MSG', 'value' => &$msg, 'length' => 300, 'type' => OCI_ASSOC)
        );
        $this->db->stored_procedure('CONSIGNMENTS_PKG', 'CHANGE_WAREHOUSE_TRANSACTION', $paramts, $results);
        return array('success' => $success, 'msg' => $msg);
    }

    public function getWarehousestransForm($trans_sr){
        $cursor = $this->db->get_cursor();
        $paramts = array(
            array('name' => ':I_TRANS_SR', 'value' => $trans_sr, 'length' => -1, 'type' => OCI_ASSOC),
            array('name' => ':O_DATA', 'value' => $cursor, 'length' => -1, 'type' => OCI_B_CURSOR)
        );
        $this->db->stored_procedure('CONSIGNMENTS_PKG','GET_WAREHOUSE_TRANS_FORM', $paramts, $results);
        return $results;
    }

}