$(document).ready(function() {

    $('#COMP_ACCOUNT_TERM').autocomplete({
        source: function (request, response) {
            $.ajax({
                type: 'POST',
                url: "index.php/common/getAccountsByTerm",
                cache: false,
                dataType: "json",
                data: {
                    TERM: $('#COMP_ACCOUNT_TERM').val(),
                },
                success: function (data) {
                    response($.map(data, function (item) {
                        return {
                            label: item.ACCOUNT_VALUE + ' - ' + item.ACCOUNT_NAME,
                            key: item.ACCOUNT_ID ,
                            value : item.ACCOUNT_VALUE
                        }
                    }));
                }
                ,
                error: function (jqXHR, textStatus, errorThrown) {
                }
            });
        },
        minLength: 1,
        position: {
            my: "right bottom",
            at: "right top",
            collision: "flip"
        },
        select: function (event, ui) {
            //$("#COMP_ACCOUNT_TERM").val(ui.item.value);
            $("#COMP_ACCOUNT").val(ui.item.key);
            $("#COMP_ACCOUNT_NAME").val(ui.item.label) ;
        },
        open: function () {
            $(this).removeClass("ui-corner-all").addClass("ui-corner-top");
        },
        close: function () {
            //alert();
            //documentSupplierChange();

            $(this).removeClass("ui-corner-top").addClass("ui-corner-all");
        }
    });

  document.getElementById('car_no').onblur = function() {
        $.ajax({
            type: 'POST',
            url: "index.php/carCheck/getcartype",
            cache: false,
            data: {
                car_no: $('#car_no').val()
            },
            success: function (result) {
                $('#car_type').val(result);}
        });
    }

    $(document).on('click',"#car_check_btn", function (event) {
        FormValidation.init();
        if($("#addcheck").valid() !== true){
            return;
        }

        var isValid = 1;
        if($("#EXAMIN_DATE").val() == ''){
            $("#EXAMIN_DATE").closest('.form-group').addClass('has-error');
            isValid = 0;
        }else{
            $("#EXAMIN_DATE").closest('.form-group').removeClass('has-error');
        }
        if($("#COMP_ACCOUNT_TERM").val() == ''){
            $("#COMP_ACCOUNT_TERM").closest('.form-group').addClass('has-error');
            isValid = 0;
        }else{
            $("#COMP_ACCOUNT_TERM").closest('.form-group').removeClass('has-error');
        }
        if($("#car_no").val() == ''){
            $("#car_no").closest('.form-group').addClass('has-error');
            isValid = 0;
        }else{
            $("#car_no").closest('.form-group').removeClass('has-error');
        }
        if($("#EXAMIN_PLACE").val() ==''){
            $("#EXAMIN_PLACE").closest('.form-group').addClass('has-error');
            isValid = 0;
        }else{
            $("#EXAMIN_PLACE").closest('.form-group').removeClass('has-error');
        }
        if($("#car_cap").val() ==''){
            $("#car_cap").closest('.form-group').addClass('has-error');
            isValid = 0;
        }else{
            $("#car_cap").closest('.form-group').removeClass('has-error');
        }
        if($("#EXAMIN_RESULT").val() ==''){
            $("#EXAMIN_RESULT").closest('.form-group').addClass('has-error');
            isValid = 0;
        }else{
            $("#EXAMIN_RESULT").closest('.form-group').removeClass('has-error');
        }

        if(!isValid) return;
            $.ajax({
            type: 'POST',
            url: "index.php/carCheck/addcarcheck",
            cache: false,
            data: {
                EXAMIN_DATE: $('#EXAMIN_DATE').val(),
                COMP_ACCOUNT_TERM: $('#COMP_ACCOUNT_TERM').val(),
                COMP_ACCOUNT: $('#COMP_ACCOUNT').val(),
                EXAMIN_PLACE: $('#EXAMIN_PLACE').val(),
                car_no: $('#car_no').val(),
                car_cap: $('#car_cap').val(),
                EXAMIN_RESULT: $('#EXAMIN_RESULT').val(),
            },
            success: function (data) {
                showMessage({message:"تم الإضافة بنجاح", type:"success", icon:"check"});
                document.getElementById('addcheck').reset();
            }
            ,
            error: function (jqXHR, textStatus, errorThrown) {
            }
        });

    });


    $(document).on('click',"#search_btn", function (event) {
        $('#searchtb').dataTable({
            "destroy": true,
            "bStateSave": true,
            "lengthMenu": [
                [10, 20, 50, 100, 150, -1],
                [10, 20, 50, 100, 150, "All"] // change per page values here
            ],
            "pageLength": 10,

            "ajax": {
                type: 'POST',
                url: "index.php/carCheck/getcarcheck",
                dataType: "json",
                cache: false,
                data: {
                    EXAMIN_DATE: $('#EXAMIN_DATE').val(),
                    COMP_ACCOUNT_TERM: $('#COMP_ACCOUNT_TERM').val(),
                    car_no: $('#car_no').val()
                }
            },
            "order": [[0, "asc"]],
            "language": {
                "lengthMenu": "عرض _MENU_ سجل في الصفحة",
                "zeroRecords": "عذرا - لا يوجد بيانات.",
                "info": "عرض _START_ الى _END_ من _TOTAL_ سجل",
                "infoEmpty": "لا تتوفر اي بيانات.",
                "infoFiltered": "(تصفية من _MAX_ سجل)",
                "loadingRecords": "تحميل...",
                "processing": "جاري معالجة البيانات...",
                "search": "بحث:",
                "paginate": {
                    "first": "الأول",
                    "last": "الأخير",
                    "next": "التالي",
                    "previous": "السابق"
                },
            },
            "sAjaxDataProp": "",
            "aoColumnDefs": [
                {
                    "aTargets": [6],
                    "mData": "download_link",
                    "mRender": function (data, type, full) {
                        var res = "";
                        res += '<a class="btn green" target="_blank" href="index.php/carCheck/updatecar/'+ data.SN+'" >تعديل</a>';
                        return res;
                    }
                }
            ],
            "aoColumns": [
                {"mData": 'EXAMIN_DATE'},
                {"mData": "FINANCIAL_NO"},
                {"mData": "EXAMIN_PLACE"},
                {"mData": "EXAMIN_RESULT"},
                {"mData": "CAR_CAP"},
                {"mData": "CAR_NO"},
                {"mData": null}
            ]

        });



   /*  $.ajax({
            type: 'POST',
            url: "index.php/carCheck/getcarcheck",
            dataType: "json",
            cache: false,
            data: {
                EXAMIN_DATE: $('#EXAMIN_DATE').val(),
                COMP_ACCOUNT_TERM: $('#COMP_ACCOUNT_TERM').val(),
                car_no: $('#car_no').val()
            },
            success: function (result) {
                $('#searchtb tbody').empty();
                $.each(result, function( index, item) {
                    $('#searchtb tbody').append('<tr data-id="'+item.SN+'"><td>'+item.EXAMIN_DATE+'</td><td>'+item.FINANCIAL_NO+'</td><td><input type="text" id="edit_place" value="'+item.EXAMIN_PLACE+'"</td><td><input type="text" id="edit_result" value="'+item.EXAMIN_RESULT+'"</td><td><input type="text" id="edit_cap" value="'+item.CAR_CAP+'"</td><td>'+item.CAR_ID+'</td>' +
                        '<td><a class="btn" id="edit"> تعديل</a></td></tr>');
                });
            }
            ,
            error: function (jqXHR, textStatus, errorThrown) {
            }
        });
*/
    });

    $(document).on('click',"#editcar", function (event) {
        $("#sn").val($(this).attr("sn"));
        $("#updateform").submit();
    });

  $(document).on('click',"#edit", function (event) {

    $.ajax({
            type: 'POST',
            url: "index.php/carCheck/edit",
            cache: false,
            data: {
                SN: $('#sn').val(),
                EXAMIN_PLACE: $('#edit_place').val(),
                EXAMIN_RESULT: $('#edit_result').val(),
                car_cap: $('#edit_cap').val()
            },
            success: function (data) {
                showMessage({message:"تم تحديث البيانات بنجاح", type:"success", icon:"check"});
            }
            ,
            error: function (jqXHR, textStatus, errorThrown) {
            }
        });

    });





    var FormValidation = function() {
        var handleValidation = function () {
            var form1 = $('#addcheck');
            var error1 = $('.alert-danger', form1);
            var success1 = $('.alert-success', form1);
            form1.validate({
                errorElement: 'span', //default input error message container
                errorClass: 'help-block help-block-error', // default input error message class
                focusInvalid: false, // do not focus the last invalid input
                ignore: "",  // validate all fields including form hidden input
                messages: {
                    COMP_ACCOUNT_TERM: {
                        required: "هذا الحقل مطلوب",
                    },
                    EXAMIN_DATE: {
                        required: "هذا الحقل مطلوب",
                        date: 'ادخلالتاريخ',
                    },
                    EXAMIN_PLACE: {
                        required: "هذا الحقل مطلوب",
                    },
                    car_no: {
                        required: "هذا الحقل مطلوب",
                    },
                    car_cap: {
                        required: "هذا الحقل مطلوب",
                    },
                    EXAMIN_RESULT: {
                        required: "هذا الحقل مطلوب",
                    },
                },
                rules: {
                    COMP_ACCOUNT_TERM: {
                        required: true
                    },
                    EXAMIN_DATE: {
                        required: true,
                        //  date : true,
                    },
                    EXAMIN_PLACE: {
                        required: true
                    },
                    car_no: {
                        required: true
                    },
                    car_cap: {
                        required: true
                    },
                    EXAMIN_RESULT: {
                        maxlength: 100
                    }
                },

                invalidHandler: function (event, validator) { //display error alert on form submit
                    success1.hide();
                    error1.show();
                    App.scrollTo(error1, -200);
                },

                highlight: function (element) { // hightlight error inputs
                    $(element).closest('.form-group').addClass('has-error'); // set error class to the control group
                },

                unhighlight: function (element) { // revert the change done by hightlight
                    $(element).closest('.form-group').removeClass('has-error'); // set error class to the control group
                },

                success: function (label) {
                    label.closest('.form-group').removeClass('has-error'); // set success class to the control group
                },

                submitHandler: function (form) {
                    success1.show();
                    error1.hide();
                }


            });
        }
        return {
            init: function () {
                handleValidation();
            }

        }
    }();


    $('#searchtb').dataTable({
        "destroy": true,
        "bStateSave": true,
        "lengthMenu": [
            [10, 20, 50, 100, 150, -1],
            [10, 20, 50, 100, 150, "All"] // change per page values here
        ],
        "pageLength": 10,
        "data": [],

        "columns": [
            { title: "تاريخ الفحص" },
            { title: "الرقم المالي" },
            { title: "مكان الفحص" },
            { title: "نتيجة الفحص" },
            { title: "سعة السيارة" },
            { title: "رقم السيارة" },
            { title: "عمليات" }
        ],
        "language": {
            "lengthMenu": "عرض _MENU_ سجل في الصفحة",
            "zeroRecords": "عذرا - لا يوجد بيانات.",
            "info": "عرض _START_ الى _END_ من _TOTAL_ سجل",
            "infoEmpty": "لا تتوفر اي بيانات.",
            "infoFiltered": "(تصفية من _MAX_ سجل)",
            "loadingRecords": "تحميل...",
            "processing":     "جاري معالجة البيانات...",
            "search":         "بحث:",
            "paginate": {
                "first":      "الأول",
                "last":       "الأخير",
                "next":       "التالي",
                "previous":   "السابق"
            }
        }

    });


    function showMessage(config){
        App.alert({
            container: '#alert_container', // alerts parent container(by default placed after the page breadcrumbs)
            place: 'prepent', // append or prepent in container
            type: config.type,  // alert's type
            message: config.message,  // alert's message
            close: true, // make alert closable
            reset: true, // close all previouse alerts first
            focus: false, // auto scroll to the alert after shown
            closeInSeconds: 10, // auto close after defined seconds
            icon: config.icon // put icon before the message
        });
    }

});