////////////////////////////////////////////////////////////////////////////////
////////////////////////////////Add Edit carConstant///////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

$( document ).ready( function () {

    $( "#carConstantForm" ).validate( {
        rules: {
            COMPANY_TERM: {
                required: true

            },
            CAR_ID: {
                required: true,
                number: true
            },
            TOTAL_CAPACITY: {
             required: true,
                number: true
            },
            CAR_MODEL :{
            required: true

            },
            PRODUCT_CATEGORY:{
                required: true

            },
            TRAILER:{
                required: true

            }


        },
        messages: {
            //COMPANY_TERM: "ادخل رقم او اسم الشركة كمنم فضلك",
            //firstname: "Please enter your firstname",
            COMPANY_TERM: {
                required: "ادخل اسم الشركة او رقمها"
            },
            CAR_ID:
            {
                required:"ادخل رقم السيارة من فضلك",
                number:"ادخل ارقام من فضلك"
                          },
            TOTAL_CAPACITY: {
                required: "ادخل السعة الكلية للمركبة من فضلك",
                number:"ادخل ارقام من فضلك"

            },
            CAR_MODEL: {
                required: "ادخل موديل السيارة من فضلك"

            },
            PRODUCT_CATEGORY: {
                required: "اختر نوع الوقود من فضلك"

            },
            TRAILER: {
                required: "ادخل نوع السيارة من فضلك"

            },

        },
        errorElement: "em",
        errorPlacement: function ( error, element ) {
            // Add the `help-block` class to the error element
            error.addClass( "help-block" );

            if ( element.prop( "type" ) === "checkbox" ) {
                error.insertAfter( element.parent( "label" ) );
            } else {
                error.insertAfter( element );
            }
        },
        highlight: function ( element, errorClass, validClass ) {
            $( element ).parents( ".col-md-9" ).addClass( "has-error" ).removeClass( "has-success" );
        },
        unhighlight: function (element, errorClass, validClass) {
            $( element ).parents( ".col-md-9" ).addClass( "has-success" ).removeClass( "has-error" );
        }
    } );



} );
$(document).on('click', "#add_car_btn", function (e) {

  if($("#carConstantForm").valid() != true){

        return;
        }

    $.ajax({
        type: 'post',
        url: "index.php/carConstants/addFreightCar",

        cache: false,
        //dataType: "json",
        data: {

            COMPANY: $("#COMPANY").val(),
            CAR_ID: $("#CAR_ID").val(),
            CAR_MODEL: $("#CAR_MODEL").val(),
            PRODUCT_CATEGORY: $("#PRODUCT_CATEGORY").val(),
            TRAILER: $("#TRAILER").val(),
            TANKS: $("#TANKS").val(),
            TOTAL_CAPACITY: $("#TOTAL_CAPACITY").val(),
        },

        success: function (data) {
          
            showMessage({message:data.msg, type:'success',  icon:'check'  });
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:"Ajax Connection Error. خطأ في الاتصال." + errorThrown, type:"error", icon:"warning"});

        }
    });
    e.preventDefault();
}
);

$(document).on('change', "#PRODUCT_CATEGORY", function (event) {
    $CAT = $(this).val();

    if ( $CAT  != 2){
        document.getElementById("TANKS").disabled=true;
        document.getElementById("TANKS").value='';

    }
    if ( $CAT  == 2){//محروقات
        document.getElementById("TANKS").disabled=false;

    }

    if ( $CAT  == 3){//غاز طبيعي
        document.getElementById("TRAILER").disabled=true;
        document.getElementById("TRAILER").value=1;
    }
    if ( $CAT  != 3){
        document.getElementById("TRAILER").disabled=false;
        document.getElementById("TRAILER").value='';
    }

});


$(document).on('click', "#get_car_btn", function (e) {
   if ($("#COMPANY_TERM").val()==''){
        $("#COMPANY").val('');
        $("#COMPANY_NAME").val('');
    }

    getFrightCarsList(); 

    $.fn.dataTable.ext.errMode = 'throw';
    e.preventDefault();
});

$(document).on('click', '.activateFrightCar', function(e){
    var elm = $(this).parent();
    $.ajax({
        type: 'post',
        url: "index.php/carConstants/activateCar",
        cache: false,
        dataType: "json",
        data: {
            CAR_SR: $(this).attr("CAR_SR")
        },
        success: function (data) {
            showMessage({message:data.msg, type:(data.success > 0)? 'success' : 'warning', icon:(data.success > 0)? 'check' : 'warning'});
            if(data.success > 0) getFrightCarsList(); 
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:'خطأ في الاتصال. ' + errorThrown, type: 'warning', icon:'warning'});

        }
    });
    e.preventDefault();
}); 

$(document).on('click', '.deactivateFrightCar', function(e){
    var elm = $(this).parent();
    $.ajax({
        type: 'post',
        url: "index.php/carConstants/deactivateCar",
        cache: false,
        dataType: "json",
        data: {
            CAR_SR: $(this).attr("CAR_SR")
        },
        success: function (data) {
            showMessage({message:data.msg, type:(data.success > 0)? 'success' : 'warning', icon:(data.success > 0)? 'check' : 'warning'});
            if(data.success > 0) getFrightCarsList(); 
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:'خطأ في الاتصال. ' + errorThrown, type: 'warning', icon:'warning'});

        }
    });
    e.preventDefault();
}); 

$(document).on('click', '.goToEditFrightCar', function(e){
    var elm = $(this).parent();
    $.ajax({
        type: 'post',
        url: "index.php/carConstants/getFreightCars",
        cache: false,
        dataType: "json",
        data: {
            CAR_SERIAL: $(this).attr("CAR_SR")
        },
        success: function (data) {
            $('#m_COMPANY option[value="'+ data[0].COMPANY_ID+'"]').attr('selected','selected');
            $('#m_CAR_SR').val(data[0].CAR_SERIAL); 
            $('#m_CAR_ID').val(data[0].CAR_ID); 
            $('#m_TOTAL_CAPACITY').val(data[0].TOTAL_CAPACITY); 
            $('#m_CAR_MODEL').val(data[0].CAR_MODEL); 
            $('#m_PRODUCT_CATEGORY option[value="'+ data[0].PRODUCT_CATEGORY+'"]').attr('selected','selected'); 
            $('#m_TANKS').val(data[0].TANKS); 
            $('#m_TRAILER option[value="'+ data[0].TRAILER+'"]').attr('selected','selected');
            $('#editFrightCarModal').modal('show');
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:'خطأ في الاتصال. ' + errorThrown, type: 'warning', icon:'warning'});

        }
    });

    e.preventDefault();
}); 

$(document).on('click', '#CHANGE_FRIGHT_CAR_BTN', function(e){
    $.ajax({
        type: 'post',
        url: "index.php/carConstants/getFreightCars",
        cache: false,
        dataType: "json",
        data: {
            CAR_SR: $("#m_CAR_SR").val(), 
            COMPANY: $("#m_COMPANY").val(), 
            CAR_ID: $("#m_CAR_ID").val(), 
            TOTAL_CAPACITY: $("#m_TOTAL_CAPACITY").val(), 
            CAR_MODEL: $("#m_CAR_MODEL").val(), 
            TANKS: $("#m_TANKS").val(), 
            TRAILER: $("#m_TRAILER").val(), 

        },
        success: function (data) {
            $('#m_COMPANY option[value="'+ data[0].COMPANY_ID+'"]').attr('selected','selected'); 
            $('#m_CAR_ID').val(data[0].CAR_ID); 
            $('#m_TOTAL_CAPACITY').val(data[0].TOTAL_CAPACITY); 
            $('#m_CAR_MODEL').val(data[0].CAR_MODEL); 
            $('#m_PRODUCT_CATEGORY option[value="'+ data[0].PRODUCT_CATEGORY+'"]').attr('selected','selected'); 
            $('#m_TANKS').val(data[0].TANKS); 
            $('#m_TRAILER option[value="'+ data[0].TRAILER+'"]').attr('selected','selected');
            $('#editFrightCarModal').modal('show');
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:'خطأ في الاتصال. ' + errorThrown, type: 'warning', icon:'warning'});

        }
    });

    e.preventDefault();
}); 

$(document).on('click', '#CHANGE_FRIGHT_CAR_BTN', function(e){
    $.ajax({
        type: 'POST',
        url: "index.php/carConstants/changeCarInfo",
        cache: false,
        dataType: "json",
        data: {
            CAR_SERIAL: $('#m_CAR_SR').val(), 
            COMPANY: $('#m_COMPANY').val(), 
            CAR_ID: $('#m_CAR_ID').val(), 
            CAPACITY: $('#m_TOTAL_CAPACITY').val(), 
            MODEL: $('#m_CAR_MODEL').val(), 
            CATEGORY: $('#m_PRODUCT_CATEGORY').val(), 
            TANKS: $('#m_TANKS').val(), 
            TRAILER: $('#m_TRAILER').val()
        },
        success: function (data) {
            if(data.success > 0){
                $('#m_COMPANY option[index=0]').attr('selected','selected'); 
                $('#m_CAR_ID').val(''); 
                $('#m_TOTAL_CAPACITY').val(''); 
                $('#m_CAR_MODEL').val(''); 
                $('#m_PRODUCT_CATEGORY option[index=0]').attr('selected','selected'); 
                $('#m_TANKS').val(''); 
                $('#m_TRAILER option[index=0]').attr('selected','selected');
                getFrightCarsList(); 
            }
            $('#editFrightCarModal').modal('hide');
            showMessage({message:data.msg, type:(data.success > 0)? 'success' : 'warning', icon:(data.success > 0)? 'check' : 'warning'});
        },
        error: function (jqXHR, textStatus, errorThrown) {
            $('#editFrightCarModal').modal('hide');
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
    e.preventDefault();
});


$(document).on('keyup', '#COMPANY_TERM', function (event) {
    $search_for = $(this).val();
    $parent = $(this).parent();
    $(this).autocomplete({
        source: function (request, response) {
            $.ajax({
                type: 'POST',
                url: "index.php/common/getCompanyByTerm",
                cache: false,
                dataType: "json",
                data: {
                    TERM: $search_for
                },
                success: function (data) {
                    response($.map(data, function (item) {
                        return {
                            //   label: item.ACCOUNT_VALUE + ' - ' + item.COMPANY_NAME + ' - ' + item.ACCOUNT_NAME,
                            value: item.COMPANY_ID + ' - ' + item.COMPANY_NAME,
                            COMPANY_ID: item.COMPANY_ID,
                            COMPANY_NAME:item.COMPANY_NAME,
                        }
                    }));

                }
                ,
                error: function (jqXHR, textStatus, errorThrown) {
                }
            });
        },
        minLength: 1,
        position: {
            my: "right bottom",
            at: "right top",
            collision: "flip"
        },
        select: function (event, ui) {
            $("#COMPANY").val(ui.item.COMPANY_ID);
            $("#COMPANY_NAME").val(ui.item.COMPANY_NAME);

        },
        open: function () {
            $(this).removeClass("ui-corner-all").addClass("ui-corner-top");
        },
        close: function () {
            //alert();
            //documentSupplierChange();

            $(this).removeClass("ui-corner-top").addClass("ui-corner-all");
        }
    });
}); 

 


$(document).on('click', "#reset_btn", function (e) {

    $("#COMPANY_NAME").val('');
    $("#COMPANY_TERM").val('');
    $("#COMPANY").val('');
    $("#CAR_ID").val('');
    $("#CAR_MODEL").val('');
    $("#TRAILER").val('');
    $("#TANKS").val('');
    $("#TOTAL_CAPACITY").val('');
    $("#PRODUCT_CATEGORY").val('');
    document.getElementById("TANKS").disabled=false;
    document.getElementById("TRAILER").disabled=false;


});
function showMessage(config){
    App.alert({
        container: '#alert_container', // alerts parent container(by default placed after the page breadcrumbs)
        place: 'prepent', // append or prepent in container
        type: config.type,  // alert's type
        message: config.message,  // alert's message
        close: true, // make alert closable
        reset: true, // close all previouse alerts first
        focus: false, // auto scroll to the alert after shown
        closeInSeconds: 10, // auto close after defined seconds
        icon: config.icon // put icon before the message
    });
}

function hideMessage(){
    $('#alert_container').html('');
}

function getFrightCarsList(){
    $('#carConsatntMaster_tb').dataTable({
        "destroy": true,
        "bStateSave": true,
        "lengthMenu": [
            [10, 20, 50, 100, 150, -1],
            [10, 20, 50, 100, 150, "All"] // change per page values here
        ],
        "pageLength": 10,

        "ajax":
        {
            "url": "index.php/carConstants/getFreightCarsList",
            "type": "POST",
            "data": {

                COMPANY: $("#COMPANY").val(),
                CAR_ID: $("#CAR_ID").val(),
                CAR_MODEL: $("#CAR_MODEL").val(),
                PRODUCT_CATEGORY: $("#PRODUCT_CATEGORY").val(),
                TRAILER: $("#TRAILER").val()
            }
        },
        "order": [],
        "language": {
            "lengthMenu": "عرض _MENU_ سجل في الصفحة",
            "zeroRecords": "عذرا - لا يوجد بيانات.",
            "info": "عرض _START_ الى _END_ من _TOTAL_ سجل",
            "infoEmpty": "لا تتوفر اي بيانات.",
            "infoFiltered": "(تصفية من _MAX_ سجل)",
            "loadingRecords": "تحميل...",
            "processing":     "جاري معالجة البيانات...",
            "search":         "بحث:",
            "paginate": {
                "first":      "الأول",
                "last":       "الأخير",
                "next":       "التالي",
                "previous":   "السابق"
            }
        },

        "sAjaxDataProp" : "",
        "aoColumnDefs":
            [
                {
                    "aTargets": [ 8 ],
                    "mData": "download_link",
                    "mRender": function ( data, type, full )
                    {
                        var res = "";
                        if (data.STATUS == '0'){
                            if($('#allowedToActive').val()) {
                                res += '<a href="" CAR_SR="'+ data.CAR_SERIAL +'" class="btn blue activateFrightCar">تفعيل</a>';
                            }
                        }
                        else if (data.STATUS == '1'){
                            if($('#allowedToDeactive').val()) {
                                res += '<a href="" CAR_SR="'+ data.CAR_SERIAL +'" class="btn red deactivateFrightCar">إيقاف</a>';
                            }
                            if($('#allowedToEdit').val()) {
                                res += '<a href="javascript:;" CAR_SR="'+ data.CAR_SERIAL +'" class="btn green goToEditFrightCar">تعديل</a>';
                            }
                        }
                        return res;
                    }
                }
            ],
        "aoColumns":
            [
                { "mData": 'COMPANY_ID' },
                { "mData": 'COMPANY_NAME' },
                { "mData": "CAR_ID" },
                { "mData": "CAR_MODEL" },
                { "mData": 'TRAILER_TXT' },
                { "mData": 'TANKS' },
                { "mData": 'TOTAL_CAPACITY' },
                { "mData": 'STATUS_TXT' },
                { "mData": null },

            ]
    });
}
