
$(document).on('change', '#CLIENT_TYPE', function(event){
    if($('#CLIENT_TYPE').val() == 0){
        $('#COM_INFO_DIV').attr('style', 'display: block;');
        $('#DISTR_INFO_DIV').attr('style', 'display: none;');
        $('#GLOBAL_ACC_DIV').attr('style', 'display: none;');
    }
    else if($('#CLIENT_TYPE').val() == 1) {
        $('#COM_INFO_DIV').attr('style', 'display: none;');
        $('#DISTR_INFO_DIV').attr('style', 'display: block;');
        $('#GLOBAL_ACC_DIV').attr('style', 'display: none;');
    }
    else if($('#CLIENT_TYPE').val() == -1) {
        $('#COM_INFO_DIV').attr('style', 'display: none;');
        $('#DISTR_INFO_DIV').attr('style', 'display: none;');
        $('#GLOBAL_ACC_DIV').attr('style', 'display: block;');
    }
}); 

$(document).on('keyup', "#COMPANY_TERM", function (event) {
        if($(this).val() == ''){
            $("#COMPANY_ID").val('');
            $("#COMPANY_NAME").val('');
        }
        $search_for = $(this).val();
        $(this).autocomplete({
            source: function (request, response) {
                $.ajax({
                    type: 'POST',
                    url: "index.php/common/getCompanyInfo",
                    cache: false,
                    dataType: "json",
                    data: {
                        term: $search_for
                    },
                    success: function (data) {
                        response($.map(data, function (item) {
                            return {
                                label: item.COMPANY_NAME_A,
                                value: item.COMPANY_ID
                            }
                        }));
                    }
                    ,
                    error: function (jqXHR, textStatus, errorThrown) {
                    }
                });
            },
            minLength: 1,
            position: {
                my: "right bottom",
                at: "right top",
                collision: "flip"
            },
            select: function (event, ui) {
                $("#COMPANY_TERM").val(ui.item.value);
                $("#COMPANY_ID").val(ui.item.value);
                $("#COMPANY_NAME").val(ui.item.label);
            },
            open: function () {
                $(this).removeClass("ui-corner-all").addClass("ui-corner-top");
            },
            close: function () {
                $(this).removeClass("ui-corner-top").addClass("ui-corner-all");
            }
        });
    });

    $(document).on('keyup', "#DISTRIBUTOR_TERM", function (event) {
        if($(this).val() == ''){
            $("#DISTRIBUTOR_ID").val('');
            $("#DISTRIBUTOR_NAME").val('');
        }
        $search_for = $(this).val();
        $(this).autocomplete({
            source: function (request, response) {
                $.ajax({
                    type: 'POST',
                    url: "index.php/fees/getDistributorByTerm",
                    cache: false,
                    dataType: "json",
                    data: {
                        term: $("#DISTRIBUTOR_TERM").val()
                    },
                    success: function (data) {
                        response($.map(data, function (item) {
                            return {
                                label: item.DISTRIBUTER_SSN + ' - ' + item.DISTRIBUTER_NAME,
                                value: item.DISTRIBUTER_SSN, 
                                DIST_NAME : item.DISTRIBUTER_NAME
                            }
                        }));
                    }
                    ,
                    error: function (jqXHR, textStatus, errorThrown) {
                    }
                });
            },
            minLength: 1,
            position: {
                my: "right bottom",
                at: "right top",
                collision: "flip"
            },
            select: function (event, ui) {
                $("#DISTRIBUTOR_TERM").val(ui.item.value);
                $("#DISTRIBUTOR_ID").val(ui.item.value);
                $("#DISTRIBUTOR_NAME").val(ui.item.DIST_NAME);
            },
            open: function () {
                $(this).removeClass("ui-corner-all").addClass("ui-corner-top");
            },
            close: function () {
                $(this).removeClass("ui-corner-top").addClass("ui-corner-all");
            }
        });
    });

    $(document).on('keyup', "#ACCOUNT_TERM", function (event) {
        if($(this).val() == ''){
            $("#ACCOUNT").val('');
            $("#ACCOUNT_NAME").val('');
        }
        $search_for = $(this).val();
        $parent = $(this).parent();
        $(this).autocomplete({
            source: function (request, response) {
                $.ajax({
                    type: 'POST',
                    url: "index.php/common/getAccountsByTerm",
                    cache: false,
                    dataType: "json",
                    data: {
                        TERM: $search_for
                    },
                    success: function (data) {
                        response($.map(data, function (item) {
                            return {
                                label: item.ACCOUNT_VALUE + ' - ' + item.ACCOUNT_NAME,
                                key: item.ACCOUNT_ID,
                                value: item.ACCOUNT_VALUE,
                                //ACCOUNT_NAME: item.ACCOUNT_VALUE + ' - ' + item.ACCOUNT_NAME ,
                            }
                        }));
                    }
                    ,
                    error: function (jqXHR, textStatus, errorThrown) {
                    }
                });
            },
            minLength: 1,
            position: {
                my: "right bottom",
                at: "right top",
                collision: "flip"
            },
            select: function (event, ui) {
                $("#ACCOUNT").val(ui.item.key);
                $("#ACCOUNT_NAME").val(ui.item.label);
                $("#ACCOUNT-error").remove();
                
            },
            open: function () {
                $(this).removeClass("ui-corner-all").addClass("ui-corner-top");
            },
            close: function () {
                if($('#ACCOUNT_TERM').val() == ''){
                    $("#ACCOUNT").val('');
                    $("#ACCOUNT_NAME").val('');
                }
                else{
                    $.ajax({
                        type: 'POST',
                        url: "index.php/common/getAccountByValue",
                        cache: false,
                        dataType: "json",
                        data: {
                            ACCOUNT_VALUE: $('#ACCOUNT_TERM').val()
                        },
                        success: function (data) {
                            $("#ACCOUNT").val(data[0].ACCOUNT_ID);
                            $("#ACCOUNT_NAME").val(data[0].ACCOUNT_VALUE + ' - ' + data[0].ACCOUNT_NAME );
                            $("#ACCOUNT-error").remove();
                        },
                        error: function (jqXHR, textStatus, errorThrown) {
                        }
                    });
                }

                $(this).removeClass("ui-corner-top").addClass("ui-corner-all");
            }
        });
    });

    $(document).on('click', '#addNewFee_btn', function(e){
        if(validateNewFeeForm()){
            var CLIENT_ID = ($("#CLIENT_TYPE").val() == 0) ? $('#COMPANY_ID').val() : $('#DISTRIBUTOR_ID').val() ;
            if($('#FEE_ACTION').val() == 'ADD_FEE'){
                $.ajax({
                    type: 'POST',
                    url: "index.php/fees/addNewPayableFees",
                    cache: false,
                    dataType: "json",
                    data: {
                        'CLIENT_TYPE': $("#CLIENT_TYPE").val(), 
                        'CLIENT_ID' : CLIENT_ID,
                        'FEE_TYPE' : $('#FEE_TYPE').val(),
                        'FEE_AMOUNT' : $('#AMOUNT').val(),
                        'MERIT_DT' : $('#MERIT_DT').val(),
                        'FEE_NOTES' : $('#FEE_NOTES').val()
                    },
                    success: function (data) {
                        showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
                        if(data.SUCCESS) clearNewFeeForm();    
                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                        showMessage({message:errorThrown, type:'warning', icon:'warning'});
                    }
                });
            }
            if($('#FEE_ACTION').val() == 'UPDATE_FEE'){
                $.ajax({
                    type: 'POST',
                    url: "index.php/fees/changePayableFees",
                    cache: false,
                    dataType: "json",
                    data: {
                        'FEE_SERIAL': $("#FEE_SERIAL").val(), 
                        'CLIENT_TYPE': $("#CLIENT_TYPE").val(), 
                        'CLIENT_ID' : CLIENT_ID,
                        'FEE_TYPE' : $('#FEE_TYPE').val(),
                        'FEE_AMOUNT' : $('#AMOUNT').val(),
                        'MERIT_DT' : $('#MERIT_DT').val(),
                        'FEE_NOTES' : $('#FEE_NOTES').val()
                    },
                    success: function (data) {
                        showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
                        if(data.SUCCESS) clearNewFeeForm();    
                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                        showMessage({message:errorThrown, type:'warning', icon:'warning'});
                    }
                });
            }
        }
        e.preventDefault();
    });

$(document).on('click', '#reset_btn', function(){
    clearNewFeeForm();
    e.preventDefault();
});

$(document).on('click', '#queryPayableFees', function(e){
    showPayableFeesList();
    e.preventDefault();
});


$(document).on('click', '.goToManageFee', function(e){
    $('#p_FEE_SR').val($(this).attr('FEE_SR')); 
    $('#manageFees_frm').submit(); 
    e.preventDefault(); 
});

$(document).on('click', '.approveFee', function(e){
    var fee_serial = $(this).attr('FEE_SR'); 
    $.ajax({
        type: 'POST',
        url: "index.php/fees/approvePayableFees",
        cache: false,
        dataType: "json",
        data: {
            'FEE_SERIAL': fee_serial
        },
        success: function (data) {
            showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
            if(data.SUCCESS) showPayableFeesList();    
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
    e.preventDefault();
});

$(document).on('click', '.cancelFee', function(e){
    var fee_serial = $(this).attr('FEE_SR'); 
    $.ajax({
        type: 'POST',
        url: "index.php/fees/cancelPayableFees",
        cache: false,
        dataType: "json",
        data: {
            'FEE_SERIAL': fee_serial
        },
        success: function (data) {
            showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
            if(data.SUCCESS) showPayableFeesList();    
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
    e.preventDefault();
});

$(document).on('click', '.returnFee', function(e){
    var fee_serial = $(this).attr('FEE_SR'); 
    $.ajax({
        type: 'POST',
        url: "index.php/fees/returnPayableFees",
        cache: false,
        dataType: "json",
        data: {
            'FEE_SERIAL': fee_serial
        },
        success: function (data) {
            showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
            if(data.SUCCESS) showPayableFeesList();    
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
    e.preventDefault();
});

$(document).on('change', '#RECEIPT_TYPE', function(){
    if($('#RECEIPT_TYPE').val() == 'C'){
        if($('#checkInfo_div').length) $('#checkInfo_div').css('display', 'block');
        $('#CHECK_STATUS').empty(); 
        $('#CHECK_STATUS').append($('<option>').val('').text('الجميع'));
        $('#CHECK_STATUS').append($('<option>').val('0').text('مستلم'));
        $('#CHECK_STATUS').append($('<option>').val('1').text('مودع'));
        $('#CHECK_STATUS').append($('<option>').val('2').text('محصل'));
        $('#CHECK_STATUS').append($('<option>').val('4').text('محول للإيرادالعام'));
        $('#CHECK_STATUS').append($('<option>').val('3').text('مرجع'));
    }
    else {
        if($('#checkInfo_div').length) $('#checkInfo_div').css('display', 'none');
        $('#CHECK_DATE').val('');
        $('#CHECK_STATUS').empty(); 
        $('#CHECK_STATUS').append($('<option>').val('').text('الجميع'));
        $('#CHECK_STATUS').append($('<option>').val('0').text('غير محول للإيراد العام'));
        $('#CHECK_STATUS').append($('<option>').val('4').text('محول للإيرادالعام'));
    }
});

$(document).on('change', '#CURRENCY', function(){
    $.ajax({
        type: 'POST',
        url: "index.php/fees/getInstituteBankAccounts",
        cache: false,
        dataType: "json",
        data: {
            'CURRENCY': $("#CURRENCY").val()
        },
        success: function (data) {
            $('#PAY_BANK').empty() ; 
            console.log(data); 
            $.each( data, function( index, element ){
                $('#PAY_BANK').append(new Option(element.ACCOUNT_NAME, element.ACCOUNT_ID)); 
            }); 
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
});

$(document).on('click', '#save_payment_btn', function(e){
    if(validatePaymentsForm()){
        var CLIENT_ID = ($("#CLIENT_TYPE").val() == 0) ? $('#COMPANY_ID').val() : $('#DISTRIBUTOR_ID').val() ;
        $.ajax({
            type: 'POST',
            url: "index.php/fees/savePaymentInfo",
            cache: false,
            dataType: "json",
            data: {
                'PAY_SERIAL': $("#PAY_SERIAL").val(), 
                'PAY_ACTION': $("#PAY_ACTION").val(), 
                'CLIENT_TYPE': $("#CLIENT_TYPE").val(), 
                'CLIENT_ID' : CLIENT_ID,
                'RECEIPT_TYPE' : $('#RECEIPT_TYPE').val(),
                'RECEIPT_ID' : $('#RECEIPT_ID').val(),
                'AMOUNT' : $('#AMOUNT').val(),
                'CURRENCY' : $('#CURRENCY').val(),
                'BANK' : $('#PAY_BANK').val(),
                'PAYMENT_DT' : $('#PAYMENT_DT').val(),
                'CHECK_BANK' : $('#CHECK_BANK').val(), 
                'CHECK_DATE' : $('#CHECK_DATE').val(),
                'PAY_NOTES' : $('#PAY_NOTES').val()
            },
            success: function (data) {
                showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
                if(data.SUCCESS) clearPaymentForm();    
            },
            error: function (jqXHR, textStatus, errorThrown) {
                showMessage({message:errorThrown, type:'warning', icon:'warning'});
            }
        });
    }      
});

$(document).on('click', '#queryPyments', function(e){
    showPaymentsList();
    e.preventDefault();
});


$(document).on('click', '.goToManagePayment', function(e){
    $('#p_PAY_SR').val($(this).attr('PAY_SR')); 
    $('#managePayments_frm').submit(); 
    e.preventDefault(); 
});

$(document).on('click', '.approvePayment', function(e){
    var pay_serial = $(this).attr('PAY_SR'); 
    $.ajax({
        type: 'POST',
        url: "index.php/fees/approvePayment",
        cache: false,
        dataType: "json",
        data: {
            'PAY_SERIAL': pay_serial
        },
        success: function (data) {
            showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
            if(data.SUCCESS) showPaymentsList();    
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
    e.preventDefault();
}); 

$(document).on('click', '.cancelPayment', function(e){
    var pay_serial = $(this).attr('PAY_SR'); 
    $.ajax({
        type: 'POST',
        url: "index.php/fees/cancelPayment",
        cache: false,
        dataType: "json",
        data: {
            'PAY_SERIAL': pay_serial
        },
        success: function (data) {
            showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
            if(data.SUCCESS) showPaymentsList();    
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
    e.preventDefault();
}); 

$(document).on('click', '.returnPayment', function(e){
    var pay_serial = $(this).attr('PAY_SR'); 
    $.ajax({
        type: 'POST',
        url: "index.php/fees/returnPayment",
        cache: false,
        dataType: "json",
        data: {
            'PAY_SERIAL': pay_serial
        },
        success: function (data) {
            showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
            if(data.SUCCESS) showPaymentsList();    
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
    e.preventDefault();
}); 

$(document).on('click', '.depositInBank', function(e){
    $('#D_PAYMENT_SR').val($(this).attr('PAY_SR'));
    $('#depositCheckModal').modal('show');
    e.preventDefault();
});

$(document).on('click', '#CONF_CHECK_DEPOSIT_BTN', function(e){
    $.ajax({
        type: 'POST',
        url: "index.php/fees/depositPaymentCheck",
        cache: false,
        dataType: "json",
        data: {
            'PAY_SERIAL': $('#D_PAYMENT_SR').val(), 
            'DEPOSIT_DT' : $('#DEPOSIT_DT').val()
        },
        success: function (data) {
            showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
            if(data.SUCCESS){
                showPaymentsList();
                $('#D_PAYMENT_SR').val('');
                $('#DEPOSIT_DT').val('');  
            }   
            $('#depositCheckModal').modal('hide');
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
    e.preventDefault();
}); 

$(document).on('click', '.collectCheck', function(e){
    $('#C_PAYMENT_SR').val($(this).attr('PAY_SR'));
    $('#CheckCollectedModal').modal('show');
    e.preventDefault();
}); 

$(document).on('click', '#CONF_CHECK_COLLECTED_BTN', function(e){
    $.ajax({
        type: 'POST',
        url: "index.php/fees/colleckPaymentCheck",
        cache: false,
        dataType: "json",
        data: {
            'PAY_SERIAL': $('#C_PAYMENT_SR').val(), 
            'COLLECT_DT' : $('#COLLECT_DT').val()
        },
        success: function (data) {
            showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
            if(data.SUCCESS){
                showPaymentsList();
                $('#C_PAYMENT_SR').val('');
                $('#COLLECT_DT').val('');  
            }   
            $('#CheckCollectedModal').modal('hide');
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
    e.preventDefault();
}); 

$(document).on('click', '.returnCheck', function(e){
    $('#R_PAYMENT_SR').val($(this).attr('PAY_SR'));
    $('#CheckReturnedModal').modal('show');
    e.preventDefault();
}); 

$(document).on('click', '#CONF_CHECK_RETURNED_BTN', function(e){
    $.ajax({
        type: 'POST',
        url: "index.php/fees/returnPaymentInBank",
        cache: false,
        dataType: "json",
        data: {
            'PAY_SERIAL': $('#R_PAYMENT_SR').val(), 
            'RETURN_DT' : $('#RETURN_DT').val()
        },
        success: function (data) {
            showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
            if(data.SUCCESS){
                showPaymentsList();
                $('#R_PAYMENT_SR').val('');
                $('#RETURN_DT').val('');  
            }  
            $('#CheckReturnedModal').modal('hide'); 
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
    e.preventDefault();
}); 

$(document).on('click', '.transToIraad', function(e){
    $('#I_PAYMENT_SR').val($(this).attr('PAY_SR'));
    $('#transToIraadModal').modal('show');
    e.preventDefault();
}); 

$(document).on('click', '#CONF_TRANS_TO_IRAAD_BTN', function(e){
    $.ajax({
        type: 'POST',
        url: "index.php/fees/transformPayToIraad",
        cache: false,
        dataType: "json",
        data: {
            'PAY_SERIAL': $('#I_PAYMENT_SR').val(), 
            'TRANS_AMOUNT' : $('#TRANS_IRAAD').val(),
            'TRANS_DT' : $('#TRANS_DT').val()
        },
        success: function (data) {
            showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
            if(data.SUCCESS){
                showPaymentsList();
                $('#I_PAYMENT_SR').val(''); 
                $('#TRANS_IRAAD').val(''); 
                $('#TRANS_DT').val(''); 
            }  
            $('#transToIraadModal').modal('hide'); 
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
    e.preventDefault();
}); 

$(document).on('click', "#getStatement_btn", function (e) {
    if(validateGetStatementForm()){
        var CLIENT_ID ;
        if($('#CLIENT_TYPE').val() == 0) CLIENT_ID = $('#COMPANY_ID').val(); 
        if($('#CLIENT_TYPE').val() == 1) CLIENT_ID = $('#DISTRIBUTOR_ID').val(); 
        if($('#CLIENT_TYPE').val() == -1) CLIENT_ID = $('#ACCOUNT').val(); 
        $('#oparatingChainsList_tb').dataTable({
            "destroy": true,
            "bStateSave": false,
            "lengthMenu": [
                        [10, 20, 50, 100, 150, -1],
                        [10, 20, 50, 100, 150, "All"] // change per page values here
            ],
            "pageLength": 10,
            dom: 'Blfrtip',
            buttons: [
                {
                    extend: 'excel', text: 'تصدير الى اكسل',
                }
            ],
            "ajax": 
            {
                "url": "index.php/statements/queryOparatingChainsStatament", 
                "type": "POST",
                "data": {
                    'CLIENT_TYPE': $("#CLIENT_TYPE").val(), 
                    'CLIENT_ID' : CLIENT_ID,
                    START_DATE: $('#CHAIN_DT_FROM').val(),
                    END_DATE: $('#CHAIN_DT_TO').val()
                }  
            },
            "order": [[0, "asc"]],
            "language": {
                    "lengthMenu": "عرض _MENU_ سجل في الصفحة",
                    "zeroRecords": "عذرا - لا يوجد بيانات.",
                    "info": "عرض _START_ الى _END_ من _TOTAL_ سجل",
                    "infoEmpty": "لا تتوفر اي بيانات.",
                    "infoFiltered": "(تصفية من _MAX_ سجل)",
                    "loadingRecords": "تحميل...",
                    "processing":     "جاري معالجة البيانات...",
                    "search":         "بحث:",
                    "paginate": {
                        "first":      "الأول",
                        "last":       "الأخير",
                        "next":       "التالي",
                        "previous":   "السابق"
                    },
                },
            "sAjaxDataProp" : "",
            "columns": [
                    {"data" : "SERIAL" , "width" : "5%"},
                    {"data" : "T_DATE_CHAR" , "width" : "10%" },
                    {"data" : "T_TYPE" , "width" : "10%" },
                    {"data" : "T_SERIAL" , "width" : "10%"  },
                    {"data" : "A_DEBT" , "width" : "10%" },
                    {"data" : "A_CREDIT" , "width" : "10%"},
                    /*
                    {"data" : null, "width": "10%", "render" : function( data, type, full){
                            return data.TOTAL_DEBT - data.TOTAL_CRIDIT  ; 
                        }
                    },*/
                    {"data" : "T_DECS" , "width" : "25%"}
            ]
        });
    }
    e.preventDefault();
});

$(document).on('click', '#printStatment_btn', function(e){
    $('#F_CLIENT_TYPE').val($('#CLIENT_TYPE').val()); 
    $('#F_START_DT').val($('#CHAIN_DT_FROM').val()); 
    $('#F_END_DT').val($('#CHAIN_DT_TO').val()); 
    if($('#CLIENT_TYPE').val() == 0){
        $('#F_CLIENT_ID').val($('#COMPANY_ID').val()); 
        $('#F_CLIENT_NAME').val($('#COMPANY_NAME').val()); 
    } 
    if($('#CLIENT_TYPE').val() == 1){
        $('#F_CLIENT_ID').val($('#DISTRIBUTOR_ID').val()); 
        $('#F_CLIENT_NAME').val($('#DISTRIBUTOR_NAME').val()); 
    }
    if($('#CLIENT_TYPE').val() == -1){
        $('#F_CLIENT_ID').val($('#ACCOUNT').val()); 
        $('#F_CLIENT_NAME').val($('#ACCOUNT_NAME').val()); 
    }
    $('#printAccountStatementForm').submit(); 
    e.preventDefault();
}); 

$(document).on('click', '#addNewBankCommission_btn', function(e){
    if(isValidBankCommission()){
        $.ajax({
            type: 'POST',
            url: "index.php/fees/saveBankCommissionInfo",
            cache: false,
            dataType: "json",
            data: {
                'COMS_BANK': $("#PAY_BANK").val(), 
                'COMS_AMOUNT': $("#COMMIS_AMOUNT").val(), 
                'COMS_CURRENCY' : $("#CURRENCY").val(),
                'COMS_DATE' : $('#COMMISSION_DT').val(),
                'COMS_NOTES' : $('#COMMS_NOTES').val(),
            },
            success: function (data) {
                showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
                if(data.SUCCESS) clearBankCommissionForm();    
            },
            error: function (jqXHR, textStatus, errorThrown) {
                showMessage({message:errorThrown, type:'warning', icon:'warning'});
            }
        });
    }
    e.preventDefault();
}); 

$(document).on('click', '#queryBankCommissions_but', function(e){
    e.preventDefault();
    getBankCommissionsList(); 
}); 

$(document).on('click', '.approveCommission', function(e){
    var comSerial = $(this).attr('COMMIS_SR'); 
    $.ajax({
        type: 'POST',
        url: "index.php/fees/approveCommission",
        cache: false,
        dataType: "json",
        data: {
            'COM_SERIAL': comSerial, 
        },
        success: function (data) {
            showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
            if(data.SUCCESS) getBankCommissionsList();    
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
    e.preventDefault();
}); 

$(document).on('click', '.cancelCommission', function(e){
    var comSerial = $(this).attr('COMMIS_SR'); 
    $.ajax({
        type: 'POST',
        url: "index.php/fees/cancelCommission",
        cache: false,
        dataType: "json",
        data: {
            'COM_SERIAL': comSerial, 
        },
        success: function (data) {
            showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
            if(data.SUCCESS) getBankCommissionsList();    
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
    e.preventDefault();
}); 

$(document).on('click', '.returnCommission', function(e){
    var comSerial = $(this).attr('COMMIS_SR'); 
    $.ajax({
        type: 'POST',
        url: "index.php/fees/returnCommission",
        cache: false,
        dataType: "json",
        data: {
            'COM_SERIAL': comSerial, 
        },
        success: function (data) {
            showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
            if(data.SUCCESS) getBankCommissionsList();    
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
    e.preventDefault();
}); 

function validateNewFeeForm(){
    var isValid = 1 ;
    if(($("#CLIENT_TYPE").val() == 0) && ($('#COMPANY_ID').val() == '')){
        isValid = 0 ;
        $(document).find("#COMPANY_TERM").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#COMPANY_TERM").closest('.form-group').removeClass('has-error');
    }
    
    if(($("#CLIENT_TYPE").val() == 1) && ($('#DISTRIBUTOR_ID').val() == '')){
        isValid = 0 ;
        $(document).find("#DISTRIBUTOR_TERM").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#DISTRIBUTOR_TERM").closest('.form-group').removeClass('has-error');
    }

    if($.trim($("#MERIT_DT").val()) == ''){
        isValid = 0 ;
        $(document).find("#MERIT_DT").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#MERIT_DT").closest('.form-group').removeClass('has-error');
    }

    if(($.trim($("#AMOUNT").val()) == '') || !($.isNumeric($("#AMOUNT").val()))){
        isValid = 0 ;
        $(document).find("#AMOUNT").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#AMOUNT").closest('.form-group').removeClass('has-error');
    }

    if($.trim($("#FEE_NOTES").val()) == ''){
        isValid = 0 ;
        $(document).find("#FEE_NOTES").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#FEE_NOTES").closest('.form-group').removeClass('has-error');
    }
    return isValid;
}

function validateGetStatementForm(){
    var isValid = 1 ;
    if(($("#CLIENT_TYPE").val() == 0) && ($('#COMPANY_ID').val() == '')){
        isValid = 0 ;
        $(document).find("#COMPANY_TERM").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#COMPANY_TERM").closest('.form-group').removeClass('has-error');
    }
    
    if(($("#CLIENT_TYPE").val() == 1) && ($('#DISTRIBUTOR_ID').val() == '')){
        isValid = 0 ;
        $(document).find("#DISTRIBUTOR_TERM").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#DISTRIBUTOR_TERM").closest('.form-group').removeClass('has-error');
    }

    if($.trim($("#CHAIN_DT_FROM").val()) == ''){
        isValid = 0 ;
        $(document).find("#CHAIN_DT_FROM").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#CHAIN_DT_FROM").closest('.form-group').removeClass('has-error');
    }
    return isValid;
}

function clearNewFeeForm(){
    $(document).find("#COMPANY_TERM").closest('.form-group').removeClass('has-error');
    $(document).find("#DISTRIBUTOR_TERM").closest('.form-group').removeClass('has-error');
    $(document).find("#MERIT_DT").closest('.form-group').removeClass('has-error');
    $(document).find("#AMOUNT").closest('.form-group').removeClass('has-error');
    $(document).find("#FEE_NOTES").closest('.form-group').removeClass('has-error');
    $("#CLIENT_TYPE option[value='0']").prop('selected', true); 
    $("#FEE_TYPE option[value='1']").prop('selected', true); 
    $("#CLIENT_TYPE").change(); 
    $("#DISTRIBUTOR_TERM").val('');
    $("#DISTRIBUTOR_ID").val('');
    $("#DISTRIBUTOR_NAME").val('');    
    $("#COMPANY_TERM").val('');
    $("#COMPANY_ID").val('');
    $("#COMPANY_NAME").val('');
    $("#MERIT_DT").val('');
    $("#AMOUNT").val('');
    $("#FEE_NOTES").val(''); 
}

function validatePaymentsForm(){
    var isValid = 1 ;
    if(($("#CLIENT_TYPE").val() == 0) && ($('#COMPANY_ID').val() == '')){
        isValid = 0 ;
        $(document).find("#COMPANY_TERM").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#COMPANY_TERM").closest('.form-group').removeClass('has-error');
    }
    
    if(($("#CLIENT_TYPE").val() == 1) && ($('#DISTRIBUTOR_ID').val() == '')){
        isValid = 0 ;
        $(document).find("#DISTRIBUTOR_TERM").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#DISTRIBUTOR_TERM").closest('.form-group').removeClass('has-error');
    }

    if($.trim($("#RECEIPT_ID").val()) == ''){
        isValid = 0 ;
        $(document).find("#RECEIPT_ID").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#RECEIPT_ID").closest('.form-group').removeClass('has-error');
    }

    if(($.trim($("#AMOUNT").val()) == '') || !($.isNumeric($("#AMOUNT").val()))){
        isValid = 0 ;
        $(document).find("#AMOUNT").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#AMOUNT").closest('.form-group').removeClass('has-error');
    }

    if($.trim($("#PAYMENT_DT").val()) == ''){
        isValid = 0 ;
        $(document).find("#PAYMENT_DT").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#PAYMENT_DT").closest('.form-group').removeClass('has-error');
    }
    if($("#RECEIPT_TYPE").val() == 'C'){
        if($.trim($("#CHECK_DATE").val()) == ''){
            isValid = 0 ;
            $(document).find("#CHECK_DATE").closest('.form-group').addClass('has-error');
        }
        else {
            $(document).find("#CHECK_DATE").closest('.form-group').removeClass('has-error');
        }
    }
    if($.trim($("#PAY_NOTES").val()) == ''){
        isValid = 0 ;
        $(document).find("#PAY_NOTES").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#PAY_NOTES").closest('.form-group').removeClass('has-error');
    }
    return isValid;
}

function clearPaymentForm(){
    $(document).find("#COMPANY_TERM").closest('.form-group').removeClass('has-error');
    $(document).find("#DISTRIBUTOR_TERM").closest('.form-group').removeClass('has-error');
    $(document).find("#RECEIPT_ID").closest('.form-group').removeClass('has-error');
    $(document).find("#AMOUNT").closest('.form-group').removeClass('has-error');
    $(document).find("#PAYMENT_DT").closest('.form-group').removeClass('has-error');
    $(document).find("#CHECK_DATE").closest('.form-group').removeClass('has-error');
    $(document).find("#PAY_NOTES").closest('.form-group').removeClass('has-error');
    $("#CLIENT_TYPE option[value='0']").prop('selected', true); 
    $("#RECEIPT_TYPE option[value='T']").prop('selected', true); 
    $("#CHECK_BANK option[value='1']").prop('selected', true); 
    $("#RECEIPT_TYPE").chenge();
    $("#CLIENT_TYPE").change(); 
    $("#DISTRIBUTOR_TERM").val('');
    $("#DISTRIBUTOR_ID").val('');
    $("#DISTRIBUTOR_NAME").val('');    
    $("#COMPANY_TERM").val('');
    $("#COMPANY_ID").val('');
    $("#COMPANY_NAME").val('');
    $("#RECEIPT_ID").val('');
    $("#AMOUNT").val('');
    $("#PAYMENT_DT").val('');
    $("#CHECK_DATE").val('');
    $("#PAY_NOTES").val(''); 
}

function showPayableFeesList(){
    var client_id ;
    if($('#CLIENT_TYPE').val() == 0) client_id = $('#COMPANY_ID').val(); 
    if($('#CLIENT_TYPE').val() == 1) client_id = $('#DISTRIBUTOR_ID').val(); 
    if($('#CLIENT_TYPE').val() == -1) client_id = $('#ACCOUNT').val(); 
    $('#payableFees_tb').dataTable({
        "destroy": true,
        "bStateSave": true,
        "lengthMenu": [
                    [10, 20, 50, 100, 150, -1],
                    [10, 20, 50, 100, 150, "All"] // change per page values here
        ],
        "pageLength": 10,
        
        "ajax": 
        {
            "url": "index.php/fees/getPayableFees", 
            "type": "POST",
            "data": {
                CLIENT_TYPE: $('#CLIENT_TYPE').val(),
                CLIENT_ID: client_id,
                FEE_TYPE: $('#FEE_TYPE').val(),
                MERIT_ST: $('#MERIT_START').val(),
                MERIT_END: $('#MERIT_END').val(),
                STATUS: $('#STATUS').val()
            }  
        },
        "order": [[0, "asc"]],
        "language": {
                "lengthMenu": "عرض _MENU_ سجل في الصفحة",
                "zeroRecords": "عذرا - لا يوجد بيانات.",
                "info": "عرض _START_ الى _END_ من _TOTAL_ سجل",
                "infoEmpty": "لا تتوفر اي بيانات.",
                "infoFiltered": "(تصفية من _MAX_ سجل)",
                "loadingRecords": "تحميل...",
                "processing":     "جاري معالجة البيانات...",
                "search":         "بحث:",
                "paginate": {
                    "first":      "الأول",
                    "last":       "الأخير",
                    "next":       "التالي",
                    "previous":   "السابق"
                },
            },
        "sAjaxDataProp" : "",
        "aoColumnDefs": 
        [ 

            {
                "aTargets": [ 1 ],
                "mData": "download_link",
                "mRender": function ( data, type, full ) 
                {
                   return data.CLIENT_ID + ' - ' + data.CLIENT_NAME;
                }
            } , 

            {
                "aTargets": [ 7 ],
                "mData": "download_link",
                "mRender": function ( data, type, full ) 
                {  
                    var res = "";
                    if(data.STATUS == 0){
                        if($('#allowedToEdit').val()) res += '<a href="" FEE_SR = "'+ data.SERIAL_NO +'" class="btn blue goToManageFee">تعديل</a>';
                        if($('#allowedToApprove').val()) res += '<a href="" FEE_SR = "'+ data.SERIAL_NO +'" class="btn green approveFee">اعتماد</a>';
                        if($('#allowedToCancel').val()) res += '<a href="" FEE_SR = "'+ data.SERIAL_NO +'" class="btn red cancelFee">الغاء</a>';
                    } 
                    if(data.STATUS == 1){
                        if($('#allowedToReturn').val()) res += '<a href="" FEE_SR = "'+ data.SERIAL_NO +'" class="btn yellow returnFee">ارجاع</a>';
                        //if($('#allowedToPrint').val()) res += '<a href="" FEE_SR = "'+ data.SERIAL_NO +'" class="btn blue printFee">طباعة</a>';
                    } 
                   return res;
                }
            } 

        ],
        "aoColumns": 
        [   
            { "mData": 'CLIENT_TYPE_TXT'},
            { "mData": null},
            { "mData": "FEE_TYPE_TXT"},
            { "mData": "FEE_AMOUNT"},
            { "mData": "MERIT_DT"},
            { "mData": "FEE_NOTES"},
            { "mData": "STATUS_TXT"},
            { "mData": null}
        ]
        
    });
}

function showPaymentsList(){
    var client_id; 
    if($('#CLIENT_TYPE').val() == 0) client_id = $('#COMPANY_ID').val(); 
    if($('#CLIENT_TYPE').val() == 1) client_id = $('#DISTRIBUTOR_ID').val(); 
    if($('#CLIENT_TYPE').val() == -1) client_id = $('#ACCOUNT').val(); 
    $('#paymentsList_tb').dataTable({
        "destroy": true,
        "bStateSave": true,
        "lengthMenu": [
                    [10, 20, 50, 100, 150, -1],
                    [10, 20, 50, 100, 150, "All"] // change per page values here
        ],
        "pageLength": 10,
        dom: 'Blfrtip',
        buttons: [
            {
                extend: 'excel', text: 'تصدير الى اكسل',
            }
        ],
        "ajax": 
        {
            "url": "index.php/fees/getPaymentsList", 
            "type": "POST",
            "data": {
                CLIENT_TYPE: $('#CLIENT_TYPE').val(),
                CLIENT_ID: client_id,
                RECEIPT_TYPE: $('#RECEIPT_TYPE').val(),
                PAY_ST: $('#PAY_START_DT').val(),
                PAY_END: $('#PAY_END_DT').val(),
                STATUS: $('#STATUS').val(), 
                CHECK_STATE : $('#CHECK_STATUS').val()
            }  
        },
        "order": [[0, "asc"]],
        "language": {
                "lengthMenu": "عرض _MENU_ سجل في الصفحة",
                "zeroRecords": "عذرا - لا يوجد بيانات.",
                "info": "عرض _START_ الى _END_ من _TOTAL_ سجل",
                "infoEmpty": "لا تتوفر اي بيانات.",
                "infoFiltered": "(تصفية من _MAX_ سجل)",
                "loadingRecords": "تحميل...",
                "processing":     "جاري معالجة البيانات...",
                "search":         "بحث:",
                "paginate": {
                    "first":      "الأول",
                    "last":       "الأخير",
                    "next":       "التالي",
                    "previous":   "السابق"
                },
            },
        "sAjaxDataProp" : "",
        "aoColumnDefs": 
        [ 

            {
                "aTargets": [ 2 ],
                "mData": "download_link",
                "mRender": function ( data, type, full ) 
                {
                   return data.CLIENT_ID + ' - ' + data.CLIENT_NAME;
                }
            } , 
            {
                "aTargets": [ 5 ],
                "mData": "download_link",
                "mRender": function ( data, type, full ) 
                {
                   return data.BANK_NAME + ' - ' + data.BANK_ACC_VAL;
                }
            } , 
            {
                "aTargets": [ 8 ],
                "mData": "download_link",
                "mRender": function ( data, type, full ) 
                {
                    if(data.RECEIPT_TYPE == 'T') return ''; 
                   return data.CHECK_BANK_NAME ;
                }
            } ,
            {
                "aTargets": [ 11 ],
                "mData": "download_link",
                "mRender": function ( data, type, full ) 
                {
                    var state = data.STATUS_TXT; 
                    if(data.RECEIPT_TYPE == 'T' && data.STATUS == 1 && data.COLLECT_STATE == 4) state = state + ' - محولة للإيراد العام'; 
                    if(data.RECEIPT_TYPE == 'T' && data.STATUS == 1 && data.COLLECT_STATE != 4) state = state + ' - غير محولة للإيراد العام'; 
                    if(data.RECEIPT_TYPE == 'C') state = state + ' - ' + data.COLLECTION_STATE; 
                    return state ;
                }
            } ,
            {
                "aTargets": [ 13 ],
                "mData": "download_link",
                "mRender": function ( data, type, full ) 
                {  
                    var res = "";
                    if(data.STATUS == 0){ // فيد الإعداد
                        if($('#allowedToEdit').val()) res += '<a href="" PAY_SR = "'+ data.SERIAL_NO +'" class="btn blue goToManagePayment">تعديل</a>';
                        if($('#allowedToApprove').val()) res += '<a href="" PAY_SR = "'+ data.SERIAL_NO +'" class="btn green approvePayment">اعتماد</a>';
                        if($('#allowedToCancel').val()) res += '<a href="" PAY_SR = "'+ data.SERIAL_NO +'" class="btn red cancelPayment">الغاء</a>';
                    } 
                    if(data.STATUS == 1 && data.RECEIPT_TYPE == 'T' && (data.COLLECT_STATE == 0 || data.COLLECT_STATE == null)){ // معتمد فقط
                        if($('#allowedToReturn').val()) res += '<a href="" PAY_SR = "'+ data.SERIAL_NO +'" class="btn yellow returnPayment">ارجاع</a>';
                        if($('#allowedToTransIraadCheck').val()) res += '<a href="" PAY_SR = "'+ data.SERIAL_NO +'" class="btn green transToIraad">تحويل للايراد العام</a>';
                        
                    }
                    if(data.STATUS == 1 && data.RECEIPT_TYPE == 'C' && (data.COLLECT_STATE == 0 || data.COLLECT_STATE == null)){
                        if($('#allowedToReturn').val()) res += '<a href="" PAY_SR = "'+ data.SERIAL_NO +'" class="btn yellow returnPayment">ارجاع</a>';
                        if($('#allowedToDepositCheck').val() && (data.RECEIPT_TYPE == 'C')) res += '<a href="" PAY_SR = "'+ data.SERIAL_NO +'" class="btn green depositInBank">ايداع</a>';
                    }
                    if(data.STATUS == 1 && data.COLLECT_STATE == 1 &&  data.RECEIPT_TYPE == 'C'){ // معتمد ومودع في البنك
                        if($('#allowedToCollectCheck').val()) res += '<a href="" PAY_SR = "'+ data.SERIAL_NO +'" class="btn green collectCheck">تحصيل</a>';
                        if($('#allowedToReturnCheck').val()) res += '<a href="" PAY_SR = "'+ data.SERIAL_NO +'" class="btn red returnCheck">مرجع بنكيا</a>';
                    }
                    if(data.STATUS == 1 && data.COLLECT_STATE == 2 &&  data.RECEIPT_TYPE == 'C'){ // دفعة شيك محصلة في البنك
                        if($('#allowedToTransIraadCheck').val()) res += '<a href="" PAY_SR = "'+ data.SERIAL_NO +'" class="btn green transToIraad">تحويل للايراد العام</a>';
                    }
                    if(data.STATUS == 1 && data.COLLECT_STATE == 3 &&  data.RECEIPT_TYPE == 'C'){ // دفعة شيك مرجعة في البنك
                        res += ''; 
                    }
                   return res;
                }
            } 

        ],
        "aoColumns": 
        [   
            { "mData": 'SERIAL_NO'},
            { "mData": 'CLIENT_TYPE_TXT'},
            { "mData": null},
            { "mData": "RECP_TYPE"},
            { "mData": "RECEIPT_ID"},
            { "mData": null},
            { "mData": "PAY_AMOUNT"},
            { "mData": "PAY_DT"},
            { "mData": null},
            { "mData": "CHECK_DATE_TXT"},
            { "mData": "NOTES"},
            { "mData": null},
            { "mData": "COLLECT_DT"},
            { "mData": null}
        ]
        
    });
}

function isValidBankCommission(){
    var isValid = 1 ;
    if(($.trim($("#COMMIS_AMOUNT").val()) == '') || !($.isNumeric($("#COMMIS_AMOUNT").val()))){
        isValid = 0 ;
        $(document).find("#COMMIS_AMOUNT").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#COMMIS_AMOUNT").closest('.form-group').removeClass('has-error');
    }

    if($.trim($("#COMMISSION_DT").val()) == ''){
        isValid = 0 ;
        $(document).find("#COMMISSION_DT").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#COMMISSION_DT").closest('.form-group').removeClass('has-error');
    }
    if($.trim($("#COMMS_NOTES").val()) == ''){
        isValid = 0 ;
        $(document).find("#COMMS_NOTES").closest('.form-group').addClass('has-error');
    }
    else {
        $(document).find("#COMMS_NOTES").closest('.form-group').removeClass('has-error');
    }
    return isValid;
}

function clearBankCommissionForm(){
    $("#COMMIS_AMOUNT").val('');
    $("#CURRENCY option[value='2']").prop('selected', true); 
    $("#CURRENCY").change(); 
    $("#COMMISSION_DT").val('');
    $("#COMMS_NOTES").val('');    
}

function getBankCommissionsList(){
    $('#bankCommisionsList_tb').dataTable({
        "destroy": true,
        "bStateSave": true,
        "lengthMenu": [
                    [10, 20, 50, 100, 150, -1],
                    [10, 20, 50, 100, 150, "All"] // change per page values here
        ],
        "pageLength": 10,
        dom: 'Blfrtip',
        buttons: [
            {
                extend: 'excel', text: 'تصدير الى اكسل',
            }
        ],
        "ajax": 
        {
            "url": "index.php/fees/getBankCommissionsList", 
            "type": "POST",
            "data": {
                BANK: $('#PAY_BANK').val(),
                COMMIS_STD: $('#COMIS_START_DT').val(),
                COMMIS_END: $('#COMIS_END_DT').val(),
                STATUS: $('#STATUS').val(), 
            }  
        },
        "order": [],
        "language": {
                "lengthMenu": "عرض _MENU_ سجل في الصفحة",
                "zeroRecords": "عذرا - لا يوجد بيانات.",
                "info": "عرض _START_ الى _END_ من _TOTAL_ سجل",
                "infoEmpty": "لا تتوفر اي بيانات.",
                "infoFiltered": "(تصفية من _MAX_ سجل)",
                "loadingRecords": "تحميل...",
                "processing":     "جاري معالجة البيانات...",
                "search":         "بحث:",
                "paginate": {
                    "first":      "الأول",
                    "last":       "الأخير",
                    "next":       "التالي",
                    "previous":   "السابق"
                },
            },
        "sAjaxDataProp" : "",
        "aoColumnDefs": 
        [ 
            {
                "aTargets": [ 1 ],
                "mData": "download_link",
                "mRender": function ( data, type, full ) 
                {
                   return data.BANK_NAME + ' - ' + data.BANK_ACC_VAL;
                }
            } , 
            {
                "aTargets": [ 6 ],
                "mData": "download_link",
                "mRender": function ( data, type, full ) 
                {  
                    var res = "";
                    if(data.STATUS == 0){ // فيد الإعداد
                        if($('#allowedToApprove').val()) res += '<a href="" COMMIS_SR = "'+ data.SERIAL_NO +'" class="btn green approveCommission">اعتماد</a>';
                        if($('#allowedToCancel').val()) res += '<a href="" COMMIS_SR = "'+ data.SERIAL_NO +'" class="btn red cancelCommission">الغاء</a>';
                    } 
                    if(data.STATUS == 1){ // معتمد 
                        if($('#allowedToReturn').val()) res += '<a href="" COMMIS_SR = "'+ data.SERIAL_NO +'" class="btn yellow returnCommission">ارجاع</a>';
                        
                    }
                   return res;
                }
            } 

        ],
        "aoColumns": 
        [   
            { "mData": 'SERIAL_NO'},
            { "mData": null},
            { "mData": "COMMISSION_AMOUNT"},
            { "mData": "CURRENCY_NAME"},
            { "mData": "COMMISSON_DT"},
            { "mData": "COM_NOTES"},
            { "mData": null},
        ]
        
    });
}

function showMessage(config){
    App.alert({
        container: '#alert_container', // alerts parent container(by default placed after the page breadcrumbs)
        place: 'prepent', // append or prepent in container 
        type: config.type,  // alert's type
        message: config.message,  // alert's message
        close: true, // make alert closable
        reset: true, // close all previouse alerts first
        focus: false, // auto scroll to the alert after shown
        closeInSeconds: 10, // auto close after defined seconds
        icon: config.icon // put icon before the message
    });
}

function hideMessage(){
    $('#alert_container').html('');
}
