
$(document).ready(function(){
    $('#compnayTotals_tb').dataTable({
        "destroy": true,
        "lengthMenu": [
                    [10, 20, 50, 100, 150, -1],
                    [10, 20, 50, 100, 150, "All"] // change per page values here
        ],
        "data": [],
        "pageLength": 10,
        "language": {
                "lengthMenu": "عرض _MENU_ سجل في الصفحة",
                "zeroRecords": "عذرا - لا يوجد بيانات.",
                "info": "عرض _START_ الى _END_ من _TOTAL_ سجل",
                "infoEmpty": "لا تتوفر اي بيانات.",
                "infoFiltered": "(تصفية من _MAX_ سجل)",
                "loadingRecords": "تحميل...",
                "processing":     "جاري معالجة البيانات...",
                "search":         "بحث:",
                "paginate": {
                    "first":      "الأول",
                    "last":       "الأخير",
                    "next":       "التالي",
                    "previous":   "السابق"
                },
        }
    }) ; 
    $('[tabindex=0]').focus();
    FormValidation.init();    
}) ;

$(document).on('keyup', "#COMP_ACCOUNT_TERM", function (event) {
    if($(this).val() == ''){
        $("#COMP_ACCOUNT_NAME").val('');
        $("#COMP_ACCOUNT").val('');
    }
    $search_for = $(this).val();
    $(this).autocomplete({
        source: function (request, response) {
            $.ajax({
                type: 'POST',
                url: "index.php/common/getAccountsByTerm",
                cache: false,
                dataType: "json",
                data: {
                    TERM: $('#COMP_ACCOUNT_TERM').val(),
                    PARENT_ACCOUNT: $('#PRODUCT_CATEGORY').val()
                },
                success: function (data) {
                    response($.map(data, function (item) {
                        return {
                           label: item.ACCOUNT_VALUE + ' - ' + item.ACCOUNT_NAME,
                            key: item.ACCOUNT_ID ,
                            value : item.ACCOUNT_VALUE
                        }
                    }));
                }
                ,
                error: function (jqXHR, textStatus, errorThrown) {
                }
            });
        },
        minLength: 1,
        position: {
            my: "right bottom",
            at: "right top",
            collision: "flip"
        },
        select: function (event, ui) {
            $("#COMP_ACCOUNT").val(ui.item.key); 
            $("#COMP_ACCOUNT_NAME").val(ui.item.label);
            $("#COMP_ACCOUNT-error").remove();

        },
        open: function () {
            $(this).removeClass("ui-corner-all").addClass("ui-corner-top");
        },
        close: function () {
            if($('#COMP_ACCOUNT_TERM').val() == ''){
                $("#COMP_ACCOUNT").val('');
                $("#COMP_ACCOUNT_NAME").val('');
            }
            else{
                $.ajax({
                    type: 'POST',
                    url: "index.php/common/getAccountsByTerm",
                    cache: false,
                    dataType: "json",
                    data: {
                        TERM: $('#COMP_ACCOUNT_TERM').val()
                    },
                    success: function (data) {
                        $("#COMP_ACCOUNT").val(data[0].ACCOUNT_ID);
                        $("#COMP_ACCOUNT_NAME").val(data[0].ACCOUNT_VALUE + ' - ' + data[0].ACCOUNT_NAME + ' - ' + data[0].ACCOUNT_ID);
                        $("#COMP_ACCOUNT-error").remove();
                    },
                    error: function (jqXHR, textStatus, errorThrown) {
                    }
                });
            }
            $(this).removeClass("ui-corner-top").addClass("ui-corner-all");
        }
    });
});

$(document).on('keypress', function (event) {
    if (event.keyCode == 13){ 
        var tabindex = $(event.target).attr("tabindex");
        tabindex++;
        $('[tabindex=' + tabindex + ']').focus();
    }
});

$(document).on('blur', "#NOTICE_TYPE", function (e) {
    if(($(this).val() == 2) || ($(this).val() == 3)) {
        $.ajax({
            type: 'POST',
            url: "index.php/common/getPetrolProductInfoByID",
            cache: false,
            dataType: "json",
            success: function (data) {
                $('#PRODUCT_LIST').empty() ; 
                $.each(data, function(key , value) {
                    $('#PRODUCT_LIST').append($("<option></option>").attr("value",value.FUEL_SERIAL).text(value.FUEL_NAME)) ;
                });
            },
            error: function (jqXHR, textStatus, errorThrown) {
            }
        });
    } else if(($(this).val() == 5) || ($(this).val() == 6)) {
        $('#PRODUCT_LIST').empty().append($("<option></option>").attr("value",6).text('محروقات مصري')) ;
    } else if($(this).val() == 8) {
        $('#PRODUCT_LIST').empty().append($("<option></option>").attr("value",5).text('غاز مصري')) ;
        $('#PRODUCT_LIST').append($("<option></option>").attr("value",3).text('غاز')) ;
    } else if($(this).val() == 7) {
        $('#PRODUCT_LIST').empty().append($("<option></option>").attr("value",1).text('بنزين 95')) ;
        $('#PRODUCT_LIST').append($("<option></option>").attr("value",2).text('سولار')) ;
        $('#PRODUCT_LIST').append($("<option></option>").attr("value",5).text('كيروسين')) ;
    }  else if($(this).val() == '') {
        $('#PRODUCT_LIST').empty() ;
    } else{
        $('#PRODUCT_LIST').empty().append($("<option></option>").attr("value",2).text('محروقات')) ;
        $('#PRODUCT_LIST').append($("<option></option>").attr("value",6).text('محروقات مصري')) ;        
        $('#PRODUCT_LIST').append($("<option></option>").attr("value",9).text('محروقات لوازم')) ;
        $('#PRODUCT_LIST').append($("<option></option>").attr("value",3).text('غاز')) ;
        $('#PRODUCT_LIST').append($("<option></option>").attr("value",5).text('غاز مصري')) ;
        $('#PRODUCT_LIST').append($("<option></option>").attr("value",4).text('سولار صناعي')) ;
        $('#PRODUCT_LIST').append($("<option></option>").attr("value",8).text('سولار مصري طاقة')) ;
        $('#PRODUCT_LIST').append($("<option></option>").attr("value",7).text('مازوت')) ;
    }


    var tabindex = $(this).attr('tabindex');
    tabindex++;
    $('[tabindex=' + tabindex + ']').focus();


});

$(document).on('click', "#getCompaniesPurchases_btn", function (e) {
    FormValidation.init();
    if($("#getTotalPurchases_frm").valid() !== true){
        return; 
    }
    getCompaniesPurchasesList();
    e.preventDefault();
});

$(document).on('click', ".issueNotification", function (e) {
    e.preventDefault();
    var elm = $(this).parent();
    $("#P_COM_ACC").val($(this).attr('P_COM'));
    $("#P_COPY").val(0);
    $.ajax({
        type: 'POST',
        url: "index.php/notifications/issueNotification",
        cache: false,
        dataType: "json",
        data: {
            "P_START_DATE"  : $('#P_START_DATE').val(),
            "P_END_DATE"    : $('#P_END_DATE').val() , 
            "P_NOTICE_TYPE" : $('#P_NOTICE_TYPE').val(),
            "P_PRODUCT_CAT" : $('#P_PRODUCT_CAT').val() , 
            "P_PRODUCT_TYPE": $('#P_PRODUCT_TYPE').val(),
            "P_COM_ACC"     : $('#P_COM_ACC').val() ,
            "P_COPY"        : $('#P_COPY').val()            
        },
        success: function (data) {
            showMessage({message: data.MSG, type: (data.NOTICE_SR > 0) ? 'success': 'warning', icon: (data.NOTICE_SR > 0) ? 'success': 'warning'});
            if(data.NOTICE_SR > 0){
                $("#P_NOTICE_ID").val(data.NOTICE_SR);
                $("#P_NOTICE_TYPE").val($('#P_NOTICE_TYPE').val());
                $("#printNotification").submit() ;
            }
            getCompaniesPurchasesList();
        }
        ,
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
}) ;

$(document).on('click', ".printNotificationCopy", function (e) {
    e.preventDefault();
    $("#P_COM_ACC").val($(this).attr('P_COM'));
    $("#P_COPY").val(1);
    $("#printNotification").submit() ;
});

$(document).on('click', "#printCompaniesPurchases_btn", function (e) {
    if(($('#START_DT').val() != '') && ($('#END_DT').val() != '')){
        e.preventDefault();
        $("#I_START_DATE").val($('#START_DT').val());
        $("#I_END_DATE").val($('#END_DT').val());
        $("#I_NOTICE_TYPE").val($('#NOTICE_TYPE').val());
        if(($("#NOTICE_TYPE").val() == 1) || ($("#NOTICE_TYPE").val() == 4) || ($("#NOTICE_TYPE").val() == 5) || ($("#NOTICE_TYPE").val() == 6) || ($("#NOTICE_TYPE").val() == 8)){
            $("#I_PRODUCT_CAT").val($('#PRODUCT_LIST').val());
            $("#I_CATEGORY_NAME").val($('#PRODUCT_LIST option:selected').text());
            
        }
        else {
            $("#I_PRODUCT_ID").val($('#PRODUCT_LIST').val());
            $("#I_PRODUCT_NAME").val($('#PRODUCT_LIST option:selected').text());
        }
        $("#printPurchasesList").submit() ;
    } else {
        showMessage({message:'الرجاء تحديد فترة الإشعار', type:'warning', icon:'warning'});
    }
});

$(document).on('click', '.deleteNotification', function(e){
    e.preventDefault();
    $.ajax({
            type: 'POST',
            url: "index.php/notifications/getNoticeInfo",
            cache: false,
            dataType: "json",
            data: {
                "P_START_DATE"  : $('#P_START_DATE').val(),
                "P_END_DATE"    : $('#P_END_DATE').val() , 
                "P_NOTICE_TYPE" : $('#P_NOTICE_TYPE').val(),
                "P_PRODUCT_CAT" : $('#P_PRODUCT_CAT').val() , 
                "P_PRODUCT_TYPE": $('#P_PRODUCT_TYPE').val(),
                "P_COM_ACC"     : $(this).attr('P_COM')         
            },
            success: function (data) {
                $('#M_NOTICE_SR').text(data.SERIAL_NO);
                $('#M_NOTICE_TYPE').text(data.NOTE_TYPE_NAME);
                $('#M_NSTART_DT').text(data.START_DT);
                $('#M_NEND_DT').text(data.END_DT);
                $('#M_COM_ACC').text(data.FIN_NO + ' - ' + data.COMPANY_NAME);
                $('#M_PRODUCT').text(data.PRODUCT_NAME);
                $('#M_NOTICE_VALUE').text(data.NOTICE_VALUE);
                $('#M_EXCPT_AMOUNT').text(data.EXCPTIONAL_AMOUNT);
                $('#M_ISSUED_BY').text(data.ISSUED_BY);
                $('#M_ISSUE_DATE').text(data.ISSUE_DT);
                $('#M_NOTICE_NOTE').text(data.NOTES);
                $('#deletedNoticeModal').modal('show');
            }
            ,
            error: function (jqXHR, textStatus, errorThrown) {
                showMessage({message:errorThrown, type:'warning', icon:'warning'});
            }
    });
});

$(document).on('click', '.calculateNotification', function(e){
    e.preventDefault();
    $('#cashDiscCalc_tb').dataTable({
        "destroy": true,
        "bStateSave": false,
        "lengthMenu": [
            [10, 20, 50, 100, 150, -1],
            [10, 20, 50, 100, 150, "All"] // change per page values here
        ],
        "pageLength": 50,
        dom: 'Blfrtip',
        buttons: [
            {
                extend: 'excel', text: 'تصدير الى اكسل',
            }
        ],
       "ajax": 
        {
            "url": "index.php/notifications/calculateCashDiscNotice", 
            "type": "POST",
            "data": {
                START_DATE  : $('#START_DT').val(),
                END_DATE    : $('#END_DT').val() , 
                PRODUCT_CAT : $('#PRODUCT_LIST').val() , 
                COM_ACC     : $(this).attr('P_COM') 
            },
        },
        "ordering": false,
        "language": {
                "lengthMenu": "عرض _MENU_ سجل في الصفحة",
                "zeroRecords": "عذرا - لا يوجد بيانات.",
                "info": "عرض _START_ الى _END_ من _TOTAL_ سجل",
                "infoEmpty": "لا تتوفر اي بيانات.",
                "infoFiltered": "(تصفية من _MAX_ سجل)",
                "loadingRecords": "تحميل...",
                "processing":     "جاري معالجة البيانات...",
                "search":         "بحث:",
                "paginate": {
                    "first":      "الأول",
                    "last":       "الأخير",
                    "next":       "التالي",
                    "previous":   "السابق"
                },
        },
        "sAjaxDataProp" : "",
        "columns": 
        [
            {"data" : "TRANS_TXT", "width": "10%" },
            {"data" : "TRANS_ID" , "width": "5%" },
            {"data" : "T_DATE_CHAR" , "width": "10%" },
            {"data" : "T_ALOW_DT" , "width": "10%" },
            {"data" : "DEBT_AMOUNT", "width": "10%" },
            {"data" : "CREDIT_AMOUNT" , "width": "10%" },
            {"data" : "BALANCE", "width": "10%" },
            {"data" : "TRNS_DESC" , "width": "25%"  }, 
            {"data" : "DISC_AMOUNT" , "width": "10%"  } 
        ]
    });

    $('#cashDiscCalculationModal').modal('show');
}); 

$(document).on('click', '#CANCLE_DELETE_BTN', function(){
    $('#deletedNoticeModal').modal('hide');
});

$(document).on('click', '#CONF_CHECK_DELETE_NOTICE_BTN', function(e){
    e.preventDefault();
    $.ajax({
            type: 'POST',
            url: "index.php/notifications/deleteNotification",
            cache: false,
            dataType: "json",
            data: {
                "SERIAL_NO" : $('#M_NOTICE_SR').text(),
                "DEL_NOTE"  : $('#M_DELETE_NOTE').val()   
            },
            success: function (data) {
                $('#deletedNoticeModal').modal('hide');
                showMessage({message: data.msg, type: (data.success > 0) ? 'success': 'warning', icon: (data.success > 0) ? 'success': 'warning'});
                if(data.success > 0){
                    getCompaniesPurchasesList();
                }
            }
            ,
            error: function (jqXHR, textStatus, errorThrown) {
                $('#deletedNoticeModal').modal('hide');
                showMessage({message:errorThrown, type:'warning', icon:'warning'});
            }
    });
});

$(document).on('change', "#NOTICE_TYPE", function (e) {
    e.preventDefault();
    if ($("#NOTICE_TYPE").val() == 5) {
        $('#PRODUCT_LIST').html('<option selected value="6">محروقات مصري</option>');
    }
    if ($("#NOTICE_TYPE").val() == 8) {
        $('#PRODUCT_LIST').html('<option selected value="5">غاز مصري</option><option selected value="3">غاز</option>');
    }
});

$(document).on('click', '#getNoticesList_btn', function(e){
    $('#noticesList_tb').dataTable({
        "destroy": true,
        "bStateSave": true,
        "lengthMenu": [
                    [10, 20, 50, 100, 150, -1],
                    [10, 20, 50, 100, 150, "All"] // change per page values here
        ],
        "pageLength": 10,
        dom: 'Blfrtip',
        buttons: [
            {

                extend: 'excel', text: 'تصدير الى اكسل',

            }
        ],
        "ajax": 
        {
            "url": "index.php/fcontrol/getNoticesList", 
            "type": "POST",
            "data": {
                NOTICE_ID: $('#NOTICE_ID').val(),
                NOTICE_TYPE: $('#NOTICE_TYPE').val(),
                START_DT: $('#START_DT').val(),
                END_DT: $('#END_DT').val(),
                COMP_ACCOUNT: $('#COMP_ACCOUNT').val(),
                PRODUCT: $('#PRODUCT_LIST').val(),
                STATUS: $('#NOTICE_STATUS').val()
            }, 
            "dataSrc": "notice_list",
        },
        //"order": [[0, "asc"]],
        "language": {
                "lengthMenu": "عرض _MENU_ سجل في الصفحة",
                "zeroRecords": "عذرا - لا يوجد بيانات.",
                "info": "عرض _START_ الى _END_ من _TOTAL_ سجل",
                "infoEmpty": "لا تتوفر اي بيانات.",
                "infoFiltered": "(تصفية من _MAX_ سجل)",
                "loadingRecords": "تحميل...",
                "processing":     "جاري معالجة البيانات...",
                "search":         "بحث:",
                "paginate": {
                    "first":      "الأول",
                    "last":       "الأخير",
                    "next":       "التالي",
                    "previous":   "السابق"
                },
        },
        "sAjaxDataProp" : "",
        "columns": [
                {"data" : "SERIAL_NO" , "width" : "5%" },
                {"data" : "COMPANY_NAME" , "width" : "15%" },
                {"data" : "NOTE_TYPE_NAME" , "width" : "10%"  },
                {"data" : null , "width" : "10%", "render" : function(data , type , full){
                        var val = '';
                        if(data.NOTICE_TYPE == 2 || data.NOTICE_TYPE == 3 || data.NOTICE_TYPE == 7){
                            val = data.PRODUCT_NAME;
                        } else {
                            val = data.PRODUCT_CAT;
                        }
                        return val ;
                    }
                },
                {"data" : "NOTICE_VALUE" , "width" : "10%" },
                {"data" : "ISSUE_DT" , "width" : "10%" },
                {"data" : "INSERT_BY_EMP" , "width" : "10%" },
                {"data" : null , "width" : "15%", "render" : function(data , type , full){
                        return data.START_DT + ' - ' + data.END_DT; 
                    }
                },
                {"data" : "APPROVAL_TXT" , "width" : "10%" },
                {"data" : null , "width" : "5%" , "render" : function(data , type , full){
                       var op = '<a href="#" NOTICE_ID="'+data.SERIAL_NO+'" NOTICE_TYPE="'+data.NOTICE_TYPE+'" class="btn btn-success getNoticeCopy">عرض</a>';
                       if(data.APPROVE_STATUS == 0){
                            op += '<a href="#" NOTICE_ID="'+data.SERIAL_NO+'" class="btn btn-danger approveNotice">اعتماد</a>';
                       }
                       if(data.APPROVE_STATUS == 1){
                            op += '<a href="#" NOTICE_ID="'+data.SERIAL_NO+'" class="btn btn-warning returnNotice">إرجاع</a>';
                       }
                       /*if(data.NOTICE_TYPE == 6){
                            op += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn yellow calculateNotification">طريقة الاحتساب</a>';
                       }*/
                       return op ;
                    }
                }
            ]
    });
}); 

$(document).on('click', '.getNoticeCopy', function(e){
    e.preventDefault();
    $("#P_NOTICE_ID").val($(this).attr('NOTICE_ID'));
    $("#P_NOTICE_TYPE").val($(this).attr('NOTICE_TYPE'));
    $("#printNotification").submit() ;
}); 

$(document).on('click', '.approveNotice', function(e){
    e.preventDefault();
    $.ajax({
        type: 'POST',
        url: "index.php/fcontrol/approveIssuedNotice",
        cache: false,
        dataType: "json",
        data: {
            "NOTICE_SR"  : $(this).attr('NOTICE_ID')          
        },
        success: function (data) {
            showMessage({message:data.msg, type:(data.success > 0)? 'success' : 'warning', icon:(data.success > 0)? 'check' : 'warning'});
            $('#getNoticesList_btn').click();
        } ,
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
});

$(document).on('click', '.returnNotice', function(e){
    e.preventDefault();
    $.ajax({
        type: 'POST',
        url: "index.php/fcontrol/returnIssuedNotice",
        cache: false,
        dataType: "json",
        data: {
            "NOTICE_SR"  : $(this).attr('NOTICE_ID')          
        },
        success: function (data) {
            showMessage({message:data.msg, type:(data.success > 0)? 'success' : 'warning', icon:(data.success > 0)? 'check' : 'warning'});
            $('#getNoticesList_btn').click();
        } ,
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:errorThrown, type:'warning', icon:'warning'});
        }
    });
});

$(document).on('focusout', '[id^="EXCEP_AMOUNT_"]', function(e) {
    var com_account = $(this).attr('COM_ACCOUNT');
    $('#OPER_NOTICE_VAL_'+com_account).val($(this).val() * 0.1); 
})

var FormValidation = function() {
    var handleValidation = function(){
        var form = $('#getTotalPurchases_frm');
        var error = $('.alert-danger', form);
        var success = $('.alert-success', form);
        form.validate({
            errorElement: 'span', //default input error message container
            errorClass: 'help-block help-block-error', // default input error message class
            focusInvalid: true, // do not focus the last invalid input
            ignore: "",  // validate all fields including form hidden input
            messages: {
                START_DT: {
                    required: "هذا الحقل مطلوب"
                },
                END_DT: {
                    required: "هذا الحقل مطلوب"
                }
            },
            rules: {
                START_DT: {
                    required: true 
                },
                END_DT: {
                    required: true
                }
            },

            invalidHandler: function (event, validator) { //display error alert on form submit              
                success.hide();
                error.show();
                //App.scrollTo(error, -200);
            },

            highlight: function (element) { // hightlight error inputs
                $(element).closest('.form-group').addClass('has-error'); // set error class to the control group
            },

            unhighlight: function (element) { // revert the change done by hightlight
                $(element).closest('.form-group').removeClass('has-error'); // set error class to the control group
            },

            success: function (label) {
                label.closest('.form-group').removeClass('has-error'); // set success class to the control group
            },

            submitHandler: function (form) {
                success.show();
                error.hide();
            }
        });
    }
    return {
        init: function () {
            handleValidation();
        }
    }
}();

function showMessage(config){
    App.alert({
        container: '#alert_container', // alerts parent container(by default placed after the page breadcrumbs)
        place: 'prepent', // append or prepent in container 
        type: config.type,  // alert's type
        message: config.message,  // alert's message
        close: true, // make alert closable
        reset: true, // close all previouse alerts first
        focus: false, // auto scroll to the alert after shown
        closeInSeconds: 10, // auto close after defined seconds
        icon: config.icon // put icon before the message
    });
    window.scrollTo(0,0);
}

function getCompaniesPurchasesList(){
    var allowedToIssue = $('#allowedToIssue').val();
    var allowedToDelete = $('#allowedToDelete').val();
    $('#compnayTotals_tb').dataTable({
        "destroy": true,
        //"bStateSave": true,
        "lengthMenu": [
                    [10, 20, 50, 100, 150, -1],
                    [10, 20, 50, 100, 150, "All"] // change per page values here
        ],
        "pageLength": 10,
        dom: 'Blfrtip',
        buttons: [
            {

                extend: 'excel', text: 'تصدير الى اكسل',

            }
        ],
        "ajax": 
        {
            "url": "index.php/notifications/getCompanyPurchasesTotals", 
            "type": "POST",
            "data": {
                NOTICE_TYPE: $('#NOTICE_TYPE').val(),
                START_DT: $('#START_DT').val(),
                END_DT: $('#END_DT').val(),
                COMP_ACCOUNT: $('#COMP_ACCOUNT').val(),
                PRODUCT: $('#PRODUCT_LIST').val()
            },
            "dataSrc": "com_info" 
        },
        //"order": [[0, "asc"]],
        "language": {
                "lengthMenu": "عرض _MENU_ سجل في الصفحة",
                "zeroRecords": "عذرا - لا يوجد بيانات.",
                "info": "عرض _START_ الى _END_ من _TOTAL_ سجل",
                "infoEmpty": "لا تتوفر اي بيانات.",
                "infoFiltered": "(تصفية من _MAX_ سجل)",
                "loadingRecords": "تحميل...",
                "processing":     "جاري معالجة البيانات...",
                "search":         "بحث:",
                "paginate": {
                    "first":      "الأول",
                    "last":       "الأخير",
                    "next":       "التالي",
                    "previous":   "السابق"
                },
        },
        "columns": [
                {"data" : null , "width" : "5%" , "render" : function(data , type , full){
                    if(($('#NOTICE_TYPE').val() == 1) || ($('#NOTICE_TYPE').val() == 4)  || ($('#NOTICE_TYPE').val() == 5) || ($('#NOTICE_TYPE').val() == 6) || ($('#NOTICE_TYPE').val() == 8)) {
                        return data.PRODUCT_CAT ;
                    } 
                    else if(($('#NOTICE_TYPE').val() == 2) || ($('#NOTICE_TYPE').val() == 3) || ($('#NOTICE_TYPE').val() == 7)){
                        return data.FUEL_NAME ;
                    }
                }},
                {"data" : "COM_ACC_VAL" , "width" : "5%" },
                {"data" : "COMPANY_NAME" , "width" : "20%" },
                {"data" : "CONSIGNMENTS_COUNT" , "width" : "5%"  },
                {"data" : "TOTAL_AMOUNT" , "width" : "5%" },
                {"data" : null , "width" : "10%", "visible": false , "render" : function(data , type , full){
                        if($('#NOTICE_TYPE').val() == 5){ 
                            return '<input type="text" COM_ACCOUNT="'+ data.COMPANY_ACCOUNT +'" class="small" id="EXCEP_AMOUNT_'+data.COMPANY_ACCOUNT+'" value="'+ data.TOTAL_AMOUNT +'" />' ;
                        }
                        if($('#NOTICE_TYPE').val() == 6){
                            return data.NOTICE_VALUE * 10; 
                        }
                        else {
                            return '' ; 
                        }
                    }
                },
                {"data" : "TOTAL_PRICE" , "width" : "10%"},
                {"data" : null , "width" : "10%" , "visible": false , "render" : function(data , type , full){
                        var colValue = 0; 
                        if(($('#NOTICE_TYPE').val() == 2) || ($('#NOTICE_TYPE').val() == 3)){
                            colValue = data.COMPANY_SHARE; 
                        }
                        return colValue; 
                    }
                },
                {"data" : null , "width" : "5%" , "visible": false , "render" : function(data , type , full){
                        var colValue = 0; 
                        if(($('#NOTICE_TYPE').val() == 2) || ($('#NOTICE_TYPE').val() == 3)){
                            colValue = data.COM_RATIO ; 
                        }
                        return colValue; 
                    }
                },
                {"data" : "NOTICE_VALUE" , "width" : "10%"  },  
                {"data" : null , "width" : "5%" , "render" : function(data , type , full){
                        var colValue = ''; 
                        if(data.NOTICE_ISSUED == 1){
                            colValue = 'غيرمدقق';
                        }
                        if(data.NOTICE_ISSUED == 2){
                            colValue = 'مدقق';
                        }
                        if(data.NOTICE_ISSUED == -1){
                            colValue = 'لم يصدر';
                        }
                        if(data.NOTICE_ISSUED == -2){
                            colValue = 'تم إصدار أكثر من اشعار';
                        }
                        if(data.NOTICE_ISSUED == 0){
                            colValue = '-';
                        }

                        return colValue ; 
                    }
                } ,               
                {"data" : null , "width" : "10%" , "render" : function(data , type , full){
                    $("#P_START_DATE").val($('#START_DT').val()) ; 
                    $("#P_END_DATE").val($('#END_DT').val()) ;
                    $("#P_NOTICE_TYPE").val($('#NOTICE_TYPE').val()) ;
                    var actions = "";
                    if($('#NOTICE_TYPE').val() == 1){
                        $("#P_PRODUCT_CAT").val($('#PRODUCT_LIST').val()) ;
                        $('#P_PRODUCT_TYPE').val('') ; 
                        if(data.NOTICE_ISSUED == -1 && allowedToIssue == 1){ 
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn blue issueNotification">اصدار فاتورة</a>';
                        }
                        else if(data.NOTICE_ISSUED == 2){
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn green printNotificationCopy">طباعة نسخة</a>'; 
                            if(allowedToDelete) actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn red deleteNotification">حذف</a>'; 
                        }
                        else {
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn green printNotificationCopy">طباعة نسخة</a>';                            
                        }
                    }
                    else if($('#NOTICE_TYPE').val() == 2){
                        $("#P_PRODUCT_CAT").val('') ;
                        $('#P_PRODUCT_TYPE').val($('#PRODUCT_LIST').val()) ; 
                        if(data.NOTICE_ISSUED == -1 && allowedToIssue == 1){ 
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn blue issueNotification">إصدار إشعار</a>';
                        }
                        else if(data.NOTICE_ISSUED == 1){
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn green printNotificationCopy">طباعة نسخة</a>'; 
                            if(allowedToDelete) actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn red deleteNotification">حذف</a>'; 
                        }
                        else {
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn green printNotificationCopy">طباعة نسخة</a>';                            
                        }
                    }
                    else if($('#NOTICE_TYPE').val() == 3){
                        $("#P_PRODUCT_CAT").val('') ;
                        $('#P_PRODUCT_TYPE').val($('#PRODUCT_LIST').val()) ; 
                        if(data.NOTICE_ISSUED == -1 && allowedToIssue == 1){ 
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn blue issueNotification">اصدار إشعار</a>';
                        }
                        else if(data.NOTICE_ISSUED == 1 ){
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn green printNotificationCopy">طباعة نسخة</a>'; 
                            if(allowedToDelete) actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn red deleteNotification">حذف</a>'; 
                        }
                        else {
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn green printNotificationCopy">طباعة نسخة</a>';                            
                        }
                    }
                    else if($('#NOTICE_TYPE').val() == 4){
                        $("#P_PRODUCT_CAT").val($('#PRODUCT_LIST').val()) ;
                        $('#P_PRODUCT_TYPE').val('') ; 
                        if(data.NOTICE_ISSUED == -1 && allowedToIssue == 1){ 
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn blue issueNotification">اصدار إشعار</a>';
                        }
                        else if(data.NOTICE_ISSUED == 1){
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn green printNotificationCopy">طباعة نسخة</a>'; 
                            if(allowedToDelete) actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn red deleteNotification">حف</a>'; 
                        }
                        else {
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn green printNotificationCopy">طباعة نسخة</a>';                            
                        }
                    } else if($('#NOTICE_TYPE').val() == 5){
                        $("#P_PRODUCT_CAT").val($('#PRODUCT_LIST').val()) ;
                        $('#P_PRODUCT_TYPE').val('') ; 
                        if(data.NOTICE_ISSUED != -1){ 
                            actions += '<a href="#" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn green printNotificationCopy">طباعة نسخة</a>';                            
                        }
                    } else if($('#NOTICE_TYPE').val() == 6){
                        $("#P_PRODUCT_CAT").val($('#PRODUCT_LIST').val()) ;
                        $('#P_PRODUCT_TYPE').val('') ; 
                        if(data.NOTICE_ISSUED == -1 && allowedToIssue == 1){ 
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn blue issueNotification">اصدار إشعار</a>';
                        }
                        else if(data.NOTICE_ISSUED == 1){
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn green printNotificationCopy">طباعة نسخة</a>'; 
                            if(allowedToDelete) actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn red deleteNotification">حذف</a>'; 
                        }
                        else {
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn green printNotificationCopy">طباعة نسخة</a>';                            
                        }
                        actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn yellow calculateNotification">طريقة الاحتساب</a>';
                    }
                    else if($('#NOTICE_TYPE').val() == 7){
                        $("#P_PRODUCT_TYPE").val($('#PRODUCT_LIST').val()) ;
                        $('#P_PRODUCT_CAT').val('') ; 
                        if(data.NOTICE_ISSUED == -1 && allowedToIssue == 1){ 
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn blue issueNotification">اصدار إشعار</a>';
                        }
                        else if(data.NOTICE_ISSUED == 1){
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn green printNotificationCopy">طباعة نسخة</a>'; 
                            if(allowedToDelete) actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn red deleteNotification">حذف</a>'; 
                        }
                        else {
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn green printNotificationCopy">طباعة نسخة</a>';                            
                        }
                    }
                    else if($('#NOTICE_TYPE').val() == 8){
                        $("#P_PRODUCT_CAT").val($('#PRODUCT_LIST').val()) ;
                        $('#P_PRODUCT_TYPE').val('') ; 
                        if(data.NOTICE_ISSUED == -1 && allowedToIssue == 1){ 
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn blue issueNotification">اصدار إشعار</a>';
                        }
                        else if(data.NOTICE_ISSUED == 1){
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn green printNotificationCopy">طباعة نسخة</a>'; 
                            if(allowedToDelete) actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn red deleteNotification">حذف</a>'; 
                        }
                        else {
                            actions += '<a href="" P_COM="'+data.COMPANY_ACCOUNT+'" class="btn green printNotificationCopy">طباعة نسخة</a>';                            
                        }
                    }
                   
                   return actions;
                }}
        ], 
        "footerCallback": function ( row, data, start, end, display ) {
            var api = this.api(), data;
 
            // Remove the formatting to get integer data for summation
            var intVal = function ( i ) {
                return typeof i === 'string' ?
                    i.replace(/[\$,]/g, '')*1 :
                    typeof i === 'number' ?
                        i : 0;
            };
 
            // Total Consignments over all pages
            totalCons = api
                .column( 3 )
                .data()
                .reduce( function (a, b) {
                    return intVal(a) + intVal(b);
                }, 0 );
 
            // Total Consignments over this page
            pageTotalCons = api
                .column( 3, { page: 'current'} )
                .data()
                .reduce( function (a, b) {
                    return intVal(a) + intVal(b);
                }, 0 );

            // Total consignments amounts over all pages
            totalAmount = api
                .column( 4 )
                .data()
                .reduce( function (a, b) {
                    return intVal(a) + intVal(b);
                }, 0 );
 
            // Total consignments amounts over this page
            pageTotalAmounts = api
                .column( 4, { page: 'current'} )
                .data()
                .reduce( function (a, b) {
                    return intVal(a) + intVal(b);
                }, 0 );

            // Total consignments prices over all pages
            totalPrice = api
                .column( 6 )
                .data()
                .reduce( function (a, b) {
                    return intVal(a) + intVal(b);
                }, 0 );
 
            // Total consignments prices over this page
            pageTotalPrice = api
                .column( 6, { page: 'current'} )
                .data()
                .reduce( function (a, b) {
                    return intVal(a) + intVal(b);
                }, 0 );

            // Total notices values over all the pages
            totalNoticesVal = api
                .column( 9 )
                .data()
                .reduce( function (a, b) {
                    return intVal(a) + intVal(b);
                }, 0 );
 
            // Total notices values over this page
            pageNoticesVal = api
                .column( 9, { page: 'current'} )
                .data()
                .reduce( function (a, b) {
                    return intVal(a) + intVal(b);
                }, 0 );
 
            // Update footer
            $( api.column( 3 ).footer() ).html(
                pageTotalCons + ' من <br />('+ totalCons +')'
            );
            $( api.column( 4 ).footer() ).html(
                pageTotalAmounts + ' من  </br>('+ totalAmount +')'
            );
            $( api.column( 6 ).footer() ).html(
                Math.round(pageTotalPrice) + ' من  </br>('+ Math.round(totalPrice) +')'
            );
            $( api.column( 9 ).footer() ).html(
                Math.round(pageNoticesVal) + ' من  </br>('+ Math.round(totalNoticesVal) +')'
            );
        }
    });
    if($('#NOTICE_TYPE').val() == 1){
        var table  = $('#compnayTotals_tb').DataTable(); 
        table.column(10).visible( false );
    }
    if(($('#NOTICE_TYPE').val() == 2) || ($('#NOTICE_TYPE').val() == 3)){
        var table  = $('#compnayTotals_tb').DataTable(); 
        table.column(7).visible( true );
        table.column(8).visible( true );
    } else if(($('#NOTICE_TYPE').val() == 5) || ($('#NOTICE_TYPE').val() == 6)){
        var table  = $('#compnayTotals_tb').DataTable(); 
        table.column(5).visible( true );
    }
}


//$(document).ready(function() {
//    //FormValidation.init();
//    $('[tabindex=0]').focus();
//}) ; 
//    
    




    

         

     