$(document).on('keyup', ".EMPLOYEE_TERM", function (event) {
    if($(this).val() == ''){
        $(this).parent().find(".EMPLOYEE_ID").val('');
        $(this).parent().parent().find(".EMPLOYEE_NAME").val('');
    }
    var search_for = $(this).val();
    var parent = $(this).parent();
    $(this).autocomplete({
        source: function (request, response) {
            $.ajax({
                type: 'POST',
                url: "index.php/rafahPort/getRafahPortWorkersByTerm",
                cache: false,
                dataType: "json",
                data: {
                    term: search_for
                },
                success: function (data) {
                    response($.map(data, function (item) {
                        return {
                            label: item.WORKER_NAME,
                            value: item.WORKER_ID
                        }
                    }));
                } ,
                error: function (jqXHR, textStatus, errorThrown) {
                }
            });
        },
        minLength: 1,
        position: {
            my: "right bottom",
            at: "right top",
            collision: "flip"
        },
        select: function (event, ui) {
            parent.find(".EMPLOYEE_TERM").val(ui.item.value);
            parent.find(".EMPLOYEE_ID").val(ui.item.value);
            parent.parent().find(".EMPLOYEE_NAME").val(ui.item.label);
        },
        open: function () {
            $(this).removeClass("ui-corner-all").addClass("ui-corner-top");
        },
        close: function () {
            $(this).removeClass("ui-corner-top").addClass("ui-corner-all");
        }
    });
});

$(document).on('click', ".deleteRow", function (e) {
    e.preventDefault();
    $(this).parents('tr').remove();
});

$(document).on('click', "#addWorkerRow_but", function(e){
    e.preventDefault();
    var titles = $('#EMP_JOP').html(); 
    $('#workers_tb tbody').append(
        '<tr>' +
        '<td class="form-group">' + 
            '<div class="col-md-3"><input name="EMPLOYEE_TERM" type="text" class="form-control EMPLOYEE_TERM" value=""><input name="EMPLOYEE_ID" class="EMPLOYEE_ID" type="hidden"></div>' +
            '<div class="col-md-6"><input name="EMPLOYEE_NAME" type="text" class="form-control EMPLOYEE_NAME" readonly></div>' +
        '</td>' +
        '<td class="form-group">'+
            '<select name="EMP_JOP" class="form-control EMP_JOP">'+titles+'</select>' +
        '</td>'+
        '<td class="form-group"><a class="btn red deleteRow" href="javascript:;" tabindex="-1"> حذف </a></td>' +
        '</tr>' 
    ); 
}); 

jQuery(document).ready(function() { 
    if($('.timepicker-24').length){
        $('.timepicker-24').timepicker({
            defaultTime: '',
            autoclose: true,
            minuteStep: 5,
            showSeconds: false,
            showMeridian: false
        });
    }   
});

$(document).on('click', '#addShiftInfo_but', function(e){
    e.preventDefault();
    $(this).attr('disabled', true); 
    if(validateShiftInfo()){
        var records = [];
        $("#workers_tb tbody tr").each(function () {
            records.push(JSON.stringify({
                'EMPLOYEE_ID': $(this).find(".EMPLOYEE_ID").val(),
                'EMP_JOP': $(this).find(".EMP_JOP").val(), 
            }));
        });
        $.ajax({
            type: 'post',
            url: "index.php/rafahPort/addRafahShiftInfo",
            cache: false,
            dataType: "json",
            data: {
                SHIFT_DATE: $("#SHIFT_DATE").val(),
                START_TIME: $("#START_TIME").val(),
                END_TIME: $("#END_TIME").val(),
                WORK_DIRECTION: $("#WORK_DIRECTION").val(),
                workerDetails: JSON.stringify(records)
            },
            success: function (data) {
                if(data.SUCCESS > 0){
                    resetShiftInfo(); 
                }
                showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
            },
            error: function (jqXHR, textStatus, errorThrown) {
                showMessage({message:"حدثت مشكلة في إتمام العملية - " + errorThrown, type:"error", icon:"warning"});
            }
        });
    }
    $(this).attr('disabled', false); 
});

$(document).on('click', '#getRafahPortShifts_btn', function(e){
    getRafahPortShiftsList(); 
}); 

$(document).on('click', '.cancelShift', function(e){
    e.preventDefault();
    var serial = $(this).attr('SHIFT_SR'); 
    bootbox.confirm("هل أنت متأكد من رغبتك في حذف وإلغاء بيانات الوردية؟", function(result) {
        if(result){
            $.ajax({
                type: 'post',
                url: "index.php/rafahPort/deleteShiftInfo",
                cache: false,
                dataType: "json",
                data: {
                    SHIFT_SR: serial
                },
                success: function (data) {
                    if(data.SUCCESS > 0){
                        getRafahPortShiftsList(); 
                    }
                    showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
                },
                error: function (jqXHR, textStatus, errorThrown) {
                    showMessage({message:"حدثت مشكلة في إتمام العملية - " + errorThrown, type:"error", icon:"warning"});
                }
            });
        }
     }); 
}); 

$(document).on('blur', '#IN_DATE , #SHIFT_DIRECTION', function(e){
    if($('#IN_DATE').val() != '' && $('#SHIFT_DIRECTION').val()!='')
    $.ajax({
        type: 'post',
        url: "index.php/rafahPort/getWorkShiftsInfo",
        cache: false,
        dataType: "json",
        data: {
            WORK_DIRECTION: $('#SHIFT_DIRECTION').val(), 
            START_DATE: $('#IN_DATE').val(), 
            END_DATE : $('#IN_DATE').val()
        },
        success: function (data) {
            if(data.length > 0){
                $('#SHIFT_SR').val(data[0].SERIAL_NO); 
                $('#SHIFT_INFO').val('وردية '+ data[0].WORK_NAME +' بتاريخ ' + data[0].SHIFT_DT + '. مسؤول الوردية: ' + data[0].SHIFT_MASTER +
                ', مسؤول التحكم: ' + data[0].SHIFT_CONTROL + ', موظف قياس المخزن: ' + data[0].WREHOUSE_MEASUR);  
                $('#SHIFT_INFO').closest('.form-group').removeClass('has-error'); 
            }
            else {
                $('#SHIFT_INFO').closest('.form-group').addClass('has-error'); 
                showMessage({message:'تعذر جلب بيانات الوردية العاملة في المعبر الوارد لهذا اليوم، الرجاء التأكد من أن بيانات الوردية مسجلة', type: 'warning', icon:'warning'});
            }              
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:'تعذر جلب بيانات الوردية العاملة في المعبر الوارد لهذا اليوم', type: 'warning', icon:'warning'});
        }
    });
    e.preventDefault();
}); 

$(document).on('change', '#AT_WORK', function(e){
    if($('#AT_WORK').val() == 1){
        $.ajax({
            type: 'post',
            url: "index.php/rafahPort/getLastGaugesData",
            cache: false,
            dataType: "json",
            success: function (data) {
                $.each(data, function(index, value){
                    var i = parseInt(value.TANK_SR)-1; 
                    $("#tanksGauges_tb tbody tr:eq("+ i +")").find('.TANK_VALUE').val(value.GUAGE_VALUE); 
                    $("#tanksGauges_tb tbody tr:eq("+ i +")").find(".TANK_PRODUCT option[value='"+value.PRODUCT_NO +"']").attr('selected', 'selected'); 
                    $("#tanksGauges_tb tbody tr:eq("+ i +")").find('.TANK_NOTES').val(value.GAUGE_NOTE); 
                });
            },
            error: function (jqXHR, textStatus, errorThrown) {
                console.log(textStatus);
            }
        });
    }
}); 

$(document).on('click', '#addTanksGaugesInfo_but', function(e){
    if(validateTanksGauges()){
        var records = [];
        $("#tanksGauges_tb tbody tr").each(function () {
            records.push(JSON.stringify({
                'TANK_SR': $(this).find(".TANK_NAME").attr('TANK_SERIAL'),
                'TANK_NAME': $(this).find(".TANK_NAME").val(), 
                'TANK_VALUE': $(this).find(".TANK_VALUE").val(), 
                'TANK_PRODUCT': $(this).find(".TANK_PRODUCT").val(), 
                'TANK_NOTES': $(this).find(".TANK_NOTES").val(), 
            }));
        });
        $.ajax({
            type: 'post',
            url: "index.php/rafahPort/saveTankGaugesData",
            cache: false,
            dataType: "json",
            data: {
                AT_WORK: $("#AT_WORK").val(),
                GAUGE_DATE: $("#IN_DATE").val(),
                GAUGE_TIME: $("#GAUGE_TIME").val(),
                SHIFT_SR: $("#SHIFT_SR").val(),
                GAUGES_DATA: JSON.stringify(records)
            },
            success: function (data) {
                if(data.SUCCESS > 0){
                    resetTanksGauges(); 
                }
                showMessage({message:data.MSG, type:(data.SUCCESS > 0)? 'success' : 'warning', icon:(data.SUCCESS > 0)? 'check' : 'warning'});
            },
            error: function (jqXHR, textStatus, errorThrown) {
                showMessage({message:"حدثت مشكلة في إتمام العملية - " + errorThrown, type:"error", icon:"warning"});
            }
        });

    }
}); 

$(document).on('click', '#getRafahPortTanksGauges_btn', function(e){
    getTanksGaugesData(); 
}); 

function getRafahPortShiftsList(){
    $('#rafahPortShifts_tb').dataTable({
        "destroy": true,
        "bStateSave": false,
        "lengthMenu": [
                    [10, 20, 50, 100, 150, -1],
                    [10, 20, 50, 100, 150, "All"] // change per page values here
        ],
        "pageLength": 10,
        dom: 'Blfrtip',
        buttons: [
            {
                extend: 'excel', text: 'تصدير الى اكسل',
            }
        ],
        "ajax": 
        {
            "url": "index.php/rafahPort/getWorkShiftsInfo", 
            "type": "POST",
            "data": {
                WORK_DIRECTION : $('#WORK_DIRECTION').val(),
                START_DATE: $('#START_DT').val(),
                END_DATE: $('#END_DT').val()
            }  
        },
        "order": [[0, "asc"]],
        "language": {
                "lengthMenu": "عرض _MENU_ سجل في الصفحة",
                "zeroRecords": "عذرا - لا يوجد بيانات.",
                "info": "عرض _START_ الى _END_ من _TOTAL_ سجل",
                "infoEmpty": "لا تتوفر اي بيانات.",
                "infoFiltered": "(تصفية من _MAX_ سجل)",
                "loadingRecords": "تحميل...",
                "processing":     "جاري معالجة البيانات...",
                "search":         "بحث:",
                "paginate": {
                    "first":      "الأول",
                    "last":       "الأخير",
                    "next":       "التالي",
                    "previous":   "السابق"
                },
            },
        "sAjaxDataProp" : "",
        "columns": [
                {"data" : "SHIFT_DT" , "width" : "10%"},
                {"data" : "SHFT_START_TIME" , "width" : "10%" },
                {"data" : "SHIFT_END_TIME" , "width" : "10%" },
                {"data" : "WORK_NAME" , "width" : "10%"  },
                {"data" : "GENERAL_MANAGER" , "width" : "10%" },
                {"data" : "SHIFT_MASTER" , "width" : "10%"},
                {"data" : "SHIFT_CONTROL" , "width" : "10%"},
                {"data" : "SHIFT_SUPERVISOR" , "width" : "10%"},
                {"data" : "WORKERS_COUNT" , "width" : "10%"},
                {"data" : null , "render" : function( data, type, full){
                        return '<a href="" SHIFT_SR = "'+ data.SERIAL_NO +'" class="btn red cancelShift">حذف</a>'  ; 
                    }
                }
        ]
    });
}

function getTanksGaugesData(){
    $('#rafahPortTanksGauges_tb').dataTable({
        "destroy": true,
        "bStateSave": false,
        "lengthMenu": [
                    [50, 100, 150, -1],
                    [50, 100, 150, "All"] // change per page values here
        ],
        "pageLength": 50,
        dom: 'Blfrtip',
        buttons: [
            {
                extend: 'excel', text: 'تصدير الى اكسل',
            }
        ],
        "ajax": 
        {
            "url": "index.php/rafahPort/getTanksGaugesData", 
            "type": "POST",
            "data": {
                GAUGE_START : $('#START_DT').val(),
                GAUGE_END: $('#END_DT').val(),
                AT_DAY_TIME: $('#GAUGE_TIME').val(),
                TANK_SR: $('#TANK_SR').val()
            }  
        },
        "ordering": false,
        "language": {
                "lengthMenu": "عرض _MENU_ سجل في الصفحة",
                "zeroRecords": "عذرا - لا يوجد بيانات.",
                "info": "عرض _START_ الى _END_ من _TOTAL_ سجل",
                "infoEmpty": "لا تتوفر اي بيانات.",
                "infoFiltered": "(تصفية من _MAX_ سجل)",
                "loadingRecords": "تحميل...",
                "processing":     "جاري معالجة البيانات...",
                "search":         "بحث:",
                "paginate": {
                    "first":      "الأول",
                    "last":       "الأخير",
                    "next":       "التالي",
                    "previous":   "السابق"
                },
            },
        "sAjaxDataProp" : "",
        "columns": [
                {"data" : "TANK_NAME" , "width" : "10%"},
                {"data" : "GAUGE_DAY" , "width" : "10%" },
                {"data" : "AT_DAY_TIME" , "width" : "10%" },
                {"data" : "GAUGE_TIME" , "width" : "5%"  },
                {"data" : "GUAGE_VALUE" , "width" : "10%" },
                {"data" : "PRODUCT_NAME" , "width" : "10%"},
                {"data" : "GAUGE_NOTE" , "width" : "10%"},
                {"data" : "INSERT_NAME" , "width" : "10%"},
                {"data" : "APPROVE_NAME" , "width" : "10%"},
                {"data" : "REC_STATUS" , "width" :"5%"},
                {"data" : null , "render" : function( data, type, full){
                        return ''; //'<a href="" GAUGE_SR = "'+ data.SERIAL_NO +'" class="btn red cancelShift"></a>'  ; 
                    }
                }
        ]
    });
}

function validateShiftInfo(){
    var valid = 1 ; 
    if($('#SHIFT_DATE').val() == ''){
        valid = 0 ;
        $(document).find("#SHIFT_DATE").closest('.form-group').addClass('has-error');
    } else {
        $(document).find("#SHIFT_DATE").closest('.form-group').removeClass('has-error');
    }
    if($('#START_TIME').val() == ''){
        valid = 0 ;
        $(document).find("#START_TIME").closest('.form-group').addClass('has-error');
    } else {
        $(document).find("#START_TIME").closest('.form-group').removeClass('has-error');
    }
    if($('#END_TIME').val() == '' || $('#START_TIME').val() == $('#END_TIME').val()){
        valid = 0 ;
        $(document).find("#END_TIME").closest('.form-group').addClass('has-error');
    } else {
        $(document).find("#END_TIME").closest('.form-group').removeClass('has-error');
    }
    $( "#workers_tb tbody tr" ).each(function() {
        if($(this).find(".EMPLOYEE_ID").val() == ''){
            valid = 0 ;
            $(this).find(".EMPLOYEE_ID").closest('.form-group').addClass('has-error');
        } 
        else {
            $(this).find(".EMPLOYEE_ID").closest('.form-group').removeClass('has-error');
        }
    });
    return valid; 
}

function resetShiftInfo(){
    $('#SHIFT_DATE').val(''); 
    $('#START_TIME').val('');
    $('#END_TIME').val('');
    $("#WORK_DIRECTION option[value=1]").attr('selected', 'selected');
    var count = 1; 
    $("#workers_tb tbody tr" ).each(function() {
        if(count != 1) $(this).remove();
        $(this).find(".EMPLOYEE_TERM").val('');
        $(this).find(".EMPLOYEE_ID").val('');
        $(this).find(".EMPLOYEE_NAME").val('');
        $("#EMP_JOP option[value=1]").attr('selected', 'selected');
        count++; 
    }); 
}

function validateTanksGauges(){
    return 1; 
}

function resetTanksGauges(){
    $('#GAUGE_TIME').val('');
    $('.TANK_VALUE').val(''); 
    $('.TANK_NOTES').val('');  
}