

$(document).on('click', "#getDetailedData_btn", function (e) {
    $('#warehouseTransList_tb').dataTable({
        "destroy": true,
        "bStateSave": false,
        "lengthMenu": [
                    [10, 20, 50, 100, 150, -1],
                    [10, 20, 50, 100, 150, "All"] // change per page values here
        ],
        "pageLength": 10,
        
        "ajax": 
        {
            "url": "index.php/statements/queryWarehouseTransDetails", 
            "type": "POST",
            "data": {
                WAREHOUSE_NO: $('#WAREHOUSE_NO').val(),
                PRODUCT: $('#FUEL_CAT').val(),
                START_DT: $('#START_DT').val(),
                END_DT: $('#END_DT').val()
            }  
        },
        "order": [[0, "asc"]],
        "language": {
                "lengthMenu": "عرض _MENU_ سجل في الصفحة",
                "zeroRecords": "عذرا - لا يوجد بيانات.",
                "info": "عرض _START_ الى _END_ من _TOTAL_ سجل",
                "infoEmpty": "لا تتوفر اي بيانات.",
                "infoFiltered": "(تصفية من _MAX_ سجل)",
                "loadingRecords": "تحميل...",
                "processing":     "جاري معالجة البيانات...",
                "search":         "بحث:",
                "paginate": {
                    "first":      "الأول",
                    "last":       "الأخير",
                    "next":       "التالي",
                    "previous":   "السابق"
                },
            },
        "sAjaxDataProp" : "",
        dom: 'Blfrtip',
        buttons: [
            {

                extend: 'excel', text: 'تصدير الى اكسل',

            }
        ],
        "columns": [
                {"data" : "SERIAL" , "width" : "5%" , "title" : ""},
                {"data" : "TRANS_DT" , "width" : "15%"  , "title" : "تاريخ الحركة" },
                {"data" : "TRANS_NOTE" , "width" : "10%"  , "title" : "نوع الحركة"},
                {"data" : "TRANS_SERIAL" , "width" : "10%"  , "title" : "معرف الحركة"},
                {"data" : "IN_AMOUNT" , "width" : "10%"  , "title" : "كمية واردة" },
                {"data" : "OUT_AMOUNT" , "width" : "10%"  , "title" : "كمية صادرة"},
                {"data" : "WAREHOUSE_NAME" , "width" : "10%" , "title" : "المخزن"},
                {"data" : "TRANS_OWNER_NAME" , "width" : "15%" , "title" : "المستفيد"},
                {"data" : "NOTES" , "width" : "15%" , "title" : "البيان"}
        ]
    });
    e.preventDefault();
});

$(document).on('click', '#detailedStatment_btn', function () {
    $("#F_WAREHOUSE").val($("#WAREHOUSE_NO").val()) ; 
    $("#F_WAREHOUSE_NAME").val($("#WAREHOUSE_NO option:selected").html()) ; 
    $("#F_PRODUCT").val($("#FUEL_CAT").val()) ; 
    $("#F_PRODUCT_NAME").val($("#FUEL_CAT option:selected").html()) ; 
    $("#F_START_DT").val($("#START_DT").val()) ; 
    $("#F_END_DT").val($("#END_DT").val()) ; 
    $("#F_REPORT_NAME").val('detailed') ; 
    $("#printWarehouseTransForm").submit() ;
});

$(document).on('click', '#totalsStatment_btn', function () {
    $("#F_WAREHOUSE").val($("#WAREHOUSE").val()) ;  
     $("#F_WAREHOUSE_NAME").val($("#WAREHOUSE option:selected").html()) ; 
    $("#F_PRODUCT").val($("#FUEL_SOURCE").val()) ; 
    $("#F_PRODUCT_NAME").val($("#FUEL_SOURCE option:selected").html()) ; 
    $("#F_START_DT").val($("#START_DT").val()) ; 
    $("#F_END_DT").val($("#END_DT").val()) ; 
    $("#F_REPORT_NAME").val('totals') ; 
    $("#printWarehouseTransForm").submit() ;
});


$(document).on('click', "#getTotalsData_btn", function (e) {
    $('#warehouseTransList_tb').dataTable({
        "destroy": true,
        "bStateSave": false,
        "lengthMenu": [
                    [10, 20, 50, 100, 150, -1],
                    [10, 20, 50, 100, 150, "All"] // change per page values here
        ],
        "pageLength": 10,
        
        "ajax": 
        {
            "url": "index.php/statements/queryWarehouseTransTotals", 
            "type": "POST",
            "data": {
                WAREHOUSE_NO: $('#WAREHOUSE').val(),
                PRODUCT: $('#FUEL_SOURCE').val(),
                START_DT: $('#START_DT').val(),
                END_DT: $('#END_DT').val()
            }  
        },
        "order": [[0, "asc"]],
        "language": {
                "lengthMenu": "عرض _MENU_ سجل في الصفحة",
                "zeroRecords": "عذرا - لا يوجد بيانات.",
                "info": "عرض _START_ الى _END_ من _TOTAL_ سجل",
                "infoEmpty": "لا تتوفر اي بيانات.",
                "infoFiltered": "(تصفية من _MAX_ سجل)",
                "loadingRecords": "تحميل...",
                "processing":     "جاري معالجة البيانات...",
                "search":         "بحث:",
                "paginate": {
                    "first":      "الأول",
                    "last":       "الأخير",
                    "next":       "التالي",
                    "previous":   "السابق"
                },
            },
        "sAjaxDataProp" : "",
        dom: 'Blfrtip',
        buttons: [
            {

                extend: 'excel', text: 'تصدير الى اكسل',

            }
        ],
        "columns": [
                {"data" : "PRODUCT_NAME" , "width" : "20%" , "title": "الصنف"},
                {"data" : "WAREHOUSE_NAME" , "width" : "5%", "title": "اسم المخزن"},
                {"data" : "PREV_BALANCE" , "width" : "15%" , "title": "كمية سابقة"},
                {"data" : "IN_AMOUNT" , "width" : "20%" , "title": "كمية واردة" },
                {"data" : "OUT_AMOUNT" , "width" : "20%", "title": "كمية صادرة" },
                {"data" : "WAREHOUSE_BALANCE" , "width" : "20%", "title": "الرصيد" },
                {"data" : null , "width" : "5%", "title": "اجراءات", "render" : function(data , type , full){
                    return '<button type="button" WAREHOUSE_ID="'+ data.WAREHOUSE +'" WAREHOUS_NAME="'+data.WAREHOUSE_NAME+'" PRODUCT_ID="'+data.PRODUCT+'" PRODUCT_NAME="'+data.PRODUCT_NAME+'" class="btn green detailedStatment_lnk">طباعة</button>' ;
                    }
                }
        ]
    });
    e.preventDefault();
});

$(document).on('click', '#detailedStatment_btn', function () {
    $("#F_WAREHOUSE").val($("#WAREHOUSE_NO").val()) ; 
    $("#F_WAREHOUSE_NAME").val($("#WAREHOUSE_NO option:selected").html()) ; 
    $("#F_PRODUCT").val($("#FUEL_CAT").val()) ; 
    $("#F_PRODUCT_NAME").val($("#FUEL_CAT option:selected").html()) ; 
    $("#F_START_DT").val($("#START_DT").val()) ; 
    $("#F_END_DT").val($("#END_DT").val()) ; 
    $("#F_REPORT_NAME").val('detailed') ; 
    $("#printWarehouseTransForm").submit() ;
    e.preventDefault();
});

$(document).on('click', '.detailedStatment_lnk', function () {
    var obj = $(this); 
    $("#F_WAREHOUSE").val(obj.attr('WAREHOUSE_ID')) ; 
    $("#F_WAREHOUSE_NAME").val(obj.attr('WAREHOUS_NAME')) ; 
    $("#F_PRODUCT").val(obj.attr('PRODUCT_ID')) ; 
    $("#F_PRODUCT_NAME").val(obj.attr('PRODUCT_NAME')) ; 
    $("#F_START_DT").val($("#START_DT").val()) ; 
    $("#F_END_DT").val($("#END_DT").val()) ; 
    $("#F_REPORT_NAME").val('detailed') ; 
    $("#printWarehouseTransForm").submit() ;
    e.preventDefault();
});

$(document).on('click', '#addWarehouseTrans_btn', function () {
    FormValidation.init();
    if($("#add_warehouse_trans_form").valid() !== true){
        return; 
    }
    $.ajax({
        type: 'post',
        url: "index.php/warehouses/addWarhouseTransaction",
        cache: false,
        dataType: "json",
        data: {
            "TRANS_DATE" : $("#TRANS_DATE").val(),
            "TRANS_TYPE" : $("#TRANS_TYPE").val(),
            "FUEL_CAT"   : $("#FUEL_CAT").val(),
            "FROM_WAREHOUSE" : $("#FROM_WAREHOUSE").val(),
            "TO_WAREHOUSE": $("#TO_WAREHOUSE").val(),
            "TRANS_AMOUNT": $("#TRAN_AMOUNT").val(),
            "TRANS_NOTES": $("#TRANS_NOTES").val()
        },
        success: function (data) {
            if(data.success > 0){
                clearTransactionForm(); 
            }
            showMessage({message:data.msg, type:(data.success > 0)? 'success' : 'warning', icon:(data.success > 0)? 'check' : 'warning'});
        },
        error: function (jqXHR, textStatus, errorThrown) {
			showMessage({message:data.msg + errorThrown, type:"error", icon:"warning"});

        }
    });
    e.preventDefault();
});

$(document).on('change', '#TRANS_TYPE', function () {
    if($("#TRANS_TYPE").val() == 4){
        $("#toWarehouse_div").attr('style', "display: block") ; 
    } else {
        $("#toWarehouse_div").attr('style', "display: none") ;
        $("#TO_WAREHOUSE option:selected").removeAttr("selected");
        $("#TO_WAREHOUSE option[value='3']").attr('selected', 'selected');
    }
});

$(document).on('click', "#getwarehousetrans_btn", function (e) {
    $('#warehousetrans_tb').dataTable({
        "destroy": true,
        "bStateSave": false,
        "lengthMenu": [
            [10, 20, 50, 100, 150, -1],
            [10, 20, 50, 100, 150, "All"] // change per page values here
        ],
        "pageLength": 10,

        "ajax":
        {
            "url": "index.php/warehouses/getWarhouseTransaction",
            "type": "POST",
            "data": {
                "WAREHOUSE" :$("#WAREHOUSE").val(),
                "FUEL_CAT"   : $("#FUEL_CAT").val(),
                "TRANS_TYPE" : $("#TRANS_TYPE").val(),
                "START_DT" : $("#START_DT").val(),
                "END_DT" : $("#END_DT").val(),
                "STATUS" : $("#STATUS").val(),
            }
        },
        "order": [[0, "asc"]],
        "language": {
            "lengthMenu": "عرض _MENU_ سجل في الصفحة",
            "zeroRecords": "عذرا - لا يوجد بيانات.",
            "info": "عرض _START_ الى _END_ من _TOTAL_ سجل",
            "infoEmpty": "لا تتوفر اي بيانات.",
            "infoFiltered": "(تصفية من _MAX_ سجل)",
            "loadingRecords": "تحميل...",
            "processing":     "جاري معالجة البيانات...",
            "search":         "بحث:",
            "paginate": {
                "first":      "الأول",
                "last":       "الأخير",
                "next":       "التالي",
                "previous":   "السابق"
            },
        },
        "sAjaxDataProp" : "",
        dom: 'Blfrtip',
        buttons: [
            {
                extend: 'excel', text: 'تصدير الى اكسل',
            }
        ],
        "aoColumnDefs":
            [
                {
                    "aTargets": [ 9 ],
                    "mData": "download_link",
                    "mRender": function ( data, type, full )
                    {
                        var res = "";
                        if(data.STATUS == 0) {
                            if($('#allowedToEdit').val()) res += '<a href="" TRANS_SR = "'+ data.SERIAL_NO +'" class="btn blue updateWarehouseTrans">تعديل </a>';
                            if($('#allowedToCancel').val()) res += '<a href="" TRANS_SR = "' + data.SERIAL_NO + '" class="btn red rejectWarehouseTrans">رفض</a>';
                            if($('#allowedToApprove').val()) res += '<a href="" TRANS_SR = "'+ data.SERIAL_NO +'" class="btn green approveWarehouseTrans">اعتماد</a>';

                        } else if(data.STATUS == 1) {
                            if($('#allowedToReturn').val()) res += '<a href="" TRANS_SR = "' + data.SERIAL_NO + '" class="btn yellow returnwarehousetrans">ارجاع</a>';
                        }
                        return res;
                    }
                }
            ],
        "aoColumns": [
            {"data" : "SERIAL_NO" , "width" : "5%"},
            {"data" : "WAREHOUSE_NAME" , "width" : "10%" },
            {"data" : "TRANS_NAME" , "width" : "10%" },
            {"data" : "FUEL_NAME" , "width" : "10%" },
            {"data" : "FUEL_UNIT" , "width" : "5%"  },
            {"data" : "TRAN_AMOUNT" , "width" : "5%" },
            {"data" : "TRANS_DT" , "width" : "10%"},
            {"data" : "STATUS_TXT" , "width" : "10%"},
            {"data" : "NOTES" , "width" : "15%"},
            {"data" : null}
        ]
    });
    e.preventDefault();
});

$(document).on('click', ".approveWarehouseTrans", function (e) {
    var elm = $(this).parent();
    $.ajax({
        type: 'post',
        url: "index.php/warehouses/AproveWarehouseTrans",
        cache: false,
        dataType: "json",
        data: {
            TRANS_SR: $(this).attr("TRANS_SR")
        },
        success: function (data) {
            elm.html(data.msg);
            showMessage({message:data.msg, type:(data.success > 0)? 'success' : 'warning', icon:(data.success > 0)? 'check' : 'warning'});
            $('#warehousetrans_tb').DataTable().ajax.reload();
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:'خطأ في الاتصال. ' + errorThrown, type: 'warning', icon:'warning'});

        }
    });
    e.preventDefault();
});

$(document).on('click', ".rejectWarehouseTrans", function (e) {
    var elm = $(this).parent();
    $.ajax({
        type: 'post',
        url: "index.php/warehouses/rejectWarehouseTrans",
        cache: false,
        dataType: "json",
        data: {
            TRANS_SR: $(this).attr("TRANS_SR")
        },
        success: function (data) {
            elm.html(data.msg);
            showMessage({message:data.msg, type:(data.success > 0)? 'success' : 'warning', icon:(data.success > 0)? 'check' : 'warning'});
            $('#warehousetrans_tb').DataTable().ajax.reload();

        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:'خطأ في الاتصال. ' + errorThrown, type: 'warning', icon:'warning'});

        }
    });
    e.preventDefault();
});

$(document).on('click', ".returnwarehousetrans", function (e) {
    var elm = $(this).parent();
    $.ajax({
        type: 'post',
        url: "index.php/warehouses/returnWarehouseTrans",
        cache: false,
        dataType: "json",
        data: {
            TRANS_SR: $(this).attr("TRANS_SR")
        },
        success: function (data) {
            elm.html(data.msg);
            showMessage({message:data.msg, type:(data.success > 0)? 'success' : 'warning', icon:(data.success > 0)? 'check' : 'warning'});
            $('#warehousetrans_tb').DataTable().ajax.reload();
        },
        error: function (jqXHR, textStatus, errorThrown) {
            showMessage({message:'خطأ في الاتصال. ' + errorThrown, type: 'warning', icon:'warning'});

        }
    });
    e.preventDefault();
});

$(document).on('click', ".updateWarehouseTrans", function (e) {
    $("#U_TRANS_SR").val($(this).attr("TRANS_SR"));
    $("#updateWarehouseTransForm").submit();
    e.preventDefault();
});

$(document).on('click', '#updateWarehouseTrans_btn', function () {
    $.ajax({
        type: 'post',
        url: "index.php/warehouses/updateWarehouseTransAction",
        cache: false,
        dataType: "json",
        data: {
            "TRANS_SR" : $("#TRANS_SR").val(),
            "TRANS_TYPE" : $("#TRANS_TYPE").val(),
            "TRANS_DATE" : $("#TRANS_DATE").val(),
            "FUEL_CAT"   : $("#FUEL_CAT").val(),
            "FROM_WAREHOUSE" : $("#FROM_WAREHOUSE").val(),
            "TO_WAREHOUSE": $("#TO_WAREHOUSE").val(),
            "TRANS_AMOUNT": $("#TRAN_AMOUNT").val(),
            "RELATED_SR": $("#RELATED_SR").val(),
             "TRANS_NOTE": $("#TRANS_NOTE").val()
        },
        success: function (data) {
            showMessage({message:data.msg, type:(data.success > 0)? 'success' : 'warning', icon:(data.success > 0)? 'check' : 'warning'});
        },
        error: function (jqXHR, textStatus, errorThrown) {

        }
    });
});


function clearTransactionForm(){
    $("#TRANS_DATE").val('');
    $("#TRANS_TYPE option[value='3']").prop('selected', 'selected');
    $("#FUEL_CAT option[value='6']").prop('selected', 'selected');
    $("#FROM_WAREHOUSE option[value='3']").prop('selected', 'selected');
    $("#toWarehouse_div").attr('style', "display: none") ;
    $("#TO_WAREHOUSE option[value='3']").prop('selected', 'selected');
    $("#TRAN_AMOUNT").val('');
    
}

$(document).ajaxStart(function () {
    App.startPageLoading({animate: true});
});

$(document).ajaxStop(function () {
    window.setTimeout(function () {
        App.stopPageLoading();
    }, 50);
});

var FormValidation = function() {
	var handleWarehouseTransValidation = function(){
        var form = $('#add_warehouse_trans_form');
        var error = $('.alert-danger', form);
        var success = $('.alert-success', form);
        form.validate({
            errorElement: 'span', //default input error message container
            errorClass: 'help-block help-block-error', // default input error message class
            focusInvalid: false, // do not focus the last invalid input
            ignore: "",  // validate all fields including form hidden input
            messages: {
                TRANS_DATE: {
                    required: "هذا الحقل مطلوب",
                    date : 'الرجاء ادخال التاريخ بصيغة صحيحة (dd/mm/yyyy)',
                } ,
                TRAN_AMOUNT: {
                    required: "هذا الحقل مطلوب",
                }
            },
            rules: {
                IN_DATE: {
                    required: true
                } ,
                TRAN_AMOUNT: {
                    required: true
                }
            },

            invalidHandler: function (event, validator) { //display error alert on form submit              
                success.hide();
                error.show();
                //App.scrollTo(error, -200);
            },

            highlight: function (element) { // hightlight error inputs
                $(element).closest('.form-group').addClass('has-error'); // set error class to the control group
            },

            unhighlight: function (element) { // revert the change done by hightlight
                $(element).closest('.form-group').removeClass('has-error'); // set error class to the control group
            },

            success: function (label) {
                label.closest('.form-group').removeClass('has-error'); // set success class to the control group
            },

            submitHandler: function (form) {
                success.show();
                error.hide();
            }
        });
    }

    return {
        init: function () {
            handleWarehouseTransValidation() ;
        }
    }
}();

function showMessage(config){
    App.alert({
        container: '#alert_container', // alerts parent container(by default placed after the page breadcrumbs)
        place: 'prepent', // append or prepent in container 
        type: config.type,  // alert's type
        message: config.message,  // alert's message
        close: true, // make alert closable
        reset: true, // close all previouse alerts first
        focus: false, // auto scroll to the alert after shown
        closeInSeconds: 10, // auto close after defined seconds
        icon: config.icon // put icon before the message
    });
}

function hideMessage(){
    $('#alert_container').html('');
}